/*
* Copyright (c) 2006 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Defines the class used to store extensions to the main 
				 PlatformFlashEngine functionality.
*
*/


#ifndef __MMI_CUSTOM_IMPL_H__
#define __MMI_CUSTOM_IMPL_H__

class MMMIExtendedEvtHndlr;
class MMIUtils;
class CMMIIncomingCallNotification;

class CFlashMMICustomizationImpl : public CFlashMMICustomization
{
public:
	static TAny* NewL();
	~CFlashMMICustomizationImpl();

	virtual TBool HandleKeyEvent(const TKeyEvent& aKeyEvent, KeyEventInfo* aKeyEventInfo);
	virtual TBool HandleLaunchL(RPointerArray<HBufC>& aArray);
	virtual TBool RegisterExtendedEventL(const TDesC& aEventName);
	virtual TBool UnregisterExtendedEvent(const TDesC& aEventName);
	virtual void UnregisterExtendedEvents();
	virtual void SetMMIUtils(MMIUtils* aUtils);
	virtual void NotifyIncomingCall(TBool aStatus);
private:
	CFlashMMICustomizationImpl();

	void AddIncomingCallListenerL();
	void RemoveIncomingCallListener();

private:
	CMMIIncomingCallNotification* iExtEventListener; // this probably should be an array of listeners eventually
	MMIUtils* iMMIUtils;
};

#endif // __MMI_CUSTOM_IMPL_H__
