/*
* Copyright (c) 2006 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Defines the Extended Event Handler that allows Flash MMI 
				 Movies to be notified of the incoming call events.
				 
*
*/


#ifndef __MMI_EVENT_HANDLER_INCOMING_CALL_H__
#define __MMI_EVENT_HANDLER_INCOMING_CALL_H__

#include <e32base.h>
#include <etel.h>

#include "mmieventhndlrbase.h"

class CContactDatabase;
class RLine;
class MMIUtils;

/**
* The CMMIIncomingCallNotification class is the Extended Event Handler that allows Flash MMI Movies to be notified
* of incoming call events.
*/
class CMMIIncomingCallNotification : public CBase , public MMMIExtendedEvtHndlr
{
public:
	static CMMIIncomingCallNotification* NewL(MMIUtils* aMMIUtils);
	~CMMIIncomingCallNotification();
	virtual void NotifyIncomingCall(TBool aStatus);
private:
	CMMIIncomingCallNotification();
	void ConstructL(MMIUtils* aMMIUtils);
	void NotifyIncomingCallL(TBool aStatus);
public://MMMIExtendedEvtHndlr
	void Destroy();
private:
	TName iName;
	MMIUtils* iMMIUtils;
};

#endif // __MMI_EVENT_HANDLER_INCOMING_CALL_H__
