/*
* Copyright (c) 2006 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Implements the member functions of the stub application 
				 class for MMI.
*
*/


#include <eikstart.h>

#include "safl2mmi.h"
#include <flash_ui.h>


CFlashStubApplication::~CFlashStubApplication()
{
	if (iFlashLibrary.Handle())
	{
		iFlashLibrary.Close();
	}
}

const TUid KUidFlashStubApp = { 0x10281F79 };

TUid CFlashStubApplication::AppDllUid() const
{
	return KUidFlashStubApp;
}

_LIT8(KStubFlashExtensions, "phonebook");
// The name of the swf file opened by the MMI stub
// application.
_LIT(KStubFlashContent, "C:\\Data\\Others\\example.swf");

CApaDocument* CFlashStubApplication::CreateDocumentL()
{
	FlashUIConfig config;
	config.iIsMMI = ETrue;
	config.iIsStubApp = ETrue;
	config.iContentFileName.Copy(KStubFlashContent);
	config.iContentChecksum = 0;
	config.iExtensions = &KStubFlashExtensions;
	config.iReserved1 = NULL;
	config.iReserved2 = 0;
	return CreateFlashDocumentL(iFlashLibrary, this, config);
}

LOCAL_C CApaApplication* NewApplication( )
{
	return new CFlashStubApplication;
}


GLDEF_C TInt E32Main()
{
    return EikStart::RunApplication(NewApplication);
    //REComSession::FinalClose();
}

