/*
* Copyright (c) 2006 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Defines the factory method that returns a pointer to a 
				 newly constructed CFlashExtension object.
*
*/


#ifndef __CSI_MMIOBJECT_H__
#define __CSI_MMIOBJECT_H__


#include <e32std.h>
#include <ecom/implementationproxy.h>

#include "flashextension.h"

/**
 * The NewFlashExtensionL function is a factory method that returns a pointer to a newly constructed
 * CFlashExtension object, transferring ownership to the caller.
 *
 * Leaves on failure to create the extension, with one of the standard System wide error codes.
 *
 * @return Pointer to a new CFlashExtension, owned by the caller.
 */
TAny* NewFlashExtensionL();

const TImplementationProxy ImplementationTable[] =
{
	{{0x1027367a},	NewFlashExtensionL}
};

/**
 * The ImplementationGroupProxy function returns a pointer to a TImplementationProxy
 * containing the list of factory functions exported by this ECom plug-in Dll.
 *
 * @param aTableCount  upon return from the function contains the number of items in the table.
 * @return pointer to a TImplementationProxy. Ownership is not transfered.
 */
EXPORT_C const TImplementationProxy* ImplementationGroupProxy(TInt& aTableCount)
{
	aTableCount = sizeof(ImplementationTable) / sizeof(TImplementationProxy);
	return ImplementationTable;
}

#endif //__CSI_MMIOBJECT_H__