/*
* Copyright (c) 2006 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Defines the utility class.
*
*/



#ifndef __MMI_UTILS_IMPL_H__
#define __MMI_UTILS_IMPL_H__

#include <e32base.h>
#include <mmiutils.h>
#include "flashliteinterfaces.h"

class CMMIUtilsImpl : public CBase, public MMIUtils
{
public:
	static CMMIUtilsImpl* NewL(MM_Object* aMMObj, CEikonEnv* aEnv);

private:
	CMMIUtilsImpl(MM_Object* aMMObj, CEikonEnv* aEnv);

public:

	CEikonEnv* GetEikonEnv() { return iEnv; }

	virtual void SendEvent(RPointerArray<TDesC>& aArgs);

	virtual TInt GetIntFromDescL(const TDesC& aDesc);
	
	virtual short SetReturnStringFromKeyValuePairsL(const CArrayFix<TMMIKeyValuePair>* aArray, const TAny* aRetString);
	virtual short SetReturnStringFromIntL(TInt aInt, const TAny* aRetString);
	virtual short SetReturnStringFromDes16L(const TDesC& aDes, const TAny* aRetString);

	// data request functions
	virtual void DataRequestSetStringProperty(const TAny* aRequestHandle, const TDesC& aKey, const TDesC& aValue);
	virtual void DataRequestSetNumberProperty(const TAny* aRequestHandle, const TDesC& aKey, TInt aValue);
	virtual TAny* DataRequestCreateObjectProperty(const TAny* aRequestHandle, const TDesC& aKey);
	virtual void DataRequestSetComplete(const TAny* aRequestHandle, TUint8 aSuccess);

private:
	CEikonEnv* iEnv;
	MM_Object* iMMObj;
};



#endif // __MMI_UTILS_IMPL_H__
