﻿/*
* ============================================================================
*  Name        : Service.as
*  Part of     : Nokia Flash Lite
*  Description : Defines the class which helps the contents to request for a 
* service and pass input and output parameters.
*                
*  Version     :
*
*  Copyright © 2008-2009 Nokia. All rights reserved.
*  This material, including documentation and any related 
*  computer programs, is protected by copyright controlled by 
*  Nokia. All rights are reserved. Copying, including 
*  reproducing, storing, adapting or translating, any 
*  or all of this material requires the prior written consent of 
*  Nokia. This material also contains confidential 
*  information which may not be disclosed to others without the 
*  prior written consent of Nokia
* ============================================================================
*/

import com.nokia.impl.CUtils;
import com.nokia.impl.ServiceUtilsProxy;

class com.nokia.impl.Callback {
	/*
	 Function: Constructor
	
	 Initializes the service parameters and creates the service 
	 instance.
	
	 Parameters:
	 aServiceName - The name of Service.
	 aInterfaceName - The name of the interface 
	 aInitialParam - The initial param to be passed during the
	  service instantiation
	
	 Returns:
	 Throws execption if service or interface name is null.
	*/
	function Callback() {
	
	}
	
	/*
	 Function: onEvent
	
	 Issues a asynchronous service request.
	
	 Parameters:
	 aOutput	 - contains Output of Async operation
	 Returns:
	 None
	*/
	function onEvent(aOutput:Object){
		var transID:Number = aOutput.TransactionID;
		var storedcallback = null;
		storedcallback = CUtils.Get(transID);
		
		var eventID:Number = aOutput.eventID;
		
		if("function" == typeof(storedcallback))
			{
			storedcallback(transID, eventID, aOutput);
			}
		else
			{
			storedcallback.onLoad(transID, eventID, aOutput);
			}
	}
};