﻿/*
* ============================================================================
*  Name        : CUtils.as
*  Part of     : Nokia Flash Lite
*  Description : Utility class, defines commonly used utility functions
*                
*  Version     :
*
*  Copyright © 2008-2009 Nokia. All rights reserved.
*  This material, including documentation and any related 
*  computer programs, is protected by copyright controlled by 
*  Nokia. All rights are reserved. Copying, including 
*  reproducing, storing, adapting or translating, any 
*  or all of this material requires the prior written consent of 
*  Nokia. This material also contains confidential 
*  information which may not be disclosed to others without the 
*  prior written consent of Nokia
* ============================================================================
*/

class com.nokia.impl.CUtils {
	/* 
	Funtion - GetTransactionID
	Param
	None 
	Return 
	Randomly generated transactionID(Number).
	*/
	public static function GetTransactionID():Number {
		return ++counter;
	}
	
	/* 
	Funtion - Store
	Param
	aTransID - transactionId inform of Number
	aListener - Listener Object

	Return 
	None
	*/
	public static function Store(aTransID:Number, aListener:Object) {
		if (null == callbackArray) {
			callbackArray = new Array();
		}
		callbackArray[aTransID] = aListener;
	}
	
	/* 
	Funtion - Get
	Param
	aTransID - transactionId inform of Number

	Return 
	Listener Object stored in Array.
	*/
	public static function Get(aTransID:Number):Object {
		return callbackArray[aTransID];
	}
	
	/* 
	Funtion - Clean
	Param
	aTransID - transactionId inform of Number

	Return 
	Cleans entry of Listener.
	*/
	public static function Clean(aTransID:Number) {
		var temp:Array = new Array();
		temp = callbackArray;
		delete callbackArray;
		callbackArray = new Array();
		for (var i in temp) {
			if (i == aTransID) {
				continue;
			}
			callbackArray[i] = temp[i];
		}
	}
	private static var counter:Number = 0;
	private static var callbackArray:Array = null;
}
