﻿/*
* ============================================================================
*  Name        : ServiceProxy.as
*  Part of     : Nokia Flash Lite
*  Description : Defines the class which provides proxy for loading service provider and also 
*				 for processing requests on service providers.
*                
*  Version     :
*
*  Copyright © 2008-2009 Nokia. All rights reserved.
*  This material, including documentation and any related 
*  computer programs, is protected by copyright controlled by 
*  Nokia. All rights are reserved. Copying, including 
*  reproducing, storing, adapting or translating, any 
*  or all of this material requires the prior written consent of 
*  Nokia. This material also contains confidential 
*  information which may not be disclosed to others without the 
*  prior written consent of Nokia
* ============================================================================
*/


intrinsic class com.nokia.impl.ServiceProxy {
	/*
	 Function: Constructor
	*/
	public function ServiceProxy();
	
	/*
	 Function: Load
	
	 Requests Loading of Service Provider.
	
	 Parameters:
	 None.
	
	 Returns:
	 Returns Non Zero Error Code on failure.
	*/
	public function Load():Number;
	
	/*
	 Function: ExecuteAsyncReqs
	
	 Requests ASynchronous Service Request.
	
	 Parameters:
	 None.
	
	 Returns:
	 Returns a Object containing Error code and TransactionID. 
	*/	
	public function ExecuteAsyncReq():Number;
	/*
	 Function: ExecuteSyncReq
	
	 Requests Synchronous Service Request.
	
	 Parameters:
	 None.
	
	 Returns:
	 Returns a Object containing Error code and Results. 
	*/
	public function ExecuteSyncReq():Object;
	
	/*
	 Function: ExecuteAsyncReq
	
	 Requests cancel of ongoing ASynchronous Service Request.
	
	 Parameters:
	 None.
	
	 Returns:
	 Returns a Object. 
	*/	
	public function CancelAsyncReq():Object;
	
	/*
	 Function: UnloadService
	
	 Unloads the specified Service Provider.
	
	 Returns:
	 Returns true if successful.
	*/
	public function UnloadService();

}

