﻿/*
* ============================================================================
*  Name        : Device.as
*  Part of     : Nokia Flash Lite
*  Description : Defines the Device class which helps the contents to request for a 
* Device Cmds.
*                
*  Version     :
*
*  Copyright © 2009-2010 Nokia. All rights reserved.
*  This material, including documentation and any related 
*  computer programs, is protected by copyright controlled by 
*  Nokia. All rights are reserved. Copying, including 
*  reproducing, storing, adapting or translating, any 
*  or all of this material requires the prior written consent of 
*  Nokia. This material also contains confidential 
*  information which may not be disclosed to others without the 
*  prior written consent of Nokia
* ============================================================================
*/
import com.nokia.impl.DeviceProxy;
import com.nokia.lib.ErrorValue;

class com.nokia.lib.Device {
	/*
	 Function: Constructor
	
	 Initializes the Device class Instance
	
	 Parameters:

	 Returns:
	 Throws execption if Device Proxy does not initializes
	*/
	function Device() {

		this.__resolve = function(methodName) {
			return function () {
			if(arguments.length >= 0){
					if((arguments[0] == undefined) || (arguments[0] == null)){
						return DeviceProxy.ProcessDeviceCmd(methodName, false); // for API with no params we will send as default false.
						}
						else{
						return DeviceProxy.ProcessDeviceCmd(methodName, arguments[0]);												
						}
				}
			else{					
					return ErrorValue.EInvalidInputError;
				}
			};
			
		};
		
	}
}