﻿/*
* ============================================================================
*  Name        : ServiceUtils.as
*  Part of     : Nokia Flash Lite
*  Description : Defines the Utility class.
*                
*  Version     :
*
*  Copyright © 2008-2009 Nokia. All rights reserved.
*  This material, including documentation and any related 
*  computer programs, is protected by copyright controlled by 
*  Nokia. All rights are reserved. Copying, including 
*  reproducing, storing, adapting or translating, any 
*  or all of this material requires the prior written consent of 
*  Nokia. This material also contains confidential 
*  information which may not be disclosed to others without the 
*  prior written consent of Nokia
* ============================================================================
*/
/*
  Class: com.nokia.lib.ServiceUtils

  Utility class.
*/
import com.nokia.lib.Service;
import com.nokia.impl.ServiceUtilsProxy;

class com.nokia.lib.ServiceUtils {
		
	static function QueryServiceList(aService:String, aInterface:String, aVersion:Object):Object{
		
		var outparam:Object = ServiceUtilsProxy.GetServiceList(aService, aInterface, aVersion);
		
		return outparam;
	}
	
	/*
	  Function: UnloadService
	
	  Unloads the service provider
	
	  Parameters:
	   aService - reference to loaded service instance
	
	  Returns:
	  true if unloading of service provider is successful
	*/
	static public function UnloadService(aService:Service):Boolean {
		if (null == aService) {
			return false;
		}
		
		var ret = aService.UnloadService();
		
		if(!ret){
			return false;
		}
		
		return true;
	}
}
