/*
* Copyright (c) 2009-2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Defines the constant which are shared among various asextension implementation                
 
 *
*/


#ifndef __ASEXTENSION_CONST_H__
#define __ASEXTENSION_CONST_H__


// Error codes returned to the flash content.
const TInt KASErrInvalidInput = -308;
const TInt KASErrNotSupported = -307; 
const TInt KASErrGenral = -304;


/*we have to bypass these internal properties of Object.Creation of Object in Action script have folowing variation:
 * 1. var a:Object = new Object(); will have properties KStrObjectPropertyProto,KStrObjectPropertyConstructor
 * 2. var a:Object = Object(); also possible to create an Object by this syntax but this won't have any interal properties
 * attached.
 * 3. var a = {Type:"contact",Data:1}; this variation will have KStrObjectPropertyConstructor2,
 *   KStrObjectPropertyProtoType properties.
 * 4. var a:Object = {Type:"contact", Data:1}; will have KStrObjectPropertyProto, KStrObjectPropertyConstructor2
*/

_LIT8(KStrObjectPropertyResolve,"__resolve");
_LIT8(KStrObjectPropertyProto,"__proto__");
_LIT8(KStrObjectPropertyProtoType, "prototype");
_LIT8(KStrObjectPropertyConstructor,"__constructor__");
_LIT8(KStrObjectPropertyConstructor2,"constructor");
//class and method names

const char* const KStrObject = "Object";
const char* const KStrReverse = "reverse";
const char* const KStrPop = "pop";
const char* const KStrLength = "length";
const char* const KStrPush = "push";
const char* const KStrArray = "Array";
const char* const KStrGetFullYear = "getFullYear";
const char* const KStrGetMonth = "getMonth";
const char* const KStrGetDate = "getDate";
const char* const KStrGetHours = "getHours";
const char* const KStrGetMinutes = "getMinutes";
const char* const KStrGetSeconds = "getSeconds";
const char* const KStrGetMilliSeconds = "getMilliseconds";

#endif /*__ASEXTENSION_CONST_H__*/
