/*
* Copyright (c) 2008-2009 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Defines the class that maps async id to transaction id.
 
 *
*/


#ifndef __ASYNCREQIDMAP_H__
#define __ASYNCREQIDMAP_H__

#include <e32std.h>
#include <e32base.h>
#include "flashliteExtensionInterfaces.h"

class CLiwGenericParamList;
/**
 Maps the async id passed by the ActionScript to the transaction id passed by
 the service provider.
 */
class TAsyncReqIDMap 
    {
public:
    /**
     Constructor.

     @param aTransID Transaction Id passed by the service provider.
     @param aLiwInterface The instance of the interface based service provider.
     */
    inline TAsyncReqIDMap(TInt32 aTransID, TInt aAsyncID,TBool aResumeOnEvent,TBool aBringToForeGround) :
        iTransID(aTransID), iAsyncID(aAsyncID),iResumeOnEvent(aResumeOnEvent),iBringToForeground(aBringToForeGround)
        {
        //iAsyncOutput = NULL;
        }

public:

    /** Async Id passed by the ActionScript.*/
    TInt iAsyncID;
    /** Transaction Id passed by the service provider.*/
    TInt32 iTransID;
    TBool iResumeOnEvent;
    TBool iBringToForeground;
    };

class CAsyncEvent : public CBase
    {
public:
    static CAsyncEvent* NewL(TInt32 aTransID, CLiwGenericParamList& aLiwOutputParams);
   
    ~CAsyncEvent();

private:
        
    void ConstructL(TInt32 aTransID, CLiwGenericParamList& aLiwOutputParams);

    
public:
    
    /** Transaction Id passed by the service provider.*/
    TInt32 iTransID;
    /**
    Async Output.
     */
    CLiwGenericParamList* iAsyncOutput;
    };


#endif

