/*
* Copyright (c) 2008-2009 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Defines the constant which are shraed among different classes.                
 
 *
*/


#ifndef __COMMONCONST_H__
#define __COMMONCONST_H__

const TInt KArg0 = 0;
const TInt KArg1 = 1;
const TInt KArg2 = 2;
const TInt KArg3 = 3;
const TInt KArg4 = 4;
const TInt KArg5 = 5;
const TInt KNumDateLen = 25;
const TInt32 KAsyncIDNone = -1;
const TInt KMaxLength = 255;

// Error codes returned to the flash content.
const TInt KFlashBindingErrProviderNotFound = -301;
const TInt KFlashBindingErrInterfaceNotFound = -302;
const TInt KFlashBindingErrGeneral = -304;
const TInt KFlashBindingErrVersion = -306;

_LIT(KStrStdDate, "19700001:000000.000000");
_LIT8(KStrMin, "min");
_LIT8(KStrMax, "max");
_LIT8(KStrVersion, "ver");
_LIT8(KStrRange, "range");

//Literals
_LIT8(KStrCancel, "Cancel");
_LIT8(KStrTransactionId, "TransactionID");
_LIT8(KStrErrorId, "ErrorCode");
_LIT8(KStrErrorMessage, "ErrorMessage");
_LIT8(KStrEventID, "eventID");
_LIT8(KStrServiceName, "ServiceName");
_LIT8(KStrInterfaceName, "ServiceInterface");
_LIT8(KStrServiceList, "ServiceList");
_LIT(KStrCmdResumePlayer,"ResumePlayer");
_LIT8(KStrMapClose, "Close");

//class and method names

const char* const KClassNameIterator = "com.nokia.lib.Iterable";
const char* const KClassNameServiceUtilsProxy = "com.nokia.impl.ServiceUtilsProxy";
const char* const KClassNameServiceProxy = "com.nokia.impl.ServiceProxy";
const char* const KClassNameMapProxy = "com.nokia.impl.MapProxy";

const char* const KMethodNameResolve = "__resolve";



const char* const KMethodNameNext = "next";
const char* const KMethodNameReset = "reset";
const char* const KMethodNameClose = "close";

const char* const KMethodNameGetServiceList = "GetServiceList";

const char* const KMethodNameLoad = "Load";
const char* const KMethodNameExecuteAsyncReq = "ExecuteAsyncReq";
const char* const KMethodNameExecuteSyncReq = "ExecuteSyncReq";
const char* const KMethodNameCancelAsyncReq = "CancelAsyncReq";
const char* const KMethodNameUnloadService = "UnloadService";

const char* const KStrErrorCode = "ErrorCode";
const char* const KStrTransId = "TransactionID";
const char* const KStrErrMessage = "ErrorMessage";

const char* const KStrResumeOnEvent = "resumeOnEvent";
const char* const KStrBringToForeGround = "bringToForeground";
#endif /*COMMONCONST_H_*/
