/*
* Copyright (c) 2008-2009 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Defines the CFlashBinding class. CFlashBinding class is a Action Script Extension Plugin. 
 *                                            
 *
*/


#ifndef __FLASH_BINDING_H__
#define __FLASH_BINDING_H__

#include <e32cons.h>
#include <e32base.h> // CBase
#include <e32std.h>	 // TBuf
#include <f32file.h>
#include <stdio.h>

#include "flashliteExtensionInterfaces.h"
#include "flashliteinterfaces.h"
#include "asextensiondelegate.h"

#include <rtsecmanager.h>
#include <rtsecmgrscriptsession.h>

class CFlashRTPolicyClient;
class MFlashRTPolicyContentSession;
class CLiwServiceHandler;
class TAsyncReqIDMap;
class MFlashEngineIntfToASExtension;


class CFlashBindingASExtDelegate : public CASExtensionDelegate
    {
public:

    /**
     Constructs a new CFlashBindingASExtDelegate object.
     
     @return a new CFlashBindingASExtDelegate object.
     */

    static CFlashBindingASExtDelegate* CFlashBindingASExtDelegate::NewL();

    /**
     Destructor.
     */
    virtual ~CFlashBindingASExtDelegate();

    // from CASExt_Delegate
    /**
     Returns PluginInfo structure to caller.
     
     @param aMMObj The MM_Object reference.
     @param aEI The ExtensionInterface reference.
     @param aOpCode The opcode.
     @param aParam Reserved for future use.
     
     @return PluginInfo structure.
     */
    virtual void InitPlugin(TInt aOpCode, TAny* aParam);

    /**
     Responsible for filling up PluginInfo Struct.
     
     @param aOpCode The opcode..
     @param aParam Reserved for future use.
     @return a new PluginInfo object. 
     */
    virtual PluginInfo* GetPluginInfoL(MFlashEngineIntfToASExtension* aFalshEngine, ExtensionInterface* aEI);
    MFlashRTPolicyContentSession* GetSecurityManagerSessionL();
    CLiwServiceHandler* GetLiwServiceHandler();

    MFlashEngineIntfToASExtension* GetFlashEngine()
        {
        return iFlashEngine;
        }
private:

    /**
     Constructor.
     */
    CFlashBindingASExtDelegate()
        {
        }
    ;

    /**
     Constructs a new CFlashBinding object. The pointer is kept
     on cleanup stack.
     
     @return a new CFlashBinding object.
     */
    static CFlashBindingASExtDelegate* CFlashBindingASExtDelegate::NewLC();

    /**
     Second phase construction.
     */
    void ConstructL();

    /**
     Initializes Security manager Session.
     
     @param aOpCode The opcode..
     @param aParam Reserved for future use.
     
     */
    
    /**
    Deletes PluginInfo structure i.e. pointers of functions registered to core player
     will be deleted. It is called by Core player.    
    */   
    static void DestroyPlugin(PluginInfo* pluginInfo);

public:

private:
    CFlashRTPolicyClient* iFpsClient;

    MFlashRTPolicyContentSession* iScriptSession;

    CLiwServiceHandler* iServiceHandler;

    TBool iIsSecMgrCheckNeeded;
    MFlashEngineIntfToASExtension* iFlashEngine;
    };

#endif //__FLASH_BINDING_H__
