/*
* Copyright (c) 2009-2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Defines the member functions of CDeviceCmdsASExtDelegate class.
 
 *
*/


#include <stdlib.h> 
#include <e32std.h>
#include <ecom/implementationproxy.h>
#include <escapeutils.h>
#include "debuglog.h"
#include "devicecmdsdelegate.h"
#include "devicecmdsproxy.h"
#include "flashengineintftoasextension.h"
#include "asextconsts.h"
const char* const KDeviceCmdsPluginName = "devicecmds";
const TUint KUidDeviceCmdsImplementationUid = 0x20022D72;


CDeviceCmdsASExtDelegate* CDeviceCmdsASExtDelegate::NewL()
    {
DEVICECMDSTRACEF("CDeviceCmdsASExtDelegate.NewL< ++");
CDeviceCmdsASExtDelegate* lSelf = CDeviceCmdsASExtDelegate::NewLC();
    CleanupStack::Pop(lSelf);
DEVICECMDSTRACEF    ( "CDeviceCmdsASExtDelegate.NewL> --");
    return lSelf;
    }

// Constructs a new CDeviceCmdsASExtDelegate object. 
CDeviceCmdsASExtDelegate* CDeviceCmdsASExtDelegate::NewLC()
    {
DEVICECMDSTRACEF( "CDeviceCmdsASExtDelegate.NewLC< ++");
    CDeviceCmdsASExtDelegate* lSelf=new(ELeave) CDeviceCmdsASExtDelegate();
    CleanupStack::PushL(lSelf);
    lSelf->ConstructL();
DEVICECMDSTRACEF    ("CDeviceCmdsASExtDelegate.NewLC> --");
    return lSelf;
    }

void CDeviceCmdsASExtDelegate::InitPlugin(TInt /*aOpCode*/, TAny* /*aParam*/)
    {
    DEVICECMDSTRACEF( "CDeviceCmdsASExtDelegate.InitPlugin< ++");
    
DEVICECMDSTRACEF    ( "CDeviceCmdsASExtDelegate.InitPlugin> --");
    }

PluginInfo* CDeviceCmdsASExtDelegate::GetPluginInfoL(MFlashEngineIntfToASExtension* aFlashEngine,
        ExtensionInterface* /*aEI*/)
    {
DEVICECMDSTRACEF("CDeviceCmdsASExtDelegate.GetPluginInfoL< ++");
    iFlashEngine = aFlashEngine;
    
    PluginInfo* lPluginInfo = new(ELeave) PluginInfo;
    CleanupStack::PushL((TAny*)lPluginInfo);
    lPluginInfo->pluginName = (char*)KDeviceCmdsPluginName;
    lPluginInfo->userData = 0;
    lPluginInfo->destroyPlugin = CDeviceCmdsASExtDelegate::DestroyPlugin;

    ClassInfo* lDeviceCmdsProxy = DeviceCmdsProxy::GetClassInfoL();
    CleanupStack::PushL((TAny*)lDeviceCmdsProxy);
 
    lPluginInfo->classes = lDeviceCmdsProxy;
    lPluginInfo->reserved1 = NULL;
    lPluginInfo->methodHook = NULL;
    
    CleanupStack::Pop(2);
DEVICECMDSTRACEF    ( "CDeviceCmdsASExtDelegate.GetPluginInfoL> --");
    return lPluginInfo;
    }


void CDeviceCmdsASExtDelegate::ConstructL()
    {
    DEVICECMDSTRACEF("CDeviceCmdsASExtDelegate.ConstructL< ++");
    Dll::SetTls(this);
    DEVICECMDSTRACEF("CDeviceCmdsASExtDelegate.ConstructL> --");
    }

CDeviceCmdsASExtDelegate::~CDeviceCmdsASExtDelegate()
    {
    }

void CDeviceCmdsASExtDelegate::DestroyPlugin(PluginInfo* pluginInfo)
    {
DEVICECMDSTRACEF("DestroyPlugin< ++");
    CDeviceCmdsASExtDelegate* lDeviceCmdsDelegateObj =
            static_cast<CDeviceCmdsASExtDelegate*>(Dll::Tls() );
    if (lDeviceCmdsDelegateObj)
        {
        delete lDeviceCmdsDelegateObj;
        lDeviceCmdsDelegateObj = NULL;
        }
    Dll::FreeTls();

    while (pluginInfo->classes)
        {
        delete pluginInfo->classes->methodNames;
        delete pluginInfo->classes->methods;
        delete pluginInfo->classes->methodTypes;
        ClassInfo* temp_classInfo = pluginInfo->classes;
        pluginInfo->classes = pluginInfo->classes->next;
        delete temp_classInfo;
        }
    delete pluginInfo;
    pluginInfo = NULL;    
DEVICECMDSTRACEF    ( "DestroyPlugin> --");
    }

const TImplementationProxy
        ImplementationTable[] =
            {
                    IMPLEMENTATION_PROXY_ENTRY(KUidDeviceCmdsImplementationUid, CDeviceCmdsASExtDelegate::NewL)
            };

EXPORT_C const TImplementationProxy* ImplementationGroupProxy(TInt& aTableCount)
    {
    aTableCount = sizeof(ImplementationTable) / sizeof(TImplementationProxy);
    return ImplementationTable;
    }

