/*
* Copyright (c) 2006-2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  
*
*/


#ifndef PLUGINARGUMENTSIMPL_H_
#define PLUGINARGUMENTSIMPL_H_

#include <badesca.h>
#include "commontypes.h"
#include "pluginarguments.h"

typedef TInt InteractionMode;

class CPluginArgProcessor: public CBase, 
						   public MPluginArguments
{
public:
	static CPluginArgProcessor* NewL(CDesCArray* aArgn, CDesCArray* aArgv);

	CPluginArgProcessor(CDesCArray* aArgN, CDesCArray* aArgV);
	~CPluginArgProcessor();

public:
	void Cleanup()
	{
		delete this;
	}
	void ProcessArgs(CDesCArray* aArgn, CDesCArray* aArgv);

	TInt InteractionMode();
	const TDesC& SwfSourcePath();
	const TDesC& BaseUrl();
	TPageAccessType AccessType();
	TBool AllowMobiFullScreen();
	TWindowMode WindowMode();

	virtual const CDesCArray& ArgNames()
	{
		return *iArgN;
	}
	virtual const CDesCArray& ArgValues()
	{
		return *iArgV;
	}

private:

	CDesCArray* iArgN;
	CDesCArray* iArgV;
	TInt iInteractionMode;
	TPtrC iSwfSrcPath;
	TPtrC iBaseUrl;
	TPageAccessType iAllowScriptAccess;
	TBool iAllowMobiFullScreen;

	TWindowMode iWindowMode;
};


#endif /* PLUGINARGUMENTSIMPL_H_ */
