/*
* Copyright (c) 2005 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  plugin control header file
*
*/

#ifndef __FLASH_ANIMATION_PLUGIN_H
#define __FLASH_ANIMATION_PLUGIN_H

#include <sendui.h> 
#include "flashplugincontrol.h"
#include "volumepropertywatchobserver.h"
#include "flashpluginimecontrol.h"
#include "hwkeywatchobserver.h"
// FORWARD DECLARATIONS
class TextInput;
//class CSender;
class MFlashPluginInstance;
class RWindow;
class CFlashPluginControl;
class MVolumePropertyWatchObserver;
class MHwKeyWatchObserver;
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
// a control to contain the flash lite object
// cf. PlatformPlayer in flash 6 plugin / SAFlashPlayerControl in saplayer
//
class CAnimationPluginControl : public CFlashPluginControl
								,public MHwKeyWatchObserver
{
public:

	static CAnimationPluginControl* NewL(MFlashPluginInstance* aInstance);
private:		
    CAnimationPluginControl(MFlashPluginInstance* aInstance);
public:    
    virtual ~CAnimationPluginControl();
private:    
    void ConstructL();
    
    //Not required; moved to CDeviceExtn
    //void SendMessage(const TUid aMtmUid, char* address, char* bodyText);
    
public: //MPluginNotifier
    TInt NotifyL(TNotificationType aCallType, void* aParam);

public:   // From MVolumePropertyWatchObserver
    void MHandleVolumeCmdL(TInt aNewValue);
    void MVolumeChanged(TInt aNewValue);

	virtual void MPausePlayKeyPressed();
	  
	virtual void MStopKeyPressed() ;
	  
	virtual void MRewindKeyPressed();
	
	virtual void MForwardKeyPressed();
			
	virtual void MBackwardKeyPressed();
			
	virtual void MFastForwardKeyPressed();
	
	//virtual void MHandleVolumeRectRedraw();
	
private:   
    void FillConfig();
    
    //TUint GetFeatureCapabilityFromMode(const TUint16 aModeType);
    
    //void RemoveVolumeObserver(); 
    
    
private:

    //CSender*    iSender;		
	TextInput*  iTextInput;	
	TUint32     iVolume;
 
public:
		
	virtual void MuteVolume() ;
	virtual void UnMuteVolume() ;

public:
	// from textInput
    TBool IsTextInputBusy();
    void  GetInputTextL(TGetInputTextData& aData);
         
  
public : //MFlashPlugin
 	TBool QueryAllowDeviceIDL();
 	   
 	/**
     Notify the plugin of any run time error which occurs 
     @param aErrorCode The error code corresponding to the error which has occured
    */
    virtual void  NotifyError(TInt aErrorCode);

    /**
	 This function is called by the host engine when there is an error in
	 processing the flash content.
	 @param aErrorCode The error code.
	 @param aIsCritical ETrue if error is critical.
	 @param aPersistent ETrue is error is persistent.
	*/
	virtual void NotifyFlashError(TInt aErrorCode, TBool aIsCritical, TBool aPersistent = ETrue);

	/**
	 This function is called by the host engine when there is an error in
	 processing the flash content.
	 @param aErrorCode The error code.
	 @param aIsCritical ETrue if error is critical.
	 @param aPersistent ETrue is error is persistent.
	*/
	virtual void NotifyClientError(TInt aErrorCode, TBool aIsCritical, TBool aPersistent = ETrue);
	
	/**
	 This function is called by the host engine flash status
	 processing the flash content.
	 @param aFlashStatus The status code.
	 @param aParam specific to status code.
	*/
	
	virtual void NotifyFlashStatus(TInt aFlashStatus, TAny* aParam) ;
	
	//virtual TUint GetFeatureCapability();
	
};

#endif // __FLASHPLUGINCONTROL_H

// End of File
