/*
* Copyright (c) 2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:
*
*/
/*
 * FlashIconHandler.h
 *
 *  Created on: Jul 19, 2009
 *      Author: vsriram
 */

#ifndef FLASHICONHANDLER_H_
#define FLASHICONHANDLER_H_

#include <e32base.h>
#include <gdi.h>
#include "commontypes.h"

class CWindowGc;
class CFbsBitmap;
class TRect;
class CFbsBitmapDevice;
class CFbsBitGc;

enum EIcons
{
    eErrorIcon = 0
};

class CFlashIconHandler : public CBase
{
public:
    static CFlashIconHandler* CreateIconHandlerL();
    void Show(CBitmapContext* aGraphicsContext,TWindowMode aWMode, EIcons eIconId, const TRect& aIconRegion);
    ~CFlashIconHandler(); //not virtual, class not intended for derivation
private:
    CFlashIconHandler();
    void LoadIconsL();
    
private: 
    CFbsBitmap*                 iErrorImageBitmap;
    CFbsBitmap*                 iErrorImageBitmapMask;
    
private:
    enum EIconLoadState
    {
        eIconNotLoaded = 0,
        eIconLoaded
        }iIconLoaded;
};

#endif /* FLASHICONHANDLER_H_ */
