/*
* Copyright (c) 2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:
*
*/


#ifndef __FLASHPLUGINCURSOR_H
#define __FLASHPLUGINCURSOR_H

#include <coedef.h>
#include "flashcursor.h"
#include <badesca.h>



const TInt KCursorWidth  = 15;
const TInt KCursorHeight = 15;

const TInt KStepCount    = 8;

const TInt KCursorStepWidth  = 5; 
const TInt KCursorStepHeight = 5; 

//class CFlashPluginControl;
class CCoeControl;
class MFlashEngine;

class CFlashCursor : public CBase, public MFlashCursor
{
public:

    static CFlashCursor* NewL(CCoeControl* aParentControl, MFlashEngine* aEngine);
    //static CFlashCursor* NewL(CCoeControl* aParentControl, CFlashPluginControl* aControl);
    virtual ~CFlashCursor();
    
    void    DisplayCursor(); 
    void    ShowCursor(const TPoint& aPoint);
    void    ShowCursor();
    void    HideCursor();
    TBool    MoveCursor(TPoint& aDistance);
    void    UpdateCursor();
    TPoint  Position();
    TBool   IsVisible() const;
    TPoint  PreviousPosition();
    TSize   Size();   
    void    SetWindowSize(const TSize& aSize);
    TRect   GetRect();
    void    SetHiddenWindow(const TRect& aRect);
    
    TPoint HandleNavigation(const TKeyEvent& aKeyEvent,
                                          TEventCode aType, TBool& aBoundaryHit);
                                  
    TFlashCursorState State();    
    void SetState(TFlashCursorState aState);  
    
    void FullScreenMode(CCoeControl* aParentControl);
    void NormalScreenMode(CCoeControl* aParentControl);
    TBool CheckControl(TPoint newPos);
    
    void RecreateCursor();
    void SetCursorPosition(const TPoint &aCurrentPosition);
    
private:
    //CFlashCursor(CCoeControl* aParentControl, CFlashPluginControl* aControl);
    CFlashCursor(CCoeControl* aParentControl, MFlashEngine* aEngine);
    void ConstructL();
    
	void CreateSprite();
	void CloseSprite();

private:
    TSize       iSize;
    TPoint      iPosition;
    CFbsBitmap* iBitmap;
    CFbsBitmap* iBitmapMask;
    TPoint      iPreviousPoint;
    TSize       iWindowSize;
    TSize       iActualWindowSize;
    TRect       iHiddenRect;
    TBool       iHiddenMovement;
    TBool       iCursorCleared;
    TBool       iFullScreenMode;
    
    TFlashCursorState iState;
    
	//The flash object that this cursor is part of.
	//Used to check if some control exists in a given co-ordinate
    //CFlashPluginControl* iFlashControl;

    MFlashEngine* iEngine;
    
	//Windowing parent control
    CCoeControl* iParentControl;

	RWsSprite   iSprite;

	TBool	iSpriteCreated;
};

#endif // __FLASHPLUGINCURSOR_H
