/*
* Copyright (c) 2006-2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  
*
*/
 

#ifndef FLASHWLESSPLUGINCONTROL_H_
#define FLASHWLESSPLUGINCONTROL_H_

#include <e32base.h>
#include <badesca.h>
#include <coecntrl.h>
#include <fbs.h>
#include <NPNFlashExtension.h>
#include <npapi.h>
#include <w32std.h>
#include <coedef.h>
#include <pluginadapterinterface.h>
#include <caf/content.h>
#include <rt_gestureobserver.h>

#include <touchfeedback.h>

#include "symbian_plugin_interface.h"
//#include "Display.h"
//#include "streamhandler.h"
#include "pluginbase.h"
#include "display.h"
#include "commontypes.h"

//using namespace ContentAccess;

class CFlashPluginInstance;
class MFlashEngine;
class MAknWsEventObserver;
class MFlashPluginInstance;

class CFlashWlessPluginControl : public CBase, 
                                 public PluginBase,
                                 public MCoeForegroundObserver,
    							 public MAknWsEventObserver
{
public:
    static CFlashWlessPluginControl* NewL(MFlashPluginInstance* aInstance, CCoeControl* aParentControl);
    ~CFlashWlessPluginControl();    
  
    int SetWindow(void* aWindow);
   
    TInt GetCurrentFrameNo() const;
        
    TInt GetTotalFrames() const;
        
    void SetVolume(TInt aVolume);

    virtual void OpenFileL(const TDesC& aFilename, const TDesC* aUrl, 
                               const TBool& aFirstMovie, CContent* aContent = NULL);

    void PrepareToExitL();
    
    TBool IsFileOpened() const;
    
    void DrawDirtyRect(const TRect& aDirtyRect);
    
    TInt HandleGestureFromBrowserL(void* event);
    
    int HandleKeyEvent(NPEvent* event);
    
    virtual void FLVideoStarted();
    
    void Redraw();
    int HandlePluginEvent(void* aEvent);
    
public: //MCoeForegroundObserver
	void HandleGainingForeground(); 
	void HandleLosingForeground();

public:
    void HandleWsEventL(const TWsEvent& aEvent,CCoeControl* aDestination);    
    void AddEventObserverToControl();
    void RemoveEventObserverFromControl();

private:
	void HandleFocusVisibilityChangeL(TBool aFocus);
	int  SendKeyEventToEngineL(const TKeyEvent& aKeyEvent, TEventCode aType);	
	
public: //MFlashImeClientIf
	void* GetParentControl() 
	{ 
		return iParentControl; 
	}	
	
public:
    virtual TBool QueryAllowDeviceIDL();

    virtual TBool QueryAllowNetAccessL();

    virtual TBool QueryAllowPhoneCallL(const TDesC& aNumberString);

    virtual void NotifyError(TInt /*aErrorCode*/, TBool aIsCritical);

    virtual void NotifyFlashError(TInt aErrorCode, TBool aIsCritical,
            TBool aPersistent = ETrue);

    virtual void NotifyClientError(TInt aErrorCode, TBool aIsCritical,
            TBool aPersistent = ETrue);

    virtual void NotifyFlashStatus(TInt aFlashStatus, TAny* aParam);
    
    TInt NotifyL(MPluginNotifier::TNotificationType aCallType, void* aParam);

public: //from MDisplay
    virtual TRect ApplicationRect();
    virtual TRect ClientRect();
    virtual TRect GetClipRect();
    virtual RWindow* GetWindow();
    virtual RWindow* GetNewVideoWindow(void* /*aClient*/) {return NULL;}
    virtual void CloseVideoWindow(void* /*aClient*/) { }    
    
#ifdef _BITBUFFER_ENABLED_     
    virtual BitmapBuffer* BitBuffer();
    virtual CFbsBitGc* GetBitmapContext();
    virtual TInt Resize(TSize aSize);
    virtual CFbsBitmapDevice* GetBitmapDevice();   
    virtual void CreateBitBuffer() 
        {
        //Do Nothing
        }
#endif    
    
public: //from MPluginView
    TBool IsValid() const;    
    TBool IsVisible() const;
    void SetClipRect(const TRect& aClipRect);
    TBool IsFLVVideo();
 
    
private:
    CFlashWlessPluginControl(MFlashPluginInstance* aInstance, CCoeControl* aParentControl);    
    void ConstructL();
    TBool IsPlayingVideo();
    void DoSetWindowL(void* aWindow);
    int DoHandleKeyEventL(NPEvent* event);
    
    TFileName               iFilename;   
    FlashEngineConfig iConfig;
    
    CFbsBitmap* iParentBitmap;
    NPWindow    iNpWindow;
    
    TBool iFlashScroll;
    TBool iBrowserScroll;

    CCoeControl* iParentControl;

};

#endif /* FLASHWLESSPLUGINCONTROL_H_ */

