/*
* Copyright (c) 2006-2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Flash Methods Handler class 
*
*/
 

#ifndef PLUGINVIEWBASE_H_
#define PLUGINVIEWBASE_H_

#include <e32err.h>

class MFlashEngine;

class MPluginViewBase 
    {
public:
   // virtual void SetWindow(NPWindow* window) =0;
    virtual int HandleEvent(NPEvent* event) =0;
    
    virtual TBool IsValid() const =0;
    virtual TBool IsVisible() const =0;
    virtual TBool IsConstructed() const =0;
    virtual TBool IsFileOpened() const =0;
    //virtual void SetClipRect(const TRect& aClipRect) =0;
    
    virtual void ChangeFLVPlayStateL(EFLVStreamState aFLVStreamState, EMediaStreamType aMediaStreamType) =0;
    virtual void SetErrorOccured(TInt aError=KErrNone) =0;
    virtual void Redraw() =0;
    
    virtual void NotifyClientError(TInt aErrorCode, TBool aIsCritical, TBool aPersistent = ETrue) =0;
    virtual void OpenFileL(const TDesC& aFilename, const TDesC* aUrl, 
                               const TBool& aFirstMovie, CContent* aContent = NULL) =0;
    
    //virtual void FLVideoStarted() =0;
    virtual void DrawDirtyRect(const TRect& aRect) =0;
    virtual TInt GetLastError() const =0;
    
    virtual TBool IsControlVisible() const =0;
    
    virtual void PrepareToExitL() =0;
    
    };
#endif /* PLUGINVIEWBASE_H_ */
