/*
* Copyright (c) 2006-2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  CFlashPluginControlFactory implementation file
*
*/

#include "saplayer_build.h"
#include "flashplugincontrolfactory.h"

#ifdef FEATURE_SCREENSAVER	
#include "FlashScreensaverControl.h"
#endif

#ifdef FEATURE_BROWSER
#include "flashbrowserplugincontrol.h"
#ifdef FEATURE_WINDOWLESS
#include "flashwlessplugincontrol.h"
#endif
#endif

#include "NPNFlashExtension.h"

#ifdef FEATURE_ANIMATION_PLUGIN
#include "flashanimcontrol.h"
#endif //FEATURE_ANIMATION_PLUGIN

#include "flashpluginif.h"

// -------------------------------------------------------------------------
// CFlashPluginControlFactory::CFlashPluginControlFactory()
//
// First phase private constructor
// --------------------------------------------------------------------------
//
CFlashPluginControlFactory::CFlashPluginControlFactory()
{
	
	
}

// ----------------------------------------------------------------------
// CFlashPluginControlFactory::CFlashPluginControlFactory()
//
// Private Destructor
// ----------------------------------------------------------------------
// 
CFlashPluginControlFactory::~CFlashPluginControlFactory()
{
	
	
	
}

// ----------------------------------------------------------------------
// CFlashPluginControl* CFlashPluginControlFactory::GetInstanceL(TInt aInteractionMode,
//													CFlashPluginInstance* aInstance)

//
// returns the plug-in control instnace
// ----------------------------------------------------------------------
//
MPluginView* CFlashPluginControlFactory::GetInstanceL(
		MFlashPluginInstance* aInstance, TWindowMode aWMode)
{
	switch (aInstance->InteractionMode())
   {
     #ifdef FEATURE_SCREENSAVER	
  		case NPScreenSaverMode:
  			{
  						/*return STATIC_CAST(PluginBase*,
  										CScreensaverPluginControl::NewL(aInstance));*/
                        return CScreensaverPluginControl::NewL(aInstance);
  							
  			}
  					//	break;
  	#endif
  	
	#ifdef FEATURE_ANIMATION_PLUGIN
	  	
   	case NPAnimPluginMode:
  	{
  				/*return STATIC_CAST(PluginBase*,
  										CAnimationPluginControl::NewL(aInstance));*/
                return CAnimationPluginControl::NewL(aInstance);
  	}
  //	break;
  	
  	#endif //FEATURE_ANIMATION_PLUGIN
  	
	default:
	{
#ifdef FEATURE_BROWSER
		switch (aWMode)
		{
		case EWindow:
			return STATIC_CAST(PluginBase*,CBrowserPluginControl::NewL(aInstance));
#ifdef FEATURE_WINDOWLESS
		case EWindowless:
		case EWindowlessOpaque:
			NPWindow windowcontrol;
			aInstance->NetscapeFns()->GetValue(NPNVnetscapeWindow,
					(void *) &windowcontrol);
			MPluginAdapter *pluginAdapter =
					(MPluginAdapter *) windowcontrol.window;
			CCoeControl* parentControl = pluginAdapter->GetParentControl();
			return STATIC_CAST(PluginBase*,CFlashWlessPluginControl::NewL(aInstance,parentControl));
#endif // FEATURE_WINDOWLESS
		}
#endif
	}
	}
	return NULL;
}

