/*
* Copyright (c) 2005 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  flash plugin header file
*
*/


#ifndef __FLASH_ANIMATION_PLUGIN_H
#define __FLASH_ANIMATION_PLUGIN_H

#include <e32std.h>
#include <DRMHelper.h>
#include "flashplugininstance.h"

/**
 * Note: Need to ensure that EPOC is defined before including these headers...
 */
#if defined(__SYMBIAN32__) && !defined(EPOC)
#define EPOC
#endif


#include <pluginadapterinterface.h>
#include "NPNFlashExtension.h"

// CONSTANTS


class FlashString;
class CPluginGlobals;
class CFlashPluginInstance;

class CAnimationPluginInstance : public CFlashPluginInstance
{
public:
    
    static CAnimationPluginInstance* NewL(MNetscapeIf* aNetscapeIf,NPFlashConfig* aConfig,
									      CPluginGlobals* aGlobals,
									      uint16 aMode,
									      TInt aInteractionMode,TPluginUiFramework aPluginUiFramework);
    
    CAnimationPluginInstance(MNetscapeIf* aNetscapeIf,NPFlashConfig* aConfig,
							 CPluginGlobals* aGlobals,
							 uint16 aMode,
							 TInt aInteractionMode);
							 
    
    virtual ~CAnimationPluginInstance();
    
    void ConstructL(TPluginUiFramework aPluginUiFramework);
    
public: //CFlashPluginInstance

 
	virtual NPFlashConfig* GetFlashconfig()
	{
		return iFlashConfig;
	}
	
	void OpenFileL(const TDesC& aFilename, const TDesC* aUrl, 
                   const TBool& aFirstMovie);
                   
    NPError HandleSetCommandL(int aVariable, void* ret_value);
    
    virtual TUint GetFeatureCapability();
    
    TUint GetFeatureCapabilityFromMode(const TUint16 aModeType);
	
private:
    void FillConfig();
    
private:    
	NPFlashConfig* iFlashConfig;
};

#endif // __FLASH_SCREENSAVER_PLUGIN_H

// End of File
