/*
* Copyright (c) 2006-2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  CFlashConfigGen header file
*
*/


#ifndef __FLASHCONFIGGEN_H
#define __FLASHCONFIGGEN_H

class MFlashEngine;
struct FlashEngineConfig;

class CFlashConfigGen : public CBase
{
public:
	static void FillFlashConfig(TInt aInteractionMode,
						        FlashEngineConfig& aConfig);
						        
    static TInt GetFlashMaxDynHeapSize(TInt aInteractionMode);
	
	static TInt GetFLVMaxDynHeapSize();
			
	private:
    CFlashConfigGen();
	~CFlashConfigGen();
			
private:
	static void FillConfigFromRepo(TInt aInteractionMode,
								   FlashEngineConfig& aConfig);
	static void FillConfigDefault(TInt aInteractionMode,
								  FlashEngineConfig& aConfig);
	
	static void FillConfigInternal(TInt aInteractionMode,
								  FlashEngineConfig& aConfig);
};

#endif
//end of file
