/*
* Copyright (c) 2005 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  browser dll initialisation code and exported functions defs
*
*/


#ifndef __FLASH_PLG_MAIN_H__
#define __FLASH_PLG_MAIN_H__

#include <e32std.h>

#if defined(__SYMBIAN32__) && !defined(EPOC)
#define EPOC
#endif

#include "saplayer_build.h"
#include "hwkeywatch.h"
#ifdef FEATURE_WEB_BROWSABILITY
#endif //FEATURE_WEB_BROWSABILITY

#include "cecombrowserplugininterface.h"
#include "netscapeif.h"

#ifdef PLUG_IN_MEM_ALLOC
class CSwfMemMgr;
#endif

class CPluginGlobals: public CBase 
{
public:
	static CPluginGlobals* NewL(); //signature changed to abstract NP APIs [Qt and S60 specific NPAPI signatures]
    void   DeletePluginGlobal();
    
    //void* NetscapeFuncs() { return iNetscapeIf->NpFuncs(); };
	///MNetscapeIf* NetscapeIf() { return iNetscapeIf; };
    CHwKeyPropertyWatch* GetHwKeyPropertyWatch() { return iHwKeyProperty;}
    
    TUint GetFreeHeapSize(TInt aInteractionMode);
    TUint GetMaxHeapSize(TInt aInteractionMode);
    void AddDynHeapAlloced(TUint aSize);
    void DynHeapFreed(TUint aSize);
#ifdef PLUG_IN_MEM_ALLOC
    CSwfMemMgr* GetMemMgr();
#endif
private:
    CPluginGlobals(); //Signature changed to abstract Q/Symbian NPAPI signatures
    void ConstructL();    
    ~CPluginGlobals();    

private:
    //MNetscapeIf*                 iNetscapeIf;
    TInt                        iResOffset;
    CHwKeyPropertyWatch*    	iHwKeyProperty;
    TInt                       iRefCnt;
    TUint                       iDynHeapSize;
#ifdef PLUG_IN_MEM_ALLOC
    CSwfMemMgr*					iSwfMemMgr;
#endif
};


class CNpEcomMain : public CEcomBrowserPluginInterface
{
public: // Functions from base classes
    static CNpEcomMain* NewL(TAny* aInitParam);
    ~CNpEcomMain();
    
private:
    CNpEcomMain(NPNetscapeFuncs* aNpf);
    void ConstructL(NPPluginFuncs* aPluginFuncs);
    
private:    
    CPluginGlobals*     iPluginGlobals;
    NPNetscapeFuncs*    iNpf;
};

/**
 * Function to load the plugin resource file 
 */
int load_pluginresourceL( TBufC<128>& aResourceFile );

#endif
