/*
* Copyright (c) 2006-2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Flash Properties Handler class 
*
*/
 

#ifndef __FLASH_PROPERTIES_H__

#define __FLASH_PROPERTIES_H__

#include <e32base.h>
#include "FlashPluginInstance.h"

#if defined(__SYMBIAN32__) && !defined(EPOC)
#define EPOC
#endif

#include <npupp.h>
#include <JavaScriptCore/npruntime.h>



class CFlashPluginInstance;

class CFlashProperties : public CBase
{
	public: 
      	static CFlashProperties* NewL(CFlashPluginInstance* aBrowserInstance);

        virtual ~CFlashProperties();	
    
    public: //methods
    
    bool GetX_POS(	const NPVariant *args, 
						uint32_t argCount, 
						NPVariant *result);
						
    bool SetX_POS(	const NPVariant *args, 
						uint32_t argCount, 
						NPVariant *result);
    
    bool GetY_POS(	const NPVariant *args, 
						uint32_t argCount, 
						NPVariant *result);
    
    bool SetY_POS(	const NPVariant *args, 
						uint32_t argCount, 
						NPVariant *result);
    
    bool GetX_SCALE(	const NPVariant *args, 
						uint32_t argCount, 
						NPVariant *result);
    
    bool SetX_SCALE(	const NPVariant *args, 
						uint32_t argCount, 
						NPVariant *result);
    
    bool GetY_SCALE(	const NPVariant *args, 
						uint32_t argCount, 
						NPVariant *result);
    
    bool SetY_SCALE(	const NPVariant *args, 
						uint32_t argCount, 
						NPVariant *result);
    
    bool GetCURRENTFRAME(	const NPVariant *args, 
						uint32_t argCount, 
						NPVariant *result);
    
    bool GetTOTALFRAMES(	const NPVariant *args, 
						uint32_t argCount, 
						NPVariant *result);
    
    bool GetALPHA(	const NPVariant *args, 
						uint32_t argCount, 
						NPVariant *result);
    
    bool SetALPHA(	const NPVariant *args, 
						uint32_t argCount, 
						NPVariant *result);
    
    bool GetVISIBILITY(	const NPVariant *args, 
						uint32_t argCount, 
						NPVariant *result);
    
    bool SetVISIBILITY(	const NPVariant *args, 
						uint32_t argCount, 
						NPVariant *result);
    
    bool GetWIDTH(	const NPVariant *args, 
						uint32_t argCount, 
						NPVariant *result);
    
    bool GetHEIGHT(	const NPVariant *args, 
						uint32_t argCount, 
						NPVariant *result);
    
    bool GetROTATION(	const NPVariant *args, 
						uint32_t argCount, 
						NPVariant *result);
    
    bool SetROTATION(	const NPVariant *args, 
						uint32_t argCount, 
						NPVariant *result);
    
    bool GetTARGET(	const NPVariant *args, 
						uint32_t argCount, 
						NPVariant *result);
    
    bool GetFRAMESLOADED(	const NPVariant *args, 
						uint32_t argCount, 
						NPVariant *result);
    
    bool GetNAME(	const NPVariant *args, 
						uint32_t argCount, 
						NPVariant *result);
    
    bool SetNAME(	const NPVariant *args, 
						uint32_t argCount, 
						NPVariant *result);
    
    bool GetDROPTARGET(	const NPVariant *args, 
						uint32_t argCount, 
						NPVariant *result);
    
    bool GetURL(	const NPVariant *args, 
						uint32_t argCount, 
						NPVariant *result);
    
    //Global properties
    bool GetHIGHQUALITY(	const NPVariant *args, 
						uint32_t argCount, 
						NPVariant *result);
    
    bool SetHIGHQUALITY(	const NPVariant *args, 
						uint32_t argCount, 
						NPVariant *result);
    
    
    bool GetFOCUSRECT(	const NPVariant *args, 
						uint32_t argCount, 
						NPVariant *result);
    
    bool SetFOCUSRECT(	const NPVariant *args, 
						uint32_t argCount, 
						NPVariant *result);
    
    bool GetSOUNDBUFTIME(	const NPVariant *args, 
						uint32_t argCount, 
						NPVariant *result);
    
    bool SetSOUNDBUFTIME(	const NPVariant *args, 
						uint32_t argCount, 
						NPVariant *result);
    
    
    
        
    private: //methods
        CFlashProperties(CFlashPluginInstance* aBrowserInstance);
        
        void ConstructL();
    
    private: //attributes
    	
    	CFlashPluginInstance* iBrowserInstance;
};


#endif //__FLASH_PROPERTIES_H__