/*
* Copyright (c) 2005 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  flash plugin header file
*
*/


#ifndef __FLASH_SCREENSAVER_PLUGIN_H
#define __FLASH_SCREENSAVER_PLUGIN_H

#include <e32std.h>
#include "FlashPluginInstance.h"

/**
 * Note: Need to ensure that EPOC is defined before including these headers...
 */
#if defined(__SYMBIAN32__) && !defined(EPOC)
#define EPOC
#endif


#include "NPNFlashExtension.h"

// CONSTANTS

class FlashString;
class CFlashScreensaverControl;
class CPluginGlobals;
class CFlashPluginInstance;
class CFlashPluginControl;

class CScreensaverPluginInstance : public CFlashPluginInstance
{
public:
    
    static CScreensaverPluginInstance* NewL(MNetscapeIf* aNetscapeIf,CPluginGlobals* aGlobals, 
                                            NPP aInstance, 
                                            uint16 aMode,
                                            TInt aInteractionMode,TPluginUiFramework aPluginUiFramework);
    
    virtual ~CScreensaverPluginInstance();
private:
    
    CScreensaverPluginInstance(MNetscapeIf* aNetscapeIf,CPluginGlobals* aGlobals, 
                               NPP aInstance, 
                               uint16 aMode,
                               TInt aInteractionMode);
    
    
    
    void ConstructL(TPluginUiFramework aPluginUiFramework);
    
public: //CFlashPluginInstance
    virtual void SetWindowL(MPluginAdapter* aPlugin, const TRect& aRect, const TRect& aClipRect);
    MPluginView* CreatePluginView(TPluginUiFramework aPluginUiFramework);

public: //MFlashPlayerControl

	virtual NPError HandleGetCommandL(NPPVariable aVariable, void* ret_value);
  	virtual NPError HandleSetCommandL(NPNVariable aVariable, void* ret_value);
  	
public: //MFlashClientIf
    virtual TUint GetFeatureCapability();
    virtual TBool CanContentBeTrustedL(const TPtrC pAccessedDomain);
    TBool AllowAMCExtension() {return EFalse;}

};

#endif // __FLASH_SCREENSAVER_PLUGIN_H

// End of File
