/*
* Copyright (c) 2005 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  plugin control header file
*
*/

#ifndef __FLASHSENDMESSAGE_H
#define __FLASHSENDMESSAGE_H
#include <sendui.h> 
#include "symbian_ui_interface.h" 

// CSender
//
// Encapsulates access to Send As messaging
// Inherits MSendAsObserver to handle call backs from CSendAs
class CSender : public CBase
{
public:
    /* IMPORT_C */ static CSender* NewL();
    virtual ~CSender();

    /* IMPORT_C */ void CreateAndEditMessageL(const TUid aMtmUid, char* address, char* bodyText);
    void CreateAndEditMessageL(const TUid aMtmUid,const TDesC& aAddress,const TDesC& aBodyText);
    //void CreateAndEditMessageL(const TUid aMtmUid, const TDesC& aAddress, const TDesC& aCc,const TDesC& aBcc, const TDesC& aSubject, const TDesC& aBodyText);
    void CreateAndEditMessageL(const TUid aMtmUid,const TMailInfo& aMailInfo);

private:

    CSender();
    void ConstructL();
    HBufC* CreateEpocStringL ( const char* str, int strlen );
    HBufC* CreateEpocStringL ( const char* text );
    TUint32 FlashStrLength ( const char* str );
    
private:
	CSendUi* iSendAppUi;
};

#endif // __FLASHSENDMESSAGE_H

// End of File
