/*
* Copyright (c) 2006-2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  CFlashPluginInstance header file
*
*/


#ifndef PLUGINMEMHANDLERIMPL_H_
#define PLUGINMEMHANDLERIMPL_H_

#include <e32base.h>
#include "pluginmemhandlerif.h"

class CPluginGlobals;
class CFlashPluginInstance;

#ifdef PLUG_IN_MEM_ALLOC
class CPluginInstanceMemInfo;
#endif

class CPluginMemHandlerImpl : public CBase, public MPluginMemHandlerIf
    {
public:
    static CPluginMemHandlerImpl* NewL(CFlashPluginInstance* aPlayerInstance);
    
    TUint GetMaxHeapSize();
    void AddDynHeapAlloced(TUint size);
    void DynHeapFreed(TUint size);
    TBool IsMemAllocSupported();
    TAny* AllocMem(TUint16 aNumBlocks);
    void FreeMem(TAny* aMemory);
    virtual ~CPluginMemHandlerImpl();
#ifdef PLUG_IN_MEM_ALLOC
    void ReAdjustMaxHeapforVideoStream(TUint aMaxHeapSize);
    
private:
    void RemoveMemHandler();   
    void AddMemHandlerL();
    
private:
    CPluginInstanceMemInfo* iInstanceMemInfo;
    TBool iAllocSupported;    
#endif  

private:
    CPluginMemHandlerImpl(CFlashPluginInstance* aPlayerInstance);
    
private:    
    CFlashPluginInstance* iPlayerInstance;
    };

#endif /* PLUGINMEMHANDLERIMPL_H_ */
