/*
* Copyright (c) 2006-2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Stream Factory Handler class
*
*/
 

#ifndef __FLASH_STREAM_FACTORY_H__
#define __FLASH_STREAM_FACTORY_H__


#if defined(__SYMBIAN32__) && !defined(EPOC)
#define EPOC
#endif

#include "commontypes.h"

//Forward declarations
class CFlashPluginStreamHandler;
class CFlashPluginInstance;
class MPluginView;

class CPluginStreamFactory : public CBase
{

	public:
	/**
     * Symbian constructor.
     *
     * @since S60 v3.1
     * @return Pointer to created CPluginMenuManager object
     */
    //static CPluginStreamFactory* NewL(CBrowserPluginControl* aCtrl);
	    static CPluginStreamFactory* NewL(CFlashPluginInstance* aPluginInstance,MPluginView* aPluginView);
   
    /**
     * Destructor.
     */
    virtual ~CPluginStreamFactory();
	
	
	private:
	
	/**
     * C++ default constructor.
     *
     * @param aCtrl CBrowserPluginControl object.
     */
    //CPluginStreamFactory(CBrowserPluginControl* aCtrl);
	    CPluginStreamFactory(CFlashPluginInstance* aPluginInstance,MPluginView* aPluginView);
    
    /**
        * By default Symbian 2nd phase constructor is private.
        */
    void ConstructL();
	
	
	public: //MPluginStreamHandler methods
	
	    virtual NPError NewStreamL(NPAPIMIMEType  /*aType*/ 
	                                ,NPAPIStreamData* /*aStream*/
	                                , NPAPIBool /*seekable*/
 								, uint16* /*stype*/);
 			
 		virtual NPError DestroyStreamL(TInt32 /*aStreamID*/
 									,NPAPIReason /*aReason*/);
 									 					
 		virtual TInt32 WriteReadyL(NPAPIStreamData* aStream);
 	
 		virtual TInt32 WriteStreamL(NPAPIStreamData* /*aStream*/
 								, TInt32 /*aOffset*/
               					, TInt32 /*aLen*/
               					, void* /*aBuffer*/);
               					
		virtual void CancelStream(TInt32 /*aStreamID*/);               					
               					
     public:           
        void SetStreamBufferSizeL(unsigned short aStreamId
        			,unsigned long aBufferSize);
               				
	private: //methods
	
		TInt FindStream(unsigned short aStreamId);
		
		
	private: //attributes
	
	    CFlashPluginInstance* iPluginInstance;
	
	    MPluginView* iPluginView;
	    
	CArrayPtr<CFlashPluginStreamHandler>*     iStreamSizeArray;
	
		
};


#endif //__FLASH_STREAM_FACTORY_H__
