/*
* Copyright (c) 2006-2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  CSwfMemMgr header file
*
*/



#ifndef __SWF_MEM_MGR_H__
#define __SWF_MEM_MGR_H__


class CPluginGlobals;
class CPluginInstanceMemInfo;
class CFlashPluginInstance;

struct CPluginInfoList
{
	CPluginInstanceMemInfo* iInstanceMemInfo;
	CPluginInfoList* iNext;
};

#define		KDLC_MAX_BLOCKS 	 (2048) 	//((KDLC_MAX_SIZE)/(KDLC_BLOCK_SIZE))
#define  	KDLC_BLOCK_SIZE 	 (32 * 1024) 	//32 KB

class CSwfMemMgr : public CBase
{
	public:
    		static CSwfMemMgr* NewL(CPluginGlobals* aGlobal, TUint aMaxAllowdHeap);
    		virtual ~CSwfMemMgr();
    private:
    		CSwfMemMgr(CPluginGlobals* aGlobal, TUint aMaxAllowdHeap);
    		void ConstructL();    
    	 	TInt FindFreeContigBlock(TUint16 aNumBlocks);
    	 	void FreeMemInfoNode();
    		
    public:
    		//func to get memory
    		//func to free memory
    		//check for candidate deletion
			void AddDynHeapAlloced(TUint aSize);
    		void DynHeapFreed(TUint aSize);
    		TAny* AllocMem(TUint16 aNumBlocks);
    		void FreeMem(TAny* aMemory,TUint16 aNumBlocks);
    		TBool IsMemUnderLimit();
    public:
    		
    		void AddPluginMemInfoL(CPluginInstanceMemInfo* aInstanceMemInfo);
    													
    		void RemoveMemInfo(CPluginInstanceMemInfo* pNode);
    		
	private: //member attribs
			CPluginGlobals* 			iGlobal;
			TUint                       iDynHeapSize;
			CPluginInfoList*			iFirst;
			CPluginInfoList*			iLast;
			RChunk*						iDlcChunk;
			TUint8						iDlcBlockFreeStats[KDLC_MAX_BLOCKS];
			TUint iMaxAllowdHeap;
			TUint						iRAMFreeCheckMark;
			
};



#endif //__SWF_MEM_MGR_H__

