/*
* Copyright (c) 2005 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  DeviceExtnImpl class implementation
*
*/


#include "deviceextnimpl.h"
#include "flashsendmessage.h"

CDeviceExtn* CDeviceExtn::NewL()
    {
    CDeviceExtn* self = new (ELeave) CDeviceExtn();
    return self;
    }

CDeviceExtn::CDeviceExtn()
    {
    }

CDeviceExtn::~CDeviceExtn()
	{
	if(iSender)
		{
		delete iSender;
		iSender = NULL;
		}
	}

void CDeviceExtn::ConstructL()
    {
    //lazy instantiation in ::SendMessage functions
    //iSender = CSender::NewL();
    }
void CDeviceExtn::SendMessage(const TUid aMtmUid, char* aAddress,
        char* aBodyText)
    {
    if (!iSender)
        { //create if not
        TRAP_IGNORE(iSender = CSender::NewL());
        }

    TRAP_IGNORE(iSender->CreateAndEditMessageL(aMtmUid, aAddress, aBodyText));
    }

void CDeviceExtn::SendMessage(const TUid aMtmUid, const TDesC& aAddress,
        const TDesC& aBodyText)
    {
    if (!iSender)
        { //create if not
        TRAP_IGNORE(iSender = CSender::NewL());
        }

    TRAP_IGNORE(iSender->CreateAndEditMessageL(aMtmUid, aAddress, aBodyText));
    }

void CDeviceExtn::SendMessageL(const TUid aMtmUid, const TMailInfo& aMailInfo, TBool /*aEmbedded*/)
   {
    if (!iSender)
        { //create if not
        TRAP_IGNORE(iSender = CSender::NewL());
        }

    TRAP_IGNORE(iSender->CreateAndEditMessageL(aMtmUid, aMailInfo));

    }
