/*
* Copyright (c) 2006-2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Flash Properties Handler class implementation
*
*/
 
#include <e32std.h>
#include "FlashProperties.h"


/**
*  CFlashProperties class
*  Flash TGetProperty,TSetProperty handler
*  Used for Javascript and Flash interaction
*  @since S60 v3.2
*/
 
CFlashProperties* CFlashProperties::NewL(CFlashPluginInstance* aBrowserInstance )
{
	CFlashProperties* self = new (ELeave) CFlashProperties(aBrowserInstance);
    CleanupStack::PushL( self );
    self->ConstructL();
    CleanupStack::Pop( self );
    return self;
}

// -------------------------------------------------------------------------
// void CFlashProperties::CFlashProperties(CFlashPluginInstance* aBrowserInstance ):
//                    void* ret_value)
// Used to Handle NP get_Val commands from client app
// --------------------------------------------------------------------------
//

CFlashProperties::CFlashProperties(CFlashPluginInstance* aBrowserInstance ):
							iBrowserInstance(aBrowserInstance)
{
	
}

// -------------------------------------------------------------------------
// void CFlashProperties::ConstructL()
// Used to Handle NP get_Val commands from client app
// --------------------------------------------------------------------------
//

void CFlashProperties::ConstructL()
{
                              
}


CFlashProperties::~CFlashProperties()
{
	
}

bool CFlashProperties::GetX_POS(	const NPVariant */*args*/, 
						uint32_t /*argCount*/, 
						NPVariant */*result*/)
{
	return false;
}
						
bool CFlashProperties::SetX_POS(	const NPVariant */*args*/, 
						uint32_t /*argCount*/, 
						NPVariant */*result*/)
{
	return false;
}
					

bool CFlashProperties::GetY_POS(	const NPVariant */*args*/, 
						uint32_t /*argCount*/, 
						NPVariant */*result*/)
{
	return false;
}

bool CFlashProperties::SetY_POS(	const NPVariant */*args*/, 
						uint32_t /*argCount*/, 
						NPVariant */*result*/)
{ 	
	return false;
}

bool CFlashProperties::GetX_SCALE(	const NPVariant */*args*/, 
						uint32_t /*argCount*/, 
						NPVariant */*result*/)
{
	return false;
}

bool CFlashProperties::SetX_SCALE(	const NPVariant */*args*/, 
						uint32_t /*argCount*/, 
						NPVariant */*result*/)
{
	return false;
}

bool CFlashProperties::GetY_SCALE(	const NPVariant */*args*/, 
						uint32_t /*argCount*/, 
						NPVariant */*result*/)
{
	return false;
}

bool CFlashProperties::SetY_SCALE(	const NPVariant */*args*/, 
						uint32_t /*argCount*/, 
						NPVariant */*result*/)
{
	return false;
}

bool CFlashProperties::GetCURRENTFRAME(	const NPVariant */*args*/, 
						uint32_t /*argCount*/, 
						NPVariant */*result*/)
{
	return false;
}

bool CFlashProperties::GetTOTALFRAMES(	const NPVariant */*args*/, 
						uint32_t /*argCount*/, 
						NPVariant */*result*/){
	return false;
}

bool CFlashProperties::GetALPHA(	const NPVariant */*args*/, 
						uint32_t /*argCount*/, 
						NPVariant */*result*/){
	return false;
}

bool CFlashProperties::SetALPHA(	const NPVariant */*args*/, 
						uint32_t /*argCount*/, 
						NPVariant */*result*/){
	return false;
}

bool CFlashProperties::GetVISIBILITY(	const NPVariant */*args*/, 
						uint32_t /*argCount*/, 
						NPVariant */*result*/){
	return false;
}

bool CFlashProperties::SetVISIBILITY(	const NPVariant */*args*/, 
						uint32_t /*argCount*/, 
						NPVariant */*result*/){
	return false;
}

bool CFlashProperties::GetWIDTH(	const NPVariant */*args*/, 
						uint32_t /*argCount*/, 
						NPVariant */*result*/){
	return false;
}

bool CFlashProperties::GetHEIGHT(	const NPVariant */*args*/, 
						uint32_t /*argCount*/, 
						NPVariant */*result*/){
	return false;
}

bool CFlashProperties::GetROTATION(		const NPVariant */*args*/, 
						uint32_t /*argCount*/, 
						NPVariant */*result*/){
	return false;
}

bool CFlashProperties::SetROTATION(	const NPVariant */*args*/, 
						uint32_t /*argCount*/, 
						NPVariant */*result*/){
	return false;
}

bool CFlashProperties::GetTARGET(	const NPVariant */*args*/, 
						uint32_t /*argCount*/, 
						NPVariant */*result*/){
	return false;
}

bool CFlashProperties::GetFRAMESLOADED(	const NPVariant */*args*/, 
						uint32_t /*argCount*/, 
						NPVariant */*result*/){
	return false;
}

bool CFlashProperties::GetNAME(	const NPVariant */*args*/, 
						uint32_t /*argCount*/, 
						NPVariant */*result*/){
	return false;
}

bool CFlashProperties::SetNAME(		const NPVariant */*args*/, 
						uint32_t /*argCount*/, 
						NPVariant */*result*/){
	return false;
}

bool CFlashProperties::GetDROPTARGET(	const NPVariant */*args*/, 
						uint32_t /*argCount*/, 
						NPVariant */*result*/)
{
	return false;
}

bool CFlashProperties::GetURL(	const NPVariant */*args*/, 
						uint32_t /*argCount*/, 
						NPVariant */*result*/)
{   return false; }

//Global properties
bool CFlashProperties::GetHIGHQUALITY(	const NPVariant */*args*/, 
						uint32_t /*argCount*/, 
						NPVariant */*result*/)
{   return false; }

bool CFlashProperties::SetHIGHQUALITY(	const NPVariant */*args*/, 
						uint32_t /*argCount*/, 
						NPVariant */*result*/)
{   return false; }


bool CFlashProperties::GetFOCUSRECT(	const NPVariant */*args*/, 
						uint32_t /*argCount*/, 
						NPVariant */*result*/)
{   return false; }

bool CFlashProperties::SetFOCUSRECT(	const NPVariant */*args*/, 
						uint32_t /*argCount*/, 
						NPVariant */*result*/)
{   return false; }

bool CFlashProperties::GetSOUNDBUFTIME(	const NPVariant */*args*/, 
						uint32_t /*argCount*/, 
						NPVariant */*result*/)
{   return false; }

bool CFlashProperties::SetSOUNDBUFTIME(	const NPVariant */*args*/, 
						uint32_t /*argCount*/, 
						NPVariant */*result*/)
{   return false; }

    
    