/*
* Copyright (c) 2006-2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Definition of the interface MHwKeyWatchObserver used to
*                observe h/w key events from CVolumePropertyWatch
*
*/


//
// JRT 22_09_04
// Version 1.0 release.

#ifndef HW_KEY__WATCH_OBSERVER_H
#define HW_KEY__WATCH_OBSERVER_H

#include "MVolumePropertyWatchObserver.h"

class MHwKeyWatchObserver: public MVolumePropertyWatchObserver
{
    public: //MVolumePropertyWatchObserver
        virtual void MHandleVolumeCmdL(TInt aNewValue) = 0;
    
    public: //Hw Key watch
	  	virtual void MPausePlayKeyPressed() = 0;
	  
	  	virtual void MStopKeyPressed() = 0;
	  
		virtual void MRewindKeyPressed() = 0;
	
		virtual void MForwardKeyPressed() =0;
			
		virtual void MBackwardKeyPressed() =0;
			
		virtual void MFastForwardKeyPressed() =0;
};

#endif

