/*
* Copyright (c) 2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:
*
*/
#ifndef FLASH_IAD_UPDATE_CALLBACK_H_
#define FLASH_IAD_UPDATE_CALLBACK_H_

#include "saplayer_build.h"

/*
 * Class        : MIadUpdateCallback
 * Description  : Provides a callback which is called after the IAD update is complete. 
 *                This interface is implemented by all controls that create the FlashEngine.
 */ 
class MIadUpdateCallback
{
public:
    /*
     * Callback function that is called once the IAD update is completed.
     */
    virtual void IADUpdateCallback( TInt aErrorCode ) = 0;
};

#endif // FLASH_IAD_UPDATE_CALLBACK_H_
