/*
* Copyright (c) 2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:
*
*/
/*
 * flashbitbuffer.h
 *
 *  Created on: Jul 28, 2009
 *      Author: vsriram
 */

#ifndef FLASHBITBUFFER_H_
#define FLASHBITBUFFER_H_

#include <e32def.h>
#include <e32cmn.h>
#include <fbs.h>
#include <bitdev.h>
#include <bitstd.h>

//#include "Display.h"

class BitmapBuffer
    {
public:
    virtual void SetSize(TSize aSize,TBool aRefresh=EFalse) =0;
    virtual void* Lock() = 0;
    virtual void Unlock( TAny* aBitmap ) =0;
    virtual void Free() =0;
    virtual TBool IsSurfaceValid() =0;
    virtual TBool IsLocked() =0;
    virtual void Clear() =0;
    };

class CFlashBitmap : public BitmapBuffer , public CBase
    {
public:
    static CFlashBitmap* NewL(CFbsBitmap* aBitmap=NULL);
    
    //in windowless mode, a different bitmap pointer
    //could be passed by browser
    inline void UpdateBitmap(CFbsBitmap* aBitmap) {iBitmap=aBitmap;}
    inline void TransferOwnership() {iDoIOwnBitmap=ETrue;}
    
    virtual ~CFlashBitmap();
    
    //CFbsBitmap* 
    
public: //from BitBuffer
    virtual void* Lock();
    virtual void Unlock( TAny* /*aBitmap*/ );
    virtual void Free();
    virtual TBool IsSurfaceValid();
    virtual TBool IsLocked();
    virtual void Clear();
    
    virtual void SetSize(TSize aSize, TBool aResize=EFalse);

private:
    CFlashBitmap(CFbsBitmap* aBitmap=NULL);
private:    
    CFbsBitmap* iBitmap;   
    CFbsBitGc* iBitmapGc;
    CFbsBitmapDevice* iBitmapDevice;
    TBool iIsBitmapLocked;
    TBitmapUtil* iBitmapUtil;
    TSize iBitmapSize;
    
    TBool iDoIOwnBitmap;
    };

#endif /* FLASHBITBUFFER_H_ */
