/*
* Copyright (c) 2006-2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  This class is used to notify client whenever sliding keypad 
*                status(ON/OFF) changes.
*
*/


#ifndef __KEYPADHANDLER_H__
#define __KEYPADHANDLER_H__

#include <e32base.h>
#include <e32property.h> // for RProperty

class MQwertyKeypadObserver
{
public:
	virtual void HandleQwertyModeChangeNotification(TInt aQwertyMode) = 0;
};


class CKeypadHandler : public CActive
{
public:
    CKeypadHandler(MQwertyKeypadObserver& aObserver, RProperty& aProperty);
    ~CKeypadHandler();

public: // New functions
    void SubscribeL();
    void UnSubscribe();
    TInt GetQwertMode();

private: // from CActive
    void RunL();
    void DoCancel();

private:
 	MQwertyKeypadObserver& iObserver;
    RProperty&  iProperty;
};

#endif // __KEYPADSUBSCRIBER_H__