/*
* Copyright (c) 2002-2004 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  AO that completes on a change in the volume property.  Used for 
*                the new Central Repository Server.  Used in EKA2 builds only
*
*/


//
// JRT 22_09_04 ver 1.0 release.

#ifndef CFLASH_VOLUME_PROPERTY_WATCH
#define CFLASH_VOLUME_PROPERTY_WATCH

#include <e32std.h>
#include <e32base.h>
#include <e32property.h>

//
// for emulator max volume = 65535
#define WINS_DEFAULT_VOLUME 43690

//
// For HW max volume = 9
#define HW_DEFAULT_VOLUME 6

#include <centralrepository.h>

class MVolumePropertyWatchObserver;

class CVolumeCenRepKeyWatcher : public CActive
	{
public:
	enum TPropertyWatchState
	{
		EConnected = 1,
		EUnableToConnect,
		ENoConnect
	};
	
	static CVolumeCenRepKeyWatcher* NewL(MVolumePropertyWatchObserver* aObserver,
										TBool aConnect=ETrue);
    virtual ~CVolumeCenRepKeyWatcher();
    TInt GetCurrentVolume();
    TInt SetCurrentVolume(TInt aVolume);
                                   
private:
	CVolumeCenRepKeyWatcher(	TBool aConnect=ETrue);
	void ConstructL(MVolumePropertyWatchObserver* aObserver,TBool aConnect=ETrue);
	TInt GetDefaultVolume();

//From CActive	
    void RunL();	
    void DoCancel();	
	

	CRepository* iCenRepos;

    TPropertyWatchState iState;
	
    MVolumePropertyWatchObserver* iObserver;
	};

#endif
