/*
* Copyright (c) 2005 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Implements the member functions of the class that provides a 
*				 mechanism for priming a timer using CTimer functionality, and 
*				 receiving a callback in the owning class.
*
*/


#include "platformbuild.h"		// Warning: this *must* the first include of every source file.
								//			It contains all the #define build parameters.
#include "saplayer_build.h"
#include "browserplugintimer_object.h"


#include <e32std.h>


CPlgTimerObject* CPlgTimerObject::NewL(TInt aPriority, MPlgAsyncHandler& aHandler)
{
    CPlgTimerObject* self = new(ELeave) CPlgTimerObject(aPriority, aHandler);
	CleanupStack::PushL(self);
	self->ConstructL();
	CleanupStack::Pop(self);
	return self;
}

CPlgTimerObject::~CPlgTimerObject()
{
	Cancel();
}

CPlgTimerObject::CPlgTimerObject(TInt aPriority, MPlgAsyncHandler& aHandler)
:CTimer(aPriority), iHandler(aHandler)
{
	CActiveScheduler::Add(this);
}

void CPlgTimerObject::RunL()
{
	iHandler.DoRunL(this);
}

TInt CPlgTimerObject::RunError(TInt aError)
{
	return iHandler.DoRunError(this,aError);
}
