/*
* Copyright (c) 2005 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Defines the dummy ccoecontrol(window) to hold a external surface
                 in NGA
*
*/


#include "saplayer_build.h"
#include "surfacecontainercontrol.h"

CSurfaceContainerControl* CSurfaceContainerControl::NewL(RWindowTreeNode* aParent, TRect rect) 
{
    CSurfaceContainerControl* ptr = new (ELeave) CSurfaceContainerControl();
    CleanupStack::PushL(ptr);
    ptr->ConstructL(aParent, rect);
    CleanupStack::Pop();
    return ptr;
}

void CSurfaceContainerControl::ConstructL(RWindowTreeNode* aParent, TRect rect)
{
    CreateWindowL(*aParent);
    SetRect(rect);
    ActivateL();        
}    

RWindow& CSurfaceContainerControl::GetWindow() 
{
    return Window();
}

void CSurfaceContainerControl::Draw(const TRect& aRect) const
{
    CWindowGc& gc = SystemGc();

#if 1
    gc.SetDrawMode(CGraphicsContext::EDrawModeWriteAlpha);  
    gc.SetBrushColor(TRgb(0,0,0,0));
    gc.SetBrushStyle(CGraphicsContext::ESolidBrush);
    gc.DrawRect(aRect);
#else    
    gc.SetDrawMode(CGraphicsContext::EDrawModePEN);
    gc.SetBrushColor(KRgbGreen);        
    gc.SetBrushStyle(CGraphicsContext::ESolidBrush);
    gc.DrawRect(aRect);
    
    TRect subRect = aRect;
    //subRect.iTl.iX += 40;
    //subRect.iTl.iY += 40;
    subRect.Shrink(40,40);
    gc.SetDrawMode(CGraphicsContext::EDrawModeWriteAlpha);           
    gc.SetBrushColor(TRgb(0,0,0,0));        
    gc.DrawRect(subRect);           
#endif    
    
#ifdef SYMBIAN_BUILD_GCE
    ControlEnv()->WsSession().Finish();
#endif     
}

CSurfaceContainerControl::CSurfaceContainerControl() 
{ 
}
