/*
* Copyright (c) 2007-2008 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Represents a security/permissions session for a content.
 *
*/


#ifndef __FLASHRTPOLICYCONTENTSESSION_H__
#define __FLASHRTPOLICYCONTENTSESSION_H__

#include <e32base.h>

class CRTSecMgrScriptSession;

class MFlashRTPolicyContentSession
    {
public:    
	/**
	 * API to fetch the underlying security manager script session 
	 *
	 * @return CRTSecMgrScriptSession*   Security manager script session.
	 */
    virtual CRTSecMgrScriptSession& Session() = 0;
    
	/**
	 * Destructor
	 *
	 * Deletes the underlying script session.
	 *
	 */    
    virtual ~MFlashRTPolicyContentSession() {};
    };

#endif //__FLASHRTPOLICYCONTENTSESSION_H__
