/*
* Copyright (c) 2007-2008 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Represents a security/permissions session for a content
 *
*/

 
#ifndef __FLASHRTPOLICYCONTENTSESSIONIMPL_H__
#define __FLASHRTPOLICYCONTENTSESSIONIMPL_H__

#include <e32base.h>

#include "flashrtpolicycontentsession.h"
#include "flashrtpolicycontentsessionimpl.h"

class CRTSecMgrScriptSession;

class CFlashRTPolicyContentSessionImpl : public CBase, public MFlashRTPolicyContentSession
    {
public:
	/**
	 * Two-phased constructor
	 * 
	 * Constructs a CFlashRTPolicyContentSessionImpl instance
	 *
	 * 
	 * @return pointer to an instance of CFlashRTPolicyContentSessionImpl
	 */  
    static MFlashRTPolicyContentSession* NewLC(CRTSecMgrScriptSession* aSMScriptSession);
    
	/**
	 * Two-phased constructor
	 * 
	 * Constructs a CFlashRTPolicyContentSessionImpl instance
	 *
	 * 
	 * @return pointer to an instance of CFlashRTPolicyContentSessionImpl
	 */      
    static MFlashRTPolicyContentSession* NewL(CRTSecMgrScriptSession* aSMScriptSession);    
    
	/**
	 * API to fetch the underlying security manager script session 
	 *
	 * @return CRTSecMgrScriptSession*   Security manager script session.
	 */    
    virtual CRTSecMgrScriptSession& Session();
    
	/**
	 * Destructor
	 *
	 * Deletes the underlying script session.
	 */    
    ~CFlashRTPolicyContentSessionImpl();
    
private:
    //Private constructor
    CFlashRTPolicyContentSessionImpl(CRTSecMgrScriptSession* aSMScriptSession);
    
    //Second phase constructor
    void ConstructL();

private:
    //Security manager script session
    CRTSecMgrScriptSession* iSMScriptSession;
    };


#include "flashrtpolicycontentsessionimpl.inl"

#endif //__FLASHRTPOLICYCONTENTSESSIONIMPL_H__
