/*
* Copyright (c) 2006 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Defines the class that provides ATS Mode Functionalities
*
*/



#ifndef __ATSHANDLER_H__
#define __ATSHANDLER_H__


#include "flashliteinterfaces.h"
#include "symbian_tihost.h"

typedef void*	(*PFNC_ATSTEST_GETINTERFACE) (EATSTestInterfaceIndex);

class CPlatformFlashEngine;

/**
 * The CATSHandler class provides functions that implements ATS Mode functionalities.
 */
class CATSHandler : public CBase
{
public:
	static CATSHandler* NewL(CPlatformFlashEngine* aEngine);
	virtual ~CATSHandler();				
private:
	CATSHandler(CPlatformFlashEngine* aEngine);
	void ConstructL();

public: //CATSHandler methods
	
	void LoadATSLibraryL(SI_Fncs* aATSFunction,SI_Fncs* aSIFunctions);
	void SetUpATSLibrary(struct MM_Object* aMMObject,unsigned long afiConfigFlags);
	void UnLoadATSLibrary();

	static TInt ATSRefreshScreen(TAny *data);
	
private:

	RLibrary 					iATSTestLibrary;
	PFNC_ATS_SETUPTESTLIBRARY 	iATS_SetupTestLibrary;
	PFNC_ATSTEST_GETINTERFACE	iFncGetInterface;
	CPlatformFlashEngine* iFlashEngine;
	CPeriodic* iPeriodicTimer;
};

#endif // __ATSHANDLER_H__
