/*
* Copyright (c) 2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:
*
*/
#ifndef AUTOMATIONHELPER_H_
#define AUTOMATIONHELPER_H_

#include "saplayer_build.h"
#include <eikenv.h>
#include <f32file.h>
#include <w32std.h>
#include <e32event.h>
#ifdef FEATURE_TESTAUTOMATION

typedef TPtr8 Buffer;
typedef TPtr FilePath;
typedef HBufC8* OutputFilePath;

struct FileInfo
    {
    FilePath filePath;
    TFileMode mode;
    Buffer buffer;
    
    FileInfo(FilePath aFilePath,Buffer aBuffer, TFileMode aMode=EFileRead)
        :buffer(aBuffer),filePath(aFilePath),mode(aMode)
        {
        }
    };

#endif

/*
 * Utility class for automation purposes
 */
class AutomationHelper
    {
#ifdef FEATURE_TESTAUTOMATION
public:
    static TInt WriteToFile(const FileInfo& aFileInfo);
    static void GenerateMouseEvent(TRawEvent aEvent);
    static TInt GenerateKeyEvent(TKeyEvent aEvent,TEventCode aCode);    
private:    
    static const TDesC8& RootDir();
#endif
    };

#endif /* AUTOMATIONHELPER_H_ */
