/*
* Copyright (c) 2006 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Defines the constants.
*
*/


#ifndef _ENGINE_DEFS_H_
#define _ENGINE_DEFS_H_

#include <languages.hrh>
#include "commondef.h"

// TODO: Hard-code these for now.. these should be configurable in .INI file or something
/*
const TUint32 KMaxPersistentStoragePerMovie	= 4*1024;	// 4k
const TUint32 KMaxPersistentStorage			= 4*1024*1024;	// 4MB
*/
const TUint32 KMaxPersistentStoragePerMovie = 64*1024;    // 64k
const TUint32 KMaxPersistentStoragePerMode  = 4*1024*1024;  // Changing to 4MB from 1MB - to store 16 main movie

const TInt KMemoryBlockSize = 32768;

#define PROTOCOL_NONE	0
#define PROTOCOL_HTTP	1
#define PROTOCOL_FILE	2
#define PROTOCOL_RTSP	3
#define PROTOCOL_SYMBOL	4
#define PROTOCOL_REFERENCE 5
const TInt KfiConfigFlags = (  FI_UseUTF16EncodingForm | FI_DynamicMemAvailable
#ifdef FEATURE_GCDEMAND									
								| FI_GcDemand
#endif //FEATURE_GCDEMAND
									);
const TInt KMPOneSecond(1000000);



_LIT(KLitSpace," ");



// format for output of data/time values
_LIT(KDateFormat,"%D%M%Y%/0%1%/1%2%/2%3%/3 %:0%H%:1%T%:2%S.%C%:3");

// Standard headers used by default
_LIT8(KUserAgent, "Mozilla/4.78 (Symbian OS; U) FlashPlayer/7.1");
_LIT8(KAccept, "*/*");
const TInt KMaxHeaderNameLen = 32;


// message format
enum {
	ESMTP = 0,
	ESMS,
	EMMS
};

enum {
	EPlayerOK = 0,
	EPlayerStoppedError = 1
};

const TInt SI_InvalidFormatError = -2;

enum {
	EChangeScreenNull = 0,
	EChangeScreenFullScreen,
	EChangeScreenAppScreen,
	EChangeScreenSetSoftkeys,
	EChangeScreenResetSoftkeys
};

enum {
	EAllow_NotSet = 0,
	EAllow_Allow = 1,
	EAllow_Deny = 2,
	EAllow_Pending = 3
};

const TInt KUidGprsAvailabilityValue = 0x100052DA;
const TUid KUidGprsAvailability = {KUidGprsAvailabilityValue};

enum TSAGprsAvailability
{
	ESAGprsAvailable,
	ESAGprsNotAvailable,
	ESAGprsAvailabilityUnknown
};

const TInt KUidGprsStatusValue = 0x100052DB;
const TUid KUidGprsStatus = {KUidGprsStatusValue};
enum TSAGprsStatus
{
	ESAGprsUnattached,
	ESAGprsAttached,
	ESAGprsContextActive,
	ESAGprsSuspend,
	ESAGprsContextActivating
};

enum
{
	ELangTaiwanEnglish = KLangTaiwanEnglish,
	ELangHongKongEnglish = KLangHongKongEnglish,
	ELangPrcEnglish = KLangPrcEnglish,
	ELangJapaneseEnglish = KLangJapaneseEnglish,
	ELangThaiEnglish = KLangThaiEnglish,
	ELangApacEnglish = KLangApacEnglish,
	ELangApacMalay = KLangApacMalay,

#ifdef __S60_32__

ELangBasque = KLangBasque,
ELangGalician = KLangGalician,

#endif

	
	ELangApacIndonesian = KLangApacIndonesian
};

// The undocument UID for TIS_620 (Thai) character conversion
const TUint KCharacterSetIdentifierTis620=0x101F8549;

//Network connection status
enum
{
	ENetStatConnected = 0,
	ENetStatConnecting,
	ENetStatDisConnected,
	ENetStatSuspended, 
    ENetStatIndeterminable
};

const TInt KMillisecondsInSecond = 1000;
const TInt KMicrosecondsInMillisecond = 1000;
const TInt KMicrosecondsInSecond = 1000000;

const TInt KSoftKeyLocationTop = 0;
const TInt KSoftKeyLocationLeft = 1;
const TInt KSoftKeyLocationBottom = 2;
const TInt KSoftKeyLocationRight = 3;

// Ascii code for zero
const TInt KAsciiZero = 48;
#endif // _ENGINE_DEFS_H_