/*
* Copyright (c) 2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Watches GPU memory status and handles low GPU situation
*
*/


#ifndef __GPUMEMWATCH_H__
#define __GPUMEMWATCH_H__

#include <e32base.h>
#include <e32cons.h>
#include <e32property.h>

class MGPUMemStatusNotifier
{
public:
    virtual void GPUMemoryLow(TBool aLow) = 0;
};

class CGPUMemWatch : public CActive
    {
public:
    static CGPUMemWatch* NewL(MGPUMemStatusNotifier* aWatch);
    ~CGPUMemWatch();
    
    //Start receiving GPU memory status broadcast from flash goom plugin 
    void WatchL();

protected:
    CGPUMemWatch(MGPUMemStatusNotifier*);
    void ConstructL();
    
    //From CActive
    void RunL();
    void DoCancel();
    
private:
    void IssueRequest();    
    
private:
    // Property to get gpu memory stauts broadcast from flash goom plugin
    RProperty iProperty;
    MGPUMemStatusNotifier* iObserver;
    };
    
#endif
