/*
* Copyright (c) 2005 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Defines the CFlhItemValuePairList class.
*
*/


#ifndef __ITEM_VALUE_PAIR_LIST_H__
#define __ITEM_VALUE_PAIR_LIST_H__

#include <e32std.h>
#include <eikenv.h>

struct TFlhKeyAndValue
{
	HBufC* iKey;
	HBufC* iValue;
};

class CFlhItemValuePairList : public CBase
{
public:
	static CFlhItemValuePairList* NewLC(CEikonEnv& aEnv, TInt aArrayResId);
	~CFlhItemValuePairList();

private:
	CFlhItemValuePairList(TInt aArrayResId);
	void ConstructL(CEikonEnv& aEnv);

public:
	TInt Id() const;
	const TPtrC ValueForKeyL(const TDesC& aKey) const;

private:
	CArrayFixFlat<TFlhKeyAndValue>* iKeyAndValue;
	TInt iId;
};



#endif // __ITEM_VALUE_PAIR_LIST_H__