/*
* Copyright (c) 2006-2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  CFlashConfigGen header file
*
*/


#ifndef __PLATFORMCONFIG__
#define __PLATFORMCONFIG__

#include <e32base.h>
#include "saplayer_build.h"

const TUint KMaxDrvLength=4;
class CPlatformConfig: public CBase
{
public:
   
	CPlatformConfig();
	~CPlatformConfig();
	
private:	

#ifdef FEATURE_FLV_MMC	
 	    TUint32 iMMCResHighWatermark;
		TUint32 iMMCResLowWatermark;
		TUint32 iMMCResUsagePolicy;
		TUint32 iRAMResLowWatermark;
		TUint32 iRAMResHighWatermark;
		TUint32 iMMCResvUnUtilisedSpace;
		#ifdef FEATURE_MULTIPLE_DRIVE
		TUint32	iMMCDriveOverridePolicy;
		#endif
		
#endif  //FEATURE_FLV_MMC
		TUint32 iFlashRAMResvUnUtilisedSpace;
		TUint32 iVideoDynHeapSize;
		TUint32 iFLVMaxFramesToDecodePerInterval;
		
		TBuf<KMaxDrvLength> iVideoResDrive;

			
					
	 void FillConfigFromRepoEngineData();
public:

	   	TInt GetFLVMaxDynHeapSize();
#ifdef FEATURE_FLV_MMC		   	
		TReal GetMMCResHighWatermark();	

		TReal GetMMCResLowWatermark();

		TInt GetMMCResUsagePolicy();
		
		TReal GetRAMResLowWatermark();
		
		TReal GetRAMResHighWatermark();
		
		TInt GetMMCResvUnUtilisedSpace();
			
		TDesC& GetVideoResDrive();
		
		
#endif //FEATURE_FLV_MMC

		#ifdef FEATURE_MULTIPLE_DRIVE
		TInt GetMMCDriveOverridePolicy();
		#endif	
				
		TInt GetFlashRAMResvUnUtilisedSpace();
		
		TInt GetFLVMaxFramesToDecodePerInterval();	   	
	   	  	   	 	
	   	TInt GetVideoDynHeapSize();
			
};	

#endif 
