/*
* Copyright (c) 2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:
*
*/
/*
 * sharedmemory.h
 *
 *  Created on: Oct 25, 2009
 *      Author: vsriram
 */

#ifndef SHAREDMEMORYCLIENT_H_
#define SHAREDMEMORYCLIENT_H_

#include <e32std.h>
#include <e32base.h>
#include <string.h>

typedef unsigned long LockId;
class CFlashRTPolicyClient;

#ifdef SHARED_MEMORY_INTER_PROCESS

class CSharedMemoryClient : public CBase
    {
public:
    static CSharedMemoryClient* NewL(const char* aName, const char* aLockName, unsigned long aSize);
    LockId LockHandle();
    void* BaseAddress();
    TInt Lock();
    TInt Unlock();
    TInt DeleteSharedMemory();
    ~CSharedMemoryClient();

private:
    CSharedMemoryClient();
    void ConstructL(const char* aName, const char* aLockName, unsigned long aSize);

    CFlashRTPolicyClient* iPolicyClient;
    RChunk iChunk; //client side handle of the global chunk
    LockId iLockId;
   };

#endif //SHARED_MEMORY_INTER_PROCESS

#endif /* SHAREDMEMORYCLIENT_H_ */
