/*
* Copyright (c) 2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:
*
*/
/*
 * sharedmemorymanager.h
 *
 *  Created on: Oct 25, 2009
 *      Author: vsriram
 */

#ifndef SHAREDMEMORYMANAGER_H_
#define SHAREDMEMORYMANAGER_H_

#include <e32cmn.h>
#include "sharedmemoryclient.h"

class CSharedMemoryManager : public CBase
    {
public:
    static CSharedMemoryManager* CreateInstanceL();
    CSharedMemoryClient* CreateSharedMemoryL(const char* name,
            const char* lockName,
            unsigned long size);

    ~CSharedMemoryManager();

    TInt DeleteSharedMemory(LockId lockId);

    TInt Lock(LockId aLockId);
    TInt Unlock(LockId aLockId);
private:
    CSharedMemoryManager(){}


    RPointerArray<CSharedMemoryClient> iSharedMemorySegments;
    };

#endif /* SHAREDMEMORYMANAGER_H_ */
