/*
* Copyright (c) 2007 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  defines the member functions of the class that is used to 
*				 access battery status and strength information.
*
*/


#ifndef __SYMBIAN_PHONE_BATTERY_INFO_H__
#define __SYMBIAN_PHONE_BATTERY_INFO_H__


#include <e32base.h>
#include <etel3rdparty.h>


class CPhoneBatteryInfo : public CActive
    {
    	public:
    				CPhoneBatteryInfo();
    				static CPhoneBatteryInfo* NewL();
					virtual ~CPhoneBatteryInfo();
					
 	  	public:
 	  				TUint GetBatteryChargeLevel();
 	  				TBool GetBatteryChargeStatus();
 	  				
		protected:	// from CActive
					void DoCancel();
					void RunL();
					
		private:
				
					void ConstructL();
					void ListenL();
					TUint GetBatteryChargeLevelL();
					TBool GetBatteryChargeStatusL();
		private:
    				CTelephony* iTelephony;
   					CTelephony::TBatteryInfoV1 iBatteryInfoV1;
    				CTelephony::TBatteryInfoV1Pckg iBatteryInfoV1Pckg;
    				CActiveSchedulerWait* iWait;


    };	


#endif //__SYMBIAN_PHONE_BATTERY_INFO_H__



