/*
* Copyright (c) 2007 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Defines the member functions of the class that is used to 
*				 keep backlight ON.
*
*/


#ifndef __SYMBIAN_BACKLIGHT_HANDLER_H__
#define __SYMBIAN_BACKLIGHT_HANDLER_H__

#include "async_object.h"
#include "timer_object.h"
class CBackLightHandler : public CBase
                          , public MFlhAsyncHandler
{
	public:
			CBackLightHandler();
			static CBackLightHandler* NewL();
			virtual ~CBackLightHandler();
	
	public: //MFlhAsyncHandler
	    virtual void DoRunL(const CActive* aActive);
	    virtual TInt DoRunError(const CActive* aActive, TInt aError);
	    
	public:
			TInt ExtendBacklight(TUint16 aDuration);
						
	private:
			void ConstructL();			
			void DeleteTimer();

	private:
		    TInt iBacklightExtensionDelay;
		    CFlhTimerObject* iBacklightExtensionTimer;
};

#endif//__SYMBIAN_BACKLIGHT_HANDLER_H__