/*
* Copyright (c) 2006 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Defines the class that provides static functions for media recognition purposes
*
*/



#ifndef __SYMBIAN_MEDIARECOGNIZER_H__
#define __SYMBIAN_MEDIARECOGNIZER_H__

class CPlatformFlashEngine;

class MediaRecognizer
{
public:

	enum TDataType
	{
		EAudio = 0,
		EVideo
	};

	static TBool CreateFilenameFromData(TFileName& aFileName, void* aData, unsigned long aDataLen, TDataType aDataType);

	static 	TBool CreateFilenameFromMMFDataL(CPlatformFlashEngine* aEngine
								,TFileName& aFileName
								, void* aData
								, unsigned long aDataLen);
	
	static 	char** GetMMFsupportedFormatsL(CPlatformFlashEngine* aEngine
										,TInt& aCount, TBool aSelectAudio
										, TInt aResourceId);
	
	static  char** GetImageDecoderSupportedFormatsL(CPlatformFlashEngine* aEngine
											,TInt& aCount);
private:

	static TBool IsAACData(const TAny* aData, TInt aSize);
	static TBool IsMP3Data(const TAny* aData, TUint32 aSize);


};

#endif /*SYMBIAN_MEDIARECOGNIZER*/