/*
* Copyright (c) 2005 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Defines the class used to support the SI_GetNetworkInfo() and 
*				 SI_GetNetworkInfoString() Flash Lite API functions. It is used 
*				 to retrieve information about the active network.
*
*/


#ifndef __SYMBIAN_NETWORKINFO_H__
#define __SYMBIAN_NETWORKINFO_H__

#ifdef FEATURE_PACK_3

#include <e32base.h>
#include <etel3rdparty.h>

/**
 * The CNetworkInfo class is used to support the SI_GetNetworkInfo() and SI_GetNetworkInfoString()
 * Flash Lite API functions. It is used to retrieve information about the active network.
 * 
 */
class CNetworkInfo : public CActive
{
public:
	static CNetworkInfo* NewL();
    CNetworkInfo();
    virtual ~CNetworkInfo();
    TBool GetNetworkInfoL(unsigned short aInfoType, TDes8& aRetString);
    TBool GetNetworkInfo(unsigned short aInfoType, TDes8& aRetString);
    TBool GetNetworkInfoL(unsigned short aInfoType, long& aRetString);
    TBool GetNetworkInfo(unsigned short aInfoType, long& aRetString);

private:
	
	CTelephony* iTelephony;
    CTelephony::TNetworkInfoV1 iNetworkInfoV1;
    CTelephony::TNetworkInfoV1Pckg iNetworkInfoV1Pckg;
	CActiveSchedulerWait* iWait;

    
private:
		void ConstructL();
		void ListenL();
		
protected:	// from CActive
	void DoCancel();
	void RunL();
	
};


#endif //FEATURE_PACK_3

#endif	// __SYMBIAN_NETWORKINFO_H__
