/*
* Copyright (c) 2007 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  defines the member functions of the class that is used to 
*				 access phone version information.
*
*/


#ifndef __SYMBIAN_PLATFORM_INFO_H__
#define __SYMBIAN_PLATFORM_INFO_H__

//forward declaration
class CPlatformFlashEngine;

class CPlatformInfo : public CBase
{
	public:
    				CPlatformInfo(CPlatformFlashEngine* aEngine);
    				static CPlatformInfo* NewL(CPlatformFlashEngine* aEngine);
					virtual ~CPlatformInfo();
					
	public:
	
				const TDesC& GetOSInfoL();
				const TDesC& GetOSInfo(); //non leaving function
				
	private:
				
				void ConstructL();	
				
				void FindOSInfoL();
				
	private:
				CPlatformFlashEngine* iEngine;//not owned
				HBufC* iPlatformName;					
				TPtr	iPlatNamePtr;
};

#endif //__SYMBIAN_PLATFORM_INFO_H__

