/*
* Copyright (c) 2005 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Defines the class used to access network registration status .
*
*/


#ifndef __SYMBIAN_REGISTRATIONSTATUS_H__
#define __SYMBIAN_REGISTRATIONSTATUS_H__

#include <e32base.h>
#include <etel3rdparty.h>


#ifdef FEATURE_PACK_3


class CRegistrationStatus : public CActive
{
public:
	static CRegistrationStatus* NewL();
    CRegistrationStatus();
    virtual ~CRegistrationStatus();
    
public:
    
    TBool GetRegistrationStatusL(unsigned short aInfoType, long& aRetVal);
    TBool GetRegistrationStatus(unsigned short aInfoType, long& aRetVal);
    
protected:	// from CActive
				void DoCancel();
				void RunL();

private:
		void ConstructL();
		void ListenL();
private:
		CTelephony* iTelephony;
	    CTelephony::TNetworkRegistrationV1 iNetworkRegistrationV1;
    	CTelephony::TNetworkRegistrationV1Pckg iNetworkRegistrationV1Pckg;
    	CActiveSchedulerWait* iWait;
				
};


#endif FEATURE_PACK_3

#endif	// __SYMBIAN_REGISTRATIONSTATUS_H__
