/*
* Copyright (c) 2005 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Declares the string utility functions.
*
*/


#ifndef __CSTRING_H__
#define __CSTRING_H__

#include "platformclib.h"
#include <e32base.h>

// a bunch of string utility functions

bool  ToU32(const char* c, U32* pResult);
U32	  ToU32(const char* c);
TUint32 ToU32(const TDesC& aString);
inline int ToInt(const char* c) { return (c == NULL) ? 0 : (*c == '-') ? -(int)ToU32(c+1) : ToU32(c); }
char* CreateStr(const char* s);
TBool StripPrefix(const TDesC& aInput, const TDesC& aPrefix, TPtrC& aStripped);
char* StripPrefix( const char* str, const char* pre);
TInt GetProtocolFromURL(const TDesC& aUrl);
TBool ComparePrefix(const TDesC& aStr, const TDesC& aPrefix);
char* StrChr( const char* str, int ch );
void ReplaceAll(TDes8& aDes8, char aFind, char aReplace);
void ReplaceAll(TDes16& aDes16, TChar aFind, TChar aReplace);
char* ReAllocString(const char* aCurrentZtString, const char* aNewData, int aNewDataLen);
HBufC* URLEncodePostDataLC(TDesC8& aData);

_LIT(KSchemeHTTP, "http://");
_LIT(KSchemeFile, "file://");
_LIT(KSchemeSymbol, "symbol://");
_LIT(KSchemeRTSP, "rtsp://");
_LIT(KSchemeReference, "reference:");
_LIT(KSchemeNET, "opennet://");

#endif	// __CSTRING_H__
