/*
* Copyright (c) 2005 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Defines the class that is used to access subscriber information.
*
*/


#ifndef __SYMBIAN_SUBSCRIBERINFO_H__
#define __SYMBIAN_SUBSCRIBERINFO_H__

#ifdef FEATURE_PACK_3

#include <e32base.h>
#include <etel3rdparty.h>

class CSubscriberInfo : public CActive
{
public:
	static CSubscriberInfo* NewL();
    CSubscriberInfo();
    ~CSubscriberInfo();

public:    
    TBool GetSubscriberInfoL(unsigned short aInfoType, TDes8& aRetString);
    TBool GetSubscriberInfo(unsigned short aInfoType, TDes8& aRetString);
    
private:
		void ConstructL();
		void ListenL();
protected:	// from CActive
		void DoCancel();
		void RunL();

private:
	CTelephony* iTelephony;
	CTelephony::TSubscriberIdV1 iSubscriberIdV1;
	CTelephony::TSubscriberIdV1Pckg iSubscriberIdV1Pckg;		
    
};


#endif FEATURE_PACK_3

#endif	// __SYMBIAN_SUBSCRIBERINFO_H__
