/*
* Copyright (c) 2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:
*
*/

#include "automationhelper.h"


#ifdef FEATURE_TESTAUTOMATION

//create a file  in the predefined path [name of the file is aFileInfo.filePath]
//
//

TInt AutomationHelper::WriteToFile(const FileInfo& aFileInfo)
    {
    RFs session = CEikonEnv::Static()->FsSession(); //inefficient..ok for test automation..
    
    RFile file;    
    TInt err(file.Create(session, aFileInfo.filePath, (TUint) aFileInfo.mode));
    
    if (KErrAlreadyExists == err)
    	err = file.Open(session, aFileInfo.filePath, (TUint) aFileInfo.mode);

    if (KErrNone == err)
   		{ 
    	TInt offset(0);
    	err = file.Seek(ESeekEnd, offset);
        err = file.Write(aFileInfo.buffer);
        file.Close();
        }

    return err;
    }


void AutomationHelper::GenerateMouseEvent(TRawEvent aEvent)
    {
    CCoeEnv::Static()->RootWin().SimulatePointerEvent(aEvent);
    }

TInt AutomationHelper::GenerateKeyEvent(TKeyEvent aEvent,TEventCode aCode)
    {
    TRAPD(err,CCoeEnv::Static()->SimulateKeyEventL(aEvent, aCode));
    return err;
    }

#endif //FEATURE_TESTAUTOMATION
