/*
* Copyright (c) 2006 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Implements the member functions of the class which implements the
*								 host engine resource handling
*
*/


#include "saplayer_build.h"
#include "version.h"
#include <bautils.h>
#include <eikenv.h>
#include "engine_data_caging_literals.hrh"

#include "flashengineresourcehandler.h"

TInt FlashEngineRscHandler::LoadEngineResourceFileL()
{
	TFileName dllName;
	TFileName rscfn;
 	Dll::FileName(dllName);
  	TBuf<2> drive = dllName.Left(2);			
	rscfn.Copy(drive); // get the drive letter
	rscfn.Append(KFlash2EngineResourceFile);

	TInt resOffset = -1;
	
	BaflUtils::NearestLanguageFile(CCoeEnv::Static()->FsSession(), rscfn);
	
	TBool fileExists( BaflUtils::FileExists(CCoeEnv::Static()->FsSession(), rscfn) );
	if ( fileExists )
    {
    	resOffset = CCoeEnv::Static()->AddResourceFileL(rscfn);
    }
	else
	{
		User::Leave(KErrNotFound);
	}
    
    return (resOffset);	
}

void FlashEngineRscHandler::DeleteEngineResourceFile(CEikonEnv* aEnv, TInt aRscOffset)
{
	if(aEnv)
	{
		aEnv->DeleteResourceFile(aRscOffset);		
	}
	return;
}
