/*
* Copyright (c) 2005 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Implements the member functions of the class used to store 
*				 extensions to the main CPlatformFlashEngine functionality.
*
*/


#include "platformbuild.h"
#include "saplayer_build.h"
#include "commondef.h"
#include "flashliteinterfaces.h"
#include "flashextension.h"


// Interface's (abstract base class's) static factory method implementation.
// Asks ECOM plugin framework to instantiate appropriate concrete plugin
// implementation.
CFlashExtension* CFlashExtension::NewL(const TDesC8& aMatch)
{
    
	const TUid KCFlashExtensionInterfaceUid = {0x10273679};

	TEComResolverParams resolverParams;
	resolverParams.SetDataType (aMatch);
	resolverParams.SetWildcardMatch (EFalse); //exact name or nothing

	TAny* interface = REComSession::CreateImplementationL (KCFlashExtensionInterfaceUid,
	        _FOFF (CFlashExtension, iDtor_ID_Key),resolverParams);	
	
	CFlashExtension* extn = reinterpret_cast <CFlashExtension*> (interface);
		
	return extn;
}

	

