/*
* Copyright (c) 2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:
*
*/
/* -*- mode: c++; c-set-style: "stroustrup"; tab-width: 4; -*-
 *
 * GPU.cpp
 *
 */

#include "symbian_sa_build.h"

#ifdef ACHW

#include "GPU.h"
//#include "bmpio.h"
//#include <stdio.h>

#if ACHW_DRAWING_LIB == ACHW_DRAWING_LIB_IS_OPENVG
#include <vg/openvg.h>
#include <vg/vgu.h>
#elif ACHW_DRAWING_LIB == ACHW_DRAWING_LIB_IS_OPENGL_ES
#include <GLES/gl.h>
#endif

#define CLIENT_SURFACE_TYPE		EGL_WINDOW_BIT
//#define CLIENT_SURFACE_TYPE		EGL_PIXMAP_BIT

// GPU::GPU() 
// {
//	iEglSurface = 0;
//	iEglContext = 0;
//	iEGLConfig = 0;
//	iEglDisplay = 0;
//	_dc = 0;
//	_pixmap = 0;
//}
// 
// GPU::~GPU() {
// 	finalize();
// }
// 
// bool GPU::initialize(
// 	HWND hWnd)
// {
// 	EGLint s_configAttribs[] = {
// 		EGL_RED_SIZE,			8,
// 		EGL_GREEN_SIZE,			8,
// 		EGL_BLUE_SIZE,			8,
// #if ACHW_DRAWING_LIB == ACHW_DRAWING_LIB_IS_OPENVG
// 		EGL_ALPHA_SIZE,			8,
// #else
// 		EGL_ALPHA_SIZE,			EGL_DONT_CARE,
// #endif
// #if defined(EGL_VERSION_1_2)
// #if ACHW_DRAWING_LIB == ACHW_DRAWING_LIB_IS_OPENVG
// 		EGL_RENDERABLE_TYPE, 	EGL_OPENVG_BIT,
// #else
// 		EGL_RENDERABLE_TYPE, 	EGL_OPENGL_ES_BIT,
// #endif
// #endif
// #if CLIENT_SURFACE_TYPE == EGL_WINDOW_BIT
// 		EGL_SURFACE_TYPE,		EGL_WINDOW_BIT,
// #elif CLIENT_SURFACE_TYPE == EGL_PIXMAP_BIT
// 		EGL_SURFACE_TYPE,		EGL_PIXMAP_BIT,
// #else
// #error unsupported
// #endif
// #if ACHW_DRAWING_LIB == ACHW_DRAWING_LIB_IS_OPENGL_ES
// 		EGL_DEPTH_SIZE,			16,
// #endif
// #if defined(PVREMU)
// 		EGL_SAMPLE_BUFFERS,		1,
// 		EGL_SAMPLES,			4,
// #endif
// 		EGL_NONE
// 	};
// 	EGLint numConfigs;
// 	EGLint majorVersion;
// 	EGLint minorVersion;
// 	_hwnd = hWnd;
// 	_pixmap = NULL;
// 
// #if CLIENT_SURFACE_TYPE == EGL_PIXMAP_BIT
// 	{
// 		HDC dc = GetDC(hWnd);
// 		GetClientRect(hWnd, &_r);
// 		_dc = CreateCompatibleDC(dc);
// 		_pixmap = createPixmap(dc, _r.right - _r.left, _r.bottom - _r.top, &_bits);
// 		ReleaseDC(hWnd, dc);
// 	}
// 	if (! _pixmap) {
// 		goto err;
// 	}
// 	SetBkMode(_dc, TRANSPARENT); //for draw DeviceText
// 	SetTextAlign(_dc, TA_LEFT | TA_BASELINE | TA_NOUPDATECP); //for draw DeviceText
// #endif
// #if defined(PVREMU)
// 	_dc = GetDC(hWnd);
// 	_eglDisplay = eglGetDisplay(_dc);
// #else
// 	_eglDisplay = eglGetDisplay(EGL_DEFAULT_DISPLAY);
// #endif
// 	if (_eglDisplay == EGL_NO_DISPLAY) {
// 		goto err;
// 	}
// 	if (! eglInitialize(_eglDisplay, &majorVersion, &minorVersion)) {
// 		goto err;
// 	}
// 	if (! eglGetConfigs(_eglDisplay, NULL, 0, &numConfigs)) {
// 		goto err;
// 	}
// #if CLIENT_SURFACE_TYPE == EGL_WINDOW_BIT
// 	eglChooseConfig(_eglDisplay, s_configAttribs, &_eglConfig, 1, &numConfigs);
// 	_eglSurface = eglCreateWindowSurface(_eglDisplay, _eglConfig, hWnd, NULL);
// 	{
// 		//for device text
// 		HDC dc = GetDC(hWnd);
// 		_dc = CreateCompatibleDC(dc);
// 		SetBkMode(_dc, TRANSPARENT); //for draw DeviceText
// 		SetTextAlign(_dc, TA_LEFT | TA_BASELINE | TA_NOUPDATECP); //for draw DeviceText
// 	}
// #elif CLIENT_SURFACE_TYPE == EGL_PIXMAP_BIT
// 	{
// 		EGLConfig configs[256];
// 		numConfigs = 256; //config_size is size of array
// 		eglChooseConfig(_eglDisplay, s_configAttribs, configs, numConfigs, &numConfigs);
// 		for (int i = 0; i < numConfigs; i++) {
// 			EGLint rsize, gsize, bsize;
// 			if (eglGetConfigAttrib(_eglDisplay, configs[i], EGL_RED_SIZE, &rsize)
// 				&& eglGetConfigAttrib(_eglDisplay, configs[i], EGL_GREEN_SIZE, &gsize)
// 				&& eglGetConfigAttrib(_eglDisplay, configs[i], EGL_BLUE_SIZE, &bsize)
// 				&& rsize == 8 //RGB888
// 				&& gsize == 8
// 				&& bsize == 8) {
// 				_eglConfig = configs[i];
// 				break;
// 			}
// 		}
// 	}
// 	_eglSurface = eglCreatePixmapSurface(_eglDisplay, _eglConfig, _pixmap, NULL);
// #else
// #error unsupported
// #endif
// 
// 	if (_eglSurface == EGL_NO_SURFACE) {
// 		goto err;
// 	}
// #if defined(EGL_VERSION_1_2)
// #if ACHW_DRAWING_LIB == ACHW_DRAWING_LIB_IS_OPENVG
// 	if (! eglBindAPI(EGL_OPENVG_API)) {
// 		goto err;
// 	}
// #else
// #endif
// #endif
// 	_eglContext = eglCreateContext(_eglDisplay, _eglConfig, NULL, NULL);
// 	if (_eglContext == EGL_NO_CONTEXT) {
// 		goto err;
// 	}
// 	if (! makeCurrent(true)) {
// 		goto err;
// 	}
// 
// 	return true;
// err:
// 	finalize();
// 	MessageBox(NULL, "failed to initialize EGL.", "ERROR", MB_OK);
// 	return false;
// }
// 
// void GPU::finalize() {
// 	if (_eglDisplay != EGL_NO_DISPLAY) {
// #if defined(PVREMU)
// 		//wait all rendering pipelines
// 		eglWaitNative(EGL_CORE_NATIVE_ENGINE);
// 		eglWaitGL();
// #endif
// 		eglMakeCurrent(_eglDisplay, NULL, NULL, NULL);
// 		if (_eglContext != EGL_NO_CONTEXT) {
// 			eglDestroyContext(_eglDisplay, _eglContext);
// 		}
// 		if (_eglSurface != EGL_NO_SURFACE) {
// 			eglDestroySurface(_eglDisplay, _eglSurface);
// 		}
// 		eglTerminate(_eglDisplay);
// 	}
// 	_eglSurface = 0;
// 	_eglContext = 0;
// 	_eglConfig = 0;
// 	_eglDisplay = 0;
// 	if (_pixmap) {
// //		DeleteObject(&_pixmap);
// 		DeleteObject(_pixmap); //hObject is handle to Bitmap
// 		_pixmap = 0;
// 	}
// 	if (_dc) {
// 		DeleteDC(_dc); //cause using CreateCompatibleDC
// 		_dc = 0;
// 	}
// }
// 
// bool GPU::makeCurrent(bool is_current) {
// #if defined(PVREMU)
// 	//wait all rendering pipelines
// 	eglWaitNative(EGL_CORE_NATIVE_ENGINE);
// 	eglWaitGL();
// #endif
// 	if (is_current) {
// 		return eglMakeCurrent(_eglDisplay, _eglSurface, _eglSurface, _eglContext) == EGL_TRUE;
// 	} else {
// 		return eglMakeCurrent(_eglDisplay, NULL, NULL, NULL) == EGL_TRUE;
// 	}
// }
// 
// void GPU::swapBuffers(HDC dc, int x, int y, int w, int h) {
// #if CLIENT_SURFACE_TYPE == EGL_WINDOW_BIT
// 	eglSwapBuffers(_eglDisplay, _eglSurface);
// #elif CLIENT_SURFACE_TYPE == EGL_PIXMAP_BIT
// #if defined(EGL_VERSION_1_2)
// 	eglWaitClient(); //EGL1.2 is supported
// #else //defined(EGL_VERSION_1_2)
// #if ACHW_DRAWING_LIB == ACHW_DRAWING_LIB_IS_OPENVG
// 	vgFinish();
// #elif ACHW_DRAWING_LIB == ACHW_DRAWING_LIB_IS_OPENGL_ES
// 	glFinish();
// #endif
// #endif //defined(EGL_VERSION_1_2)
// 	{
// 		HBITMAP pixmap0 = (HBITMAP)SelectObject(_dc, _pixmap);
// // 		StretchBlt(dc, x, y, x + w, y + h, _dc, x, y, x + w, y + h, SRCCOPY);
// 		int width = _r.right - _r.left;
// 		int height = _r.bottom - _r.top;
// 		StretchBlt(dc, 0, 0, width, height, _dc, 0, 0, width, height, SRCCOPY);
// 		SelectObject(_dc, pixmap0);
// 	}
// #endif
// }
// 
// void GPU::dumpScreen(HDC dc, int id, int w, int h)
// {
// 	static HBITMAP pixmap;
// 	static UINT *bits;
// 	static int w0, h0;
// 	if (w0 != w || h0 == h) {
// 		if (pixmap) {
// 			DeleteObject(pixmap);
// 			pixmap = NULL;
// 		}
// 		pixmap = createPixmap(dc, w, h, &bits);
// 		w0 = w;
// 		h0 = h;
// 	}
// 	char str[256];
// #if ACHW_DRAWING_LIB == ACHW_DRAWING_LIB_IS_OPENVG
// 	sprintf(str, "C:/swfdump-vg/%05d-%03dx%03d.bmp", id, w, h);
// 	vgFinish();
// #elif ACHW_DRAWING_LIB == ACHW_DRAWING_LIB_IS_OPENGL_ES
// 	sprintf(str, "C:/swfdump-gl/%05d-%03dx%03d.bmp", id, w, h);
// 	glFinish();
// #endif
// #if defined(PVREMU)
// 	glReadPixels(0, 0, w, h, GL_RGBA, GL_UNSIGNED_BYTE, bits);
// 	for (INT y = 0; y < h / 2; y++) {
// 		UINT *p0 = &bits[y * w];
// 		UINT *p1 = &bits[(h - 1 - y) * w];
// 		for (INT x = 0; x < w; x++) {
// 			UINT c0 = *p0;
// 			UINT c1 = *p1;
// 			c0
// 				= ((c0 & 0x000000ff) << 16)
// 				| ((c0 & 0x0000ff00))
// 				| ((c0 & 0x00ff0000) >> 16)
// 				| ((c0 & 0xff000000));
// 			c1
// 				= ((c1 & 0x000000ff) << 16)
// 				| ((c1 & 0x0000ff00))
// 				| ((c1 & 0x00ff0000) >> 16)
// 				| ((c1 & 0xff000000));
// 			*p0++ = c1;
// 			*p1++ = c0;
// 		}
// 	}
// #else
// 	eglCopyBuffers(_eglDisplay, _eglSurface, pixmap);
// #endif
// 	bmpio_save(bits, w, h, str);
// }
// 
// HBITMAP GPU::createPixmap(
// 	HDC hDC,
// 	int width,
// 	int height,
// 	UINT **vram)
// {
// 	BYTE bytes[sizeof(BITMAPINFO) + 256U * sizeof(RGBQUAD)];
// 	BITMAPINFO *bmi;
// 	bmi = (BITMAPINFO*)bytes;
// 	memset(bmi, 0, sizeof(bytes));
// 	bmi->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
// 	bmi->bmiHeader.biWidth = width;
// 	bmi->bmiHeader.biHeight = -height;
// 	bmi->bmiHeader.biPlanes = (short)1;
// 	bmi->bmiHeader.biBitCount = 32; //EGLConfig attributes is RGBA8888
// 	bmi->bmiHeader.biCompression = BI_RGB;
// // 	bmi->bmiHeader.biCompression = BI_BITFIELDS;
// // 	{
// // 		DWORD *mask = (DWORD *)bmi->bmiColors;
// // 		mask[0] = 0xf800;
// // 		mask[1] = 0x07e0;
// // 		mask[2] = 0x001f;
// // 	}
// 	bmi->bmiHeader.biSizeImage = 0;
// 	bmi->bmiHeader.biXPelsPerMeter = 0;
// 	bmi->bmiHeader.biYPelsPerMeter = 0;
// 	bmi->bmiHeader.biClrUsed = 0; //zero
// 	bmi->bmiHeader.biClrImportant = 0;
// 	return CreateDIBSection(hDC, bmi, DIB_RGB_COLORS, (VOID **)vram, NULL, 0);
// }

#endif // ACHW
