/*
* Copyright (c) 2005 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Implements the member functions of the class CPerfAutoUtil
*				 
*
*/

#include "perfauto_util.h"
#include <commdb.h>


_LIT(KConfFilePathForPromptDisable,"c:\\data\\others\\flashliteIAP.conf");

CPerfAutoUtil::CPerfAutoUtil()
{
	
}

CPerfAutoUtil::~CPerfAutoUtil()
{
	
}

TInt CPerfAutoUtil::ReadIAPL()
{
	RFs lFS;
	TBuf8<200>	lIAPName;
	RFile lFile;
	TInt lRet;
	TInt lFileSize =0;
	TInt lPos =0;

//	if(!iConfFilePath.Length())
//		return 0;
	
	User::LeaveIfError(lFS.Connect());
		
	lRet = lFile.Open(lFS, KConfFilePathForPromptDisable, EFileRead | EFileShareExclusive);
		
	if (lRet != KErrNone)
	{
		lFS.Close();
		return 0;
	}
		
	lFile.Size(lFileSize);
		 
	HBufC8 *lFileBuffer = HBufC8::NewL(lFileSize);
	CleanupStack::PushL(lFileBuffer);
		
	TPtr8 lPtr= lFileBuffer->Des();
		
	lFile.Read(lPtr,lFileSize);
		
	lPos = lPtr.Find(_L8(">"));
		
	if (lPos == KErrNotFound)
	{
		lFile.Close();
		lFS.Close();
		return 0;
	}
			
			
	lIAPName = lPtr.Mid(1, lPos-1);	
		
	CleanupStack::PopAndDestroy(lFileBuffer);
	
	if(lIAPName.Length()==0)
		return 0;
	
		
	lFile.Close(); //close file and RFs handle
	lFS.Close();	
//Read Id from commsDB for config IAP name. 		
	CCommsDatabase* lCommDb = CCommsDatabase::NewL(EDatabaseTypeIAP);
	CleanupStack::PushL(lCommDb);

			
	CCommsDbTableView* dBTable = lCommDb->OpenIAPTableViewMatchingBearerSetLC(ECommDbBearerWLAN,ECommDbConnectionDirectionOutgoing); 
	
	HBufC* lbuffer = EscapeUtils::ConvertToUnicodeFromUtf8L(lIAPName);	
	
	if(lbuffer != NULL) 
	{   	    
		if(dBTable->GotoFirstRecord() == KErrNone)
		{
			do 
			{
				TBuf<200> lName;
			    dBTable->ReadTextL(TPtrC(COMMDB_NAME), lName);
				dBTable->ReadUintL(TPtrC(COMMDB_ID), iIAPId);
					  			  
				
			    if(!lName.Compare(*lbuffer))
			    {
			        
			        delete lbuffer;
			        break;
			    }
			         
			} 
			while(dBTable->GotoNextRecord() == KErrNone);
		}
	}
	else
		iIAPId = 0;	
   			
	//CFlhAsyncIPSelectDlg::IapIdFromWapIdL(iIAPId, iIAPId, *pCommDb);
		
	CleanupStack::PopAndDestroy(dBTable); 	
	CleanupStack::PopAndDestroy(lCommDb);		
	
	return iIAPId;
}
