/*
* Copyright (c) 2007 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Implements the member functions of the class that is used to 
*				 access subscriber information.
*
*/

//#ifdef USE_ATS_REFERENCE

#include "platformbuild.h"
#include "platformtypes.h"
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <UTF.h>
#include <APGCLI.H>
#include <APGTASK.H>
#include <BAUTILS.H> 

#include "symbian_engine.h"
#include "Symbian_TiHost.h"

_LIT(Store1, "C:\\Data\\Others\\ATS\\store1.txt");
_LIT(Store2, "C:\\Data\\Others\\ATS\\store2.txt");
_LIT(Store3, "C:\\Data\\Others\\ATS\\store3.txt");



short TI_GetSpecContents(char *SpecName,
						 char **pBuf,
						 unsigned long *bufSize)
{
    DEBUGPRINT("tihost::TI_GetSpecContents<< ++ ");
	short status = ATS_ERROR;

	TBuf16<512> lFileName;
	TInt lRet = KErrNone;

	RFile lFile;
     
    if(BaflUtils::FileExists(CEikonEnv::Static()->FsSession(),_L("C:\\data\\others\\ats\\resultswf.txt")))
         {
         CEikonEnv::Static()->FsSession().Delete(_L("C:\\data\\others\\ats\\resultswf.txt"));             
         return ATS_IN_AUTOSWF; 
         }	
    else if (SpecName != NULL) 
        { //Second time through, time to open XML master file
        TInt fileNameLength = strlen(SpecName);
        
        for (TInt idx = 0; idx < fileNameLength; ++idx)
            {
            if( SpecName[idx] == '/' )
                {
                SpecName[idx] = '\\';
                }
            }
        
        TPtrC8 fileNamePtr((TUint8 *)(SpecName));            
        
        CnvUtfConverter::ConvertToUnicodeFromUtf8((TDes &)lFileName, fileNamePtr);
                   
        lRet = lFile.Open(CEikonEnv::Static()->FsSession(), lFileName, EFileRead | EFileShareExclusive | EFileStream);
        if (lRet != KErrNone)
            { 
            DEBUGPRINT("tihost::TI_GetSpecContents>>--");    
            return status; 
            }        
        } 
	
	 if (lFile.SubSessionHandle() != 0) 
	     {
	      if (*pBuf == NULL) 
	          { // We're requesting the file size
	          TInt fileSize;
	          lFile.Size(fileSize);
	          *bufSize = (unsigned long)fileSize;
	          status = ATS_OK;                
	          }
	      else if (*bufSize != 0)
	          {
	          if (*pBuf)
	              {
	              //DWORD NumRead;
	              TPtr8 bufptr( (TUint8*)(*pBuf), *bufSize );
	              lFile.Read(bufptr);
	              if (bufptr.Length() == *bufSize) 
	                  {
	                  status = ATS_OK;
	                  }                
	              }    
	          } 
	     }
	 
	lFile.Close();
	DEBUGPRINT("tihost::TI_GetSpecContents>>--");  
	return status;
}


short TI_GetCurrentDisplay(unsigned char */*pMem*/,
						   unsigned long /*MemSize*/,
						   int /*XDim*/,
						   int /*YDim*/,
						   FI_DisplayFormat /*format*/,
						   FI_DisplayType type)
{
    DEBUGPRINT("tihost::TI_GetCurrentDisplay<< ++ ");
	short status = ATS_ERROR;

	switch (type) {
	case FI_DisplayType_Total:
		break;
	case FI_DisplayType_Player:
		break;
	default:
		break;
	}
	DEBUGPRINT("tihost::TI_GetCurrentDisplay>>-- ");
	return status;
}

short TI_AllocateBuffer( char **pBuf,
						unsigned long BufSize)
{
    DEBUGPRINT("tihost::TI_AllocateBuffer<< ++ ");
	*pBuf = (char *)malloc(BufSize);
	if (*pBuf != NULL)
	{
        DEBUGPRINT("tihost::TI_AllocateBuffer>> -- ");
		return ATS_OK;
	}
	else
	{
        DEBUGPRINT("tihost::TI_AllocateBuffer>> -- ");
		return ATS_ERROR;
	}
	
}

short TI_ReleaseBuffer( unsigned char*pBuf)
{
    DEBUGPRINT("TI_ReleaseBuffer< ++");
	if (pBuf)
		free(pBuf);
	DEBUGPRINT("TI_ReleaseBuffer> --");
	return ATS_OK;
}

short TI_ReadFromLocalStore(FI_LSType type,
							char **pBuf,
							unsigned long *Size)
{
    DEBUGPRINT("tihost::TI_ReadFromLocalStore<< ++ ");

	short lStatus = ATS_OK;
	RFile lFile;
	int lRet;
	if (*pBuf == NULL)
	    {		
			if (type == LocalStoreOne)
				lRet = lFile.Open(CEikonEnv::Static()->FsSession(), Store1, EFileRead | EFileShareExclusive | EFileStream);
			else if (type ==LocalStoreTwo )
				lRet = lFile.Open(CEikonEnv::Static()->FsSession(), Store2, EFileRead | EFileShareExclusive | EFileStream);
			else if (type ==LocalStoreThree)
				lRet = lFile.Open(CEikonEnv::Static()->FsSession(), Store3, EFileRead | EFileShareExclusive | EFileStream);
			else
				lRet = KErrNotFound;  
			
			if (lRet != KErrNone)
			    {			
                    DEBUGPRINT("tihost::TI_ReadFromLocalStore>> -- ");    
					return ATS_ERROR;
			    }
			
			TInt fileSize;
			lFile.Size(fileSize);
			*Size = (unsigned long)fileSize;
			lFile.Close();		
	    }
    else if (*Size != 0)
      {        
			if (type == LocalStoreOne)
				lRet = lFile.Open(CEikonEnv::Static()->FsSession(), Store1, EFileRead | EFileShareExclusive | EFileStream);
			else if (type ==LocalStoreTwo )
				lRet = lFile.Open(CEikonEnv::Static()->FsSession(), Store2, EFileRead | EFileShareExclusive | EFileStream);
			else if (type ==LocalStoreThree)
				lRet = lFile.Open(CEikonEnv::Static()->FsSession(), Store3, EFileRead | EFileShareExclusive | EFileStream);
			else
				lRet = KErrNotFound; 
		
			if (lRet != KErrNone)
			    {	
                    DEBUGPRINT("tihost::TI_ReadFromLocalStore>> -- ");   
					return ATS_ERROR;
			    }
			TPtr8 bufptr( (TUint8*)(*pBuf), *Size );
			lFile.Read(bufptr);
			if (bufptr.Length() != *Size) 
			    {
					lStatus = ATS_ERROR;
			    }			
			lFile.Close();		
      }
	DEBUGPRINT("tihost::TI_ReadFromLocalStore>> -- ");	
	return lStatus;
}



short TI_WriteToLocalStore(FI_LSType type,
						   FI_Operation op,
						   char *pBuf,
						   unsigned long Size)

{
    DEBUGPRINT("tihost::TI_WriteToLocalStore<< ++ ");  

	short lStatus = ATS_OK;

	RFile lFile;
	int lRet;
	
	if (op == FI_Delete)
	{
		switch (type) {
			case LocalStoreOne:
			    CEikonEnv::Static()->FsSession().Delete(Store1);
				break;
			case LocalStoreTwo:
			    CEikonEnv::Static()->FsSession().Delete(Store2);
				break;
			case LocalStoreThree:
			    CEikonEnv::Static()->FsSession().Delete(Store3);
				break;
		}
		
		DEBUGPRINT("tihost::TI_WriteToLocalStore>> -- ");
		return lStatus;
	}
	
	if (op == FI_Create)
	    {
        if (type == LocalStoreOne)
            lRet = lFile.Create(CEikonEnv::Static()->FsSession(), Store1, EFileWrite |  EFileShareAny);
        else if (type ==LocalStoreTwo )
            lRet = lFile.Create(CEikonEnv::Static()->FsSession(), Store2, EFileWrite |  EFileShareAny);
        else if (type ==LocalStoreThree)
            lRet = lFile.Create(CEikonEnv::Static()->FsSession(), Store3, EFileWrite |  EFileShareAny);
        else 
            lRet = KErrNotFound;  
	    }
	else
	    {
        if (type == LocalStoreOne)
            lRet = lFile.Open(CEikonEnv::Static()->FsSession(), Store1, EFileWrite |  EFileShareAny);
        else if (type ==LocalStoreTwo )
            lRet = lFile.Open(CEikonEnv::Static()->FsSession(), Store2, EFileWrite |  EFileShareAny);            
        else if (type ==LocalStoreThree)            
            lRet = lFile.Open(CEikonEnv::Static()->FsSession(), Store3, EFileWrite |  EFileShareAny);
        else
            lRet = KErrNotFound;	         	
	    }

	
	if (lRet != KErrNone)
	    {		
            DEBUGPRINT("tihost::TI_WriteToLocalStore>> -- ");
			return ATS_ERROR;
	    }
	
	TInt pos = 0;
	if (op == FI_Append)
		lFile.Seek(ESeekEnd,pos);
	
	if (op==FI_Append && pBuf != NULL && Size != 0 )
	    {
		TPtr8 bufptr((TUint8 *)pBuf, Size, Size );
		lRet = lFile.Write(bufptr);
		if (lRet != KErrNone)
		{
			lStatus = ATS_ERROR;
		}
		lFile.Flush();
	}
	
	lFile.Close();	
	DEBUGPRINT("tihost::TI_WriteToLocalStore>> -- ");
	return lStatus;
}

short TI_SendToRemoteStore(unsigned char */*pBuf*/,
						   unsigned long /*Size*/)
{
	// Setting up socket connection here
	return ATS_OK;
}


#define DOUBLE_LEN 200
short TI_DestroyPlayer(struct MM_Object *mm_obj, unsigned char* SwfToExecute)
{
    DEBUGPRINT("TI_DestroyPlayer< ++");
   
   if(SwfToExecute == NULL || *SwfToExecute == '\0')
   {
       DEBUGPRINT("TI_DestroyPlayer> --");
       return 0;
   }
   
    TInt fileNameLength = strlen((const char *)SwfToExecute);
    
    
    for (TInt idx = 0; idx < fileNameLength; ++idx)
    {
        if( SwfToExecute[idx] == '/' )
        {
            SwfToExecute[idx] = '\\';
        }
    }
    TPtrC8 fileNamePtr((TUint8 *)(SwfToExecute));

	TBuf16<200> fileName;
	CnvUtfConverter::ConvertToUnicodeFromUtf8(fileName, fileNamePtr);
	
     
	CPlatformFlashEngine* pEngine = mm_obj->pHostObj->iFIInterface->GetEngine();//we believe this returns the current engine object.

	//__UHEAP_MARK;
	if(pEngine)
	    {		
	    TRAP_IGNORE(pEngine->OpenFileAndStartMovieL(fileName, 1)); //use the same filename variable that was used previously.	
	    }
	//__UHEAP_MARKEND;	
	DEBUGPRINT("TI_DestroyPlayer> --");
	return 1;
}

void SetupHostPtrs(TI_Fncs *hptr) 
{
	hptr->AllocateBuffer = &TI_AllocateBuffer;
	hptr->DestroyPlayer = &TI_DestroyPlayer;
	hptr->GetCurrentDisplay = &TI_GetCurrentDisplay;
	hptr->GetSpecContents = &TI_GetSpecContents;
	hptr->ReadFromLocalStore = &TI_ReadFromLocalStore;
	hptr->ReleaseBuffer = &TI_ReleaseBuffer;
	hptr->SendToRemoteStore = &TI_SendToRemoteStore;
	hptr->WriteToLocalStore = &TI_WriteToLocalStore;

}

void CleanupATSLibrary()
{
}

//#endif /* USE_ATS_REFERENCE*/

