/*
* Copyright (c) 2006-2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Script interaction class 
*
*/
 

#ifndef __MSCRIPT_HANDLER_H__

#define __MSCRIPT_HANDLER_H__

#include "MFlashMethods.h"
#include "MExternalInterface.h"
#include "MPluginScriptHandler.h"

//forward  declaration
class MFlashMethods;
class MExternalInterface;
class MPluginScriptHandler;


//implemented by Host engine
class MHostScriptHandler
{
	public: 
	
		virtual MFlashMethods* GetFlashMethods()=0;
		
#ifdef FEATURE_EXTERNAL_API				
		virtual MExternalInterface* GetExternalInterface()=0;
		
		virtual TBool CallJSMethodL( const char* aRequest) = 0;
	
		virtual TBool EvaluateJavaScriptL( const char* aExpression) = 0;
	
		virtual TBool DoFsCommandL(const char* aCommand, const char* aArgs) = 0;

#endif					
		//Used by Host engine and core player to talk to Javascript
		virtual MPluginScriptHandler* GetPluginScriptHandler()=0;
		
		//This function should be called by plugin before calling
		//GetFlashMethods,GetExternalInterface
		virtual void SetPluginScriptHandler(MPluginScriptHandler* aPluginScriptHandler)=0;
};



#endif // __MSCRIPT_HANDLER_H__