/*
* Copyright (c) 2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:
*
*/
#ifndef __ASEXT_DELEGATEBASE_H__
#define __ASEXT_DELEGATEBASE_H__

#include <e32base.h>
#include <ecom/ecomresolverparams.h>
#include <ecom/ecom.h>

//forward declaration
class MFlashEngineIntfToASExtension;
struct ExtensionInterface;

/**
* The CASExtensionDelegate class is an abstract base class for all types of ActionScript extensions.
*/
class CASExtensionDelegate : public CBase
{
public:
enum TDoItLOperationOpCodes
	{
		EOpCodePauseState = 0,
		EOpCodeSMCheckNeeded = 100

	};


public:
	inline static CASExtensionDelegate* NewL(const TDesC8& aMatch);

	~CASExtensionDelegate() { REComSession::DestroyedImplementation (iDtor_ID_Key); }

public:
	
	virtual void InitPlugin( TInt aOpCode, TAny* aParam) = 0;
 
	virtual PluginInfo* GetPluginInfoL(MFlashEngineIntfToASExtension* aFalshEngine, ExtensionInterface* aEI) = 0;

private:
	TUid iDtor_ID_Key;

};

#include "asextensiondelegate.inl"

#endif // __ASEXT_DELEGATEBASE_H__
