/*
* Copyright (c) 2006-2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  CFlashPluginInstance header file
*
*/


#ifndef COMMONTYPES_H_
#define COMMONTYPES_H_

#include <e32std.h>
#include <e32def.h>
#include "netscapeif.h"
//#include "pluginarguments.h"
//#include "flashpluginif.h"

//typedef TInt InteractionMode;

enum TPageAccessType
{
	EPageUrlNormal,
	EPageUrlUnknown_AllowOutboundScriptAccess,
	EPageUrlUnknown_ProhibitOutboundScriptAccess
};

enum TWindowMode
{
    EWindow=0,
    EWindowless,
    EWindowlessOpaque
};

// this enum has moved from FlashPlgControl to this class so that 
// other classes too can set plugin focus state. Fix for ASHA-7RKHZT.
enum TFlashPluginFocusState
{
	EFlashPluginBackground,
	EFlashPluginForeground
};

enum EFLVStreamState
{
	EFlashPluginNoFLVStream,
	EFlashPluginFLVStreamInProgress,
	EFlashPluginFLVStreamClosed
};

enum TFlashPluginVisibilityState
{
	// Consistent with CCoeControl::IsVisible()
	EFlashPluginInvisible,
	EFlashPluginVisible
};

enum TIadProgressState
{
	EIadUpdateNotComplete,
	EIadUpdateComplete,
	EIadUserNotifiedOnCompletion
};

typedef struct _FlashPluginStream
{
	HBufC* url;
	unsigned int end;
	unsigned int lastmodified;
	void* notifyData;
	const char* headers;

} NPAPIStreamData;

typedef struct _NPAPIEvent
{
	unsigned long event;
	void* param;
} NPAPIEvent;

//typedef const TDesC8&    NPAPIMIMEType;
typedef TPtrC8 NPAPIMIMEType;
typedef unsigned char NPAPIBool;
typedef short NPAPIError;
typedef short NPAPIReason;
typedef short NPError;
typedef unsigned short uint16;

enum
{
	NPERR_Generic = 1,
	NPERR_Invalid_Instance = 2,
	NPERR_Module_Load_Failed = 4,
	NPERR_Out_Of_Memory = 5,
	NPERR_Invalid_Param = 9,
	NPERR_Invalid_Url = 10
//NPERR_INVALID_URL
};

enum EScreenMode
{
    eAppScreen =0,
    eFullScreen
};

enum TPluginUiFramework
{
	EAvkonFrameWork,
	EQtFrameWork
};

#endif /* COMMONTYPES_H_ */
