/*
* Copyright (c) 2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:
*
*/


#ifndef __FLASHCURSOR_H
#define __FLASHCURSOR_H

#include <w32std.h>

enum TFlashCursorState
{
    EFlashCursorHidden          = 0,
    EFlashCursorDisplaying      = 1,
    EFlashCursorMoving          = 2,
    EFlashCursorHiddenMoving    = 3
};

class MFlashCursor
{
public:
    virtual void    DisplayCursor() = 0; 
    virtual void    UpdateCursor() = 0;
    virtual TPoint  Position() = 0;
    virtual TBool   IsVisible() const = 0;
    virtual TPoint  PreviousPosition() = 0;
    virtual TSize   Size() = 0; 
    virtual TRect   GetRect() = 0;
    virtual void    SetHiddenWindow(const TRect& aRect) = 0;
    virtual void  	SetWindowSize(const TSize& aSize) = 0;
    virtual void    RecreateCursor() = 0;
    virtual void    HideCursor() = 0;
    virtual void    ShowCursor() = 0;
    
    virtual TFlashCursorState State() = 0;
    virtual void SetState(TFlashCursorState aState) = 0;
};

#endif // __FLASHCURSOR_H