/*
* Copyright (c) 2006 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  
*
*/



#ifndef FLASHENGINECLIENTIF_H_
#define FLASHENGINECLIENTIF_H_

#include "saplayer_build.h"
#include <e32std.h>
//#include "flash_engine.h"
#include "symbian_ui_interface.h"
#include "commontypes.h"

class TGetInputTextData;
class TRect;
class RWindow;

class MFlashClientAppInfo;
class MUserNotiferIf;
class MPluginMemHandlerIf;
class MDisplay;
class MPluginStreamIf;
class MDeviceExtnIf;
class MMp3StateObserver;
class MFlashCursor;
class MIadUpdateCallback;
class MInputTxtIf;
class MFlashVideoClientIf;
class MFlashEngine;

typedef TUint32 AccessPointId;

class MAccessPointIf
    {
public:    
    virtual AccessPointId IAPId() =0;
    virtual void SaveIAPId(AccessPointId aIAPId) = 0;
    };

class MFlashClientIf
    {
public:    
     virtual MFlashClientAppInfo* GetClientAppInfoIf() =0;
     virtual MDisplay* GetDisplay() =0;
     virtual MPluginMemHandlerIf* GetPluginMemHdlrIf() =0;
     virtual MUserNotiferIf* GetUserNotifierIf() =0;
     virtual MPluginStreamIf* GetStreamIf() =0;
     virtual MDeviceExtnIf* GetDeviceIf() =0;
     virtual MMp3StateObserver* GetMp3StateObserver() =0;
     virtual MFlashCursor* GetCursor() =0;
     virtual MInputTxtIf* GetInputTextIf() =0;
     virtual MFlashVideoClientIf* GetFlvClientIf() =0;
     virtual MAccessPointIf* GetIAPIf() =0;
     
#ifdef SELF_IAD_UPDATE     
     virtual MIadUpdateCallback* GetIADUpdateCallback() =0;
#endif
     
     virtual TWindowMode GetWMode() =0;

     //virtual EEngineExecutionMode GetExecutionMode() =0;     
     virtual void  DrawDirtyRect(const TRect& aRect) = 0;
     virtual void AddEventObserverToControl()= 0;  
     virtual void RemoveEventObserverFromControl() = 0;
     virtual void NotifyEngineState(TEngineState aEngineState) =0;
     virtual void NotifyShutdownCountdown(TInt aItemsRemaining) =0;
     virtual RFile* GetRFileHandleForPlay() =0;
     virtual void NotifyPhoneActiveL(TBool aIsActive) =0;
     virtual void ClearErrors() =0;
     
     virtual TBool  IsUrlDescSet() =0;
     virtual const TPtr GetUrlDesc() = 0;
     
     virtual TBool CanContentBeTrustedL(const TDesC& pAccessedDomain)= 0;
     virtual void KickoffRestartTimerL() =0;
     virtual void Quit() =0;
     
     virtual TUint GetFeatureCapability() =0;
     virtual TInt GetPersistentDirectory(const TDesC& aSwfPath, TFileName& aPersistentDir) =0;
     virtual void StartShutDownProcess()=0;
     virtual TBool AllowAMCExtension()=0;
     virtual TBool IsWidgetMode()=0;
    };


#endif /* FLASHENGINECLIENTIF_H_ */
