/*
* Copyright (c) 2006-2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  
*
*/


#ifndef FLASHPLUGINIF_H_
#define FLASHPLUGINIF_H_

#include "commontypes.h"

typedef int NetscapeReason;
typedef void NetscapeStream;
typedef void NetscapeWindow;
typedef int NetscapeVariable;
class MVolumePropertyWatchObserver;
class CHwKeyPropertyWatch;

#include "flash_engine.h"
#include "NPNFlashExtension.h"

class MFlashEngine;
class MHostScriptHandler;
class CPluginGlobals;

class MFlashPluginIf
    {
public:
	virtual HBufC* GetFlashBaseURL() =0;
    virtual void PrepareToExit() =0;
    virtual void Close() =0;
    
    virtual int SetWindow(NetscapeWindow* window) =0;

    virtual int NewStream(const TDesC8& aType, NetscapeStream* aStream, bool seekable,
            unsigned short* stype) = 0;

    virtual int DestroyStream(NetscapeStream* aStream, NetscapeReason aReason) =0;

    virtual int AsFile(NetscapeStream* aStream, const TDesC& aFname) =0;

    virtual int WriteReady(NetscapeStream* aStream) =0;

    virtual int WriteStream(NetscapeStream* aStream, int aOffset, int aLen,
            void* aBuffer) =0;
    
    virtual int HandlePluginEvent(void* aEvent) =0;
    
    virtual int UrlNotify(NetscapeReason aReason, void* notifyData) =0;
    
    virtual int GetValue(NetscapeVariable variable, void* ret_value) =0;
    virtual int SetValue(NetscapeVariable variable, void* ret_value) =0;
    
    virtual MHostScriptHandler* GetHostScriptHandler() =0;
    virtual TBool PercentLoaded(TReal& aPercentLoaded) =0;
    };

class MHwKeyWatchObserver;
class MFlashPlayerControl;
class MNetscapeIf;
class CHwKeyPropertyWatch;
class CVolumeCenRepKeyWatcher;

class MFlashPluginInstance
    {

public:
    virtual const TDesC& GetBaseURL() = 0;
    virtual const TDesC& GetSecurityContextURL() = 0;
    virtual TBool PercentLoaded(TReal& aPercentLoaded) =0;
    
    virtual void PrepareToExit() =0;
    
    virtual TBool IsPlayerInitialzed() =0;
    virtual int OpenMovie() =0;
    
    virtual int InteractionMode() =0; 
    
    //virtual EEngineExecutionMode GetExecutionMode() =0;
    virtual EBrPluginExecutionMode GetBrPluginExecutionMode() =0;
    virtual MNetscapeIf* NetscapeFns() =0;
    virtual MVolumePropertyWatchObserver* GetMHwKeyWatchObserver()=0;
    
    virtual NPFlashConfig* GetFlashconfig() =0;
    
    virtual TBool DeferredLaunch() =0;
    virtual TBool GetAllowMobiFullScreen() =0;
    virtual CHwKeyPropertyWatch* GetHwKeyPropertyWatch() =0;
    //virtual int AddHwKeyObserver(MHwKeyWatchObserver*) =0;
    //virtual void RemoveHwKeyObserver(MHwKeyWatchObserver*) =0;
    
    //virtual void SetVolume(TInt aVolume) =0;
    virtual void MuteVolume() =0;
    virtual void UnMuteVolume() =0;
    
    virtual MFlashPlayerControl* GetFlashPlayerControl() =0;    
    
    virtual void ReAdjustMaxHeapforVideoStream(TUint aMaxHeapSize) =0;
    
    virtual MFlashEngine* GetEngine() =0;
    
    virtual void AddHwSideKeyObserverL() =0;
    virtual void RemoveHwSideKeyObserver() =0;
       
#ifdef SELF_IAD_UPDATE  
    virtual TIadProgressState GetIADProgressState() =0;
    virtual void SetIADProgressState(TIadProgressState aState) =0;
#endif    
    
    virtual CPluginGlobals* GetGlobals() = 0;
    virtual TBool IsVolumeKeySupported() = 0;
    
    virtual CVolumeCenRepKeyWatcher* GetVolumeCenRepKeyWatcher() = 0;
    virtual TInt GetCurrentEngineVolume() = 0;
    virtual void SetVolumeToEngine(TInt aVolume) = 0;
    
    //virtual MNetscapeIf* NetscapeIf() = 0;
    virtual void Pause(TInt aReason) = 0;
    virtual void Stop() = 0;
    virtual void Rewind() = 0;
    
    //virtual void PrepareToExit() = 0;
    
    virtual TWindowMode GetWMode() = 0;
    
    virtual TBool QueryAllowNetworkAccess() = 0;
    };
#endif /* FLASHPLUGINIF_H_ */
