/*
* Copyright (c) 2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:
*
*/
/*
 * plugininputtexthandlerif.h
 *
 *  Created on: Apr 10, 2009
 *      Author: vsriram
 */

#ifndef PLUGININPUTTEXTHANDLERIF_H_
#define PLUGININPUTTEXTHANDLERIF_H_

class TGetInputTextData;

class MInputTxtIf
    {
public:    
    virtual TBool IsTextInputBusy() = 0;
    /**
     This function initiates a modal input text dialog, pausing the 
     movie until the user dismisses the dialog
     @param aData structure for the input text data.
     */
    virtual void GetInputTextL(TGetInputTextData& aData) = 0;

#ifdef FEATURE_INLINE_TEXT_ENTRY

    /**
     Enables the IME Control for inline text editing with FEP
     */
    virtual void EnableIMEL() = 0;

    /**
     Disables the IME Control. 
     */
    virtual void DisableIME() = 0;

    /**
     Gets the current text input mode. 
     */
    virtual TInt GetCurrentInputMode() = 0;

#endif  // FEATURE_INLINE_TEXT_ENTRY
    };

#endif /* PLUGININPUTTEXTHANDLERIF_H_ */
