/*
* Copyright (c) 2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:
*
*/
/*
 * netscapeif.h
 *
 *  Created on: Sep 3, 2009
 *      Author: vsriram
 */

#ifndef NETSCAPEIF_H_
#define NETSCAPEIF_H_

typedef void* NPPInstance;
typedef void* NPFuncs;

class MNetscapeIf
    {
public:    
    virtual void* NPPInstance() =0;
    
    //convenience function..
    virtual void* NpFuncs() =0;
    virtual TBool QueryAllowNetworkInWidgetMode()=0;
    virtual int ResolveExecutionMode() =0;
    virtual int GetUrl( const TDesC& url, const TDesC* target) =0;
    virtual int PostUrl(const TDesC& url, const TDesC* target,
            const TDesC& buf, bool file) =0;
    
    virtual int GetUrlNotify(const TDesC& url, const TDesC* target,
            void* notifyData) =0;
    
    virtual int PostUrlNotify(const TDesC& url, const TDesC* target,
            const TDesC& buf, bool file, void* notifyData) =0;
    
    virtual int GetValue(int variable, void* ret_alue) =0;
    virtual int SetValue(int variable, void *ret_alue) =0;
    virtual HBufC8* GetBaseUrlLC() = 0;
    virtual HBufC8* GetHTMLBaseTagValueLC() = 0;
    virtual void InvalidateRect(const TRect& aRect) = 0;
    
    virtual void SetScriptAccess() = 0;
    virtual void DeleteFlashMethodObject() =0;
    };

#endif /* NETSCAPEIF_H_ */
