/*
* Copyright (c) 2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:
*
*/
/*
 * pluginarguments.h
 *
 *  Created on: Sep 3, 2009
 *      Author: vsriram
 */

#ifndef PLUGINARGUMENTS_H_
#define PLUGINARGUMENTS_H_

#include "commontypes.h"

/*
 * An abstract model of plugin arguments data structure.
 * Provide concrete implementation based on the browser framework.
 * 
 */
class MPluginArguments
    {
public:
    virtual void Cleanup() =0;
    virtual int InteractionMode() =0;
    virtual const TDesC& SwfSourcePath() =0;
    virtual const TDesC& BaseUrl() =0;
    virtual TPageAccessType AccessType() =0;    
    virtual TBool AllowMobiFullScreen() =0;
    
    virtual TWindowMode WindowMode() =0;
    
    virtual const CDesCArray& ArgNames() =0;
    virtual const CDesCArray& ArgValues() =0;
    };

#endif /* PLUGINARGUMENTS_H_ */
