/*
* Copyright (c) 2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:
*
*/
/*
 * pluginmemhandler.h
 *
 *  Created on: Apr 10, 2009
 *      Author: vsriram
 */

#ifndef PLUGINMEMHANDLER_H_
#define PLUGINMEMHANDLER_H_

#include <e32def.h>

class MPluginMemHandlerIf
    {
public:
    virtual TUint GetMaxHeapSize() =0;

    virtual void AddDynHeapAlloced(TUint size) =0;

    virtual void DynHeapFreed(TUint size) =0;

#ifdef PLUG_IN_MEM_ALLOC    
    virtual TBool IsMemAllocSupported() =0;

    virtual TAny* AllocMem(TUint16 aNumBlocks) =0;

    virtual void FreeMem(TAny* aMemory) =0;
    
    virtual void ReAdjustMaxHeapforVideoStream(TUint aMaxHeapSize) =0;
#endif

    
    
    };

#endif /* PLUGINMEMHANDLER_H_ */
