/*
* Copyright (c) 2006-2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  CFlashPluginInstance header file
*
*/


#ifndef PLUGINVIEW_H_
#define PLUGINVIEW_H_

//include header file for TFlashPluginFocusState

//typedef void* NetscapeWindow;

#include "commontypes.h"
#include "flash_engine.h"
#include "inputtexthandlerif.h"
#include "uinotifierif.h"
#include "screenfurnitureif.h"

class MMp3StateObserver;
class MFlashVideoClientIf;
class MDisplay;

class MPluginView : public MInputTxtIf,
                    public MUserNotiferIf,
                    public MDisplay
    {
public:
    
    virtual int SetWindow(void* window) =0;
    
    virtual void PrepareToExit() =0;
    virtual void Close() =0;
    
    virtual int OpenFile(const TDesC& aFilename, const TDesC& aUrl, 
                                           TBool aFirstMovie, CContent* aContent=NULL) =0;
    
    //void SetRect(const TRect& aRect) =0;
    virtual TRect GetClipRect() =0;
    virtual TRect GetSWFRect() =0;
    
    //TODO : Should be part of MDisplay
    virtual void DrawDirtyRect(const TRect& aRect) =0;
    
    virtual void MakeVisible(TBool /*aVisible*/) {}
    
    virtual TBool IsFileOpened() =0;    
    virtual TBool IsValid() =0;
    virtual TBool IsVisible() =0;
    virtual TBool IsConstructed() =0;
    
    virtual void NotifyClientError(TInt aErrorCode, TBool aIsCritical, TBool aPersistent) =0;
    
    virtual void SetPluginFocus(TFlashPluginFocusState aFocus) =0;
    virtual int HandlePluginEvent(void* event) =0;
    
    virtual TBool HandleURLReqForFullScreen(const TDesC& aUrl) =0;
    
    virtual void ChangeFLVPlayStateL(EFLVStreamState aFLVStreamState, EMediaStreamType aMediaStreamType) =0;
    
    //virtual int HandleEvent(void*);
    
    virtual int GetLastError() =0;
    virtual void SetErrorOccured(TInt aErr=KErrNone) =0;
    
    virtual TBool IsFLVVideo() =0;
    
    virtual void ShowVolumePopup(TInt aCurrentVolume) = 0;
    
    virtual void AddEventObserverToControl() = 0;
    virtual void RemoveEventObserverFromControl() = 0;
    
    virtual MMp3StateObserver* GetMP3StateObserver() = 0;
    virtual MFlashVideoClientIf* GetFlvClientIf() = 0;
    
    virtual TBool QueryAllowDenyL(const TDesC& aQueryText) = 0;
    virtual TBool QueryTrustDomainL(const TDesC& aDomain) = 0;
    
    };

//IMPORT_C MPluginView* CreatePluginView(MFlashPluginInstance*);

#endif /* PLUGINVIEW_H_ */
