/*
* Copyright (c) 2006-2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Flash adaptation engine constant defines 
*
*/

#ifndef _SAFLASH_CONSTS_H__
#define _SAFLASH_CONSTS_H__



// char constants
const char KCharForwardSlash='/';
const char KCharBackslash='\\';

// Boolean string values used for comparisons
_LIT(KTrueStrVal, "true");
_LIT(KFalseStrVal, "false");

_LIT(KFlashResourceDrivesInOrder, "ZCE");


const TUint16 KUnicodeParagraphSeparator = 0x2029;
#define FLASH_LINE_FEED_CHAR		0x0A
#define FLASH_CARRIAGE_RETURN_CHAR	0x0D

// Volume control
const TUint KMuteMask=0x80000000;
const TUint KUnMuteMask=0x7FFFFFFF;
const TUint KMinUserVolume=0;
const TUint KMaxUserVolume=10;
const TUint KDefaultVolume = 4;

// Viewer Zoom control
const TUint KMaxZoomLevel=1;

/*******************************************************************************/
//							IME: Dynamic Input Text
/*******************************************************************************/
// Flash does not enforce a limit to the maximum
// number of characters that can be entered. However, we don't want to allow an
// infinite amount of text, so pick a reasonable limit, say 4k.

// IME: Max number characters can be entered to text field.
const TUint KMaxNumChar = 0X00001000;
//Added by Nokia S60
//feature capabilities

const TUint KCapabilitiesScreensaver = 0x10000;
const TUint KCapabilitiesBrowser = 0x20000;
const TUint KCapabilitiesAnimation = 0x40000;
const TUint KCapabilitiesIdle= 0x80000;
const TUint KCapabilitiesRingTone = 0xF0000;
const TUint KCapabilitiesCallImage = 0x100000;
const TUint KCapabilitiesBackground = 0x200000;
const TUint KCapabilitiesWallpaper=0x400000;
const TUint KCapabilitiesNotification=0x800000;
const TUint KCapabilitiesStartupScreen =0xF00000;
const TUint KCapabilitiesShutdownScreen=0x1000000;
_LIT8( KShowroomDirPrivate,":/private/20003b78/");
_LIT8( KTrustedPhoneDirPath,"c:/data/others/trusted/" );
_LIT8( KTrustedDir,"trusted/");
_LIT8( KForwardSlash,"/");
_LIT8( KBackwardSlash,"\\");
_LIT8( KOthersTrustedDir,":/others/trusted/");
/*_LIT8( KTrustedPhoneDirPrivate,"c:/private/" );
_LIT8( KTrustedMMCDirPrivate,"e:/private/");*/
_LIT8( KTrustedZDirPrivate,"z:/private/");
_LIT8( KNoAutoTrust,"_No_Auto_Trust");

/*******************************************************************************/

#endif	// _SAFLASH_CONSTS_H__
