/*
* Copyright (c) 2006-2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Flash adaptation engine defines 
*
*/

#ifndef __SAFLASH_COREDEFS__H__
#define __SAFLASH_COREDEFS__H__


// This macro allows recursive low memory testing of a call which can leave. This macro should never be
// used on checked in code, but can be used for testing individual leaving functions for OOM problems during
// development and debugging.
#define TRAPD_OOM_STRESS_TEST(function)	TInt error;{ \
													TInt failnext=0; \
													do { \
														__UHEAP_FAILNEXT(failnext++); \
														TRAP(error,function) \
														__UHEAP_RESET; \
														ASSERT(error==KErrNoMemory || error==KErrNone); \
													} \
													while(error==KErrNoMemory); \
												}


// The __OOM_TEST_LEAVING_HOST_CALLS__ macro can be used to switch on recursive low memory testing for all
// points in the code where Leaving functions are wrapped in TRAPD_WRAPPER macros. When not defined all TRAPD_WRAPPER
// functions revert to normal TRAPD macros.
//#define __OOM_TEST_LEAVING_HOST_CALLS__
#ifdef __OOM_TEST_LEAVING_HOST_CALLS__
#define TRAPD_WRAPPER(function) TRAPD_OOM_STRESS_TEST(function)
#else
#define TRAPD_WRAPPER(function) TRAP_IGNORE(function)
#endif



/*******************************************************************************************/

#endif	// __SAFLASH_COREDEFS__H__
