/*
* Copyright (c) 2006-2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Flash Player build Definitions
*
*/


#ifndef __SAPLAYER_BUILD_H__

#define __SAPLAYER_BUILD_H__

#define __FLASHBINDING_FEATURE__
////////////////////////////////////////////////////////////////////////////
//Platform specific
//
#define GESTURE_LIBRARY_SUPPORTED
//For  touch  
#define FEATURE_TOUCH

//#define FEATURE_F9

#define ENABLE_SF_CHANGES

/*
* Used to turn on and off the Flash Lite 3 features
*/

#define __FEATURE_FLASH_LITE_3_

/////////////////////////////////////////////////////////////////////////////
//FL common feature definitions
//

#define FEATURE_INLINE_TEXT_ENTRY

#ifdef __FEATURE_FLASH_LITE_3_

 /*
* Used to turn on and off the Flash Lite 3 UI feature
* Feature to show flash in fullscreen ,landscape mode
*/	

#define __FEATURE_UI_LANDSCAPE_FULLSCREEN	

#endif

///////////////////////////////////////////////////////////////////////////////
// Web video phase specific definitions. 
//

///////////////////////////////////////////////////////////////////////////////
//host engine specific definitions
//

//#define _HELIX_AUDIO

//#undef RD_MULTIPLE_DRIVE 
#define FEATURE_MULTIPLE_DRIVE 

#ifdef __FEATURE_FLASH_LITE_3_
	/*
	* Used to turn on and off the pre-compiled swf support feature
	*/
	
	#define  __FEATURE_PRE_COMPILED_SWF
	
	/*
	* Used to turn on and off reading the pre-compiled swf file names from RSC file
	*/

	#ifdef __FEATURE_PRE_COMPILED_SWF
	#define __FEATURE_PRE_COMPILED_SWF_RSC
	#endif //__FEATURE_PRE_COMPILED_SWF
	
	/*
	* Used to turn on and off the enhanced heap support for stub
	*/
	
	#define __FEATURE_STUB_ENHANCED_HEAP
	
	
	/*
	* Ability to select FLV extensions in File view , play in viewer and embedded mode
	*/

	#define __FEATURE_FLV_RECOG_PLAY
    /*
    * Ability to select F4V extensions in File view , play in viewer and embedded mode
    */
    #define __FEATURE_F4V_RECOG_PLAY
	
	#define FEATURE_HIDE_SAFLASH
	#define FEATURE_SUPPORT_ALR_SNAP

	#define FEATURE_VIDEO_OVERLAY_RECTS

#define FEATURE_FULLSCREEN
	
#define IADCLIENT_API_SUPPORT
#endif //__FEATURE_FLASH_LITE_3_

#define FEATURE_HOST_SEEK_FLV

//#define FEATURE_PERFORMANCE_AUTOMATION

//#define FEATURE_ATS_AUTOMATION

#define FEATURE_TESTAUTOMATION

#define FEATURE_BINDING_PREINSTALLED_LIB

/////////////////////////////////////////////////////////////////////////////
//Netscape plug-in specific defintions
//
#define FLASH_ENABLE_STRAY_DRAG_SUPPRESSOR

/*
* Used to turn on and off the screensaver support feature
*/

#define __FEATURE_SCREENSAVER

/*
* Used to turn on and off the animation plug-in feature
*/

#define __FEATURE_ANIMATION_PLUGIN

/*
* Used to turn on and off the browser plug-in feature
*/

#define FEATURE_LOCAL_CONNECTION

#define __FEATURE_BROWSER

#ifdef __FEATURE_BROWSER

// Commenting it out as at present __FEATURE_BROWSER_INTERACTIVE_BOOL flag is undefined across all the platforms	
//	#undef __FEATURE_BROWSER_INTERACTIVE_BOOL  //commented for Rel 3.1

	#ifdef __FEATURE_FLASH_LITE_3_

	//#ifdef RD_BROWSER_WIDGETS

		/*
		* Used to turn on and off the Flash Lite web browsability feature
		*/

		#define FEATURE_WEB_BROWSABILITY

		/*
		* Used to turn on and off the Flash 8 External API feature
		*/
		
		#define FEATURE_EXTERNAL_API
		
		#ifndef __S60_32__
		#define _TOT_CHANGES
		#endif //__S60_32__
	
	//#endif

		// Flag to stream data from browser when in browser plug-in mode
		// if undef host engine will stream data from its download mgr

		#define __USE_BROWSER_STREAM__



					
		#ifdef __FEATURE_UI_LANDSCAPE_FULLSCREEN

			/*
			* Used to turn on and off the Flash Lite 3  plug-in UI feature
			* Feature to show flash in fullscreen ,landscape mode
			*/
			#define __FEATURE_PLUGIN_UI_OPTIONS

		#endif //__FEATURE_UI_LANDSCAPE_FULLSCREEN
			
		/*
		*  Do mem allocation from plug-in
		*/

		#define PLUG_IN_MEM_ALLOC

	#endif //__FEATURE_FLASH_LITE_3_

#endif //__FEATURE_BROWSER

//#define __FEATURE_OSK__
#define __FEATURE_TOOLBAR__
#define __FEATURE_CONTEXT_SENSITIVE_MENU__
#define __FEATURE_TOGGLE_ON_DOUBLE_CLICK__
/*
* Used to turn on and off the cursor and scroll support feature
*/
#define ENABLE_CURSOR  

#define FEATURE_EXTENSION

// IAD Flag
#ifdef FF_IAUPDATE
//#define SELF_IAD_UPDATE
#endif



/////////////////////////////////////////////////////////////////////////////
//#define ENABLE_OFN_SUPPORT ////Check if required for 9.2

/////////////////////////////////////////////////////////////////////////////
// Zoom Stripe support macro
//
//
//#define ENABLE_ZOOM_STRIP_SUPPORT //Check if required for 9.2
//debug related flags 
// only for debug purpose, should disable in release candidate
//

#define FEATURE_BG_TRANSPARENCY
//TODO::Remove this check while releasing. It is used to compile the same code on PF5250 SDK.
#ifdef __OPENVGHEADERS_USE_VG_1_1
    #define FEATURE_OPENVG
    #define USE_VPU2
#endif

#ifdef FEATURE_OPENVG
    #define FEATURE_WATCH_GPU_MEM 
#endif

/* Define this macro to use the new implementation for Synchronous  
 * MSO.  If undefined, legacy Asynchronous MSO will be used.
 */
#define USE_SYNC_MSO

//#define FEATURE_WINDOWLESS

/* Define this macro to use the implementation for SI_ComputeStackBase
 * needed for AS3 engine stack limit check
 */
#define FEATURE_COMPUTE_STACK

/* Define this macro if last rendered bitmap handle is shared with browser
 * while scrolling a webpage, 
 * If this flag is enabled browser will draw plugin area while scrolling/Pinch zoom
 */
#define FEATURE_COLLECT_BITMAP

#define LOG_ALL			0
#define LOG_DEBUG		1
#define LOG_INFO		2
#define LOG_ERROR		3
#define LOG_NONE		4


#undef __DEBUG_LOGS__

#ifdef _DEBUG
#define CUR_LOG_LEVEL	LOG_ALL
#else
#define CUR_LOG_LEVEL	LOG_NONE
#endif

#ifdef  __DEBUG_LOGS__
//#define __FILE_MODE_LOGGING
//#define _VIEWER_DEBUG__
//#define NP_DEBUG
//#define __LOG_SI_CALLS__
//#define __LOG_FI_CALLS__
#endif


////////////////////////////////////////////////////////////////////////////
#endif //__SAPLAYER_BUILD_H__
