/*
* Copyright (c) 2006-2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  
*
*/
 

#ifndef SCREENFURNITUREIF_H_
#define SCREENFURNITUREIF_H_

#include <e32std.h>
#include <w32std.h>

#ifdef _BITBUFFER_ENABLED_
#include "flashbitbuffer.h"
#endif

#include "commontypes.h"

class CFbsBitGc;

class MDisplay
    {
public:
#ifdef FEATURE_EXTENSION
    virtual void SetAutoRotationModeL(TBool aMode) = 0; //enable or disable Sensor autoroatation mode
#endif
    virtual TRect ApplicationRect() =0;
    virtual TRect ClientRect() =0;
    virtual void SetAppScreenL() =0;
    virtual void ResetScreenInCurrentModeL() =0;
    virtual void SetSoftkeysL(HBufC** aSoftkeyArray, const TInt aSoftkeyArraySize) =0;
    virtual void ResetSoftkeysL() =0;
    virtual void SetFullScreenL(TBool aMode=EFalse)=0;
    virtual TBool IsFullScreenMode() =0;
    virtual TRect GetClipRect() =0;
    virtual RWindow* GetWindow() =0;
    
#ifdef __FEATURE_OSK__    
    virtual void SetOSKIsActive(TBool aOnoROff) =0;
#endif
	virtual RWindow* GetNewVideoWindow(void* aClient) =0;
	virtual void CloseVideoWindow(void* aClient) =0;
    
    virtual void ZoomShowAll() =0;
    virtual void SetScreenL(EScreenMode aScreenMode) = 0;
    
#ifdef _BITBUFFER_ENABLED_    
    virtual void CreateBitBuffer() {}
    virtual BitmapBuffer* BitBuffer() =0;
    virtual CFbsBitGc*  GetBitmapContext() =0;
    virtual CFbsBitmapDevice* GetBitmapDevice() =0;
    virtual TInt Resize(TSize aSize) =0;
#endif    
    
#ifdef FEATURE_TESTAUTOMATION
    virtual TRect PositionRelativeToDeviceScreen() =0;
#endif
    };
#endif /* SCREENFURNITUREIF_H_ */
