/*
* Copyright (c) 2010 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:
*
*/
/*
 * uinotifier.h
 *
 *  Created on: Apr 10, 2009
 *      Author: vsriram
 */

#ifndef UINOTIFIER_H_
#define UINOTIFIER_H_

#include "symbian_ui_interface.h"

class MUserNotiferIf
    {
public:
    //Not Used
    //virtual TBool QuerySharedObject() =0; 
    
    virtual TBool QueryAllowDeviceIDL() =0;
    
    /**
     Displays a confirmation query that the flash content is
     attempting to access the network.
     */
    virtual TBool QueryAllowNetAccessL() = 0;

    /**
     Displays a confirmation query that the flash content is attempting
     to dial a phone number.
     @return ETrue if the user allows to make the call.
     */
    virtual TBool QueryAllowPhoneCallL(const TDesC& aNumberString) = 0;

    virtual void  NotifyError(TInt /*aErrorCode*/, TBool aIsCritical) =0;
    
    /**
     This function is called by the host engine when there is an error in
     processing the flash content.
     @param aErrorCode The error code.
     @param aIsCritical ETrue if error is critical.
     @param aPersistent ETrue is error is persistent.
     */
    virtual void NotifyFlashError(TInt aErrorCode, TBool aIsCritical,
            TBool aPersistent = ETrue, ErrorInfo* aErroInfo = NULL) = 0;

    /**
     This function is called by the host engine when there is an error in
     processing the flash content.
     @param aErrorCode The error code.
     @param aIsCritical ETrue if error is critical.
     @param aPersistent ETrue is error is persistent.
     */
    virtual void NotifyClientError(TInt aErrorCode, TBool aIsCritical,
            TBool aPersistent = ETrue) = 0;

    /**
     This function is called by the host engine flash status
     processing the flash content.
     @param aErrorCode The error code.
     @param aIsCritical ETrue if error is critical.
     @param aPersistent ETrue is error is persistent.
     */

    virtual void NotifyFlashStatus(TInt aFlashStatus, TAny* aParam) = 0;

    virtual void NotifyDataAccessError(const char* aUrl, TInt aErrorCode) = 0;
    };

#endif /* UINOTIFIER_H_ */
