/*
* Copyright (c) 2007-2008 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Defines the member functions of the stub application class.
*
*/

#include "saflash3.h"
#include <flash_ui.h>


////////////////////////////////////////////////////////////////////////////////
// App initialization functions
////////////////////////////////////////////////////////////////////////////////

#include <eikstart.h>
#include <aknnotewrappers.h>

LOCAL_C CApaApplication* NewApplication( )
{
	CApaApplication* app=NULL;
	TRAP_IGNORE (app = new(ELeave) CFlashStubApplication);
	return app;
}

GLDEF_C TInt E32Main()
    {
    return EikStart::RunApplication(NewApplication);
    }



//#endif //__FLASHLITE_BETA3

CFlashStubApplication::~CFlashStubApplication()
{
	if (iFlashLibrary.Handle())
	{
		iFlashLibrary.Close();
	}
}

const TUid KUidFlashStubApp = { 0x101FD693};


TUid CFlashStubApplication::AppDllUid() const
{
	return KUidFlashStubApp;
}


CApaDocument* CFlashStubApplication::CreateDocumentL()
{
	FlashUIConfig config;
	config.iIsMMI = EFalse;
	config.iIsStubApp = EFalse;
	config.iContentFileName.Copy(KNullDesC);
	config.iContentChecksum = 0;
	config.iExtensions = NULL;
	config.iReserved1 = NULL;
	config.iReserved2 = 0;
	
	if(!FlashStubsSupported())
	{
		User::Leave(KErrNotSupported);
	}
	return CreateFlashDocumentL(iFlashLibrary, this, config);
}



