/*
* Copyright (c) 2006-2008 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:
*
*/


#ifndef BUTTONGRID_H_
#define BUTTONGRID_H_

#ifdef __FEATURE_OSK__

#include <e32base.h>
#include <e32std.h>

class COnScreenKey;

class CButtonGrid : public CBase
{
public:
	CButtonGrid(TRect aLocation, TInt aRows, TInt aCols, TInt aHMargin=0, TInt aVMargin=0);
	~CButtonGrid();
	
	TInt AddButton(COnScreenKey* aOverlayKey);	// sets the OverlayKey rect
	TInt ChangeLayout(TRect aLocation, TInt aRows, TInt aCols,  TInt aHMargin=0, TInt aVMargin=0);
	
	void RemoveAllButtons();
	
private:
	RPointerArray<COnScreenKey> iButtonArray;
	RArray<TPoint>	iButtonLocationArray;
	
	TInt	iRows;
	TInt	iCols;
	TRect	iRect;
	TSize	iCellSize;
	TSize	iActualCellSize;	// this is iCellSize - margin
	TInt    iHMargin;
	TInt    iVMargin;
	
};

#endif //__FEATURE_OSK__
#endif /* BUTTONGRID_H_ */
