/*
* Copyright (c) 2006-2008 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:
*
*/


#ifndef OVERLAYKEY_H_
#define OVERLAYKEY_H_

#ifdef __FEATURE_OSK__

#include <aknbutton.h>

class COnScreenKey : public CAknButton
{
public:
    static COnScreenKey* NewL(TKeyEvent aKeyEvent, TInt aResourceId, TRect aLocation, MCoeControlObserver* aObserver, const CCoeControl& aContainer);
    static COnScreenKey* NewL(TKeyEvent aKeyEvent, TDesC& aCaption, TRect aLocation, MCoeControlObserver* aObserver, const CCoeControl& aContainer);
	~COnScreenKey();
	
	void RePosition(TRect aNewRect);
	TKeyEvent  GetKeyEvent() const;
	void	   SetButtonState(TEventCode aEventCode);
	TBool	   IsRepeat();

protected:
    COnScreenKey(TKeyEvent aKeyEvent, TInt aResourceId, TRect aLocation);
    COnScreenKey(TKeyEvent aKeyEvent, TDesC& aCaption, TRect aLocation);
	void ConstructL(MCoeControlObserver* aObserver, const CCoeControl& aContainer);

private:
	TKeyEvent	iKeyEvent;	// the event associated with this key
	TInt		iResourceId;
	TRect		iLocation;
    TInt        iKeyUpsReceived;
	
};

#endif // __FEATURE_OSK__
#endif /* OVERLAYKEY_H_ */
