/*
* Copyright (c) 2006-2008 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:
*
*/


#ifndef OVERLAYCONTROL_H_
#define OVERLAYCONTROL_H_

#include "saplayer_build.h"

#ifdef __FEATURE_OSK__
#include <aknappui.h>
#include <coecntrl.h>
#include "on_screen_key_observer.h"
#include "on_screen_keypad_constants.h"
#include "on_screen_keypad.h"

class COnScreenKeypad;

class COnScreenKeypadControl: public CCoeControl
{
public:
	static COnScreenKeypadControl* NewL(MOnScreenKeyObserver* aObserver, const TRect& aRect, TOSKMode aMode);
	~COnScreenKeypadControl();
	
	void UpdateL(TRect& aRect, TOSKMode aMode);
	void HandleForeground();
	void DisableToggleScreen();
	
protected:
	COnScreenKeypadControl();
	void ConstructL(MOnScreenKeyObserver* aObserver, const TRect& aRect, TOSKMode aMode);
	
private:
	void Draw(const TRect& aRect) const;
	void HandlePointerEventL(const TPointerEvent& aPointerEvent);
    TInt CountComponentControls() const;
    CCoeControl* ComponentControl(TInt aIndex) const;
    
private: // members
	COnScreenKeypad*	iOnScreenKeypad;
	TInt iControlCount;
	
	TOSKMode iOverlayMode;
};

#endif //__FEATURE_OSK__
#endif /* OVERLAYCONTROL_H_ */
