/*
* Copyright (c) 2005 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Defines the document class.
*
*/


#ifndef __SYMBIAN_DOCUMENT_H__
#define __SYMBIAN_DOCUMENT_H__

#include <AknDoc.h>
#include <flash_ui.h>

class CAiwGenericParamList;
class CSaFlashDocument : public CAknDocument
{
public:
	CSaFlashDocument(CEikApplication& aApp, const FlashUIConfig& aConfig);
	CFileStore* OpenFileL(TBool aDoOpen, const TDesC& aFilename, RFs& aFs);
	void OpenFileL(CFileStore*& aFileStore,  RFile& aFile);
	
		/**
        * Read generic parameter input list.
        */
		void RestoreL  (  const CStreamStore &  aStore,const CStreamDictionary &  aStreamDic );
		
		/**
        * Reset the value of flag indicating whether the base
        * url path is set or not.
        */
		void ResetUrlSetFlag();
		
private: 
	// Inherited from CEikDocument
	CEikAppUi* CreateAppUiL();
	void CheckAllowMove( CAiwGenericParamList*& paramList);

private:
	FlashUIConfig iConfig;
};

#endif // __SYMBIAN_DOCUMENT_H__
