/*
* Copyright (c) 2005 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Defines the file control class.
*
*/


#ifndef __SYMBIAN_FILECONTROL_H__
#define __SYMBIAN_FILECONTROL_H__

#include <eiklbo.h>		// for MEikListBoxObserver
#include <e32base.h>
#include <eiksbfrm.h>
#include <touchfeedback.h>

class CSaFlashFileView;
class CEikFormattedCellListBox;
//#ifdef __FLASHLITE2.0_REL3.1
////////////////////////////////////////////////////////////////////////////////
// Constants
////////////////////////////////////////////////////////////////////////////////
const TInt KWaitNoteCallBackPriority(CActive::EPriorityStandard);
const TInt KMaxWaitNoteShowTime = 2000000;
//#endif //__FLASHLITE2.0_REL3.1

class CSaFlashFileControl : public CCoeControl, public MEikListBoxObserver , public MEikScrollBarObserver
{
public:
	CSaFlashFileControl(CSaFlashFileView* aView);
	~CSaFlashFileControl();
	void ConstructL(const TRect& aRect);

public:		// external interface for CSaFlashFileView

	// Builds the list box control
	void BuildListBoxL();

	// Sets the list box text array
	void UpdateTextArrayL(CDesCArray* textArray, const TDesC& aEmptyMsg);

	void SetCurrentItemL(TInt aIndex);
	void ShowWaitNoteL(TInt aResourceId);
	//Callback function for deleting wait note.
	static TInt WaitNoteTimeoutL( TAny* aThis );

public:		// override from CCoeControl

	TInt CountComponentControls() const;
	CCoeControl* ComponentControl(TInt aIndex) const;
	TKeyResponse OfferKeyEventL(const TKeyEvent& aKeyEvent, TEventCode aType);

	void HandleResourceChange(TInt aType);

private:	// override from CCoeControl

	void SizeChanged();
	
private:	// override from MEikListBoxObserver

	void HandleListBoxEventL(CEikListBox* aListBox, TListBoxEvent aEventType);
	private:
	virtual void HandleScrollEventL(CEikScrollBar* aScrollBar,
                                             TEikScrollEvent aEventType);

private:	// Methods
	
	void SetGraphicIconsL();

private:	// Data

	CEikFormattedCellListBox* 		iListBox;
	CSaFlashFileView*				iView;
	CPeriodic*    iWaitNoteTimer;
	/*
    * Flag which determines whether tactile feedback is supported or not.
    */
    TBool iTactileFeedbackSupported;
    
    MTouchFeedback* iFeedback;
};

#endif //__SYMBIAN_FILECONTROL_H__