/*
* Copyright (c) 2005 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Defines the the Trust store for list of trusted files.
*
*/

//SecuritySandbox
#ifndef SYMBIAN_RESTARTTIMER_H_
#define SYMBIAN_RESTARTTIMER_H_
#include <e32base.h>
#include <s32std.h>
#include <e32cmn.h>
class CSaFlashAppUi;

class CRestartTimer:public CTimer
    {
    public:
        /*
         * Two Phase Constructor 
         * 
         * contructs the timer object and eturns the pointer
         */
        static CRestartTimer* NewL(TInt aPriority,CSaFlashAppUi *aAppUI);
        
        /*
         * Destructor
         */
        ~CRestartTimer();
        /*
         * Function to start the timer
         */
        void Start();
    public:  //From CActive 
        void RunL();
        
    private:
        /*
         * Second phase constructor
         */
        void ConstructL();
        /*
         * private Constructor
         * @param TInt aPriority priority of the atcive scheduler
         * @param CSaFlashApUi aAppUI instance of AppU
         */ 
         CRestartTimer(TInt aPriority,CSaFlashAppUi *aAppUI);
    public:
        /*
         * Instance of AppUI to resatart the player
         */
        CSaFlashAppUi *iAppUI;

    };
#endif //SYMBIAN_RESTARTTIMER_H_


