/*
* Copyright (c) 2005 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Defines the volume control class.
*
*/


#ifndef __SYMBIAN_VOLUMECONTROL_H__
#define __SYMBIAN_VOLUMECONTROL_H__

#include <coecntrl.h>

class CSaFlashVolumeView;
class CGulIcon;
class CAknVolumeControl;

class CSaFlashVolumeControl : public CCoeControl
{
public:
	CSaFlashVolumeControl(CSaFlashVolumeView* aView);
	~CSaFlashVolumeControl();
	void ConstructL(const TRect& aRect);
	
	void AddControls();
	void Mute(TBool aFMute);
	RWindow* GetWindow() { return &Window(); } 
	TRect GetClippingRect() 
    {
    return iEngRect;
    }

	
private:
	// Inherited from CCoeControl
	void Draw(const TRect& aRect) const;
	TKeyResponse OfferKeyEventL(const TKeyEvent& aKeyEvent, TEventCode aType);
	void HandlePointerEventL(const TPointerEvent& aPointerEvent);
	void HandleResourceChange(TInt aType);
	void DrawControlL(const TRect& aRect);
	TInt CountComponentControls() const;
	CCoeControl* ComponentControl( TInt aIndex ) const;
    void SizeChanged();
	
private:
	CSaFlashVolumeView*		iView;
	TInt iVolume;
	TInt iMaxVolume;
	TBool iActivatedNow;
	mutable TInt iDrawnVolume;
	mutable TRect iEngRect;
	TRect iVolumeRect;
	TRect iVolumeBitmapRect;
	CFbsBitmap* iVolumeBitmap;
	CGulIcon* iMuteIcon;
	CAknVolumeControl* iAknVolumeControl;
};

#endif // __SYMBIAN_VOLUMECONTROL_H__
