/*
* Copyright (c) 2008-2009 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  
                                 
*
*/


#ifndef __SYMBIAN_VOLUMEVIEW_H__
#define __SYMBIAN_VOLUMEVIEW_H__

#include "symbian_view.h"

class CSaFlashVolumeControl;
class MFlashEngine;

class CSaFlashVolumeView : public CSaFlashView
{
public:
	CSaFlashVolumeView(MFlashEngine* aEngine);
	void ConstructL();
	~CSaFlashVolumeView();
	void MakeStatusPaneInvisible();	
	
public: // from CAknView
	TUid Id() const;
	void DoActivateL(const TVwsViewId& aPrevViewId, TUid aCustomMessageId, const TDesC8& aCustomMessage );
	void DoDeactivate();
	void HandleCommandL(TInt aCommand);
	RWindow* GetWindow();
	TBool IsFullScreen();
	TRect GetClippingRect();
public: // from CSaFlashView
	CCoeControl* GetContainer();
	void HandleResourceChange(TInt aType);
	void ShowMuteIconL(TBool aMute);
	void HandleError(TInt aErr);
	
private:
	CSaFlashVolumeControl*	iContainer;
	MFlashEngine*	iEngine;
	TInt iPrevVolume;
	friend class CSaFlashVolumeControl;
};

#endif // __SYMBIAN_VOLUMEVIEW_H__