/*
* Copyright (c) 2008-2009 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  
                                 
*
*/


#ifndef _UI_DEFS_H_
#define _UI_DEFS_H_


const TUid KUidSAFlash = { 0x101FD693 }; 

const TUid KSAFlashPlayerViewId = { 1 };
const TUid KSAFlashFileViewId = { 2 };
const TUid KSAFlashVolumeViewId = { 3 };
const TUid KSAFlashAboutViewId = { 4 };

// Series60 v2 only supports two softkeys.
const TInt KSoftkeyCount = 2;


const TInt KMaxPasswordInputChars = 80;

//const TInt KReportErrorStartDelay = 1000;
const TInt KReportErrorStartDelay = 1000000;
const TInt KReportErrorInterval = 0;

//For the about dialog
const unsigned short KVerInfoLength = 50;
const unsigned short KAboutTxtBoldStartPos = 0;
const unsigned short KAboutTxtBoldLength = 23; 
//For AppUi
const unsigned short KCommonArraySize = 32;
const TInt KCommonBufSize = 256;

_LIT(KDirSearchStr, "*");
_LIT(KDirSeparator, "\\" );

_LIT(KFlashMimeType, "application/x-shockwave-flash");
//#ifdef __FEATURE_FLV_RECOG_PLAY
_LIT(KFLVMimeType,"video/x-flv");
//#endif
//#ifdef __FEATURE_F4V_RECOG_PLAY
_LIT(KF4VMimeType,"video/x-f4v");
//#endif
// maximum size of an attachment
const TInt KMaximumMessageSize = 100000;

// Volume control graphics
const TUint32 KLightColor = 0x00FFAAAA;
const TUint32 KDarkColor = 0x00AA4433;
const TInt KVolumeBarMinimumSteps = 2;
const TInt KVolumeControlSlots = 16;
const TInt KVolumeControlLeftArrowSlot = 1;
const TInt KVolumeControlFirstBarSlot = 3;
const TInt KVolumeControlRightArrowSlot = 14;
const TInt KVolumeControlTopOffset = 2;
const TInt KVolumeControlBottomOffset = 2;

// These are used by the file view and dirlist

const TUint32 KMaxFileNameLen = 64;

_LIT(KFileSearchStr, "*");
_LIT(KSwfSearchStr, "*.swf");
_LIT(KDcfSearchStr, "*.dcf");
_LIT(KOdfSearchStr, "*.odf");
//#ifdef __FEATURE_FLV_RECOG_PLAY
_LIT(KFlvSearchStr, "*.flv");
//#endif
//#ifdef __FEATURE_F4V_RECOG_PLAY
_LIT(KF4vSearchStr, "*.f4v");
//#endif
//_LIT(KSvgSearchStr, "*.svg");

_LIT(KSwfExtension, ".swf");
_LIT(KFlvExtension, ".flv");
_LIT(KF4vExtension, ".f4v");

#define KDirIconId	'0'
_LIT(KDirItemPrefix, "0" );

#define KSwfIconId	'1'
_LIT(KSwfItemPrefix, "1" );

//#ifdef __FLASHLITE2.0_REL3.1
#define KDirSubIconId	'2'
_LIT(KDirSubItemPrefix, "2" );


_LIT(KSwfRightsValidPrefix, "3");
_LIT(KSwfItemRightsExpPrefix, "4");

_LIT(KPhoneIcon, "0\t");
_LIT(KMemoryCardIcon, "1\t");
//#endif //__FLASHLITE2.0_REL3.1

//#ifdef __FLASHLITE2.0_REL3.1
_LIT(KAvkonMbmFilePath1, "\\resource\\apps\\avkon2.mif"); 

// file view depth 
// over 4 folders in depth is displayed just as tree dots at the end of navipane.
const TUint KSaFlashMaxDepth = 4;
const TUint KSaFlashRoot = 0;
const TUint KSaFlashFirstLevel = 1;
const TUint KSaFlashSecondLevel = 2;
const TUint KSaFlashThirdLevel = 3;
const TUint KSaFlashFourthLevel = 4;
const TUint KSaFlashLastLevel = 4;
//#endif //__FLASHLITE2.0_REL3.1
#endif // _UI_DEFS_H_