/*
* Copyright (c) 2008-2009 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  
                                 
*
*/


#include "platformbuild.h"		// Warning: this *must* the first include of every source file.
								//			It contains all the #define build parameters.
#include "saplayer_build.h"
#include <akntitle.h> 
#include <aknappui.h>
#include <StringLoader.h>
#include <drmrightsmanager.rsg>
#include <pathinfo.h>
#ifdef FEATURE_MULTIPLE_DRIVE
#include <driveinfo.h>
#endif
#include <textresolver.h>
#include <nwx_status.h>
#include <in_iface.h>
#include <bldvariant.hrh>
#include <AknCommonDialogs.h>
#include <featmgr.h>
#include <tz.h>
#include <bautils.h>
#include <CAknFileNamePromptDialog.h>
#include "platformclib.h"

#include "symbian_appui.h"
#include "symbian_playerview.h"
#include "symbian_playercontrol.h"
#include "playerviewmenumgr.h"

#include "flash2ui.hrh"
#include "symbian_uiutil.h"
#include "saflash_consts.h"
#include "saflash_coredefs.h"
#include "flash_engine.h"
#include "symbian_fileview.h"
#include "commondef.h"
//#include "symbian_dirlist.h"
#include "ui_defs.h"

#include <aknlists.h>
#include <aknPopup.h>
#include <AknSettingCache.h>
#include <flash2ui.rsg>
#ifdef __FEATURE_TOOLBAR__
#include <flash2uiiad.rsg>
#endif
#ifndef EKA2
#include <sendnorm.rsg> // for CSendAppUi reference to R_SENDUI_MENU
#endif //EKA2
#include <AknGlobalNote.h> 

#include <AknQueryDialog.h>


#ifdef FEATURE_DEBUG_SOFTKEY_LOCATION
const TInt EFlashCmdSofkeyLocChange=701;
#endif // FEATURE_DEBUG_SOFTKEY_LOCATION

#ifdef FEATURE_INLINE_TEXT_ENTRY
#include "amp_textnavigation.h"
#endif // FEATURE_INLINE_TEXT_ENTRY


#ifdef FEATURE_MULTIPLE_DRIVE    
#include <AknCommonDialogsDynMem.h>
#include <CAknMemorySelectionDialogMultiDrive.h>
#include <CAknFileSelectionDialog.h>
#endif

#ifdef __FEATURE_OSK__
#include "on_screen_keypad_control.h"
#include "on_screen_keypad_constants.h"
#include "on_screen_keypad.h"
#include "timer_object.h"
#endif // __FEATURE_OSK__


#if defined(__WINS__)
    #define WINS_DEFAULT_VOLUME 43690 //two-third of the maximum volume
#endif        

extern void VwrDebug(TUint8 aLogLevel, TRefByValue<const TDesC> aText, ... );
////////////////////////////////////////////////////////////////////////////////
// CSaFlashPlayerView
////////////////////////////////////////////////////////////////////////////////
struct TSaFlashError
{
	TInt errorcode;
	TInt resourceIdDbg;
	TInt resourceIdRls;
};


CSaFlashPlayerView::CSaFlashPlayerView(TUint32 aDebugMode, TBool aIsStubApp):
											 iFullScreen(EFalse)
											,iContainer(NULL)
											,iErrorHandler(NULL)
											,iLowMemErrorDialog(NULL)
#ifdef __FEATURE_OSK__
                                            ,iOnScreenKeypadControl(NULL)
                                            ,iCompatabilityMode(ETrue)
                                            ,iASyncOnScreenKeypadDestroyer(NULL)
#endif // __FEATURE_OSK__											
											,iQuality(EEikFlashCmdQualityMed)
											,iFirstHit(ETrue)
											,iFlashErrorBuffer(NULL)
											,iReportedErrorsFlag(0)
											,iLaunchType(EStartedFromMenu)
											,iIsStubApp(aIsStubApp)
											,iDebugMode(aDebugMode)
											,iSavedFilename(NULL)
											,iVolume(0)
											,iVolumeLevel(0)
											,iBackButtonActive(EFalse)
											,iDrmHelper(NULL)
											,iSideVolKeysSupported(EFalse)
											,iActivatingVolumeView(EFalse)
											,iZoomSuccess(ETrue)
											,iZoomedTimes(0)
											, iFileInitialized(EFalse)
                                            ,iEngineInitiatedPause(EFalse)
											,iDisableMenuRotateScreen(EFalse)
											#ifdef FEATURE_INLINE_TEXT_ENTRY
											,iIMEControl(NULL)
											,iIMEWasDeactivatedForPausing(EFalse)
											#endif //FEATURE_INLINE_TEXT_ENTRY
											#ifdef __FEATURE_UI_LANDSCAPE_FULLSCREEN
											,iAppOrtn(CAknAppUiBase::EAppUiOrientationUnspecified)
											,iVideoContent(EFalse)
											,iLandScape(EFalse)
											#endif
											,iEmbeddedVideo(EFalse)
                                            ,iIsTouchFeatureSupported(EFalse)											
{
	
	iSideVolKeysSupported = FeatureManager::FeatureSupported(KFeatureIdSideVolumeKeys);
	#ifdef __FEATURE_OSK__
	iLSK = EEikFlashCmdNone;
	iRSK = EEikFlashCmdNone;
	#endif // __FEATURE_OSK__
}

CSaFlashPlayerView::~CSaFlashPlayerView()
{

		
	delete iErrorHandler;
	delete iContainer;
#ifdef FEATURE_INLINE_TEXT_ENTRY
	delete iIMEControl;
#endif // FEATURE_INLINE_TEXT_ENTRY
	delete iFlashErrorBuffer;
	delete iLowMemErrorDialog;
	if (iDrmHelper)
    {
        delete iDrmHelper;
    }
	
    if( iSavedFilename )
    {
    	delete iSavedFilename;
    	iSavedFilename = NULL;
    }
    

    
   #ifdef __FEATURE_UI_LANDSCAPE_FULLSCREEN
    if(iUiChanger)	
    {
    	delete iUiChanger;
    	iUiChanger= NULL;
    }
   #endif 	
   
   if(iMenuMgr)	
   {
   		delete iMenuMgr;
   		iMenuMgr = NULL;
   }

#ifdef __FEATURE_OSK__
   if(iOnScreenKeypadControl)
   {
       delete iOnScreenKeypadControl;
       iOnScreenKeypadControl = NULL;
   }
#endif // __FEATURE_OSK__
}
void CSaFlashPlayerView::ConstructL(/*MFlashUI* aFlashUI,*/ FlashEngineConfig& aConfig
/*
#ifdef SELF_IAD_UPDATE
        , MIadUpdateCallback* aIADUpdateCallbackInterface
#endif
*/
        )
{
    FeatureManager::InitializeLibL();  // Initialising feature manager
    iIsTouchFeatureSupported = FeatureManager::FeatureSupported(KFeatureIdPenSupport);
    FeatureManager::UnInitializeLib(); // Uninitialise Feature manager
    
	VwrDebug(LOG_DEBUG,_L("CSaFlashPlayerView::ConstructL() ++"));
	BaseConstructL(R_SAFLASH_PLAYERVIEW);
	VwrDebug(LOG_DEBUG,_L("CSaFlashPlayerView::ConstructL(): BaseConstructL(R_SAFLASH_PLAYERVIEW)"));

	iContainer = new(ELeave) CSaFlashPlayerControl(this) ;
	VwrDebug(LOG_DEBUG,_L("CSaFlashPlayerView::ConstructL(): iContainer = new(ELeave) CSaFlashPlayerControl(this)"));
	iContainer->SetMopParent(this);
	VwrDebug(LOG_DEBUG,_L("CSaFlashPlayerView::ConstructL(): iContainer->SetMopParent(this)"));
	
#ifdef __FEATURE_TOOLBAR__
	if(iIsTouchFeatureSupported)
	{
			iShowToolBar = ETrue;
    CreateAndSetToolbarL(R_FLASH_TOOLBAR_PORTRAIT);
    ShowToolbarOnViewActivation(ETrue);
    CAknToolbar* fixedToolbar = Toolbar(); 
	    if(fixedToolbar)
		{
        fixedToolbar->SetToolbarObserver(this);
        fixedToolbar->SetToolbarVisibility(ETrue, ETrue);
    }	
	}
#endif

	
    iContainer->ConstructL(/*aFlashUI,*/ ClientRect(), aConfig
/*
#ifdef SELF_IAD_UPDATE
            , aIADUpdateCallbackInterface
#endif          
*/
            );
	VwrDebug(LOG_DEBUG,_L("CSaFlashPlayerView::ConstructL(): iContainer->ConstructL(aFlashUI, ClientRect(), aConfig)"));

	//AppUi()->Cba()->SetCommandSetL(R_AVKON_SOFTKEYS_OPTIONS_BACK);
	AppUi()->Cba()->SetCommandSetL(R_SAFLASH_PLAYERVIEW_SOFTKEYS_OPTIONS_BACK);
	iBackButtonActive = ETrue;
	iFlashErrorBuffer = HBufC::NewL(KMaxErrorMsgSize);

	const TInt resourceId = R_STR_RLS_OUTOFMEMORY_ERROR;
	iLowMemErrorDialog = CFlashErrorDialog::NewL(*GetEngine(),R_SAFLASH_ERRORDIALOG_ABORT, resourceId, *iEikonEnv);

	iErrorHandler = new(ELeave) SAFlashErrorHandler ( this, *iLowMemErrorDialog );
	
	iDrmHelper = CDRMHelper::NewL( *CCoeEnv::Static() );

	

	
	#ifdef __FEATURE_UI_LANDSCAPE_FULLSCREEN
		iAppOrtn = iAvkonAppUi->Orientation();
		iUiChanger = new (ELeave) CAsyncUIChanger(this);
		
	#endif
	
	if(aConfig.iMode & KDisableMenuRotateScreen ) 
		iDisableMenuRotateScreen = ETrue;
	
	TRAP_IGNORE(iMenuMgr = CPlayerViewMenuManager::NewL(this
										,iContainer
										,((CSaFlashAppUi*)AppUi())));
	
	VwrDebug(LOG_DEBUG,_L("CSaFlashPlayerView::ConstructL() --"));
}

TUid CSaFlashPlayerView::Id() const
{
	return KSAFlashPlayerViewId;
}

void CSaFlashPlayerView::HandleEmbeddedAppLaunch(TBool aAppTakesForeground)
{
	// This function makes the PlayerView invisible when we launch
	// an embedded app. This fixes a problem where embedded apps
	// would not redraw their complete status pane.
	if (aAppTakesForeground)
	{
		iContainer->MakeVisible(EFalse);
	}
	else
	{
		iContainer->MakeVisible(ETrue);
	}
}

void CSaFlashPlayerView::DoActivateL(const TVwsViewId& /*aPrevViewId*/, TUid /*aCustomMessageId*/, const TDesC8& /*aCustomMessage*/)
{
    /* EPLU-84GAA5: Moved additon of view to
     * CSaFlashAppUi::CreatFlashViewsL function 
     */
	// Adds container to view control stack.
	//AppUi()->AddToStackL(*this, iContainer);
	iContainer->MakeVisible(ETrue);

	if (iFullScreen || iIsStubApp)
	{
		StatusPane()->MakeVisible(EFalse);
		Cba()->MakeVisible(EFalse);
	}
	else
	{
		StatusPane()->MakeVisible(ETrue);
		Cba()->MakeVisible(ETrue);
	}
#ifdef __FEATURE_TOOLBAR__
	if(iIsTouchFeatureSupported)
	{
    CAknToolbar* fixedToolbar = Toolbar(); 
        if(fixedToolbar && iShowToolBar)
        {
            fixedToolbar->SetToolbarVisibility(ETrue, ETrue);
        }
	}
#endif
	iVolume = iContainer->GetEngine()->GetVolume();
	
	//This  has  to be tested  and agreedupon  in 3.2 devices  and  can  be  removed
	/*if ( iVolume & KMuteMask )
		{
		#ifndef FEATURE_TOUCH	
				iContainer->ShowMutedIconL(ETrue);		//SCALABLE			
			#endif
		}	*/					
	SetPlayerViewTitleL();
	iContainer->GetEngine()->SetForeground(ETrue);
	if( !iActivatingVolumeView )
	    {
	    iContainer->GetEngine()->ResumeL(EReasonFocus, ETrue);
	    }
	else
        {
        iActivatingVolumeView = EFalse;
		}
	
	// Gets the current input launguage id.
	CAknSettingCache& cache = CAknEnv::Static()->SettingCache();
	iContainer->SetCurrentInputLanguage (cache.InputLanguage());
	iContainer->DrawNow();
}

void CSaFlashPlayerView::DoDeactivate()
{
	if (!fBeingDestroyed)
	{
		StatusPane()->MakeVisible(ETrue);
	    Cba()->MakeVisible(ETrue);
	}
	
	if (iContainer)
	{
		CancelFocusHandler();

		AppUi()->RemoveFromStack(iContainer);
		iContainer->MakeVisible(EFalse);
		MFlashEngine* pEngine = iContainer->GetEngine();
		if (pEngine && !iActivatingVolumeView)
		{
			pEngine->SetForeground(EFalse);
			pEngine->Pause(EReasonFocus);
		}
	}
}

#ifdef FEATURE_INLINE_TEXT_ENTRY

CSaFlashPlayerBaseIMEControl* CSaFlashPlayerView::GetIMEControl()
{
	return iIMEControl;
}

void CSaFlashPlayerView::ResetIMEL()
	{
	if( iIMEControl->IsInLine() )
		{
		iContainer->SimulateIMEEventL(); // Disabling
		iContainer->SimulateIMEEventL(); // Enabling
		}
	}

void CSaFlashPlayerView::DisableIME()
	{
	if(iIMEControl)
		{
		iIMEControl->CommitConversion(EFalse);

		CCoeFep* fep = iCoeEnv->Fep();
		if (fep!=NULL)
			{
			// Conversion string is already committed above (wanted behavior).
			//
			// Hopefully this does some good in resetting FEP variables.
			fep->CancelTransaction();
			}

		// FEP may have changed the soft keys at this point so reset them
		// T9 and Zi FEPs leave soft keys un-reseted even if we called CCoeFep->CancelTransaction().
		// This should help.
		RemoveCba(CEikButtonGroupContainer::ELeftSoftkeyPosition);
		RemoveCba(CEikButtonGroupContainer::ERightSoftkeyPosition);
		RemoveCba(CEikButtonGroupContainer::EMiddleSoftkeyPosition);

		//CEikButtonGroupContainer* cba = Cba();
		AppUi()->RemoveFromStack(iIMEControl);
		delete iIMEControl;
		iIMEControl = NULL;
		iContainer->GetEngine()->GetTextNavigation()->ShowCursor(ETrue);
		GetEngine( )->RestoreSoftKeys();
		}
	}

void CSaFlashPlayerView::RemoveCba(TUint aButtonPos)
	{
	CEikButtonGroupContainer* cba = Cba();
	
	if( !cba ) 
		{
		return;	
		}
	
	if (!iIMEControl->IsInLine())
		{
		return;	
		}
	
	CSaFlashPlayerIMEControl *imeControl = (CSaFlashPlayerIMEControl*) iIMEControl;			
    CAknEdwinState* fepState = imeControl->FepState();
    
    if (!fepState)
	    {
	    return;	
	    }
    
    //if (EditorState()->CbaState().iRightSoftkeyCommandId)
    CAknEdwinState::SEditorCbaState& cbaState = fepState->CbaState();
    
    switch(aButtonPos)
		{
		case CEikButtonGroupContainer::ELeftSoftkeyPosition:
			if (!cbaState.iLeftSoftkeyCommandId)
				{
				return;	
				}
			cba->RemoveCommandFromStack(aButtonPos, cba->ButtonGroup()->CommandId(aButtonPos));
			cba->RemoveCommandObserver(aButtonPos);
			cbaState.iLeftSoftkeyCommandId=0;    
			break;

		case CEikButtonGroupContainer::ERightSoftkeyPosition:
			if (!cbaState.iRightSoftkeyCommandId)
				{
				return;	
				}
			cba->RemoveCommandFromStack(aButtonPos, cba->ButtonGroup()->CommandId(aButtonPos));
			cba->RemoveCommandObserver(aButtonPos);
			cbaState.iRightSoftkeyCommandId=0;    
			break;

		case CEikButtonGroupContainer::EMiddleSoftkeyPosition:
			if (!fepState->MiddleSoftkeyCommandId())
				{
				return;	
				}
			cba->RemoveCommandFromStack(aButtonPos, cba->ButtonGroup()->CommandId(aButtonPos));
			cba->RemoveCommandObserver(aButtonPos);
			fepState->SetMiddleSoftkeyCommandId(0);    
			break;
		}
	}

void CSaFlashPlayerView::EnableIMEL()
{
	CAknSettingCache& cache = CAknEnv::Static()->SettingCache();
	if (iContainer->CurrentInputLanguage() != cache.InputLanguage())
	{
	iContainer->SetCurrentInputLanguage(cache.InputLanguage());	
	}
	
	CInputModeSelector* inputModeSelector = CInputModeSelector::NewL(iContainer->GetEngine()->GetTextNavigation(),iContainer);
	bool IsFep  = inputModeSelector->IsFEP();
	delete inputModeSelector;
	if ((iIMEControl) && !iIMEControl->IsInLine()) 
	{	
		delete iIMEControl;
		iIMEControl = NULL;		
	}

	if(!iIMEControl)
	{
		if (IsFep) 
			{	
			iIMEControl = new (ELeave) CSaFlashPlayerFEPIMEControl(iContainer->GetEngine(),
																	this,
																	iContainer->PositionRelativeToScreen());
			}
		else 
			{
			iIMEControl = new (ELeave) CSaFlashPlayerIMEControl(iContainer->GetEngine(),
																this,
																iContainer->PositionRelativeToScreen());

			(STATIC_CAST(CSaFlashPlayerIMEControl*, iIMEControl))->SetCurrentInputLanguage(iContainer->CurrentInputLanguage()); 
			}
				
	/*******************************************************************************/
		iIMEControl->SetMopParent(this);
		iIMEControl->ConstructL();
		iContainer->iIsActivatingIME = ETrue;
		AppUi()->AddToStackL(*this, iIMEControl);
		iContainer->iIsActivatingIME = EFalse;
		ResetSoftkeysL();
	}
}

TInt CSaFlashPlayerView::GetCurrentInputMode()
{
	if(iIMEControl)
	{
		if (iIMEControl->IsInLine() == true) 
			{
			CSaFlashPlayerIMEControl *imeControl = (CSaFlashPlayerIMEControl*) iIMEControl;
			CAknEdwinState* state = (CAknEdwinState*) imeControl->Extension1()->State(KNullUid);
			if(state)
				{
				return state->CurrentInputMode();
				}
			}
	}

	return KErrNotFound;
}

void CSaFlashPlayerView::GetInputTextL(const TUint16* aInitialString, TUint aStrLen, TUint aMaxNumChars, TUint aTextFlags)
	{
	TGetInputTextData *getInputTextRequest = new(ELeave) TGetInputTextData;
	TPtrC16 ptr(aInitialString, aStrLen);
	getInputTextRequest->iInitialString = ptr.AllocL();  //ptr.AllocL();
	
	if (aMaxNumChars > KMaxNumChar)
		{
		//Max number characters which can be entered to text field.
		//Host will never get Zero for it.
		aMaxNumChars =  KMaxNumChar ;
		}	
	getInputTextRequest->iMaxNumChars = aMaxNumChars;

	getInputTextRequest->iTextFlags = aTextFlags;
	((CSaFlashAppUi*)AppUi())->GetInputTextL(*getInputTextRequest);

	delete getInputTextRequest->iInitialString;
	delete getInputTextRequest;
	}

#endif // FEATURE_INLINE_TEXT_ENTRY

/*static void
HandleSoftKey( TInt aScanCode, CCoeControl& aControl )
{
	TKeyEvent keyEvent;
	Mem::FillZ( & keyEvent, sizeof( TKeyEvent ) );

	keyEvent.iScanCode = aScanCode;

	aControl.OfferKeyEventL( keyEvent, EEventKey );
}*/


#ifdef __FEATURE_UI_LANDSCAPE_FULLSCREEN

void CSaFlashPlayerView::RotateAppL()
{


		
	// On opening flash file, very first time when "Options->Rotate Display" is pressed, Orientation is EAppUiOrientationUnspecified that is default--irrespective of mode.
	// If device is in potrait mode, on first rotate display command, device is set to Landscape.
	
	// Special case:
	// If device is in Landscape mode, on first rotate display command device is set to Landscape-rather than Potriat- only. 
	// Because of satisfaction of first condition.
	// On Second rotate display command, device is set to potrait,because Orientation returned by follwoing statment is EAppUiOrientationLandscape than EAppUiOrientationUnspecified.
	
	TInt AppOrtn = iAvkonAppUi->Orientation();
	
	if(AppOrtn == CAknAppUiBase::EAppUiOrientationLandscape)
		{
		iAvkonAppUi->SetOrientationL(CAknAppUiBase::EAppUiOrientationPortrait);
		iLandScape = EFalse;
		}
	else if (AppOrtn == CAknAppUiBase::EAppUiOrientationPortrait)
		{
		iAvkonAppUi->SetOrientationL(CAknAppUiBase::EAppUiOrientationLandscape);
		iLandScape = ETrue;
		}
	else // for EAppUiOrientationUnspecified
		{
		TRect rect = ApplicationRect();
		TInt width = rect.Width();
		TInt height = rect.Height();

		if (width > height)
			{
			iAvkonAppUi->SetOrientationL(CAknAppUiBase::EAppUiOrientationPortrait);
			iLandScape = EFalse;
			}
		else
			{
			iAvkonAppUi->SetOrientationL(CAknAppUiBase::EAppUiOrientationLandscape);
			iLandScape = ETrue;
			}
		}
		
	if( iContainer && iContainer->GetEngine() )
	{
		iContainer->GetEngine()->UpdateVideoScreen();
	}
}

void CSaFlashPlayerView::RestoreOrientationL()
{	
    /***
	TInt AppOrtn = iAvkonAppUi->Orientation();
	
	if(AppOrtn != iAppOrtn)	
	{
		iAvkonAppUi->SetOrientationL(iAppOrtn);
	}
	
	SetAppScreenL();
	
	if( iContainer && iContainer->GetEngine() )
	{
		iContainer->GetEngine()->UpdateVideoScreen();
	}
	***/
}

void CSaFlashPlayerView::GoLandscapefullScreenL()
{
	TInt AppOrtn = iAvkonAppUi->Orientation();
	
	if(AppOrtn != CAknAppUiBase::EAppUiOrientationLandscape)
	{
		iAvkonAppUi->SetOrientationL(CAknAppUiBase::EAppUiOrientationLandscape);
		iLandScape = ETrue;
	}
	
	SetFullScreenL();
}

void CSaFlashPlayerView::VideoInPlay()
{
    iVideoContent = ETrue;	
    iContainer->VideoInPlay();
    
    TBool checkFileRetVal = EFalse;
   
    if ( iLaunchType == EEmbedded ) 
    {
        TRAPD(error, checkFileRetVal = FlashUiUtil::GetFileTypeL(iFile));
        if (error != KErrNone)
            {
            VwrDebug(LOG_DEBUG,
            _L("CSaFlashPlayerView::VideoInPlay() FlashUiUtil::GetFileTypeL leave: %d\n"), error);
            }
    }
    else
        
    {
        TFileName fileName;
        fileName = *((CSaFlashAppUi*)AppUi())->GetFilename();
        TRAPD(error, checkFileRetVal = FlashUiUtil::GetFileTypeL(fileName));
        if (error != KErrNone)
        {
        VwrDebug(LOG_DEBUG,
        _L("CSaFlashPlayerView::VideoInPlay() FlashUiUtil::GetFileTypeL leave: %d\n"), error);
        }
    }
    if (checkFileRetVal == 2 || checkFileRetVal == 3)
    {
        iUiChanger->IssueRequest();
    }
}

void CSaFlashPlayerView::VideoIsEmbedded(TBool aEmbeddedVideo)
{
	iEmbeddedVideo = aEmbeddedVideo;
}

void CSaFlashPlayerView::VideoNotInPlay()
{
    iVideoContent = EFalse;
    iEmbeddedVideo = EFalse;
    iContainer->VideoNotInPlay();   
}

void CSaFlashPlayerView::DoZoomShowAll()
{
    /* Zoom out completely for any video content present.
     * Scenario: Frame 1 is zoomed in & pan OFF.  Now user moves
     * to Frame 2 which contains Video content */

    TRAPD(error, HandleCommandL(EEikFlashCmdShowAll));
    if (KErrNone != error)
    {
        VwrDebug(LOG_DEBUG,
            _L("CSaFlashPlayerView::DoZoomShowAll() HandleCommandL leave: %d\n"), error);
    }
}
#endif  //__FEATURE_UI_LANDSCAPE_FULLSCREEN

void CSaFlashPlayerView::HandleBackgroundEvent()
{
	iContainer->CancelPauseBlinker();
}

void CSaFlashPlayerView::CancelHwKeyObserver()
{
	iContainer->CancelHwKeyObserver();
}

void CSaFlashPlayerView::AddHwKeyObserverL()
{
	iContainer->AddHwKeyObserverL();
}

void CSaFlashPlayerView::CloseVolPopUp()
{
	iContainer->CloseVolPopUp();
}

void CSaFlashPlayerView::HandleForegroundEvent()
{
	iContainer->ResumePauseBlinker();
#ifdef __FEATURE_OSK__
	if(iOnScreenKeypadControl)
	{
		iOnScreenKeypadControl->HandleForeground();
	}
#endif // __FEATURE_OSK__
}

#ifdef __FEATURE_TOOLBAR__
void CSaFlashPlayerView::OfferToolbarEventL(TInt aCommand)
    {
    if (((CSaFlashAppUi*)AppUi())->GetFilename() == NULL)
        {
        // don't handle toolbar commands if no SWF is active.
        return;
        }
    switch(aCommand)
        {
        case EEikPauseButton:
            if ( !(iContainer->GetEngine()->IsRunning()) ) {
                HandleCommandL(EEikFlashCmdPlay);
            }
            else if( iContainer->GetEngine()->IsPaused() ) {
            HandleCommandL(EEikFlashCmdResume);
            }
            else {
            HandleCommandL(EEikFlashCmdPause);
            }
            //EEikFlashCmdPause
            //EEikFlashCmdPlay
            //EEikFlashCmdResume
            break;
            
        case EEikToggleButton:
            if(!IsFullScreen())
                HandleCommandL(EEikFlashCmdFullScreen);
            else
                HandleCommandL(EEikFlashCmdPartScreen);
            
            break;
        case EEikZoomButton:
            if(!IsVideoContent())
            {
                if (iZoomedTimes) {
                HandleCommandL(EEikFlashCmdZoomOut);
                HandleCommandL(EEikFlashCmdNonPanMode);
                }
                else {
                HandleCommandL(EEikFlashCmdZoomIn);
			    HandleCommandL(EEikFlashCmdNonPanMode);
                }
            }
            
            break;
        }
    }

void CSaFlashPlayerView::ChangeToolbarPauseIcon(TBool aIsPaused)
{
    if(iIsTouchFeatureSupported)
    {
    CAknButton* button;
    CAknToolbar* fixedToolbar = Toolbar(); 
    button = (CAknButton*) fixedToolbar->ControlOrNull(EEikPauseButton);
        if (button)
        {
        if ( aIsPaused ) 
        { 
            button->SetCurrentState( 1, ETrue ); 
        }
            else
            {
            button->SetCurrentState( 0, ETrue ); 
            }
        }    
    }
}

void CSaFlashPlayerView::DynInitToolbarL(TInt /*aResourceId*/, 
                                               CAknToolbar* /*aToolbar*/)
    {
    //CEikonEnv::Static()->AlertWin(_L("Tool Bar Initiate!!"));
    }
#endif //__FEATURE_TOOLBAR__
void CSaFlashPlayerView::HandleCommandL( TInt aCommand )
{
  	TBool needsRedraw = EFalse;
    TInt dummy = 0;  	
  
	switch  ( aCommand )
	{
	#ifdef __FEATURE_UI_LANDSCAPE_FULLSCREEN
		case EEikFlashCmdRotate:
		{
			RotateAppL();						
		}
		break;
	#endif
					
	case EAknSoftkeyBack:
	
		// if iBackButtonActive is false (i.e. Pause) and full screen is active 
		// treat command as Resume instead of Back for first hit.For second hit treat 
		// command as Back. Note: When viewer is in full screen, HandleCommandL() is called
		// 2 times.

		if (iLaunchType == EEmbedded)
			{
			if (iBackButtonActive && iFirstHit)
				{
					//need to save if launching app say move
					if((((CSaFlashAppUi*)AppUi())->CanAllowMove()) && !FileExistsInDefaultFolder())
					{	
						if(LaunchSaveQueryDialogL(iSavedFilename->Des()))	
						{
							HandleSaveCommandL();	
						}
						
					}
		   				
				}
			//promt an error message that the file cannot be saved- what to prompt is TBD
			}
		
		if ((iLaunchType == EEmbedded) || (iLaunchType == EStartedFromApp))
			{
			if(iBackButtonActive && !iFullScreen)
            	{
            	#ifdef __FEATURE_UI_LANDSCAPE_FULLSCREEN
                RestoreOrientationL();
                #endif
				
				iContainer->ShowMutedIconL(EFalse);
				iContainer->ShowPauseIconL(EFalse);
				((CSaFlashAppUi*)AppUi())->CloseApplication();
            	}
            else
	            {
	            if( iBackButtonActive  && iFirstHit )
		            {
		            #ifdef __FEATURE_UI_LANDSCAPE_FULLSCREEN
                	RestoreOrientationL();
                	#endif
		            
		            iContainer->ShowMutedIconL(EFalse);
					iContainer->ShowPauseIconL(EFalse);
					((CSaFlashAppUi*)AppUi())->CloseApplication();
		            iBackButtonActive = ETrue;
            		iFirstHit = EFalse;	
		            }
		        else if ( !iBackButtonActive)
	            	{
					iContainer->GetEngine()->ResumeL(EReasonUser, ETrue);
					iContainer->ShowPauseIconL(EFalse);
					//Cba()->SetCommandSetL( R_AVKON_SOFTKEYS_OPTIONS_BACK );
					Cba()->SetCommandSetL(R_SAFLASH_PLAYERVIEW_SOFTKEYS_OPTIONS_BACK);
					Cba()->DrawNow();
					iBackButtonActive = ETrue;
					iFirstHit = EFalse;
	            	}
	            else
		            {
		            iFirstHit = ETrue;     	
		            }
	            }	
			}
		else
			{
			if(iBackButtonActive && !iFullScreen )
            	{
                iContainer->ShowMutedIconL(EFalse);
                iContainer->ShowPauseIconL(EFalse);
                ((CSaFlashAppUi*)AppUi())->CloseApplication();
            	}
            else
            	{
            	if( iBackButtonActive  && iFirstHit )
            		{
            		iContainer->ShowMutedIconL(EFalse);
            		iContainer->ShowPauseIconL(EFalse);
            		iContainer->GetEngine()->DestroyPlayer();
            		iZoomSuccess = ETrue;
      				iZoomedTimes = 0;

	                
            		SetAppScreenL();
            		AppUi()->ActivateLocalViewL(KSAFlashFileViewId);
            		
            		#ifdef __FEATURE_UI_LANDSCAPE_FULLSCREEN
            		RestoreOrientationL();//restore old orientation
            		#endif
            		
            		iBackButtonActive = ETrue;
            		iFirstHit = ETrue;
            		}
            	else if ( !iBackButtonActive)
	            	{
					iContainer->GetEngine()->ResumeL(EReasonUser, ETrue);
					iContainer->ShowPauseIconL(EFalse);
					//Cba()->SetCommandSetL( R_AVKON_SOFTKEYS_OPTIONS_BACK );
					Cba()->SetCommandSetL(R_SAFLASH_PLAYERVIEW_SOFTKEYS_OPTIONS_BACK);
					Cba()->DrawNow();
					iBackButtonActive = ETrue;
					iFirstHit = EFalse;	
	            	}
	            else
		            {
		            iFirstHit = ETrue;     	
		            }
            	}	
            }
		break;
		
		
	case EEikFlashCmdSave:
			HandleSaveCommandL();
		break;
		
	case EEikFlashCmdVolume:
	    iActivatingVolumeView = ETrue;
		AppUi()->ActivateLocalViewL(KSAFlashVolumeViewId);
		break;
		
	case EEikFlashCmdPause:
#ifdef __FEATURE_TOOLBAR__
        if(!IsVideoContent())
        {
	    DisableZoomToolBarButton();
        }
#endif
#ifdef FEATURE_INLINE_TEXT_ENTRY
		if(iIMEControl)
		{
			DisableIME();
			iIMEWasDeactivatedForPausing = ETrue;
		}
#endif //FEATURE_INLINE_TEXT_ENTRY
		CancelFocusHandler();
		iContainer->GetEngine()->Pause(EReasonUser);
//#ifdef __FLASHLITE2.0_REL3.1			
		iContainer->ShowPauseIconL(ETrue);
		Cba()->SetCommandSetL( R_SAFLASH_SOFTKEYS_OPTIONS_RESUME );
        Cba()->DrawDeferred();//_SCALABLE
        iBackButtonActive = EFalse;
//#endif //__FLASHLITE2.0_REL3.1
		break;
		
	case EEikFlashCmdRewind:
		{
#ifdef __FEATURE_TOOLBAR__		
            if(!IsVideoContent())
            {
            EnableZoomToolBarButton();
            }
#endif
			iContainer->GetEngine()->RewindL();
			//Cba()->SetCommandSetL( R_AVKON_SOFTKEYS_OPTIONS_BACK );
			Cba()->SetCommandSetL(R_SAFLASH_PLAYERVIEW_SOFTKEYS_OPTIONS_BACK);
            Cba()->DrawDeferred();//_SCALABLE
            iBackButtonActive = ETrue;
			iContainer->ShowPauseIconL(EFalse);
		}
		break;
		
	case EEikFlashCmdQualityLow:
		{
			iQuality = aCommand;
			iContainer->GetEngine()->SetQuality(FI_QualityLow);
			if (iContainer->GetEngine()->IsPaused())
			{
				needsRedraw = ETrue;
			}
		}
		break;

	case EEikFlashCmdQualityMed:
		{
			iQuality = aCommand;
			iContainer->GetEngine()->SetQuality(FI_QualityMedium);
			if (iContainer->GetEngine()->IsPaused())
			{
				needsRedraw = ETrue;
			}
		}
		break;

	case EEikFlashCmdQualityHigh:
		{
			iQuality = aCommand;
			iContainer->GetEngine()->SetQuality(FI_QualityHigh);
			if (iContainer->GetEngine()->IsPaused())
			{
				needsRedraw = ETrue;
			}
		}
		break;
		
	case EEikFlashCmdAbout:
//#ifdef __FLASHLITE2.0_REL3.1
		{
			((CSaFlashAppUi*)AppUi())->AboutL();
		}
//#endif //__FLASHLITE2.0_REL3.1
		break;
		
	case EEikFlashCmdHelp:
		{
		if ( !(iContainer->GetEngine()->IsRunning() ))
			{
			((CSaFlashAppUi*)AppUi())->LaunchHelpL( EEikFlashHelpStop );
			}
		else if ( iContainer->GetEngine()->IsPaused() )
			{
			((CSaFlashAppUi*)AppUi())->LaunchHelpL( EEikFlashHelpPause );
			}
		else if (  iContainer->GetEngine()->IsRunning() )  
			{
			((CSaFlashAppUi*)AppUi())->LaunchHelpL( EEikFlashHelpPlay );
			}
		}
		break;
		
	case EEikFlashCmdFullScreen:
		SetFullScreenL();
		break;
		
	case EEikFlashCmdPartScreen:
		SetAppScreenL();
		Cba()->DrawDeferred();   //_SCALABLE
		break;
		
	case EEikFlashCmdShowAll:
		iZoomedTimes = 0;
		iContainer->GetEngine()->Zoom(EShowAll, dummy);
		iZoomSuccess = ETrue;
		break;

	case EEikFlashCmdZoomIn:
		iZoomSuccess = iContainer->GetEngine()->Zoom(EZoomIn,iZoomedTimes);

		
		break;

	case EEikFlashCmdZoomOut:
		iZoomSuccess = iContainer->GetEngine()->Zoom(EZoomOut,iZoomedTimes);
		break;

	case EEikFlashCmdPanMode:
		iContainer->GetEngine()->SetPanMode(ETrue);
		break;

	case EEikFlashCmdNonPanMode:
		iContainer->GetEngine()->SetPanMode(EFalse);
		break;
//#ifdef __FLASHLITE2.0_REL3.1		
	
	case EEikFlashCmdMute:
		{
			HandleMuteL ();
		}
		break;
	
	case EEikFlashCmdPlay:
		{
#ifdef __FEATURE_TOOLBAR__
        if(!IsVideoContent())
        {
            EnableZoomToolBarButton();
        }
#endif
			iContainer->ShowPauseIconL(EFalse);//SCALABLE
			if ( iLaunchType == EEmbedded)
			{
				if (!iFileInitialized)
					return;
				//iContainer->GetEngine()->OpenFileHandleAndStartMovieL(iFile, ETrue);	
				iContainer->OpenFileL(iFile);
			}
			else
			{
				//iContainer->GetEngine()->OpenFileAndStartMovieL(*((CSaFlashAppUi*)AppUi())->GetFilename(), ETrue);	
				iContainer->OpenFileL(*((CSaFlashAppUi*)AppUi())->GetFilename());
			}
		}
		break;
		
	case EEikFlashCmdUnmute:
		{
			Mute(EFalse);
		
			//Unmuting & volume is zero,NO USE. 
			//So, set it to one(lowest volume).
			if (iVolume == 0)
				{
				iVolume = 1;
				}
			
        	iContainer->GetEngine()->SetVolume( iVolume );
       		iContainer->ShowVolumePopupL(iVolume);
        	//This  has  to be tested  and agreedupon  in 3.2 devices  and  can  be  removed
	  	/*#ifndef FEATURE_TOUCH
	        iContainer->ShowMutedIconL(EFalse);//SCALABLE
		#endif*/
	        ((CSaFlashAppUi*)AppUi())->SaveVolumeL(iVolume);

		}
		break;
		
	case EEikFlashCmdResume:
		{
#ifdef __FEATURE_TOOLBAR__
        if(!IsVideoContent())
        {
		EnableZoomToolBarButton();
        }
#endif
		#ifdef FEATURE_INLINE_TEXT_ENTRY
		if(iIMEWasDeactivatedForPausing)
			{
			EnableIMEL();
			iIMEWasDeactivatedForPausing = EFalse;
			}
		#endif //FEATURE_INLINE_TEXT_ENTRY

		iContainer->GetEngine()->ResumeL(EReasonUser, EFalse);
		//Cba()->SetCommandSetL( R_AVKON_SOFTKEYS_OPTIONS_BACK );
		Cba()->SetCommandSetL(R_SAFLASH_PLAYERVIEW_SOFTKEYS_OPTIONS_BACK);
        Cba()->DrawDeferred();//_SCALABLE
        iContainer->ShowPauseIconL(EFalse);//SCALABLE
        iBackButtonActive = ETrue;
		}
		break;
		
	
	case EEikFlashCmdViewDetails:
		{
			DisplayFileDetailsL();
		}
		break;
		
	case EEikFlashCmdStop:
		{
            iZoomSuccess = ETrue;
			CancelFocusHandler();
			iContainer->GetEngine()->Stop();
			iContainer->ShowPauseIconL(EFalse);//SCALABLE
#ifdef __FEATURE_TOOLBAR__
	        ChangeToolbarPauseIcon(ETrue);
#endif
		    //Cba()->SetCommandSetL( R_AVKON_SOFTKEYS_OPTIONS_BACK );
		    Cba()->SetCommandSetL(R_SAFLASH_PLAYERVIEW_SOFTKEYS_OPTIONS_BACK);
	        Cba()->DrawDeferred();  //__SCALABLE
	        iBackButtonActive = ETrue;
		}
//#endif //__FLASHLITE2.0_REL3.1		
		break;

	case EEikFlashCmdSend:
		{
		STATIC_CAST(CSaFlashAppUi*, AppUi())->HandleSendCommandL(aCommand, KNullDesC);
		}
		break;
	case EEikFlashCmdOpen: // It will be called only if MSK is enabled.
		{
		if (AknLayoutUtils::MSKEnabled())
			{
			if (iIMEFirstHit && iFullScreen)
				{
				iIMEFirstHit = EFalse;				
				}
			else
				{
				TWsEvent event = STATIC_CAST(CSaFlashAppUi*, AppUi())->iWsEvent;
				TInt type = EEventKey;		
				REINTERPRET_CAST(CCoeControl*, iContainer)->OfferKeyEventL(*event.Key(), (TEventCode)type );
				iIMEFirstHit = ETrue;
				}
			}
		}
	break;
	
		case EEikFlashCmdCustom1 :
		case EEikFlashCmdCustom2 :
		{
		if (iIMEFirstHit && iFullScreen
#ifdef __FEATURE_OSK__
                && !(iOnScreenKeypadControl) //the understanding of this is vague, the realtion between imefisthit and fullscreen is not clear, this is a quick fix to SKs being alternated
#endif // __FEATURE_OSK__
		    )
			{
			iIMEFirstHit = EFalse;
			}
		else
			{
			TWsEvent event = STATIC_CAST(CSaFlashAppUi*, AppUi())->iWsEvent;
			TInt type = EEventKey;		
			if(event.Type() == 3)
				  REINTERPRET_CAST(CCoeControl*, iContainer)->OfferKeyEventL(*event.Key(), (TEventCode)type);
			else
			    iContainer->GetEngine()->SendPointertoSoftKey(aCommand);
			
			iIMEFirstHit = ETrue;
			}
		}
		break;
        /* ESLM-86CA6X: Mapped Style popup 'Exit' command appropriately
         * instead of 'Back' functionality */
#ifdef __FEATURE_CONTEXT_SENSITIVE_MENU__
		case EAknSoftkeyExit:
        {
			iContainer->ShowMutedIconL(EFalse);
			iContainer->ShowPauseIconL(EFalse);			
			((CSaFlashAppUi*)AppUi())->CloseApplication();
        }
		break;
#endif
	default:
	
		break;
	}
	if (needsRedraw)
	{
		if (iFullScreen) 
		{
			SetFullScreenL();
		}
		else
		{
			SetAppScreenL();
			Cba()->DrawDeferred();   //_SCALABLE
		}
	}
}


void CSaFlashPlayerView::HandleSaveCommandL()
{
if ( !iContainer->GetEngine()->PlayerStoppedWithError() )
	{
	HBufC* fileName = HBufC::NewLC(KMaxFileName);
	TPtr ptrFileName = fileName->Des();
	
	if(iSavedFilename->Length() > 0)
		{
		ptrFileName = iSavedFilename->Left( iSavedFilename->Length() );
		}
#ifdef FEATURE_MULTIPLE_DRIVE
	//G:\\ other multidrives rootlevel is not set to Others
	// this needs add in rss for R_SAFLASH_MEMORY_SELECTIONDIALOG
	// root path to be defined, but we do not know the drive name
	//there is no relative root path definition possible in rss
	// instead of AknCommonDialogsDynMem::RunSaveDlgLD  use
	//CAknMemorySelectionDialogMultiDrive.its a domain API supported in 5.0
		TInt incMedias=AknCommonDialogsDynMem::EMemoryTypePhone|
                   AknCommonDialogsDynMem::EMemoryTypeInternalMassStorage|
                   AknCommonDialogsDynMem::EMemoryTypeMMCExternal|
                   AknCommonDialogsDynMem::EMemoryTypeMMC;
                   	
//Part of Fix for EHLI-7YXE63: Toolbar Appears Over Save To Options Menu
 	//When rotated from Landscape to Portrait Mode.So, Hiding Toolbar
    	//Till the Save To Dialog is Dismissed.
	#ifdef __FEATURE_TOOLBAR__
		iShowToolBar = EFalse;
		CAknToolbar* toolBar = NULL;
		toolBar = Toolbar();
		if(toolBar)
			toolBar->SetToolbarVisibility(EFalse,EFalse);

	#endif //__FEATURE_TOOLBAR__                   	
    if(AknCommonDialogsDynMem::RunSaveDlgLD(incMedias,ptrFileName, R_SAFLASH_MEMORY_SELECTIONDIALOG))
    {
    ((CSaFlashAppUi*)AppUi())->SaveFileL(ptrFileName);
    }    
	#ifdef __FEATURE_TOOLBAR__
		iShowToolBar = ETrue;
		if(toolBar)
			toolBar->SetToolbarVisibility(ETrue,ETrue);

	#endif //__FEATURE_TOOLBAR__
#else  //////FEATURE_MULTIPLE_DRIVE
	
	CDir* cdir_dirs = NULL;
	TFileName phoneDefaultPath;			
	phoneDefaultPath.Copy(PathInfo::PhoneMemoryRootPath());
	phoneDefaultPath.Append(PathInfo::OthersPath());
	phoneDefaultPath.Append( KDirSearchStr );				
	TInt err = iEikonEnv->FsSession().GetDir(phoneDefaultPath, KEntryAttDir | KEntryAttMatchExclusive, ESortByName | EAscending, cdir_dirs);
		
	if (err == KErrNone)
		{
		CleanupStack::PushL( cdir_dirs );
		TInt count = cdir_dirs->Count();
		TInt phoneSubDirCount = 0;					
		TEntry entry;
		for ( TInt i = 0; i < count; ++i )
			{
			entry = (*cdir_dirs)[i];
			if (entry.IsDir())
				{
				phoneSubDirCount++;
				}
			}
		
		
		if ( cdir_dirs )
			{
			CleanupStack::PopAndDestroy(cdir_dirs);	
			}
		
		TInt mmcSubDirCount = -1;
		if(CheckMemoryCard())
			{//If MMC is present.					
			mmcSubDirCount = 0;
			TFileName mmcDefaultPath;
			mmcDefaultPath.Copy(PathInfo::MemoryCardRootPath());
			mmcDefaultPath.Append(PathInfo::OthersPath());
			mmcDefaultPath.Append( KDirSearchStr );
			cdir_dirs = NULL;
			err = iEikonEnv->FsSession().GetDir(mmcDefaultPath, KEntryAttDir | KEntryAttMatchExclusive, ESortByName | EAscending, cdir_dirs);
			if (err == KErrNone)
				{
				CleanupStack::PushL( cdir_dirs );						
				count = 0;
				count = cdir_dirs->Count();
				for ( TInt i = 0; i < count; ++i )
					{
					entry = (*cdir_dirs)[i];
					if (entry.IsDir())
						{
						mmcSubDirCount++;
						}
					}
				if ( cdir_dirs )
					{
					CleanupStack::PopAndDestroy(cdir_dirs);	
					}
				}
			
			}
		
		if ( phoneSubDirCount > 0 || mmcSubDirCount > 0 )
			{
			//Sub folder exist.
			if(AknCommonDialogs::RunSaveDlgLD( ptrFileName , R_SAFLASH_MEMORY_SELECTIONDIALOG ))
				{						
				((CSaFlashAppUi*)AppUi())->SaveFileL(ptrFileName);	
						//now disable save prompt while closing, valid for embedded mode
						((CSaFlashAppUi*)AppUi())->SetAllowMove(EFalse);
				}
			}
		else if (phoneSubDirCount == 0 && mmcSubDirCount == 0)
			{
			//Selection of Phone memory or MMC, but not Folders.
			if(AknCommonDialogs::RunSaveDlgNoDirectorySelectionLD( ptrFileName , R_SAFLASH_MEMORY_SELECTIONDIALOG ))
				{
				((CSaFlashAppUi*)AppUi())->SaveFileL(ptrFileName);
						//now disable save prompt while closing, valid for embedded mode
						((CSaFlashAppUi*)AppUi())->SetAllowMove(EFalse);
				}				
			}
		else
			{						
			//No Sub folder exist under phone path and MMC is not present.
			phoneDefaultPath.Delete(phoneDefaultPath.Length() - 1 , 1);
			TParse parser;
			parser.Set(ptrFileName, NULL, NULL);					
			
			TInt fileSelectionDialog = 0 ;
			CAknFileNamePromptDialog* promptDialog =CAknFileNamePromptDialog::NewL(fileSelectionDialog);
        	CleanupStack::PushL( promptDialog );
        	promptDialog->SetPathL( phoneDefaultPath );
        	
        	TFileName fileName(phoneDefaultPath);
        	fileName.Append(parser.NameAndExt());
        	
        	TInt promptReturnValue = promptDialog->ExecuteL( fileName );
        	CleanupStack::PopAndDestroy(); // promptDialog
        	if (promptReturnValue)
            	{
            	phoneDefaultPath.Append(fileName);
            	((CSaFlashAppUi*)AppUi())->SaveFileL(phoneDefaultPath);	
	                	//now disable save prompt while closing, valid for embedded mode
						((CSaFlashAppUi*)AppUi())->SetAllowMove(EFalse);
            	}
            
			}
		}	
#endif ////FEATURE_MULTIPLE_DRIVE		
	}

}
void CSaFlashPlayerView::DynInitMenuPaneL( TInt aResourceId, CEikMenuPane* aMenuPane )
{
	iMenuMgr->DynInitMenuPaneL(aResourceId,aMenuPane);
	
}

void CSaFlashPlayerView::DynInitMenuBarL( TInt /*aResourceId*/, CEikMenuBar* /*aMenuBar*/ )
{
}

void CSaFlashPlayerView::ResetScreenInCurrentModeL()
{
	if(iFullScreen)
	{
#ifdef __FEATURE_OSK__
		// __FEATURE_OSK__ iContainer->UpdateScreenSizeL(AppUi()->ApplicationRect());
		SetFullScreenL();
#endif // __FEATURE_OSK__
	}
	else
	{
#ifdef __FEATURE_OSK__
		// __FEATURE_OSK__ iContainer->UpdateScreenSizeL(AppUi()->ClientRect());
		SetAppScreenL();
#endif // __FEATURE_OSK__
	}
}

CEikButtonGroupContainer* CSaFlashPlayerView::GetCba()
{
	return Cba();
}

#ifdef __FEATURE_OSK__
void CSaFlashPlayerView::SetOSKIsActive(TBool aShow)
{
    if (aShow)
    {
    	iCompatabilityMode=ETrue;
    }
    else
    {
    	iCompatabilityMode=EFalse;
    }
}
#endif // __FEATURE_OSK__

#ifdef __FEATURE_UI_LANDSCAPE_FULLSCREEN
void CSaFlashPlayerView::DisableZoomToolBarButton()
{
    if(iIsTouchFeatureSupported)
    {
    CAknToolbar* fixedToolbar = Toolbar();
		if(fixedToolbar)
    fixedToolbar->SetItemDimmed(EEikZoomButton,ETrue, ETrue);
}
}

void CSaFlashPlayerView::EnableZoomToolBarButton()
{
    if(iIsTouchFeatureSupported)
    {
        TBool disableZoom = (iContainer->IsEngineDead());
        CAknToolbar* fixedToolbar = Toolbar();
            if(fixedToolbar)
                fixedToolbar->SetItemDimmed(EEikZoomButton,disableZoom, ETrue);
    }
}
#endif // __FEATURE_UI_LANDSCAPE_FULLSCREEN

void CSaFlashPlayerView::SetAppScreenL()
{
#ifdef __FEATURE_OSK__
    if(iOnScreenKeypadControl)
    {
    	TCallBack callback(DestroyOnScreenKeypadControl,static_cast<TAny*>(this));
    	if(iASyncOnScreenKeypadDestroyer)
    	{
    		delete iASyncOnScreenKeypadDestroyer;
    		iASyncOnScreenKeypadDestroyer = NULL;
    	}
    	iASyncOnScreenKeypadDestroyer = CFlhTimerObject2::NewL(CActive::EPriorityStandard,callback);
    	iASyncOnScreenKeypadDestroyer->After(1);
    }
#endif // __FEATURE_OSK__

	StatusPane()->MakeVisible(ETrue);
	Cba()->MakeVisible(ETrue);
#ifdef __FEATURE_TOOLBAR__
	if(iIsTouchFeatureSupported)
	{
    CAknToolbar* fixedToolbar = Toolbar(); 
        if(fixedToolbar && iShowToolBar)
        {
        fixedToolbar->SetToolbarVisibility(EFalse); //this is a fix for the toolbar not being shown sometimes, hide and and show it and it works.
        fixedToolbar->SetToolbarVisibility(ETrue, ETrue);
    }   
	}
#endif
	iFullScreen = EFalse;
	
#ifdef __FEATURE_UI_LANDSCAPE_FULLSCREEN       
#ifdef __FEATURE_TOOLBAR__
		if(iShowToolBar)
			{
			iContainer->HandleFixedToolbarVisibility(ETrue);
			}
		else
			{
			iContainer->HandleFixedToolbarVisibility(EFalse);
			}
#endif

#endif // __FEATURE_UI_LANDSCAPE_FULLSCREEN

        
	iContainer->UpdateScreenSizeL(AppUi()->ClientRect());	
	iContainer->ResizeOtherControls();
}

void CSaFlashPlayerView::SetFullScreenL()
{
	if (IsForeground())
	{
		StatusPane()->MakeVisible(EFalse);
		Cba()->MakeVisible(EFalse);
#ifdef __FEATURE_TOOLBAR__
		if(iIsTouchFeatureSupported)
        {
		Toolbar()->MakeVisible(EFalse);  
        }
#endif		
		iFullScreen = ETrue;
		
#ifdef __FEATURE_UI_LANDSCAPE_FULLSCREEN		
        iContainer->HandleFixedToolbarVisibility(EFalse);
#endif // __FEATURE_UI_LANDSCAPE_FULLSCREEN
		
		TRect appRect = AppUi()->ApplicationRect();
		SetFlashDisplayAreaRect(appRect);
        TRect flashDisplayRect;		
#ifdef __FEATURE_OSK__
		CSaFlashAppUi* ui = (CSaFlashAppUi*)iEikonEnv->AppUi();
		TBool userInitiated = ui->UserInitiatedFullScreen();
		TRAPD(oskError, ShowOnScreenKeypadL(appRect, userInitiated)); // may modify the flash display area rect
		if(oskError != KErrNone)
        {
			// could not show the OSK... Let Flash occupy the entire screen
            SetFlashDisplayAreaRect(appRect);
        }
#endif // __FEATURE_OSK__
		flashDisplayRect = GetFlashDisplayAreaRect();
		iContainer->UpdateScreenSizeL(flashDisplayRect);
		iContainer->ResizeOtherControls();
	}
}

TRect CSaFlashPlayerView::ApplicationRect()
{
	return AppUi()->ApplicationRect(); 
}

void CSaFlashPlayerView::OpenFileL(const TDesC& aFilename)
{
	#ifdef __FEATURE_UI_LANDSCAPE_FULLSCREEN
	iVideoContent = EFalse;
	#endif
	
	iContainer->OpenFileL(aFilename);
	if( iSavedFilename )
	{
		delete iSavedFilename;
		iSavedFilename = NULL;
	}
	iSavedFilename = aFilename.Alloc();
	SetTitleL( aFilename );
}

void CSaFlashPlayerView::SetTitleL(const TDesC& aFilename)
{
    // Put filename in title pane
    CAknTitlePane* titlePane = (CAknTitlePane*)StatusPane()->ControlL(TUid::Uid(EEikStatusPaneUidTitle));
    TFileName fileName = aFilename;
    TParse parser;
    parser.Set(fileName, NULL, NULL);
    titlePane->SetTextL(parser.Name());
}


void CSaFlashPlayerView::OpenFileL(RFile& aFile)
{
	iFile = aFile;
   	iFileInitialized = ETrue;
    
    if (iSavedFilename)
    {
        delete iSavedFilename;
        iSavedFilename = NULL;
    }
    
    // Get file path from RFile
    TPath* filepath = new(ELeave) TPath;
    aFile.FullName(*filepath);
    iSavedFilename = filepath->Alloc();
    delete filepath;
    
    SetTitleL(*iSavedFilename);
    
    #ifdef __FEATURE_UI_LANDSCAPE_FULLSCREEN
	iVideoContent = EFalse;
	#endif
    
    iContainer->OpenFileL(aFile);
    //SetAppScreenL();
}


void CSaFlashPlayerView::ClearErrors()
{
	iReportedErrorsFlag = 0;
}

//#ifdef __FLASHLITE2.0_REL3.1

void CSaFlashPlayerView::NotifyDataAccessError(const char* aUrl, TInt aErrorCode)
{
	TRAPD_WRAPPER(NotifyDataAccessErrorL(aUrl, aErrorCode));
}

void CSaFlashPlayerView::NotifyDataAccessErrorL(const char* aUrl, TInt aErrorCode)
{	
    CTextResolver* iTextResolver = CTextResolver::NewLC(*iCoeEnv); 
    HBufC* errorMsg = 0;
    
    switch ( aErrorCode )
    {
    	case ECompleteFailedConnect:
    	{
    		errorMsg = ( iTextResolver->ResolveErrorString( KErrIfDNSNotFound ) ).Alloc();
            break;
    	}
    	
    	case ECompleteFailedHTTP:
    	case ECompleteFailedError:
    	{
			errorMsg = ( iTextResolver->ResolveErrorString( KErrNetUnreach ) ).Alloc();
            break;
        }
        
    	case ECompleteFailedURLTooLong:
    	{
			errorMsg = ( iTextResolver->ResolveErrorString( NW_STAT_BAD_REDIRECT_URL ) ).Alloc();
            break;
        }

	case ECompleteFailedFileNotFound:
	{
     		if (!aUrl)
     			{
     			aUrl = "";	
     			}
            
            TPtrC8 ptr ( (TUint8*) aUrl );
            TInt strlen = ptr.Length ();
    		
            HBufC* hBuf = iContainer->GetEngine()->CreateEpocStringL(aUrl, strlen);
			CleanupStack::PushL( hBuf );
			
            TInt pos = hBuf->LocateReverse('\\');
            TPtrC fileName = hBuf->Right(hBuf->Length() - pos - 1);    		
            errorMsg = StringLoader::LoadL( R_STR_FILE_NOT_FOUND,
                    	fileName, iEikonEnv );
            CleanupStack::PopAndDestroy( hBuf );
            
        	//errorMsg = ( iTextResolver->ResolveErrorString( KErrNotFound ) ).Alloc();
        	break;
	}
        
    	case EInvalidVideoFileError:
    	case EFailedPreparingVideoError:
    	{
    		errorMsg = ( iTextResolver->ResolveErrorString( KErrGeneral ) ).Alloc();
            break;
    	}
    	
    	default:
    		break;
    } //switch
    
    CleanupStack::PopAndDestroy();    // iTextResolver

    if ( errorMsg != 0 )
    {
    	//ErrorHandler takes care of deleting errorMessage
		GetErrorHandler()->ReportError( errorMsg, SAFlashErrorHandler::EFlagContinue | SAFlashErrorHandler::EFlagAbort );
    }
    
}
//#endif //__FLASHLITE2.0_REL3.1

//#ifdef __FLASHLITE2.0_REL3.1

void CSaFlashPlayerView::NotifyClientError(TInt aErrorCode, TBool aIsCritical, TBool aPersistent)
{	
	TRAPD(err, NotifyClientErrorL(aErrorCode, aIsCritical, aPersistent));
	if ( err == KErrNone )
	{
		
	}
}

TBool CSaFlashPlayerView::QueryAllowDenyL(const TDesC& aQueryText)
	{
	return GetErrorHandler()->QueryAllowDenyL(aQueryText);
	}
void CSaFlashPlayerView::NotifyClientErrorL(TInt aErrorCode, TBool aIsCritical, TBool aPersistent)
{    
	CTextResolver* iTextResolver = CTextResolver::NewLC(*iCoeEnv); 
    HBufC* errorMsg = 0;
    
    switch (aErrorCode)
    {
    	case EInvalidFsCommandLaunchError:
    	case EGeneralError:
    	case EInvalidConfigError:
    	{
    		errorMsg = ( iTextResolver->ResolveErrorString( KErrGeneral ) ).Alloc();
            break;
    	}
    	
    	case EInsufficientMemoryError:
    	{
    		errorMsg = StringLoader::LoadL( R_STR_INSUFFICIENT_MEMORY_ERROR, iEikonEnv );
    		break;
    	}
    	
    	case EInvalidTelURLError:
    	{
    		errorMsg = StringLoader::LoadL( R_STR_INVALID_TEL_URL_ERROR, iEikonEnv );
    		break;
    	}
    	
     	case EInsufficientGPUMemoryError:
    	{
    	    iContainer->SetErrorOccured(KErrNoMemory);
    	    break;
    	}
    } //switch

	CleanupStack::PopAndDestroy();    // iTextResolver
	
	if (aPersistent && errorMsg)
	{
		//This transfers ownership of errorMsg to the ErrorHandler
		GetErrorHandler()->ReportError(errorMsg, 
			aIsCritical ? SAFlashErrorHandler::EFlagAbort : 
			SAFlashErrorHandler::EFlagAbort | SAFlashErrorHandler::EFlagContinue );
	}
	else
	{
		if ( errorMsg )
		{
			TRAPD(err, 
			{
				CleanupStack::PushL(errorMsg);
				FlashUiUtil::ShowNoteL( EAknGlobalErrorNote, *errorMsg );
				CleanupStack::PopAndDestroy();    // errorMsg 
			});
			
			if (err ==KErrNone )
			{
				
			}	
		}
	}
	
	VwrDebug(LOG_DEBUG,_L("CSaFlashPlayerView::NotifyClientError %d"),aIsCritical);   
	
	if(aIsCritical)
	{
	VwrDebug(LOG_DEBUG,_L("CSaFlashPlayerView::NotifyClientError going to nml screen"));
	    
	    HandleCommandL(EEikFlashCmdPartScreen);
	    CAknToolbar* fixedToolbar = Toolbar(); 
        if(fixedToolbar)
        {
            fixedToolbar->SetItemDimmed(EEikPauseButton,ETrue,ETrue);  // The user cannot resume when the state is changed by the engine 
            fixedToolbar->SetItemDimmed(EEikZoomButton,ETrue,ETrue);   
            fixedToolbar->SetItemDimmed(EEikToggleButton,ETrue,ETrue); 
            fixedToolbar->DrawNow();
        }
	}
	
	VwrDebug(LOG_DEBUG,_L("CSaFlashPlayerView::NotifyClientError --"));	
}

void CSaFlashPlayerView::NotifyFlashError( TInt aErrorCode, TBool aIsCritical, TBool aPersistent,
											ErrorInfo* aErrorInfo )
{	

	GetEngine()->Pause(EReasonUser);
	TRAPD(err, NotifyFlashErrorL(aErrorCode, aIsCritical, aPersistent,aErrorInfo ));	
	if (err == KErrNone )
	{
		
	}
}

void CSaFlashPlayerView::NotifyFlashErrorL(TInt aErrorCode, TBool aIsCritical, TBool aPersistent,
											ErrorInfo* aErrorInfo)
{
    HBufC* errorMsg = 0;
    TInt errorId = -1; // keep track of the error number in the list.       
    iErrorOcurred=ETrue;
    switch ( aErrorCode )
    {
    	case FI_OutOfMemoryError:
    	{
    		errorMsg = StringLoader::LoadL( R_STR_INSUFFICIENT_MEMORY_ERROR, iEikonEnv );
    		errorId = 0;
    		break;
    	}
    	
    	case FI_StackLimitReachedError:
    	{	
    		errorMsg = StringLoader::LoadL( R_STR_INSUFFICIENT_MEMORY_ERROR, iEikonEnv );
    		errorId = 1;
    		break;
    	}
    	
    	case FI_CorruptSWFDataError:
    	{
    		errorMsg = StringLoader::LoadL( R_STR_RLS_CORRUPTSWFDATA_ERROR, iEikonEnv );
    		errorId = 2;
    		break;
    	}

    	case FI_NetworkMemoryError:
    	{
    		errorMsg = StringLoader::LoadL( R_STR_INSUFFICIENT_MEMORY_ERROR, iEikonEnv );
    		errorId = 10;
    		break;
    	}
    	
    	case EInvalidFileVersionError:
    	{
    		errorMsg = StringLoader::LoadL( R_STR_INVALID_FILE_VERSION_ERROR,aErrorInfo->iInfo,iEikonEnv );
    		break;
    	}
    	default:
    	{
    	    errorMsg = StringLoader::LoadL( R_STR_FLITE_ERROR_IN_CONTENT ,aErrorCode, iEikonEnv );
    	    break;
    	}
    	    
    	
    } //switch
    
    TUint errorFlag = (errorId >= 0) ? 1 << errorId : 0;
    if ( errorMsg && !(errorFlag & iReportedErrorsFlag))
    {
    	iReportedErrorsFlag |= errorFlag;
    	if (aPersistent)
		{
			//This transfers ownership of errorMsg to the ErrorHandler
			GetErrorHandler()->ReportError(errorMsg, 
				aIsCritical ? SAFlashErrorHandler::EFlagAbort : 
				SAFlashErrorHandler::EFlagAbort | SAFlashErrorHandler::EFlagContinue );
//				GetErrorHandler()->ReportError(errorMsg, SAFlashErrorHandler::EFlagAbort );
			
				
		}
		else
		{
			CleanupStack::PushL(errorMsg);
			FlashUiUtil::ShowNoteL( EAknGlobalErrorNote, *errorMsg );
			CleanupStack::PopAndDestroy(errorMsg);//To be added in FL2.0 as well
		}
    }
    else //To be added in FL2.0 as well
    {
        if(errorMsg)
        {
            delete errorMsg;
            errorMsg = NULL;
        }
    }	    
}


// Not documented anywhere that I can find, but the max length of a softkey string is 32 characters.
// If we send more than 32 characters, we get a USER 11 panic.
const TInt KMaxSoftkeyTextLength = 32;

void CSaFlashPlayerView::SetSoftkeysL(HBufC** aSoftkeyArray, TInt aSoftkeyArraySize)
{
	// We currently only support two softkeys.
	const TDesC* key1 = (aSoftkeyArraySize > 0) ? aSoftkeyArray[0] : NULL;
	const TDesC* key2 = (aSoftkeyArraySize > 1) ? aSoftkeyArray[1] : NULL;

	// We must set both CBAs in order for softkeys to work in non-fullscreen and fullscreen mode.
	CEikButtonGroupContainer* cba = Cba();
	CEikButtonGroupContainer* appUIcba = AppUi()->Cba();

	TInt rsrcId = KErrNotFound;
	TInt keyId1 = KErrNotFound;
	TInt keyId2 = KErrNotFound;

	if ( key1 && key2 )
	{
		rsrcId = R_SOFTKEYS_CUSTOM;
		keyId1 = EEikFlashCmdCustom1;
		keyId2 = EEikFlashCmdCustom2;
#ifdef __FEATURE_OSK__		
		iLSK = EEikFlashCmdCustom1;
		iRSK = EEikFlashCmdCustom2;
#endif // __FEATURE_OSK__
	}
	else if ( key1 )
	{
		rsrcId = R_SOFTKEYS_CUSTOM_BACK;
		keyId1 = EEikFlashCmdCustom1;
#ifdef __FEATURE_OSK__
		iLSK = EEikFlashCmdCustom1;
#endif // __FEATURE_OSK__
	}
	else if ( key2 )
	{
		rsrcId = R_SOFTKEYS_OPTIONS_CUSTOM;
		keyId2 = EEikFlashCmdCustom2;
#ifdef __FEATURE_OSK__
		iRSK = EEikFlashCmdCustom2;
#endif // __FEATURE_OSK__
	}

	SetCbaL(cba, rsrcId, key1, keyId1, key2, keyId2);
	SetCbaL(appUIcba, rsrcId, key1, keyId1, key2, keyId2);
}

void CSaFlashPlayerView::SetCbaL(CEikButtonGroupContainer* aCba, TInt aRsrcId, const TDesC* aKey1, TInt aKeyId1, const TDesC* aKey2, TInt aKeyId2)
{
	if ( KErrNotFound != aRsrcId )
	{
		aCba->SetCommandSetL(aRsrcId);

		if ( KErrNotFound != aKeyId1 ) { aCba->SetCommandL(aKeyId1, aKey1->Left(KMaxSoftkeyTextLength)); }
		if ( KErrNotFound != aKeyId2 ) { aCba->SetCommandL(aKeyId2, aKey2->Left(KMaxSoftkeyTextLength)); }
	}

	aCba->DrawDeferred();
}

void CSaFlashPlayerView::ResetSoftkeysL()
{
	CEikButtonGroupContainer* cba = Cba();
	CEikButtonGroupContainer* appUIcba = AppUi()->Cba();
	ResetCbaL(cba);
	ResetCbaL(appUIcba);

#ifdef __FEATURE_OSK__	
	iLSK = EEikFlashCmdNone;
	iRSK = EEikFlashCmdNone;
#endif // __FEATURE_OSK__
}

void CSaFlashPlayerView::ResetCbaL(CEikButtonGroupContainer* aCba)
{
	if(aCba)
	{
		if ( iContainer->GetEngine() && 
			 iContainer->GetEngine()->IsRunning() && 
			 iContainer->GetEngine()->IsPaused() )
		{
			aCba->SetCommandSetL(R_SAFLASH_SOFTKEYS_OPTIONS_RESUME);
			aCba->DrawDeferred();
			iBackButtonActive = EFalse;		
		}
		else
		{
			aCba->SetCommandSetL(R_SAFLASH_PLAYERVIEW_SOFTKEYS_OPTIONS_BACK);
			aCba->DrawDeferred();
			iBackButtonActive = ETrue;	
		}
		
		// Notify the engine to refresh the screen. 
		if ( iContainer->GetEngine() )
		{
			iContainer->GetEngine()->UpdateVideoScreen();	
		}		
		
	}
}

CCoeControl* CSaFlashPlayerView::GetContainer()
{
	return iContainer;
}

RWindow* CSaFlashPlayerView::GetWindow()
{
	return iContainer->GetWindow();
}

RWindow* CSaFlashPlayerView::GetNewVideoWindow(void* aClient)
{
    return iContainer->GetNewVideoWindow(aClient);
}

void CSaFlashPlayerView::CloseVideoWindow(void* aClient)
{
    return iContainer->CloseVideoWindow(aClient);
}

MFlashEngine* CSaFlashPlayerView::GetEngine()
{
	VwrDebug(LOG_DEBUG,_L("CSaFlashPlayerView::GetEngine() ++"));
	return iContainer->GetEngine();
}

void CSaFlashPlayerView::EngineDestroyed()
{
    if(iContainer)
    {
        iContainer->EngineDestroyed();
    }
}
//#ifdef __FLASHLITE2.0_REL3.1
void CSaFlashPlayerView::Mute(TBool aMute)
{
	if (aMute)
	{
		iVolume |= KMuteMask;
	}
	else
	{
		iVolume &= KUnMuteMask;
	}
}

void CSaFlashPlayerView::HandleMuteL (TBool aSave) //aSave is default parm true
{
	//this aSave is true always since most functions dont send false
	// in hw key case reporsitory storing is done in MVolumechanged function
	//so need not store again , just mute it bhai!
	Mute(ETrue);
	
	if(aSave)
	{
		((CSaFlashAppUi*)AppUi())->SaveVolumeL (iVolume);	
	}
	
   // iVolume= KVolumeMuteValue;
	
	iContainer->GetEngine()->SetVolume (KVolumeMuteValue);
	iContainer->ShowVolumePopupL(KVolumeMuteValue);
	//This  has  to be tested  and agreedupon  in 3.2 devices  and  can  be  removed
	/*#ifndef FEATURE_TOUCH
		
		iContainer->ShowMutedIconL (ETrue);	//SCALABLE
	#endif	*/		
}


void CSaFlashPlayerView::SetVolumeL(TInt aVolume)
{    
	iVolume=aVolume;
	((CSaFlashAppUi*)AppUi())->SaveVolumeL (iVolume);
	      
	iContainer->GetEngine()->SetVolume (iVolume);    
}

TInt CSaFlashPlayerView::GetVolume()
{
	return (iVolume);
}


void CSaFlashPlayerView::SetPlayerViewTitleL()
{
	if( iSavedFilename )	
	{// Put active filename to Title pane
    	CAknTitlePane* titlePane = ( CAknTitlePane* )
                StatusPane()->ControlL( TUid::Uid( EEikStatusPaneUidTitle ) );

    	TFileName fileName = *(iSavedFilename);
    	TParse parser;	
    	parser.Set( fileName, NULL, NULL );
    	titlePane->SetTextL( parser.Name() );
	}
}

void CSaFlashPlayerView::DisplayFileDetailsL()
{
    if (((CSaFlashAppUi*)AppUi())->GetFilename() == NULL)
        {
        //No SWF file currently loaded:
        return;
        }
    // Create listbox
    CEikFormattedCellListBox* list = new(ELeave) CAknDoublePopupMenuStyleListBox;
    CleanupStack::PushL(list);

    // Create popup list
    /*Fix for ESLM-83NACK : As AVKON has made some changes to support an email application requirement (JKEI-83P9JQ)
     * LSK is hidden while showing a pop-up hence R_AVKON_SOFTKEYS_BACK is used  */
    CAknPopupList* popupList = CAknPopupList::NewL(list, R_AVKON_SOFTKEYS_BACK, AknPopupLayouts::EMenuDoubleWindow);
    CleanupStack::PushL(popupList);

    // initialize listbox.
    
    // Clear flag.
    TInt flags = 0; 
    list->ConstructL(popupList, flags);
    list->CreateScrollBarFrameL(ETrue);
    list->ScrollBarFrame()->SetScrollBarVisibilityL(CEikScrollBarFrame::EOff, CEikScrollBarFrame::EAuto );

    HBufC* popupTitle = CCoeEnv::Static()->AllocReadResourceLC(R_STR_HEADING_PRES_DETAILS);
    popupList->SetTitleL(*popupTitle);
    CleanupStack::PopAndDestroy(); // popupTitle

    // Make listitems.
    CDesCArrayFlat* items = new(ELeave) CDesCArrayFlat(1);
    CleanupStack::PushL(items);

    _LIT(KListBoxItemFormat, "%S\t%S");

    // Get the directory entry
    TEntry entry;
    TFileName fileName;
    fileName = *((CSaFlashAppUi*)AppUi())->GetFilename();
    if ( iLaunchType == EEmbedded )
    {	
    	
    	iFile.Name(iOrigName);
    	entry.iName = iOrigName;
    	iFile.Modified(entry.iModified);
    	iFile.Size(entry.iSize);
    }
    else
    {
        User::LeaveIfError(iCoeEnv->FsSession().Entry(fileName, entry));
    }
    TTime localTime = entry.iModified; // convert from universal time
    RTz tz;
    User::LeaveIfError( tz.Connect() );
    User::LeaveIfError( tz.ConvertToLocalTime( localTime ) );
    tz.Close();

    // Display filename
    {
        HBufC* fnameTitle = iCoeEnv->AllocReadResourceLC(R_STR_DETAILS_FILENAME);
        HBufC* fnameItem = HBufC::NewLC(entry.iName.Length() + fnameTitle->Length() + 1);
        TPtr itemptr = fnameItem->Des();

        itemptr.Format(KListBoxItemFormat, fnameTitle, &entry.iName);
        items->AppendL(*fnameItem);
        CleanupStack::PopAndDestroy(2); // fnameItem, filenameTitle
    }

    // Display format
    { 
    TBool checkFileRetVal = EFalse;
    if ( iLaunchType == EEmbedded ) 
    {
    	checkFileRetVal = FlashUiUtil::GetFileTypeL(iFile);
    }
    else
    {
    	checkFileRetVal = FlashUiUtil::GetFileTypeL(fileName);
    }
    if (checkFileRetVal)
        {
        TInt dot = entry.iName.LocateReverse('.');
        //if (dot != KErrNotFound)
        	{
            	TPtrC ext;
            	if(checkFileRetVal == 1) //swf type
            	{
            		ext.Set((KSwfExtension().Right(KSwfExtension().Length() - 1)));	
            	}
				#ifdef __FEATURE_FLV_RECOG_PLAY
            	else if( checkFileRetVal == 2 )
            	{
            		ext.Set((KFlvExtension().Right(KFlvExtension().Length() - 1)));	
            	}
				#endif
                #ifdef __FEATURE_F4V_RECOG_PLAY
                //else //f4v type
                else if( checkFileRetVal == 3 )
                {
                    ext.Set((KF4vExtension().Right(KF4vExtension().Length() - 1))); 
            	}
				#endif

            HBufC* formatTitle = iCoeEnv->AllocReadResourceLC(R_STR_DETAILS_FORMAT);
            HBufC* formatItem = HBufC::NewLC(formatTitle->Length() + entry.iName.Length() - dot);
            TPtr itemptr = formatItem->Des();
            itemptr.Append(*formatTitle);
            itemptr.Append('\t');
            itemptr.Append(ext);

            items->AppendL(*formatItem);
            CleanupStack::PopAndDestroy(2); // formatItem, formatTitle
        	}
        }
        
    }

    // Display date
    {
        HBufC* dateTitle = iCoeEnv->AllocReadResourceLC(R_STR_DETAILS_DATE);
        HBufC* dateFormat = iCoeEnv->AllocReadResourceLC(R_QTN_DATE_USUAL_WITH_ZERO);
        TBuf<KMaxShortDateFormatSpec*2> dateString;
        localTime.FormatL(dateString, *dateFormat);
        HBufC* dateItem = HBufC::NewLC(dateTitle->Length() + dateString.Length() + 1);
        TPtr itemptr = dateItem->Des();

        itemptr.Format(KListBoxItemFormat, dateTitle, &dateString);
        AknTextUtils::LanguageSpecificNumberConversion(itemptr);
        items->AppendL(*dateItem);
        CleanupStack::PopAndDestroy(3); // dateItem, dateFormat, dateTitle
    }

    // Display time
    {
        HBufC* timeTitle = iCoeEnv->AllocReadResourceLC(R_STR_DETAILS_TIME);
        HBufC* timeFormat = iCoeEnv->AllocReadResourceLC(R_QTN_TIME_USUAL_WITH_ZERO);
        TBuf<KMaxTimeFormatSpec*2> timeString;
        localTime.FormatL(timeString, *timeFormat);
        HBufC* timeItem = HBufC::NewLC(timeTitle->Length() + timeString.Length() + 1);
        TPtr itemptr = timeItem->Des();

        itemptr.Format(KListBoxItemFormat, timeTitle, &timeString);
        AknTextUtils::LanguageSpecificNumberConversion(itemptr);
        items->AppendL(*timeItem);
        CleanupStack::PopAndDestroy(3); // timeItem, timeFormat, timeTitle
    }

    // Display size
    {
        HBufC* sizeTitle = iCoeEnv->AllocReadResourceLC(R_STR_DETAILS_SIZE);
        HBufC* sizeString = NULL;
        if (entry.iSize >= 1024)
        {
            sizeString = StringLoader::LoadLC(R_QTN_SIZE_KB, ((entry.iSize + 512) >> 10));
        }
        else
        {
            sizeString = StringLoader::LoadLC(R_QTN_SIZE_B, entry.iSize);
        }
        HBufC* sizeItem = HBufC::NewLC(sizeTitle->Length() + sizeString->Length() + 1);
        TPtr itemptr = sizeItem->Des();
        itemptr.Format(KListBoxItemFormat, sizeTitle, sizeString);
        AknTextUtils::LanguageSpecificNumberConversion(itemptr);
        items->AppendL(*sizeItem);
        CleanupStack::PopAndDestroy(3); // sizeItem, sizeString, sizeTitle
    }

//#ifdef __FLASHLITE2.0_REL3.1
	    // Display the DRM rights
    {
        TInt result;
        iOrigName = *((CSaFlashAppUi*)AppUi())->GetFilename();
        TBool isProtected;
		CContent *content;
		if ( iLaunchType == EEmbedded )
		{
			content = CContent::NewLC(iFile); 
		}
		else
		{
			content = CContent::NewLC(iOrigName);
		}
        content->GetAttribute( EIsProtected, isProtected );
        CleanupStack::PopAndDestroy(); // content

        if (isProtected)
        {
            CDRMHelperRightsConstraints* aExecuteRights = NULL;
            CDRMHelperRightsConstraints* aIgnore1 = NULL;
            CDRMHelperRightsConstraints* aIgnore2 = NULL;
            CDRMHelperRightsConstraints* aIgnore3 = NULL;

            TBool aExpired;
            TBool aSendingAllowed;
            TBool notYetValid = FALSE;
			TInt err;
			if ( iLaunchType == EEmbedded )
			{
				TRAP(err,iDrmHelper->GetRightsDetailsL(iFile, 
               		ContentAccess::EExecute,
               		aExpired,
               		aSendingAllowed,
               		aIgnore1, 
               		aIgnore2,
               		aExecuteRights,  
               		aIgnore3));
			}
			else
			{
				TRAP(err,iDrmHelper->GetRightsDetailsL(iOrigName, 
               		ContentAccess::EExecute,
               		aExpired,
               		aSendingAllowed,               		
               		aIgnore1, 
               		aIgnore2, 
               		aExecuteRights, 
               		aIgnore3));
			}
			
  
            // Delete ignored constraints
            if( aIgnore1 )
            {
            	delete aIgnore1;
            }
            if( aIgnore2)
            {
            	delete aIgnore2;
            }
            if(aIgnore3)
            {
            	delete aIgnore3;
            }
            
            if( err == KErrCANoRights)
            {
          	      AddStringPairL(R_QTN_DRM_MGR_DET_STAT, R_QTN_DRM_MGR_DET_NOT_VALID_YET, items, EFalse);
            }
            
			if (aExecuteRights)
			{
	            CleanupStack::PushL(aExecuteRights);
	            
	            if (aExecuteRights->FullRights())
	            {
	                AddStringPairL(R_QTN_DRM_MGR_DET_FULL_X, R_QTN_DRM_MGR_DET_UNLIMITED, items, ETrue);
	            }
	            else
	            {
	                // Check for count based rights
	                TUint32 aCounter;
	                TUint32 aOriginalCounter;
	                TTimeIntervalSeconds aTimer;
	                TTimeIntervalSeconds aInterval;
	                TTime aStartTime;
	                TTime aEndTime;
	                
	                TRAP(result, aExecuteRights->GetCountersL(aCounter, aOriginalCounter));
	                if ((result != KErrNotFound) && (result != KErrNone))
	                {
	                    User::Leave(result);
	                }
	                if (result != KErrNotFound)
	                {
	                    AddCountsL(aCounter, items);
	                }

#ifdef PHASE_TWO
	                // Check for timed count based rights
	                TRAP(result, aExecuteRights->GetTimedCountL(aCounter, aOriginalCounter, aTimer));
	                if ((result != KErrNotFound) && (result != KErrNone))
	                {
	                    User::Leave(result);
	                }
	                if (result != KErrNotFound)
	                {
	                    AddCountsL(aCounter, items);
	                }
#endif
	                
	                // Check for interval based rights
	                TRAP(result, aExecuteRights->GetIntervalL(aInterval));
	                if ((result != KErrNotFound) && (result != KErrNone))
	                {
	                    User::Leave(result);
	                }
	                if (result != KErrNotFound)
	                {
	                    TRAP(result, aExecuteRights->GetIntervalStartL(aStartTime));
	                    if ((result != KErrNotFound) && (result != KErrNone))
	                    {
	                        User::Leave(result);
	                    }
	                    if (result == KErrNotFound)  // Interval has not yet been started
	                    {
	                        AddStringPairL(R_QTN_DRM_MGR_DET_UTS_X, R_QTN_DRM_MGR_DET_NOT_ACT, items, ETrue);
	                        AddTimeLeftL(R_QTN_DRM_MGR_DET_UDL_X, aInterval, items, ETrue);
	                        notYetValid = TRUE;
	                    }
	                }
	                
	                // Check for date/time based rights
	                TRAP(result, aExecuteRights->GetStartTimeL(aStartTime));
	                if ((result != KErrNotFound) && (result != KErrNone))
	                {
	                    User::Leave(result);
	                }
	                
	                if (result != KErrNotFound)
	                {
	                    TRAP(result, aExecuteRights->GetEndTimeL(aEndTime));
	                    if ((result != KErrNotFound) && (result != KErrNone))
	                    {
	                        User::Leave(result);
	                    }
						
						if (result != KErrNotFound)
						{
							AddDateAndTimeL(R_QTN_DRM_MGR_DET_RVF_X, aStartTime, items);
	                    	AddDateAndTimeL(R_QTN_DRM_MGR_DET_RVT_X, aEndTime, items);	
						}
	                }
	                
#ifdef PHASE_TWO
	                // Check for accumulated based rights
	                TRAP(result, aExecuteRights->GetAccumulatedTimeL(aInterval));
	                if ((result != KErrNotFound) && (result != KErrNone))
	                {
	                    User::Leave(result);
	                }
	                if (result != KErrNotFound)
	                {
	                   AddTimeLeftL(R_QTN_DRM_MGR_DET_ACCUM_TIME_LEFT, aInterval, items, EFalse);
	                }
#endif

	                // Add status
	                if (aExpired)
	                {
	                    AddStringPairL(R_QTN_DRM_MGR_DET_STAT, R_QTN_DRM_MGR_DET_EXP, items, EFalse);
	                }
	                else
	                {
	                    if (notYetValid)
	                    {
	                        AddStringPairL(R_QTN_DRM_MGR_DET_STAT, R_QTN_DRM_MGR_DET_NOT_VALID_YET, items, EFalse);
	                    }
	                    else
	                    {
	                        AddStringPairL(R_QTN_DRM_MGR_DET_STAT, R_QTN_DRM_MGR_DET_VALID, items, EFalse);
	                    }
	                }

	                // Add content sending attribute
	                if (aSendingAllowed)
	                {
	                    AddStringPairL(R_QTN_DRM_MGR_DET_CS, R_QTN_DRM_MGR_DET_ALLOWED, items, EFalse);
	                }
	                else
	                {
	                    AddStringPairL(R_QTN_DRM_MGR_DET_CS, R_QTN_DRM_MGR_DET_FORBID, items, EFalse);
	                }
	            }
	            CleanupStack::PopAndDestroy(); //playRights
            }
        }
    }

    // Set listitems.
    CTextListBoxModel* model = list->Model();
    model->SetItemTextArray(items);
    model->SetOwnershipType(ELbmOwnsItemArray);
    CleanupStack::Pop(); // items
		
		#ifdef __FEATURE_TOOLBAR__
    iShowToolBar = EFalse;
    CAknToolbar* toolBar = NULL;
    if(iIsTouchFeatureSupported)
    {
        toolBar = Toolbar();
    }
    toolBar->SetToolbarVisibility(EFalse,EFalse);
        
	#endif

    // Show popup list
    (void) popupList->ExecuteLD();
    
    #ifdef __FEATURE_TOOLBAR__
    iShowToolBar = ETrue;
    toolBar->SetToolbarVisibility(ETrue,EFalse);
#endif


    CleanupStack::Pop(); // popupList
    CleanupStack::PopAndDestroy(); // list
}
//#endif //__FLASHLITE2.0_REL3.1

//#ifdef __FLASHLITE2.0_REL3.1
void CSaFlashPlayerView::AddDateAndTimeL(TUint32 aTitleId, TTime aDateTime, CDesCArrayFlat* aItems)
{
    HBufC* dateFormat = StringLoader::LoadLC( R_QTN_DATE_USUAL_WITH_ZERO, iEikonEnv );
    TBuf<KMaxShortDateFormatSpec*2> dateString;
    aDateTime.FormatL(dateString, *dateFormat);
    
    HBufC* timeFormat = StringLoader::LoadLC( R_QTN_TIME_USUAL, iEikonEnv );
    TBuf<KMaxTimeFormatSpec*2> timeString;
    aDateTime.FormatL(timeString, *timeFormat);

    // Join the two strings
    HBufC* dateTimeBuffer = HBufC::NewLC(dateString.Length() + timeString.Length() + 3);
    TPtr dateTimePointer = dateTimeBuffer->Des();
    
    _LIT(KSpace, " ");
    dateTimePointer.Append(dateString);
    dateTimePointer.Append(KSpace);
    dateTimePointer.Append(timeString);

    HBufC* dateTimeTitleText = StringLoader::LoadLC( R_QTN_DRM_MGR_DET2_EXECUTE, iEikonEnv );
    HBufC* timeTitleText = StringLoader::LoadLC( aTitleId, *dateTimeTitleText, iEikonEnv );
    
    HBufC* itemBuffer = HBufC::NewLC(dateTimeBuffer->Length() + timeTitleText->Length() + 50);
    TPtr itemPointer = itemBuffer->Des();
    
    itemPointer.Append(*timeTitleText);
    _LIT(KTab, "\t");
    itemPointer.Append(KTab);
    itemPointer.Append(*dateTimeBuffer);
	AknTextUtils::LanguageSpecificNumberConversion(itemPointer);		
    
    aItems->AppendL(*itemBuffer);
    CleanupStack::PopAndDestroy(6); 
}

void CSaFlashPlayerView::AddTimeLeftL(TUint32 aTitleId, TTimeIntervalSeconds aInterval, CDesCArrayFlat* aItems, TBool aDisplayPlayText)
{
    TUint8 seconds = aInterval.Int() % 60;
    TUint8 minutes = (aInterval.Int() / 60) % 60;
    TUint8 hours = (aInterval.Int() / 60 / 60) % 24;
    TUint8 days = (aInterval.Int() / 60 / 60 / 24) % 31;
    TUint8 months = (aInterval.Int() / 60 / 60 / 24 / 31) % 12;
    TUint16 years = (aInterval.Int() / 60 / 60 / 24 / 31 / 12);

    if (years > 0)
    {
        AddSingleOrDoubleValueL(aTitleId, 
                R_QTN_DRM_NBR_OF_YEARS_ONE,
                R_QTN_DRM_NBR_OF_YEARS_TWO_FOUR,
                R_QTN_DRM_NBR_OF_YEARS_FIVE_ZERO,
                R_QTN_DRM_NBR_OF_YEARS_ONE_FINAL,
                R_QTN_DRM_NBR_OF_MONTHS_ONE,
                R_QTN_DRM_NBR_OF_MONTHS_TWO_FOUR,
                R_QTN_DRM_NBR_OF_MONTHS_FIVE_ZERO,
                R_QTN_DRM_NBR_OF_MONTHS_FIVE_ZERO, // No need for a one final
                aItems,
                years,
                months, aDisplayPlayText);
    }
    else  if (months > 0)
    {
        AddSingleOrDoubleValueL(aTitleId, 
                R_QTN_DRM_NBR_OF_MONTHS_ONE,
                R_QTN_DRM_NBR_OF_MONTHS_TWO_FOUR,
                R_QTN_DRM_NBR_OF_MONTHS_FIVE_ZERO,
                R_QTN_DRM_NBR_OF_MONTHS_FIVE_ZERO, // No need for a one final
                R_QTN_DRM_NBR_OF_DAYS_ONE,
                R_QTN_DRM_NBR_OF_DAYS_TWO_FOUR,
                R_QTN_DRM_NBR_OF_DAYS_FIVE_ZERO,
                R_QTN_DRM_NBR_OF_DAYS_ONE_FINAL,
                aItems,
                months,
                days, aDisplayPlayText);
    }
    else  if (days > 0)
    {
        AddSingleOrDoubleValueL(aTitleId, 
                R_QTN_DRM_NBR_OF_DAYS_ONE,
                R_QTN_DRM_NBR_OF_DAYS_TWO_FOUR,
                R_QTN_DRM_NBR_OF_DAYS_FIVE_ZERO,
                R_QTN_DRM_NBR_OF_DAYS_ONE_FINAL,
                R_QTN_DRM_NBR_OF_HOURS_ONE,
                R_QTN_DRM_NBR_OF_HOURS_TWO_FOUR,
                R_QTN_DRM_NBR_OF_HOURS_FIVE_ZERO,
                R_QTN_DRM_NBR_OF_HOURS_ONE_FINAL,
                aItems,
                days,
                hours, aDisplayPlayText);
    }
    else  if (hours > 0)
    {
        AddSingleOrDoubleValueL(aTitleId, 
                R_QTN_DRM_NBR_OF_HOURS_ONE,
                R_QTN_DRM_NBR_OF_HOURS_TWO_FOUR,
                R_QTN_DRM_NBR_OF_HOURS_FIVE_ZERO,
                R_QTN_DRM_NBR_OF_HOURS_ONE_FINAL,
                R_QTN_DRM_NBR_OF_MINS_ONE,
                R_QTN_DRM_NBR_OF_MINS_TWO_FOUR,
                R_QTN_DRM_NBR_OF_MINS_FIVE_ZERO,
                R_QTN_DRM_NBR_OF_MINS_ONE_FINAL,
                aItems,
                hours,
                minutes, aDisplayPlayText);
    }
    else  if (minutes > 0)
    {
        AddSingleOrDoubleValueL(aTitleId, 
                R_QTN_DRM_NBR_OF_MINS_ONE,
                R_QTN_DRM_NBR_OF_MINS_TWO_FOUR,
                R_QTN_DRM_NBR_OF_MINS_FIVE_ZERO,
                R_QTN_DRM_NBR_OF_MINS_ONE_FINAL,
                R_QTN_DRM_NBR_OF_SECS_ONE,
                R_QTN_DRM_NBR_OF_SECS_TWO_FOUR,
                R_QTN_DRM_NBR_OF_SECS_FIVE_ZERO,
                R_QTN_DRM_NBR_OF_SECS_ONE_FINAL,
                aItems,
                minutes,
                seconds, aDisplayPlayText);
    }
    else
    {
        AddSingleValueL(aTitleId, 
                R_QTN_DRM_NBR_OF_SECS_ONE,
                R_QTN_DRM_NBR_OF_SECS_TWO_FOUR,
                R_QTN_DRM_NBR_OF_SECS_FIVE_ZERO,
                R_QTN_DRM_NBR_OF_SECS_ONE_FINAL,
                aItems,
                seconds, aDisplayPlayText);
    }
}

void CSaFlashPlayerView::AddSingleOrDoubleValueL(TUint32 aTitleId,
    TUint32 aFirstOne, TUint32 aFirstTwoFour, TUint32 aFirstFiveZero, TUint32 aFirstOneFinal,
    TUint32 aSecondOne, TUint32 aSecondTwoFour, TUint32 aSecondFiveZero, TUint32 aSecondOneFinal,
    CDesCArrayFlat* aItems, TUint8 aFirstValue, TUint8 aSecondValue, TBool aDisplayPlayText)
{
    if (aSecondValue == 0)
    {
        AddSingleValueL(aTitleId, aFirstOne, aFirstTwoFour, aFirstFiveZero, 
        	aFirstOneFinal, aItems, aFirstValue, aDisplayPlayText);
    }
    else
    {
        AddDoubleValueL(aTitleId, 
            aFirstOne, aFirstTwoFour, aFirstFiveZero, aFirstOneFinal,
            aSecondOne, aSecondTwoFour, aSecondFiveZero, aSecondOneFinal,
            aItems, aFirstValue, aSecondValue, aDisplayPlayText);
    }
}

void CSaFlashPlayerView::AddDoubleValueL(TUint32 aTitleId,
    TUint32 aFirstOne, TUint32 aFirstTwoFour, TUint32 aFirstFiveZero, 
    TUint32 aFirstOneFinal, TUint32 aSecondOne, TUint32 aSecondTwoFour, 
    TUint32 aSecondFiveZero, TUint32 aSecondOneFinal, 
    CDesCArrayFlat* aItems, TUint8 aFirstValue, TUint8 aSecondValue, TBool aDisplayPlayText)
{
    _LIT(KListBoxItemFormat, "%S\t%S");
    HBufC* firstMeasurement;
    HBufC* secondMeasurement;

    // Format measurements
    firstMeasurement = FormatValueLC(aFirstOne, aFirstTwoFour, aFirstFiveZero, aFirstOneFinal, aFirstValue);
    secondMeasurement = FormatValueLC(aSecondOne, aSecondTwoFour, aSecondFiveZero, aSecondOneFinal, aSecondValue);
    CDesC16ArrayFlat* array = new(ELeave) CDesCArrayFlat(1);
    CleanupStack::PushL(array);
    array->AppendL(*firstMeasurement);
    array->AppendL(*secondMeasurement);
    HBufC*  formatString = StringLoader::LoadLC(R_QTN_DRM_MGR_DET_INTER_TWO, *array, iEikonEnv );
        
	HBufC* title;
    // Add item to list
		
	if ( aDisplayPlayText )
	{
		HBufC* titleText = StringLoader::LoadLC( R_QTN_DRM_MGR_DET2_EXECUTE, iEikonEnv );
		title = StringLoader::LoadLC( aTitleId, *titleText, iEikonEnv );
	}
	else
	{
		title = StringLoader::LoadLC( aTitleId, iEikonEnv );
	}

    HBufC* itemBuffer = HBufC::NewLC(formatString->Length() + title->Length() + 1);
    TPtr itemPointer = itemBuffer->Des();
    itemPointer.Format(KListBoxItemFormat, title, formatString);
    AknTextUtils::LanguageSpecificNumberConversion(itemPointer);
    aItems->AppendL(*itemBuffer);
	if ( aDisplayPlayText )
	{
		CleanupStack::PopAndDestroy(7); // title, itemBuffer, bodyText
	}
	else
	{
		CleanupStack::PopAndDestroy(6); 
	}
}

HBufC* CSaFlashPlayerView::FormatValueLC(TUint32 aOne, TUint32 aTwoFour, TUint32 aFiveZero, TUint32 aOneFinal, TUint8 aValue)
{
    HBufC* formattedValue;
    if (aValue == 1)
    {
        return iCoeEnv->AllocReadResourceLC(aOne);
    }
    
    if (((aValue % 10) == 0) || ((aValue >=11) && (aValue <= 14)) || (((aValue % 10) >= 5) && ((aValue % 10) <= 9)))
    {
        formattedValue = StringLoader::LoadLC( aFiveZero, aValue, iEikonEnv );
    }
    else if ((aValue % 10) == 1)
    {
        formattedValue = StringLoader::LoadLC( aOneFinal, aValue, iEikonEnv );
    }
    else
    {
        formattedValue = StringLoader::LoadLC( aTwoFour, aValue, iEikonEnv );
    }
    return formattedValue;
}

void CSaFlashPlayerView::AddSingleValueL(TUint32 aTitleId, TUint32 aOne, 
	TUint32 aTwoFour, TUint32 aFiveZero, TUint32 aOneFinal, 
	CDesCArrayFlat* aItems, TUint8 aValue, TBool aDisplayPlayText)
{
    _LIT(KListBoxItemFormat, "%S\t%S");
    
    HBufC* titleText;
    if ( aDisplayPlayText )
	{
		HBufC* titleResourceText = StringLoader::LoadLC( R_QTN_DRM_MGR_DET2_EXECUTE, iEikonEnv );
		titleText = StringLoader::LoadLC( aTitleId, *titleResourceText, iEikonEnv );
	}
	else
	{
		titleText = StringLoader::LoadLC( aTitleId, iEikonEnv );
	}
	
    HBufC* formattedValue = FormatValueLC(aOne, aTwoFour, aFiveZero, aOneFinal, aValue);
    
    HBufC* itemBuffer = HBufC::NewLC(formattedValue->Length() + titleText->Length() + 1);
    TPtr itemPointer = itemBuffer->Des();
    itemPointer.Format(KListBoxItemFormat, titleText, formattedValue);
    AknTextUtils::LanguageSpecificNumberConversion(itemPointer);
    aItems->AppendL(*itemBuffer);
    if ( aDisplayPlayText )
    {
    	CleanupStack::PopAndDestroy(4); 
    }
    else
    {
    	CleanupStack::PopAndDestroy(3);
    }
}

void CSaFlashPlayerView::AddStringPairL(TUint32 aTitleId, TUint32 aBodyId, 
	CDesCArrayFlat* aItems, TBool displayPlayText)
{
    _LIT(KListBoxItemFormat, "%S\t%S");
    HBufC* title;
    if ( displayPlayText )
    {
    	HBufC* titleText = StringLoader::LoadLC( R_QTN_DRM_MGR_DET2_EXECUTE, iEikonEnv );
    	title = StringLoader::LoadLC( aTitleId, *titleText, iEikonEnv );	
    }
    else
    {
    	title = StringLoader::LoadLC( aTitleId, iEikonEnv );	
    }
    
    HBufC* body = iCoeEnv->AllocReadResourceLC(aBodyId);
    HBufC* itemBuffer = HBufC::NewLC(title->Length() + body->Length() + 1);
    TPtr itemPointer = itemBuffer->Des();
    
    itemPointer.Format(KListBoxItemFormat, title, body);
    aItems->AppendL(*itemBuffer);
    if ( displayPlayText )
    {
   	    CleanupStack::PopAndDestroy(4); // titleText, title, body, itemBuffer
    }
    else
    {
    	CleanupStack::PopAndDestroy(3);
    }
}

void CSaFlashPlayerView::AddCountsL(TUint32 aCounter, CDesCArrayFlat* aItems)
{
    _LIT(KListBoxItemFormat, "%S\t%S");
    
    HBufC* countsTitleText = StringLoader::LoadLC( R_QTN_DRM_MGR_DET2_EXECUTE, iEikonEnv );
    HBufC* countsTitle = StringLoader::LoadLC( R_QTN_DRM_MGR_DET_UTL_X, *countsTitleText, iEikonEnv );
   
    HBufC* countsValue;
    if (aCounter == 1)
    {
       countsValue = StringLoader::LoadLC( R_QTN_DRM_MGR_DET_1_COUNT, iEikonEnv ); 
    }
    else
    {
       countsValue = StringLoader::LoadLC( R_QTN_DRM_MGR_DET_N_COUNTS, aCounter, iEikonEnv);
    }
 
    HBufC* itemBuffer = HBufC::NewLC(countsTitle->Length() + countsValue->Length() + 1);
    TPtr itemPointer = itemBuffer->Des();

    itemPointer.Format(KListBoxItemFormat, countsTitle, countsValue);
    AknTextUtils::LanguageSpecificNumberConversion(itemPointer);
    aItems->AppendL(*itemBuffer);
    CleanupStack::PopAndDestroy(4); 
}

void CSaFlashPlayerView::HandleResourceChangeL(TInt/* aType*/)
{
	if(iFullScreen)
	{
		SetFullScreenL();
	}
	else
	{
		SetAppScreenL();
	}
}

TBool CSaFlashPlayerView::FileExistsInDefaultFolder()
{
	
	
#ifdef FEATURE_MULTIPLE_DRIVE
TBool retVal=ETrue;
TRAPD(err,retVal=FileExistsInDefaultDriveL());
if(err==KErrNone)
	{
	}
return retVal;

#else  ///FEATURE_MULTIPLE_DRIVE
	TFileName rootPhonePath;
	TFileName rootMemCardPath;
	
	rootPhonePath.Copy(PathInfo::PhoneMemoryRootPath());
	rootPhonePath.Append(PathInfo::OthersPath());
	
	rootMemCardPath.Copy(PathInfo::MemoryCardRootPath());
	rootMemCardPath.Append(PathInfo::OthersPath());	
	TInt phonePath = KErrNotFound;
	TInt memCardPath= KErrNotFound;
	if(((CSaFlashAppUi*)AppUi())->GetFilename())
	{
		phonePath = (((CSaFlashAppUi*)AppUi())->GetFilename())->FindF( rootPhonePath );
		memCardPath = (((CSaFlashAppUi*)AppUi())->GetFilename())->FindF( rootMemCardPath );		
	}
	
	
	if ( (phonePath == KErrNotFound) && (memCardPath == KErrNotFound) )
	{
		return EFalse;
	}
	else
	{
		return ETrue;
	}
#endif/////FEATURE_MULTIPLE_DRIVE
}

#ifdef FEATURE_MULTIPLE_DRIVE
TBool CSaFlashPlayerView::FileExistsInDefaultDriveL()
    {
    //search for the file in all  available drives(phone mem,MMC, mass storage.....)
           
    HBufC* fileName =HBufC::NewLC(KMaxFileName);
    fileName=((CSaFlashAppUi*)AppUi())->GetFilename();
    TPtr ptrFileName=fileName->Des();
    
///	TDriveUnit gives drive number.
    RFs& fs = iEikonEnv->FsSession();
	TInt drive = TDriveUnit(ptrFileName);
	TUint driveStatus=0;
	User::LeaveIfError(DriveInfo::GetDriveStatus(fs,drive,driveStatus));
	
	HBufC* rootPath=HBufC::NewLC(KMaxFileName);
	TPtr ptrRootPath=rootPath->Des();

	TInt filePath =KErrNotFound;
 
/// status of device memory :EDriveInternal
/// status of mass storage  :EDriveInternal and EDriveExternallyMountable
/// status of removable MMC	:EDriveRemovable
///
	if(driveStatus & DriveInfo::EDriveInternal)
	{
		if(driveStatus & DriveInfo::EDriveExternallyMountable)
		{
			User::LeaveIfError(PathInfo::GetRootPath(ptrRootPath,drive));
			ptrRootPath.Append(PathInfo::OthersPath());
			filePath=(((CSaFlashAppUi*)AppUi())->GetFilename())->FindF(ptrRootPath);
		}
		else
		{
			User::LeaveIfError(PathInfo::GetRootPath(ptrRootPath,drive));
			ptrRootPath.Append(PathInfo::OthersPath());
			filePath=(((CSaFlashAppUi*)AppUi())->GetFilename())->FindF(ptrRootPath);	
		}
	}
	else
	{
		if(driveStatus & DriveInfo::EDriveRemovable)
		{
		User::LeaveIfError(PathInfo::GetRootPath(ptrRootPath,drive));
		ptrRootPath.Append(PathInfo::OthersPath());
		filePath=(((CSaFlashAppUi*)AppUi())->GetFilename())->FindF(ptrRootPath);	
		}
	}
	    
	CleanupStack::PopAndDestroy(2);//rootPath,fileName
	 
	   
	   
	
	if(filePath==KErrNotFound)
	{
		return EFalse;	
	}
    else
    {
    	return ETrue;
    }


    }
    #endif

CSaFlashPlayerView::TLaunchType CSaFlashPlayerView::GetLaunchType()
{
	return iLaunchType;	
}


        	
        	


TBool CSaFlashPlayerView::IsFullScreenMode()const
    {
    return iFullScreen;
    }
    
TBool CSaFlashPlayerView::CheckMemoryCard()
	{
	TDriveInfo driveInfo;
	TFileName memCardPath;
	TBool hasMMC = EFalse;
	// Get drive info
    TInt error = iEikonEnv->FsSession().Drive( driveInfo,
        MemoryCardDrive() ); 
        
	if ( error || driveInfo.iType == EMediaNotPresent )
    	{
        hasMMC = EFalse;
        }
	else if (driveInfo.iType == EMediaHardDisk)
	    {
	    hasMMC = ETrue;
	    }
    
    TInt err = KErrNotReady;    
    if(hasMMC)
    	{
    	memCardPath.Copy(PathInfo::MemoryCardRootPath());
		memCardPath.Append(PathInfo::OthersPath());
		err = iEikonEnv->FsSession().MkDirAll(memCardPath);
    	}
	
	switch(err)
		{
		case KErrNone:
		case KErrAlreadyExists:
		case KErrLocked:
		return ETrue;		

		case KErrNotReady:
		case KErrCorrupt:
		return EFalse;		

		default:
		return EFalse;
		}
	}

TInt CSaFlashPlayerView::MemoryCardDrive()
	{
	TInt res = 0;
    TInt err = RFs::CharToDrive( PathInfo::MemoryCardRootPath()[0], res );
	return res;
	}

// -----------------------------------------------------------------------------
// CSaFlashPlayerView::DoSaveL()
// This function checks if Save is displayed and saving is already done
// and prompts a confirmation query to the user and then calls SaveFileL
// -----------------------------------------------------------------------------

void CSaFlashPlayerView::DoSaveL()
{
//Honour EGenericParamAllowMove when invoked in embedded mode during a back or exit
//Proceed to save if the user has selected either back or Exit and confirmed save query 

	TFileName phoneDefaultPath;			
	phoneDefaultPath.Copy(PathInfo::PhoneMemoryRootPath());
	TOverflowHandler overflow;
	phoneDefaultPath.AppendFormat(PathInfo::OthersPath(), &overflow );
					    
	if (overflow.IsOverflowed() == KErrOverflow)
	  {
	      User::LeaveIfError(KErrOverflow);  
	   }

	CDir* cdir_dirs = NULL;		
	
	TInt err = iEikonEnv->FsSession().GetDir(phoneDefaultPath, KEntryAttDir | KEntryAttMatchExclusive, ESortByName | EAscending, cdir_dirs);
	if(err==KErrNone)
	{
		 CleanupStack::PushL( cdir_dirs );
		 TFileName fileName;
		 
		if((((CSaFlashAppUi*)AppUi())->GetFilename())==NULL)
		{
		
		if ( cdir_dirs )
			{
			 CleanupStack::PopAndDestroy(cdir_dirs);
			}
				
		return;	
		}	
					
    	 fileName = *((CSaFlashAppUi*)AppUi())->GetFilename();
    	 
    	 
    	 TBool aSave=EFalse;
    	  
    	 if(!FileExistsInDefaultFolder()) 
    	 {
    	 	 aSave=ETrue;
    	 }
    	  	
    	 if(fileName.Length()<=0)
    	 {
    	 	User::LeaveIfError(KErrBadDescriptor);
    	 }
    	  
         HBufC* hBuf=HBufC::NewLC(fileName.Length());
         *hBuf=fileName;
                          
		    	 
    	 TInt pos = hBuf->LocateReverse('\\'); //we need only the file name, not entire embedded path   	 		    	             	
    	 //we need only the file name, not entire embedded path   	 		    	             	
    	 if(pos!=KErrNotFound)
    	 {
    	 TInt length=fileName.Length();
    	 *hBuf = hBuf->Right(length-pos - 1);
    	 
    	 fileName=*hBuf;
    	 
    	if(hBuf)
		{
			CleanupStack::PopAndDestroy(hBuf);
		}
    
    	if ( cdir_dirs )
		{
			   CleanupStack::PopAndDestroy(cdir_dirs);
		}				
		
	    	TOverflowHandler overflow;
	     	phoneDefaultPath.AppendFormat( fileName, &overflow );
					    
		    if (overflow.IsOverflowed() == KErrOverflow)
		        {
		        User::LeaveIfError(KErrOverflow);  
		        }
	 	TBool fileExists( BaflUtils::FileExists(CCoeEnv::Static()->FsSession(), phoneDefaultPath));
	
       if(!fileExists)	 
       {
       	
	   if(((CSaFlashAppUi*)AppUi())->CanAllowMove())
	   {	       
	    		    
	    	if (aSave && !iErrorOcurred)
	    	{    		
	    	
		    	 if(LaunchSaveQueryDialogL(fileName) )
		        {
		              
				 	((CSaFlashAppUi*)AppUi())->SaveFileL(phoneDefaultPath);	  
				}
				else
				{
				    ((CSaFlashAppUi*)AppUi())->CloseApplication();	
				}
						
	    	}
	    
	   }
			   }
	   }
	    	           
	}        	         
    
    
}
    
    // -----------------------------------------------------------------------------
// CSVGTUIDialog::LaunchSaveQueryDialogL
// -----------------------------------------------------------------------------
//
TBool CSaFlashPlayerView::LaunchSaveQueryDialogL(const TFileName& afileName) const
    {
    HBufC* titleText = NULL;

	HBufC* fileName =HBufC::NewLC(afileName.Length());
    TPtr filePtr(fileName->Des());
  	
	//we need only the file name, not entire embedded path   	 		    	             			    	 
    TInt pos = afileName.LocateReverse('\\'); 
    if(pos!=KErrNotFound)
   	 {//we have file name passed with path, so we need to strip it
    	 filePtr.Copy(afileName.Right(afileName.Length() -pos - 1));
   	 }
   	 else
   	 {//ok, we have only name sent so use it
   	 	filePtr.Copy(afileName);
   	 }
  
    titleText = StringLoader::LoadLC( R_QTN_FLITE_QUERY_CONF_SAVE_DOWNLOADED, 
                              filePtr );

    CAknQueryDialog* query = CAknQueryDialog::NewL( );
    TBool retVal = query->ExecuteLD( R_SAFLASH_CONFIRMATION_QUERY, 
                                                   *titleText );
 	CleanupStack::PopAndDestroy( titleText );
 	      
    CleanupStack::PopAndDestroy( fileName );
    
    if ( retVal == EAknSoftkeyOk || retVal == EAknSoftkeyYes )
        {
        return ETrue;
        }
    return EFalse;
    }
    
//#endif //__FLASHLITE2.0_REL3.1


TBool CSaFlashPlayerView::IsVideoContent() const
{
	#ifdef __FEATURE_UI_LANDSCAPE_FULLSCREEN
		return iVideoContent;
	#else
		return EFalse;
	#endif
}

TBool CSaFlashPlayerView::IsVideoEmbedded()
{
	return iEmbeddedVideo;
}

#ifdef __FEATURE_FLV_RECOG_PLAY		

TBool CSaFlashPlayerView::IsFlvFilePlaying()
{
	if(iContainer)
	{
		return iContainer->IsFlvFilePlaying();
	}

	return EFalse;	
}

#endif

#ifdef __FEATURE_F4V_RECOG_PLAY     

TBool CSaFlashPlayerView::IsF4vFilePlaying()
{
    if(iContainer)
    {
        return iContainer->IsF4vFilePlaying();
    }

    return EFalse;  
}

#endif
TBool CSaFlashPlayerView::IsDisableMenuRotateScreen() const
{

	return iDisableMenuRotateScreen;
	
}

TBool CSaFlashPlayerView::IsVolumeKeySupported()const
{
	return iSideVolKeysSupported;
}

TBool CSaFlashPlayerView::IsVolumeMuted() const
{
	if(iVolume & KMuteMask)
	{
		return ETrue;
	}
	else
	{
		return EFalse;	
	}
	
}

TBool CSaFlashPlayerView::IsFullScreen() const
{
	return iFullScreen;
}

TBool CSaFlashPlayerView::IsLandScape() const
{
#ifdef __FEATURE_UI_LANDSCAPE_FULLSCREEN
	return iLandScape;
#else
	return EFalse;
#endif
}

TBool CSaFlashPlayerView::CanZoomOutfurther() const
{
	if(iZoomSuccess && (iZoomedTimes > 0))
	{
		return ETrue;
	}
	else
	{
		return EFalse;
	}
}
	
TBool CSaFlashPlayerView::CanZoomInfurther() const
{
	if(iZoomSuccess && (iZoomedTimes < KMaxZoomLevel))
	{
		return ETrue;
	}
	else
	{
		return EFalse;
	}
	
}

TInt  CSaFlashPlayerView::GetQuality() const
{
	return iQuality;
}

void CSaFlashPlayerView::HandleVideoErrorsL()
    {
        TBool checkFileRetVal = EFalse;
        if ( iLaunchType == EEmbedded ) 
        {
           checkFileRetVal = FlashUiUtil::GetFileTypeL(iFile);
        }
        else
        {
            TFileName fileName;
            fileName = *((CSaFlashAppUi*)AppUi())->GetFilename();
            checkFileRetVal = FlashUiUtil::GetFileTypeL(fileName);
        }
        // Ensure auto-rotate is not enabled 
        if (checkFileRetVal == 2 || checkFileRetVal == 3)
        {
            if(IsLandScape())
                iAvkonAppUi->SetOrientationL(CAknAppUiBase::EAppUiOrientationLandscape);
            else
                iAvkonAppUi->SetOrientationL(CAknAppUiBase::EAppUiOrientationPortrait);
        }
        
        if(iFullScreen)
        {
            SetAppScreenL();
        }

    }

void  CSaFlashPlayerView::HandleVideoError(const TInt& aError ) 
{
    TRAPD(error, HandleVideoErrorsL());
    if (error != KErrNone)
        {
        VwrDebug(LOG_DEBUG,
        _L("CSaFlashPlayerView::HandleVideoErrorL leave: %d\n"), error);
        }
    // Disable tool bar
    CAknToolbar* toolBar = Toolbar();
    if(toolBar)
    {
        toolBar->SetItemDimmed(EEikPauseButton,ETrue,ETrue);  // The user cannot resume when the state is changed by the engine 
        toolBar->SetItemDimmed(EEikZoomButton,ETrue,ETrue);   
        toolBar->SetItemDimmed(EEikToggleButton,ETrue,ETrue); 
        toolBar->DrawNow();
    }
    
    iContainer->HandleVideoError(aError);
}
	
void CSaFlashPlayerView::HandleEngineStateChangeL(TEngineState aState)
{
    // Engine changed its state on its own!
    iEngineState = aState;

#ifdef __FEATURE_TOOLBAR__
    CAknToolbar* toolBar = NULL;
    if(iIsTouchFeatureSupported)
    {
        toolBar = Toolbar();
    }
#endif
    switch(aState)
    {
    case EEnginePaused:
        iContainer->ShowPauseIconL(ETrue);
#ifdef __FEATURE_TOOLBAR__
        if(toolBar)
        {
        toolBar->SetItemDimmed(EEikPauseButton,ETrue,ETrue);  // The user cannot resume when the state is changed by the engine 
        toolBar->SetItemDimmed(EEikZoomButton,ETrue,ETrue);   
        toolBar->SetItemDimmed(EEikToggleButton,ETrue,ETrue); 
        toolBar->DrawNow();
        }
#endif
        Cba()->SetCommandSetL(R_SAFLASH_PLAYERVIEW_SOFTKEYS_OPTIONS_BACK);  // but he can quit if he wants to...
        Cba()->DrawNow();
        iBackButtonActive = ETrue;
        iEngineInitiatedPause = ETrue;
        break;
    case EEngineResumed:
        iContainer->ShowPauseIconL(EFalse);//SCALABLE
#ifdef __FEATURE_TOOLBAR__
        if(toolBar)
        {
        toolBar->SetItemDimmed(EEikPauseButton,EFalse,ETrue);
        toolBar->SetItemDimmed(EEikZoomButton,EFalse,ETrue);   
        toolBar->SetItemDimmed(EEikToggleButton,EFalse,ETrue); 
        }
#endif
        Cba()->SetCommandSetL(R_SAFLASH_PLAYERVIEW_SOFTKEYS_OPTIONS_BACK);
        Cba()->DrawNow();
        iBackButtonActive = ETrue;
        iEngineInitiatedPause = EFalse;
        break;
    }

}

TBool CSaFlashPlayerView::ShowPlayOption()
{
    // if we are paused AND if the pause was initiated by the engine, we should not show the option
    return !((iEngineState == EEnginePaused) && iEngineInitiatedPause);
}
#ifdef __FEATURE_OSK__

void CSaFlashPlayerView::ShowOnScreenKeypadL(const TRect& aAppRect, TBool aUserInitiatedFullScreen)
{
	if(iASyncOnScreenKeypadDestroyer && iASyncOnScreenKeypadDestroyer->IsActive())
	{
		// we are in the process of destroying the keypad
		// (we may hit this flow when we are scheduled for destruction, but the RunL isn't called yet.
		// If the orientation is changed, then we should not try to recreate the keypad)
		return;
	}
	
    TBool swfHasVideo = EFalse;
	if(iContainer)
	{
    	MFlashEngine* engine = iContainer->GetEngine();
	    if(engine)
	    {
	        swfHasVideo = engine->GetSwfHasVideo();
	    }
	}
    
	if(!iCompatabilityMode || (swfHasVideo && !IsVideoEmbedded()))
	{
		// if the compatibility mode is disabled OR if the content contains non embedded video,
		// do not display on screen keypad.
		if(iOnScreenKeypadControl)
		{
			delete iOnScreenKeypadControl;
			iOnScreenKeypadControl = NULL;
		}
		return;
	}
	
	if(iOnScreenKeypadControl == NULL)
	{
		InitializeOnScreenKeypadL(aAppRect, aUserInitiatedFullScreen);
	}
	else
	{
		UpdateOnScreenKeypadL(aAppRect, aUserInitiatedFullScreen);
	}
}

void CSaFlashPlayerView::InitializeOnScreenKeypadL(const TRect& aAppRect, TBool aUserInitiatedFullScreen) 
{
	TOSKMode mode = GetOnScreenKeypadMode(aUserInitiatedFullScreen);

	ASSERT(iOnScreenKeypadControl == NULL);

	if( mode == EQwertyNoKeypad )
	{
		// if we flip open the keypad when in fullscreen mode, we don't have to show the keypad  
		return;
	}

	TRect aOSKRect = GetOnScreenKeypadRect(aAppRect,mode);
	iOnScreenKeypadControl = COnScreenKeypadControl::NewL(this,aOSKRect,mode);

}

void CSaFlashPlayerView::UpdateOnScreenKeypadL(const TRect& aAppRect, TBool aUserInitiatedFullScreen)
{

	TOSKMode mode = GetOnScreenKeypadMode(aUserInitiatedFullScreen);
	if( mode == EQwertyNoKeypad )
	{
		// if we flip open the keypad when in fullscreen mode, me may have to hide the keypad  
		if(iOnScreenKeypadControl)
		{
			delete iOnScreenKeypadControl;
			iOnScreenKeypadControl = NULL;
		}
		return;
	}

	if(iOnScreenKeypadControl)
	{
		TRect aOSKRect = GetOnScreenKeypadRect(aAppRect,mode);
	    iOnScreenKeypadControl->UpdateL(aOSKRect,mode);
	}
}

TOSKMode CSaFlashPlayerView::GetOnScreenKeypadMode(TBool aUserInitiatedFullScreen)
{
	TOSKMode onScreenKeypadMode = EPortrait;
	CSaFlashAppUi* ui = (CSaFlashAppUi*)iEikonEnv->AppUi();
	
    CAknAppUiBase::TAppUiOrientation orientation;// = iAvkonAppUi->Orientation(); - returns EAppUiOrientationUnspecified always!
    TRect clientRect = ui->ClientRect();
    if(clientRect.Width() > clientRect.Height())
    {
    	orientation = CAknAppUiBase::EAppUiOrientationLandscape;
    }
    else
    {
    	orientation = CAknAppUiBase::EAppUiOrientationPortrait; 
    }

	if(IsVideoEmbedded())
	{		
		switch(orientation)
		{
			case CAknAppUiBase::EAppUiOrientationLandscape:
				if(!aUserInitiatedFullScreen)
				{
					onScreenKeypadMode = EQwertyNoKeypad;
				}
				else
				{
					onScreenKeypadMode = EQwertyLandscape;
				}
				break;
				
			case CAknAppUiBase::EAppUiOrientationPortrait:
				if(!aUserInitiatedFullScreen)
				{
					onScreenKeypadMode = EQwertyNoKeypad;
				}
				else
				{
					onScreenKeypadMode = EPortraitWithOnlyToggleScreenIcon;
				}
				break;
			
		}
		return onScreenKeypadMode;
	}

    switch(orientation)
    {
    case CAknAppUiBase::EAppUiOrientationPortrait:
    	onScreenKeypadMode = EPortrait;
    	if(!aUserInitiatedFullScreen)
    	{
    		onScreenKeypadMode = EPortraitWithoutToggleScreenIcon;
    	}
    	break;
    case CAknAppUiBase::EAppUiOrientationLandscape:
    	if(ui->GetQwertyKeyPadStatus())
    	{
    		onScreenKeypadMode = EQwertyLandscape;
    		if(!aUserInitiatedFullScreen)
    		{
    			onScreenKeypadMode = EQwertyNoKeypad;
    		}
    	}
    	else
    	{
    		onScreenKeypadMode = ELandscape;
        	if(!aUserInitiatedFullScreen)
        	{
        		onScreenKeypadMode = ELandscapeWithoutToggleScreenIcon;
        	}
    	}
    	break;
    }

    return onScreenKeypadMode;
}

TRect CSaFlashPlayerView::GetOnScreenKeypadRect(const TRect& aAppRect, TOSKMode aMode)
{
	TRect	oskRect;
	TPoint	location;
	TInt	oskHeight = aAppRect.Height();;
	TInt	oskWidth  = aAppRect.Width();
	TInt	flashDisplayWidth = aAppRect.Width();
	TInt	flashDisplayHeight = aAppRect.Height();

	switch(aMode)
	{
	case EPortrait:
	case EPortraitWithoutToggleScreenIcon:
		oskHeight = (aAppRect.Height()*KOSKPortraitModeHeightFactor)/KOSKPercentFactor;
		flashDisplayHeight -= oskHeight;
		break;

	case EPortraitWithOnlyToggleScreenIcon:
		oskHeight = (aAppRect.Height()*KOSKPortraitModeWithToggleIconHeightFactor)/KOSKPercentFactor;
		flashDisplayHeight -= oskHeight;
		break;
	
	case ELandscape:
	case ELandscapeWithoutToggleScreenIcon:
		oskWidth  = (aAppRect.Width()*KOSKLandscapeModeWidthFactor)/KOSKPercentFactor;
		flashDisplayWidth -= oskWidth;
		break;
		
	case EQwertyLandscape:
		oskWidth = (aAppRect.Width()*KOSKQwertyLandscapeModeWidthFactor)/KOSKPercentFactor;
		flashDisplayWidth -= oskWidth;
		break;
	}
	
	location.iX = (aAppRect.Width() - oskWidth);
	location.iY = (aAppRect.Height() - oskHeight);
	oskRect.SetHeight(oskHeight);
	oskRect.SetWidth(oskWidth);
	oskRect.Move(location);
	iFlashDisplayRect.SetWidth(flashDisplayWidth);
	iFlashDisplayRect.SetHeight(flashDisplayHeight);

	iOnScreenKeypadRect = oskRect;
	return iOnScreenKeypadRect;
}


void CSaFlashPlayerView::HandleSoftKeyL(TInt aKey)
{
	if(aKey == EKeyCBA1)
	{
		if(iLSK == EEikFlashCmdCustom1)
		{
			// LSK has been overridden
			HandleCommandL(iLSK);
		}
		else
		{
			SimulateSoftKey(EKeyCBA1);
		}
	}
	else if(aKey == EKeyCBA2)
	{
		if(iRSK == EEikFlashCmdCustom2)
		{
			// LSK has been overridden
			HandleCommandL(iRSK);
		}
		else
		{
			SimulateSoftKey(EKeyCBA2);
		}
	}
}

void CSaFlashPlayerView::SimulateSoftKey(TInt aKey)
{
    RWsSession sess=CCoeEnv::Static()->WsSession();
    TWsEvent event;
    TInt id = sess.GetFocusWindowGroup();
    event.SetType(EEventKey);
    event.SetTimeNow();
    event.Key()->iCode = aKey;
    event.Key()->iModifiers = 0;
    event.Key()->iRepeats = 0;
    event.Key()->iScanCode = EStdKeyNull;
    sess.SendEventToWindowGroup( id, event );
    sess.Flush();
}

TKeyResponse CSaFlashPlayerView::OfferOverlayKeyEvent(const TKeyEvent& aKeyEvent, TEventCode aType)
{
    TBool specialKeyHandled = EFalse;
    
    TRAP_IGNORE(specialKeyHandled = HandleSpecialKeyL(aKeyEvent,aType));
    
    if(specialKeyHandled)
    {
        return EKeyWasConsumed;
    }
    else
    {
        TKeyResponse response = EKeyWasNotConsumed;
        
        if(iContainer)
        {
			TRAPD(err, response = iContainer->OfferOverlayKeyEvent(aKeyEvent,aType));
			if(err != KErrNone)
			{
				return EKeyWasNotConsumed;
			}
        }
        
        return response;
    }
}

TBool CSaFlashPlayerView::HandleSpecialKeyL(const TKeyEvent& aKeyEvent, TEventCode aType)
{
    TBool handled = EFalse;
    if(aType == EEventKeyUp)
    {
        TInt eventCode = (TInt)aKeyEvent.iCode;
        switch(eventCode)
        {
        case EKeyPressLSK:
        	HandleSoftKeyL(EKeyCBA1);
            handled = ETrue;
            break;
        case EKeyPressRSK:
        	HandleSoftKeyL(EKeyCBA2);
            handled = ETrue;
            break;
        case EKeyPressToggleScreen:
            HandleCommandL(EEikFlashCmdPartScreen);
            handled = ETrue;
            break;
        }
    }
    
    return handled;
}

TInt CSaFlashPlayerView::DestroyOnScreenKeypadControl(TAny* aArgs)
{
	CSaFlashPlayerView* flashView = static_cast<CSaFlashPlayerView*>(aArgs);
	
	if(flashView)
	{
		if(flashView->iOnScreenKeypadControl)
		{
			delete flashView->iOnScreenKeypadControl;
			flashView->iOnScreenKeypadControl = NULL;
		}
		if(flashView->iASyncOnScreenKeypadDestroyer)
		{
			delete flashView->iASyncOnScreenKeypadDestroyer;
			flashView->iASyncOnScreenKeypadDestroyer = NULL;
		}
	}
	
	return KErrNone;
}

#endif // __FEATURE_OSK__

#ifdef __FEATURE_CONTEXT_SENSITIVE_MENU__
void CSaFlashPlayerView::ShowContextSensitiveMenu(const TPoint& aPoint)
{
    iMenuMgr->DynInitContextSensitiveMenu(this,aPoint);
}
#endif

////////////////////////////////////////////////////////////////
// CAsyncUIChanger
///////////////////////////////////////////////////////////////    

// -------------------------------------------------------------------------
//CAsyncUIChanger::CAsyncUIChanger(CBrowserPluginInstance* aPlayer) 
// constructor
// --------------------------------------------------------------------------
//

#ifdef __FEATURE_UI_LANDSCAPE_FULLSCREEN
CAsyncUIChanger::CAsyncUIChanger(CSaFlashPlayerView* aPlayerView)
              : CActive(EPriorityStandard)
              ,iPlayerView(aPlayerView)
{
    CActiveScheduler::Add(this);
    
}

// -------------------------------------------------------------------------
// CAsyncUIChanger::~CAsyncUIChanger()
// destructor
// --------------------------------------------------------------------------
//

    
CAsyncUIChanger::~CAsyncUIChanger()
    {
    Cancel();
    }

// -------------------------------------------------------------------------
// void CAsyncUIChanger::RunL()
// Active object execution method
// --------------------------------------------------------------------------
//

    
void CAsyncUIChanger::RunL()
    {
    
    if( iStatus.Int() != KErrNone )
        {
        return;        
        }

	iPlayerView->GoLandscapefullScreenL();
	
    }

// -------------------------------------------------------------------------
// void CAsyncUIChanger::IssueRequest()
// Used to Handle asynchronous request for deletion
// --------------------------------------------------------------------------
//
    
void CAsyncUIChanger::IssueRequest()
    {
       
    if(IsActive())
        {
        return;
        }
        
    TRequestStatus* status = &iStatus;
    SetActive();
    User::RequestComplete(status, KErrNone);
    
   
    }

// -------------------------------------------------------------------------
// void CAsyncUIChanger::DoCancel()
// cancel active object
// --------------------------------------------------------------------------
//
    
void CAsyncUIChanger::DoCancel()
    {
    }

#endif
//End of File
