/*
* Copyright (c) 2005 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  implements the the Trust store for list of trusted files.
*
*/

//SecuritySandbox
#include "symbian_appui.h"
#include "symbian_restarttimer.h"
// ---------------------------------------------------------------------------
// Two phase construction
//
// ---------------------------------------------------------------------------


    
CRestartTimer*  CRestartTimer::NewL(TInt aPriority,CSaFlashAppUi *aAppUI)
    {
         return new(ELeave) CRestartTimer(aPriority,aAppUI);
    }
// ---------------------------------------------------------------------------
// Two phase construction
//
// ---------------------------------------------------------------------------

        
CRestartTimer::~CRestartTimer()
    {
        Cancel();
    }
//---------------------------------------------------------------------------
//start the timer
//---------------------------------------------------------------------------
void CRestartTimer::Start()
    {
        iStatus=KRequestPending;
        if( !IsActive() )
            {
                SetActive();
                TRequestStatus* temp=&iStatus;
                User::RequestComplete(temp,KErrNone);
            }
         
        }
// ---------------------------------------------------------------------------
// RunL for the timer
//
// ---------------------------------------------------------------------------

        
 void CRestartTimer::RunL()
     {
         iAppUI->RestartPlayerL();  
     }
 // ---------------------------------------------------------------------------
 // Two phase construction
 //
 // ---------------------------------------------------------------------------


 
void CRestartTimer::ConstructL()
    {
    CTimer::ConstructL();    
    }
// ---------------------------------------------------------------------------
// Constructor for the timer
//
// ---------------------------------------------------------------------------

        
CRestartTimer::CRestartTimer(TInt aPriority,CSaFlashAppUi *aAppUI)
:CTimer(aPriority),iAppUI(aAppUI)
    {
        CActiveScheduler::Add(this);
    }
