/*
* Copyright (c) 2006 Nokia Corporation and/or its subsidiary(-ies).
* All rights reserved.
* This software, including documentation is protected by copyright controlled
* by Nokia Corporation. Copying, including reproducing, storing, adapting or
* translating, any or all of this material can only be done in accordance
* with the Nokia Symbian License version 1.0 (or any subsequent update) or
* any other license terms expressly agreed between you and Nokia.
* This material contains Nokia's confidential information which
* may not be disclosed to others without the prior written consent of Nokia.
*
* Initial Contributors:
* Nokia Corporation - initial contribution.
*
* Contributors:
*
* Description:  Implements the member functions of the class which implements the
*				 main hostengine functionality.
*
*/

#include "platformbuild.h"		// Warning: this *must* the first include of every source file.
								//			It contains all the #define build parameters.
#include "platformclib.h"
#include "platformdebug.h"
#include "saplayer_build.h"
#include "version.h"
#include "reent.h"
#include <flashliteplugin.rsg>
//TODO::Remove this check while releasing. It is used to compile the same code on PF5250 SDK.
#ifdef __OPENVGHEADERS_USE_VG_1_1
    #include <es_enum_partner.h> 
#endif

#include <f32file.h>
#include <AknQueryDialog.h>
#include <apgcli.h>
#include <sacls.h> // for RSystemAgent::GetState()
#include <hal.h>
#include <apgtask.h>
#include <charconv.h>
#include <bafindf.h>
#include <miutset.h>
//#include <mmsconst.h>
#include <smut.h>
#include <bautils.h>
#include <es_enum.h>
#include <pathinfo.h>
#include <sysutil.h>
#include <commdb.h>
#include <bitdev.h>
#include <featmgr.h>
#include <bldvariant.hrh>
#include <etelmm.h>
#include <httperr.h>
#include <AknUtils.h>
#include <flogger.h>
#include <string.h> // for using stncmp, string compare
#include <flash2engine.rsg>
//Toget keyboard layout
#include <AvkonInternalCRKeys.h>
#include <PtiDefs.h>
#include <pathinfo.h>
#include <driveinfo.h>
#include <utf.h>

#if defined(FEATURE_OPENVG) && defined(USE_VPU2)
#include <alf/alfcompositionclient.h>
#endif

#include "symbian_engine.h"
#include "symbian_plugin_interface.h"
#include "flashliteinterfaces.h"
#include "symbian_stringutils.h"
#include "saflash_consts.h"
#include "symbian_http.h"
#include "symbian_file.h"
#include "symbian_videoobject.h"
#include "symbian_videoengine.h"
#include "symbian_phonemonitor.h"
#include "symbian_phonecall.h"
#include "symbian_sound.h"
#include "symbian_image.h"
#include "symbian_ui_interface.h"
#include "async_event.h"
#include "engine_data_caging_literals.hrh"
#include "symbian_localhttp.h"
#include "item_val_pair_list.h"
#include "symbian_socket.h"
#include "amp_textnavigation.h"
#include "NPNFlashDefs.h"
#include "symbian_mediarecognizer.h"
#include "platformconfig.h"
#include "symbian_platforminfo.h"
#include "flplatformdecoderinterface.h"

#include "flashengineresourcehandler.h"
#include "mp3streamstateobserver.h"
#include "amp_returnstring.h"
#include "flashrtpolicyclient.h"

#include "mamcextensioncallback.h"

#ifdef SELF_IAD_UPDATE
#include "symbian_updatecheck.h"
#endif


#ifdef FEATURE_VIDEO_DLL
#include "flash_video_codec.h"
#endif
#define PLAYER_MAJOR_VERSION  MAJOR_VERSION

#ifdef FEATURE_BINDING_PREINSTALLED_LIB
	#include "flashrtbindingaslibraryswf.cpp"
#endif
#ifdef FEATURE_EXTENSION
#include "asextensiondelegate.h"
#include <ecom/ecom.h>
#include <ecom/implementationinformation.h>
#include <escapeutils.h>
#include "sharedmemorymanager.h"
_LIT(KASCmdResumePlayer,"ResumePlayer");
const TUid KASExtInterfaceUid = {0x2001E5C7}; 
_LIT(KDisableAutoRoataion, "DisableAutoRotation");
_LIT(KExpediteConnection, "ExpediteConnection"); 
_LIT16(KJPEGMimeType,"image/jpeg");
    const TInt KASErrNotSupported = -308;
#endif //FEATURE_EXTENSION
#include "ipconn_mgr.h"

//#define BLOCK_ADOBE_DISPLAY

// CONSTANTS
const TUint32   KRAMFreeCheckMark        		= 5*1024*1024;
const TInt      KDefaultNameLength       		= 5;
//const TInt      KMaxVideoFramesToProcess 		= 4;
const short 	KPendingUpdateFlag		 		= (short)8;
const TInt 		KFrameIntervalDefault 	 		= 20;	// 20ms
const TUint8 	KAsciiOffset 		     		= 10;
const TInt 		KMaxSymbianPhoneNumberLength 	= 256;
const TInt 		KDefaultFontSize 				= 18;
const TInt 		KMaxInt 						= 32768;
const TInt 		KPortNumLength 					= 5;
const TInt 		KHttpDefaultPort 				= 80;
const TInt 		KMaxNumberOfRequests 			= 1;
//This timer is used to pause the plugin after all mp3 streams are closed
const TInt KMp3StreamTimer =60*1000*1000;//15 seconds
//Time interval at which the backlight is extended
const TInt	KBacklightExtensionTime = 2*1000*1000;
const TUint KMaxVolumeFromFL     = 100;

#ifndef USE_VPU2
const TInt      KMaxVideoPositioToBlt           = 2*1000*1000;  // 2 seconds.
#endif

_LIT8(KSWFFileFirstFewBytes, 	"FWS"); // uncompressed SWF
_LIT8(KSWCFileFirstFewBytes, 	"CWS"); // compressed SWF
_LIT (KLitAllocFailure,			"AllocFailure");
_LIT8(KColonChar, 				":");
_LIT(KFlhExtraChar, 			"?");
_LIT(KFlhFileExtensionSWF, 		"swf");
_LIT(KFlhFileExtensionSVG, 		"svg");

_LIT(KAllowFullscreen, "allowfullscreen");

_LIT(KCanHandleException, "canHandleException");
_LIT(KLitPvt,"c:\\private\\");
_LIT(KTermiChar,"\r\n");

_LIT(KSLeft,"L");
_LIT(KSRight,"R");
_LIT(KSTop,"T");
_LIT(KSBottom,"B");

_LIT(KAllowNetworking, "allownetworking");
_LIT(KAllowNetInternal, "internal");
_LIT(KAllowNetAll,"all");
_LIT(KAllowNetNone, "none");
_LIT(KAllowNetMax,"max");

_LIT(KFlashId,"id"); // This has to be added into NPNFlashDef.h eventually.

#ifdef FEATURE_OPENVG

    //#define EGL_SINGLE_BUFFERING  //When pixmap surface is used, it should always be single buffering

    const EGLint KWinSurfaceAttribList[] =
    {
    #ifdef EGL_SINGLE_BUFFERING
            EGL_RENDER_BUFFER, EGL_SINGLE_BUFFER,
    #endif
            EGL_VG_COLORSPACE, EGL_VG_COLORSPACE_sRGB,
            EGL_VG_ALPHA_FORMAT, EGL_VG_ALPHA_FORMAT_PRE,
            EGL_NONE 
     };    

    const TUint KMaxSupportedFrameDimension = 2048;
    
    #include <VG/openvg.h>
    #include <VG/vgu.h>
#endif // FEATURE_OPENVG


#ifdef NP_DEBUG
const TUint KMaxLogLength   = 512;

#include <flogger.h>

void NPPDebug(TUint8 aLogLevel,TBool aIsPlugin, TRefByValue<const TDesC> aText, ... )
    {

    if(aLogLevel < CUR_LOG_LEVEL)
    	return;

    VA_LIST args;
    VA_START( args, aText );

    TBuf<KMaxLogLength> buf;
    buf.FormatList( aText, args );

    RFileLogger logger;

    TInt ret=logger.Connect();

    if (ret==KErrNone)
        {
        logger.SetDateAndTime( EFalse,EFalse );
        if(aIsPlugin)
        {
        	logger.CreateLog( _L("FlashLogs"), _L("NPLogFile"), EFileLoggingModeAppend );
        }
        else
        {
        	logger.CreateLog( _L("FlashLogs"), _L("ViewrLogFle"), EFileLoggingModeAppend );
        }

        logger.Write(buf);
        }

    logger.Close();

    VA_END( args );
    }

#else

void NPPDebug(TUint8 /*aLogLevel*/,TBool /*aIsPlugin*/,TRefByValue<const TDesC> /*aText*/, ... )
    {
    }

#endif

#ifdef LOG_MESSAGE
_LIT8(KLitLogSeparator," -- ");
_LIT8(KLitElapsedTime,"Elapsed Time: ");
_LIT8(KLitCrCr,"\n\n");
_LIT8(KLitValSep,"\nVal: ");
#endif // LOG_MESSAGE
//This is dummy function added because extern void FcDebugPanic() is declared in generic_debug.h and definition is present in coreplayer
//If not defined we will get build break for debug builds
void FcDebugPanic()
{
#if 0
#if defined(DEBUG) || defined(_DEBUG)
#ifdef __WINS__
        _asm { int 3h };
#else
        User::Panic(_L("ASSERT"), 0);
#endif // __WINS__
#endif // DEBUG || _DEBUG

#if 0
    // crashing is not a good idea as it is unrecoverable... asserts are not always unrecoverable.
    int *p = 0;
    *p=1;
#endif
#endif
}



static int Parse1Hex(TUint c)
{
    if (c >= '0' && c <= '9')
        return c - '0';
    if (c >= 'a' && c <= 'f')
        return c - 'a' + 10;
    if (c >= 'A' && c <= 'F')
        return c - 'A' + 10;
    return 0;
}

inline int Parse2Hex(const TUint16* c)
{
    return (Parse1Hex(c[0])<<4) + Parse1Hex(c[1]);
}

// this class is private to the CPlatformFlashEngine class, and is therefore implemented here

//static
CPlatformFlashEngine::CQueuedSILaunch* CPlatformFlashEngine::CQueuedSILaunch::NewL(struct MM_Object* aMMObj,
									   TUint16 aArgc,
									   const TDesC** aArgv,
									   TInt16 aIsEmbedded)
{
	CQueuedSILaunch* self=new(ELeave) CQueuedSILaunch(aMMObj,aArgc,aIsEmbedded);
	CleanupStack::PushL(self);
	self->ConstructL(aArgv);
	CleanupStack::Pop(self);
	return self;
}

CPlatformFlashEngine::CQueuedSILaunch::~CQueuedSILaunch()
{
	for(TInt i=0;i<iArgc;i++)
	{
		delete iArgv[i];
	}
	delete [] iArgv;
}


_LIT(KLitCamera,"camera");
_LIT(KLitBrowser,"browser");
_LIT(KLitBrowserExecutable,"browserng.exe");
void CPlatformFlashEngine::CQueuedSILaunch::ConstructL(const TDesC** aArgv)
{
	iArgv=new(ELeave) HBufC*[iArgc];

	for(TInt i=0;i<iArgc;i++)
	{
		iArgv[i]=aArgv[i]->AllocL();
	}

	// do some fundamental checks to make sure there is a good chance we will be able to launch the app...
	if( iArgc>0)
	{
		 if( 0 == iArgv[0]->Compare(KLitCamera) || 0==iArgv[0]->Compare(KLitBrowser))
		 {
			 return; // we are OK
		 }
		 else // just have an app by path - better make sure it exists
		 {
		 	// const TParsePtrC ptrC(*iArgv[0]);
			//if(BaflUtils::FolderExists(((FI_Interface*)ipMMObj->pHostObj)->GetEngine()->GetRFs(),ptrC.DriveAndPath()))
				 return; // OK
		 }

	}
	User::Leave(KErrNotSupported); // cannot launch the app requested
}

CPlatformFlashEngine::CQueuedSILaunch::CQueuedSILaunch(struct MM_Object* aMMObj, TUint16 aArgc, TInt16 aIsEmbedded)
:ipMMObj(aMMObj), iArgc(aArgc), iIsEmbedded(aIsEmbedded)
{}

void CPlatformFlashEngine::CQueuedSILaunch::LaunchL()
{
	CPlatformFlashEngine* pEngine = ipMMObj->pHostObj->iFIInterface->GetEngine();

	if(!iArgc)
		return;

	// we already have a legacy way to run the browser - so use that
	// iSource 14029: Workaround to support entering name of browser executable "BrowserNG.exe"
	// to launch the browser with a URL as argument.
	if(0==iArgv[0]->CompareF(KLitBrowser) || (0 == KLitBrowserExecutable().CompareF(*iArgv[0])))
	{
		if(iArgc>1)
		{
			pEngine->HandleBrowserURLL(*(iArgv[1]));
			return;
		}
        pEngine->HandleBrowserURLL(KNullDesC);
		return;
	}


	else
    {
        TInt maxLen = 0;
		const TDesC* argsDes=&KNullDesC;
        HBufC* args = 0;
        if(iArgc > 1)
        {
            TInt i;
            for(i=1; i<iArgc; i++)
            {
                maxLen += iArgv[i]->Length() + 1;
            }

            args = HBufC::NewLC(maxLen);
            TPtr16 argsPtr(args->Des());
            for(i=1; i<iArgc; i++)
            {
                argsPtr.Append(*iArgv[i]);
                if(i != iArgc-1)
                {
                    argsPtr.Append(KLitSpace);
                }
            }
			argsDes=args;
        }

		if (0 ==iArgv[0]->Compare(KLitCamera))
		{
			TInt resoffset = FlashEngineRscHandler::LoadEngineResourceFileL();
			HBufC* cameraAppPath=pEngine->GetEikonEnv()->AllocReadResourceLC(R_FLASH_CAMERA_APP_PATH);
			pEngine->LaunchAppL(*cameraAppPath,*argsDes);
			CleanupStack::PopAndDestroy(cameraAppPath);
			FlashEngineRscHandler::DeleteEngineResourceFile(CEikonEnv::Static(), resoffset);
		}
		else
		{
			pEngine->LaunchAppL(*iArgv[0], *argsDes);
		}

		// For Flash Lite 1.1 compatibility, we must also support launching
        // any application by its path.

        if(args)
        {
            CleanupStack::PopAndDestroy(args);
        }
    }

	return; // success
}

// class CPlatformFlashEngine


extern "C" void allocFailureHandler( void* /*data*/ )
{
	User::Panic(KLitAllocFailure, 1);
}



void FpeExceptionHandler(TExcType)
{
	return;
}


EXPORT_C MFlashEngine* CreateNewFlashEngineL()
{
	CPlatformFlashEngine* eng = new(ELeave) CPlatformFlashEngine();
	return (MFlashEngine*)eng;
}

LOCAL_C short GetSoftkeyLocationFromOS()
{
	short flashLoc = KSoftKeyLocationBottom; // bottom is default

	AknLayoutUtils::TAknCbaLocation loc=AknLayoutUtils::CbaLocation();
	if(loc==AknLayoutUtils::EAknCbaLocationBottom)
	{
		flashLoc = KSoftKeyLocationBottom; // bottom
	}
	else if(loc==AknLayoutUtils::EAknCbaLocationRight)
	{
		flashLoc = KSoftKeyLocationRight; // right
	}
	else if(loc==AknLayoutUtils::EAknCbaLocationLeft)
	{
		flashLoc = KSoftKeyLocationLeft; // left
	}
	else
	{
		flashLoc = KSoftKeyLocationTop; // top
	}

	return flashLoc;
}

CPlatformFlashEngine::CPlatformFlashEngine()
	: iEnv(CEikonEnv::Static())
	, iFs(iEnv->FsSession())
	, iLaunchQueue(_FOFF(CQueuedSILaunch,iLink))
	, iBrowserUid(KNullUid)
	, iNotifyEndOfMovie (ETrue)
	, iSwfSrcPath(NULL,0)
	, iControlPresent(EFalse)
	, iFLVStatus(ENetStreamNull)
	,iMP3StreamCount(0)
	,iTrustStore(NULL)
	, iItemValuePairArrays(NULL)
	, iAsyncIPDlgArray(NULL)
#ifdef FEATURE_INLINE_TEXT_ENTRY
	, iTextNavigation( NULL )
#endif //FEATURE_INLINE_TEXT_ENTRY
	, iUtcReferenceTime(TDateTime(1970, EJanuary, 0, 00,00,00,000000))
	, iFitVideoToScreen(EFalse)
	, iIsVideoContent(EFalse)
	, iWindowMode(EWindow)
	, iFontMapTable(NULL)
	, iAllowFullscreen(ETrue)
	, iAllowNetworking(kAllowNetworkingAll)
{
	User::SetExceptionHandler(FpeExceptionHandler, KExceptionFpe);

	iMMObject = NULL;

	// Bitmap
	iBitmap = NULL;
	iBitmapGc = NULL;
	iBitmapDevice = NULL;
	iIsBitmapLocked = EFalse;
	iWindowGc = NULL;
	
#ifdef FEATURE_OPENVG
    iAuxTextBitmap = NULL;
    iAuxTextBitmapGc = NULL;
    iAuxTextBitmapDevice = NULL;
    iIsAuxTextBitmapLocked = NULL;
#endif
    
    iDefaultFontBitmapDevice = NULL;

	iDefaultFont = NULL;
	iCurrentFontId = 0;
	iLoop = KDefaultLoop;
    iReplayFlag = EFalse;

	iTimer     = NULL;
    iMp3Timer  = NULL;
    iIAPTimer  = NULL;
    iBacklightExtensionTimer = NULL;

	iIsRunning = EFalse;
	//iMustExit = EFalse;
	iPauseFlags = ENotPaused;
	iForeground = ETrue;
	iPassOnException = EFalse;
 	iVideoRect.iRect.SetSize(TSize(0,0));

	iPlayerStaticHeap = NULL;
	iPlayerDynamicHeapAlloced = 0;

	iIsLastTypefaceValid = EFalse;

	iPlayerState = EPlayerOK;
	iRedraw = EFalse;

	iBaseURL = NULL;
	iHTMLBaseURL = NULL;
	iEngineSecurityContextUrl = NULL;
	iAllowScriptAccess = 2; //"Samedomain" by default
	iNewFile = NULL;
	iDownloading = EFalse;

	iSvgMode = EFalse;
	iFrameInterval = KFrameIntervalDefault; // default to 20ms.
	iVibrationHandler = NULL;
	iDelay=0;
#ifdef FEATURE_PACK_3
	iPlatformInfo = NULL;
    iRegistrationStatus = NULL;
    iSubscriberInfo = NULL;
    iNetworkInfo = NULL;
    iPhoneInfo = NULL;
    iBatteryInfo = NULL;
    iSignalInfo = NULL;
    iChargingInfo = NULL;
#endif // FEATURE_PACK_3

	iPhoneMonitor = NULL;
	iSoundHandler = NULL;
	// Async event variables
	iGetInputTextRequest = NULL;
	iIMEControlState = EIMENotInitialized; // state 0 for IME control
	iChangeScreenSizeRequest = EChangeScreenNull;
	iChangeKeysRequest = EChangeScreenNull;
	iSoftkeyArray = NULL;
	iSoftkeyArraySize = 0;

	iIsInitialized = EFalse;
	iCharacterConverter = NULL;
	iNetBufArray.Reset();
	iFileEngine = NULL;
	iHttpEngine = NULL;
	iIPConnMgr = NULL;
	iLocalHttpEngine = NULL;
	iVideoEngine = NULL;
#ifdef FEATURE_XML_SOCKET
	iSocketEngine = NULL;
#endif //FEATURE_XML_SOCKET
	iImageConverter = NULL;

	//iFlashUI = NULL;
	//iControl = NULL;
	//iBrowserPluginActive = EFalse;

	iDynamicMemBlocks = NULL;

	// set backlight extension time to the current time.
	//	iBacklightExtensionTime.UniversalTime();

	iZoomFactor = 0;
	iPanMode = EFalse;

    
    //iMachineUid = 0;
	//iDeviceName = NULL;
	//iPlatformName = NULL;
	iResourceOffset = 0;

	iFileUtils=NULL;
	iAsyncEventHandler = NULL;
#ifndef USE_SYNC_MSO
	iShObjEngine=NULL;
#else
	iSharedObjHandler = NULL;
#endif  //USE_SYNC_MSO
	
	iQuality = FI_QualityMedium;
	iSoftkeyLocation=GetSoftkeyLocationFromOS();
	iIsStopped = EFalse;

#ifdef FEATURE_OPENVG
	iEGLDisplay = NULL;
	iEGLSurface.surface = NULL;
	iEGLContext = NULL;
	iEGLInitialized = EFalse;
	iCurrentIMIndicatorBounds.SetRect(0,0,0,0);
	iCurrentTextInputMode = -1; 
	iIMIndicatorBmp = NULL;
	iIMIndicatorBmpGc = NULL;
	iIMIndicatorBmpDevice = NULL;    
	iInputModeIndicatorImage = VG_INVALID_HANDLE;   
	iRenderToggleTimer = NULL;
	iEGLMaxSupportedWidth = 0;
	iEGLMaxSupportedHeight = 0;
#endif 

#if defined(FEATURE_OPENVG) && defined(USE_VPU2)
    iCompositionControl = NULL;
#endif
    
#ifdef FEATURE_WATCH_GPU_MEM
    iGPUMemLow = EFalse;
#endif    

	iFLVPlayStat = EFalse;
#ifdef FEATURE_ATS_AUTOMATION
	iATSHandler = NULL;
#endif
	#ifdef FEATURE_PERFORMANCE_AUTOMATION
	iPerfTestMode = EFalse;
	#endif
	iFrameBufferResized = EFalse;
	iInDoPlay = EFalse;
    iMp3PlayStateObserver =NULL;

	iContentOverVideo = EFalse;
	iNetworkPromptPausedCount = 0;
	//Set to default mode.Currently we have requirement to recognise widget mode
	//iInteractionMode = EDefaultMode;

	iFullScreenViaFSCommand = EFalse;
    iSwfHasVideo = 0;
    iSwfHasAudio = 0;
	
	iRequestedScreenChange=EFalse;
	iSwfPath = NULL;
	iFrameBufferSize = TSize(0,0);

#ifdef FORCE_REFRESH_WORKAROUND
	iForceRedrawTimer = NULL;
	iForceRedraw = EFalse;
#endif
	
#ifdef DUMP_DIRTY_RECTS
	iSurfaceData = NULL;
	iBitmapToBeDumped = NULL;
#endif
	
	iSwfStarted = EFalse;

#ifdef  FEATURE_COLLECT_BITMAP
	iLastRenderedBitmap = NULL;
    iIgnoreDrawBitBuffer = EFalse;
#endif
}

//Removed as this function is not used anywhere
/*void CPlatformFlashEngine::SetTempPathAndName()
{

   	//Returns the Uid of Application.
	TUid Identi = User::Identity();

	_LIT(KOpenNetFileName,"net.swf");
	//uidName consists of Uid name of application. For Ex. [101fd693]
	TUidName uidName = Identi.Name();
	//Deleting '[' from the Uid name.
	uidName.Delete(0,1);
	//Deleting ']' from the Uid name.
	uidName.Delete(uidName.Length()-1,1);
	iTempOpenNetFileName.Copy(KPersistentSubdirName);
	iTempOpenNetFileName.Append(uidName);
	iTempOpenNetFileName.Append(KDoubleSlash);
	iTempOpenNetFileName.Append(KOpenNetFileName);
}*/
FlashEngineConfig CPlatformFlashEngine::GetConfig()
{
	 return iConfig;
}
void CPlatformFlashEngine::ConstructL(FlashEngineConfig& aConfig,
            MFlashClientIf* aClientInterface,
            EEngineExecutionMode aExecutionMode,
            EBrPluginExecutionMode aBrPluginMode 
            )
    {    
    iFlashClientIf = aClientInterface;
    iExecutionMode = aExecutionMode;
    iBrPluginMode = aBrPluginMode;
#ifdef FEATURE_WINDOWLESS    
    iWindowMode = iFlashClientIf->GetWMode();
#endif //FEATURE_WINDOWLESS    
    
//    if( (iExecutionMode==eWidget) || (iExecutionMode==eBrowserPlugin) )
  //      iBrowserPluginActive = ETrue;
    
    iConfig.iHelixFlvMode = EFalse;

#ifdef FEATURE_OPENVG
    iHwConfig.hardwareQuality = FI_HardwareQuality_Default;
    iHwConfig.configFlags = FI_HardwareConfig_UseAuxTextBufferForHWRendering;
#ifndef  EGL_SINGLE_BUFFERING 
    iHwConfig.configFlags |= FI_HardwareConfig_HardwareSurfaceIsDoubleBuffered;
#endif  
    
    iOpenVgMode     = ETrue;
    iRenderToBitmap = EFalse;
	iSwitchingToSWRenderingInPrgress = EFalse;    
    if(iWindowMode != EWindow)
    {
        iOpenVgMode = EFalse;
        iRenderToBitmap = ETrue;
    }
    
#else
    iOpenVgMode = EFalse;
    iRenderToBitmap = ETrue;    
#endif    
#ifdef FEATURE_MANAGER_CHECK
    // Check if Vibration is allowed for this device
    FeatureManager::InitializeLibL();
    iVibraFeatureSupportedByDevice = FeatureManager::FeatureSupported( KFeatureIdVibra );
    iVibraFeatureSupportedByCenRep = iConfig.iMode & KCenRepVibraFeatureSupport;//IF vibration bit is ON then value will be Non-Zero
    //Once CenRep is working need to remove this statement
    iVibraFeatureSupportedByCenRep = ETrue;
    iVibraFeatureSupported = iVibraFeatureSupportedByDevice & iVibraFeatureSupportedByCenRep;

    // In WebVideo Ph2, helix flv decoders will be used. So let us check for this feature
    //Once KFeatureIdWebvideoPh2 flag is included, please uncomment the Feature manager call.
    //aConfig.iHelixFlvMode = FeatureManager::FeatureSupported( KFeatureIdWebvideoPh2 );

    aConfig.iHelixFlvMode = ETrue;

    FeatureManager::UnInitializeLib();
#endif // FEATURE_MANAGER_CHECK

#ifdef LOG_MESSAGE
    // Create the log file
    iLogFile = new RFile;

    if (iLogFile)
    {
        int err = iLogFile->Open(iFs, KFlashLogFile, EFileWrite | EFileShareExclusive);

        if (err != KErrNone)
        {

            err = iLogFile->Create(iFs, KFlashLogFile, EFileWrite | EFileShareExclusive);

            if (err != KErrNone)
            {
                delete iLogFile;
                iLogFile = NULL;
            }
        }
        if (iLogFile)
        {
            TInt endOfFile = 0;
            iLogFile->Seek(ESeekEnd, endOfFile);
        }
    }
#endif  // LOG_MESSAGE

    iSoftkeyArraySize = aConfig.iSoftkeyCount;

    if( iSoftkeyArraySize )
        iSoftkeyArray = new(ELeave) HBufC*[iSoftkeyArraySize];

    TInt i;
    for(i=0; i<iSoftkeyArraySize; i++)
    {
        iSoftkeyArray[i] = NULL;
    }

    //iFlashUI = NULL;
    iConfig = aConfig;
    iPlayerStaticHeapSize = aConfig.iStaticHeapSize;
    iPlayerDynamicHeapMaxSize = aConfig.iDynamicHeapMaxSize;

    iPlatformConfig = new (ELeave) CPlatformConfig;

    // Initialize SI_FI_Interface by loading library
	#if defined(FEATURE_PERFORMANCE_AUTOMATION) || defined(FEATURE_TESTAUTOMATION)//this flag can be used for both widget as well as performance automation
	_LIT8(KWritoLocalFileDllName, "WriteToLocalFile");
	_LIT8(KCommaSeperator,",");

	if((iConfig.iMode & KPerformanceTestMode))  
	{
    	iConfig.iMode = (iConfig.iMode | KSupportMMI); // Enable support for MMI for the Automation mode so that WriteTolocalfile MMI extension can be loaded 
    	TInt lLengthListofPredefinedExtension = 0;
    	if(iConfig.iExtensions)
        	lLengthListofPredefinedExtension = iConfig.iExtensions->Length();
    
    	TInt lLengthListofAutomationExtensions = lLengthListofPredefinedExtension + KWritoLocalFileDllName().Length() + KCommaSeperator().Length()+ 1; 
    	HBufC8* lAutomationExtensions = HBufC8::NewLC(lLengthListofAutomationExtensions);
    	TPtr8 lPtr(NULL,0);
    	lPtr.Set(lAutomationExtensions->Des());
    	if(iConfig.iExtensions)
    	{
        	lPtr.Copy(*(iConfig.iExtensions));//only add this is extension to be loaded  if already present
        	lPtr.Append(KCommaSeperator); //only add this is extension to be loaded  if already present
        	lPtr.Append(KWritoLocalFileDllName);
    	}
    	else
    	{
        	lPtr.Copy(KWritoLocalFileDllName);
    	}       
    
    	iConfig.iSMCheckNeeded = EFalse; // Disable SMcheck as there is only WriteToLocal Extension needed for Logging.
    	iFiObject.InitializeL(iConfig.iMode, lAutomationExtensions, *iEnv, iConfig.iSMCheckNeeded); 
    
    	//delete this pointer       
    	CleanupStack::PopAndDestroy(lAutomationExtensions);
	}
	else
	{
	    iFiObject.InitializeL(iConfig.iMode, iConfig.iExtensions, *iEnv, iConfig.iSMCheckNeeded);
	}
	#else
	iFiObject.InitializeL(iConfig.iMode, iConfig.iExtensions, *iEnv, iConfig.iSMCheckNeeded);
	#endif
    /*
    if (iConfig.iMode & KSupportNetwork)
    {
        //Moved to CPlatformFlashEngine::GetHttpEngine() 
        //iHttpEngine = CHttpEngine::NewL(this);

        //Moved to CPlatformFlashEngine::GetLocalHttpEngine()
        //iLocalHttpEngine = CLocalHttpEngine::NewL();

        //Moved to CPlatformFlashEngine::GetSocketEngine()
#ifdef FEATURE_XML_SOCKET
        //iSocketEngine = CFlashSocketEngine::NewL(*this);
#endif//FEATURE_XML_SOCKET
    }
    */

    //Moved to CPlatformFlashEngine::GetFileEngine()
    /*
    if (iConfig.iMode & KSupportLocalFile)
    {
        iFileEngine = CFileEngine::NewL();
    }    
    */

    //Moved to CPlatformFlashEngine::GetVideoEngine()
    /*if (iConfig.iMode & KSupportVideo)
    {
        iVideoEngine = CVideoEngine::NewL(*this, iFs);
    }*/
    
    //Moved to CPlatformFlashEngine::GetImageConverter()
    //iImageConverter = CImageConverter::NewL(*this);

#ifdef FEATURE_PACK_3

    //Moved to CPlatformFlashEngine::GetPlatformInfo()
    /*if(!iPlatformInfo)
        {
            iPlatformInfo = CPlatformInfo::NewL(this);
        }*/

    if(!NoETelSuppport()) //no etel info fetch required then dont create
    { 

        if(!iPhoneInfo)
        {
            iPhoneInfo = CPhoneInfo::NewL();
        }
        
        //if(iFlashUI)
        if(eStandAlone==iExecutionMode)
        {
            //let us not create for plug-in now, we will do it when AS queries.

            //Moved to CPlatformFlashEngine::GetNetworkInfoL()
            /*if(!iNetworkInfo)
            {
                iNetworkInfo = CNetworkInfo::NewL();
            }*/

            /*
            //Moved to CPlatformFlashEngine::GetSubscriberInfoL()
            if(!iSubscriberInfo)
            {
                iSubscriberInfo = CSubscriberInfo::NewL();
            }
            */
            //Moved to CPlatformFlashEngine::GetRegistrationStatusL
            /*if(!iRegistrationStatus)
            {
                iRegistrationStatus = CRegistrationStatus::NewL();
            }*/

            /*
            if(!iBatteryInfo)
            {
                iBatteryInfo = CPhoneBatteryInfo::NewL();
            }

            if(!iSignalInfo)
            {
                iSignalInfo = CPhoneSignalInfo::NewL();
            }

            if(!iChargingInfo)
            {
                iChargingInfo = CPhoneChargingInfo::NewL();
            }
            */
        }
    }

#endif // FEATURE_PACK_3

    //Needed to create phone monitor during startup?
    if(!NoIncomingCallMonitor())
    {
        iPhoneMonitor = new(ELeave) CPhoneMonitor();
        if(iPhoneMonitor)
            iPhoneMonitor->ConstructL(this);
    }

    if (iConfig.iMode & KSupportSound)
    {
        iSoundHandler = new(ELeave) CSoundHandler();
    }

    //TODO : Refine this with system lib call
	iFrameBufferDisplayFormat = (FI_DisplayFormat)iFiObject.FI_GetDisplayFormat(GetMMObject());
	ASSERT(iFrameBufferDisplayFormat == FI_DisplayFormat_ARGB8888_32);
    ASSERT(TDisplayModeUtils::NumDisplayModeBitsPerPixel(iEnv->ScreenDevice()->DisplayMode()) == 32);
	iDisplayFormat = iEnv->ScreenDevice()->DisplayMode();

    CreateCharacterConverterL();

    iAsyncEventHandler = CFlhAsyncEvent::NewL(this);

    iLaunchQueueHandler=CFlhAsyncObject::NewL(CActive::EPriorityHigh,*this); // run before absolutely anything else...
    iFileUtils = CFlhFileUtils::NewL(iFs);
	

//	LoadResourceFileL();

    // Make it low priority, otherwise high frame-rate movies will prevent sound from starting.
    iTimer = CFlhTimerObject::NewL(CActive::EPriorityStandard,*this);
    iLowestPriorityActiveObj = CFlhAsyncObject::NewL(CActive::EPriorityLow,*this);
    //iLowestPriorityActiveObj = CFlhAsyncObject::NewL(KMinTInt32,*this);

    iAsyncIPDlgArray        = new (ELeave) CArrayPtrSeg<CFlhAsyncIPSelectDlg>(1);
    iItemValuePairArrays    = new (ELeave) CArrayPtrSeg<CFlhItemValuePairList>(1);


    iBkLightHandler = CBackLightHandler::NewL();
    iSwfInDestruction = EFalse;

#ifdef FEATURE_WEB_BROWSABILITY
    if(eStandAlone!=iExecutionMode)
    {
        //we dont support scripting in viewer mode
        iHostScriptHandler = CHostScriptHandler::NewL(this);
    }
#endif //FEATURE_WEB_BROWSABILITY

    iFlvDecoder = NULL;
#ifdef FEATURE_ATS_AUTOMATION
    if(iConfig.iMode & KPlayerInATSMode)
    {
        iATSHandler = CATSHandler::NewL(this);
        iPerfTestMode = ETrue; //network connection for both performance and ats automation is same. so make a common runtime flag true.
    }
#endif
  //check the engine mode  bit for performanceTest Mode
#ifdef FEATURE_PERFORMANCE_AUTOMATION
  if(aConfig.iMode & KPerformanceTestMode)
  {
    iPerfTestMode = ETrue;
  }
  #endif
#ifdef FEATURE_TESTAUTOMATION
  if(aConfig.iMode & KPlayerInATSMode)
  {
    iPerfTestMode = ETrue;
  }
  #endif
#ifdef DUMP_DIRTY_RECTS
  iDirtyRectLengthsFile.Replace(iFs,_L("C:\\data\\others\\dirtyrectLengths.txt"),EFileWrite);
  iDirtyRectNum=0;
#endif

// HostEngineGlobals
  iHostEngineGlobals = CHostEngineGlobals::CreateHostEngineGlobalsL();
  iHostEngineGlobals->PlatformFlashEngine(this);

#ifdef SELF_IAD_UPDATE
	  MIadUpdateCallback* iadClient = aClientInterface->GetIADUpdateCallback();
	  if(iadClient)
		  HandleIADCheck( iadClient, aConfig );
#endif

#ifdef FEATURE_WATCH_GPU_MEM    
    TRAP_IGNORE(
        iGPUMemWatch = CGPUMemWatch::NewL(this);
        if(iGPUMemWatch)
            iGPUMemWatch->WatchL();
    );
#endif
    
#ifdef FEATURE_OPENVG
    TRAP_IGNORE(CCoeEnv::Static()->AddForegroundObserverL(*this));
#endif

  NPPDebug( LOG_ALL, IsBrowserPluginActive(), _L("Engine::ConstructL()--"));

    }
/*
void CPlatformFlashEngine::ConstructL(MFlashUI* aFlashUI, FlashEngineConfig& aConfig
#ifdef SELF_IAD_UPDATE
, MIadUpdateCallback* aIADUpdateCompleteCallback
#endif
        )
{
    NPPDebug( LOG_ALL, IsBrowserPluginActive(), _L("Engine::ConstructL()++"));
    NPPDebug( LOG_ALL, IsBrowserPluginActive(), _L("FlashLite 3.1 Engine"));
	iConfig.iHelixFlvMode = EFalse;

#ifdef FEATURE_MANAGER_CHECK
	// Check if Vibration is allowed for this device
    FeatureManager::InitializeLibL();
    iVibraFeatureSupportedByDevice = FeatureManager::FeatureSupported( KFeatureIdVibra );
    iVibraFeatureSupportedByCenRep = iConfig.iMode & KCenRepVibraFeatureSupport;//IF vibration bit is ON then value will be Non-Zero
	//Once CenRep is working need to remove this statement
	iVibraFeatureSupportedByCenRep = ETrue;
    iVibraFeatureSupported = iVibraFeatureSupportedByDevice & iVibraFeatureSupportedByCenRep;

	// In WebVideo Ph2, helix flv decoders will be used. So let us check for this feature
	//Once KFeatureIdWebvideoPh2 flag is included, please uncomment the Feature manager call.
	//aConfig.iHelixFlvMode = FeatureManager::FeatureSupported( KFeatureIdWebvideoPh2 );

	aConfig.iHelixFlvMode = ETrue;

    FeatureManager::UnInitializeLib();
#endif // FEATURE_MANAGER_CHECK

#ifdef LOG_MESSAGE
	// Create the log file
	iLogFile = new RFile;

	if (iLogFile)
	{
		int err = iLogFile->Open(iFs, KFlashLogFile, EFileWrite | EFileShareExclusive);

		if (err != KErrNone)
		{

			err = iLogFile->Create(iFs, KFlashLogFile, EFileWrite | EFileShareExclusive);

			if (err != KErrNone)
			{
				delete iLogFile;
				iLogFile = NULL;
			}
		}
		if (iLogFile)
		{
			TInt endOfFile = 0;
			iLogFile->Seek(ESeekEnd, endOfFile);
		}
	}
#endif	// LOG_MESSAGE

    iSoftkeyArraySize = aConfig.iSoftkeyCount;

    if( iSoftkeyArraySize )
        iSoftkeyArray = new(ELeave) HBufC*[iSoftkeyArraySize];

    TInt i;
    for(i=0; i<iSoftkeyArraySize; i++)
    {
        iSoftkeyArray[i] = NULL;
    }

	iFlashUI = aFlashUI;
	iConfig = aConfig;
	iPlayerStaticHeapSize = aConfig.iStaticHeapSize;
	iPlayerDynamicHeapMaxSize = aConfig.iDynamicHeapMaxSize;

	iPlatformConfig = new (ELeave) CPlatformConfig;

	// Initialize SI_FI_Interface by loading library

	iFiObject.InitializeL(iConfig.iMode, iConfig.iExtensions, *iEnv, iConfig.iSMCheckNeeded);

	if (iConfig.iMode & KSupportNetwork)
	{
		iHttpEngine = CHttpEngine::NewL(this);

		iLocalHttpEngine = CLocalHttpEngine::NewL();

#ifdef FEATURE_XML_SOCKET
		iSocketEngine = CFlashSocketEngine::NewL(*this);
#endif//FEATURE_XML_SOCKET
	}

	if (iConfig.iMode & KSupportLocalFile)
	{
		iFileEngine = CFileEngine::NewL();
	}

	if (iConfig.iMode & KSupportVideo)
	{
		iVideoEngine = CVideoEngine::NewL(*this, iFs);
	}

	iImageConverter = CImageConverter::NewL(*this);

#ifdef FEATURE_PACK_3

	if(!iPlatformInfo)
	    {
	    	iPlatformInfo = CPlatformInfo::NewL(this);
	    }

	if(!NoETelSuppport()) //no etel info fetch required then dont create
	{ //optimaization for performance
		if(!iPhoneInfo)
		{
		   	iPhoneInfo = CPhoneInfo::NewL();
		}

		if(iFlashUI)
		{
			//let us not create for plug-in now, we will do it when AS queries.

			if(!iNetworkInfo)
			{
				iNetworkInfo = CNetworkInfo::NewL();
			}

			if(!iSubscriberInfo)
			{
				iSubscriberInfo = CSubscriberInfo::NewL();
			}

			if(!iRegistrationStatus)
			{
				iRegistrationStatus = CRegistrationStatus::NewL();
			}

		    if(!iBatteryInfo)
			{
		    	iBatteryInfo = CPhoneBatteryInfo::NewL();
			}

			if(!iSignalInfo)
			{
		    	iSignalInfo = CPhoneSignalInfo::NewL();
			}

			if(!iChargingInfo)
			{
		    	iChargingInfo = CPhoneChargingInfo::NewL();
			}
		}
	}

#endif // FEATURE_PACK_3

	if(!NoIncomingCallMonitor())
	{
		iPhoneMonitor = new(ELeave) CPhoneMonitor();
		if(iPhoneMonitor)
			iPhoneMonitor->ConstructL(this);
	}

	if (iConfig.iMode & KSupportSound)
	{
		iSoundHandler = new(ELeave) CSoundHandler();
	}

	TUint16 df = iFiObject.FI_GetDisplayFormat(GetMMObject());
	switch (df)
	{

		case FI_DisplayFormat_RGB666_24:
		iDisplayMode = EColor16M;
		break;

		case FI_DisplayFormat_RGB666_32:
		iDisplayMode = EColor16MU;
		break;

		case FI_DisplayFormat_ARGB8888_32:
		{
			iDisplayMode = EColor16MA; //EColor16MU;
			break;
		}
        default:
        case FI_DisplayFormat_RGB565_16:
		iDisplayMode = EColor64K;
		break;
	}


	CreateCharacterConverterL();

	iAsyncEventHandler = CFlhAsyncEvent::NewL(this);

	iLaunchQueueHandler=CFlhAsyncObject::NewL(CActive::EPriorityHigh,*this); // run before absolutely anything else...
    iFileUtils = CFlhFileUtils::NewL(iFs);
	if(aConfig.iMode & KSupportSharedObject)
	{
		TFileName pdir;

		CreateFilenameEnsurePath(iFs,pdir,EFalse);
		iShObjEngine = CFlhShObjEngine::NewL(iFs, *iFileUtils, pdir);
	}

//	LoadResourceFileL();

	// Make it low priority, otherwise high frame-rate movies will prevent sound from starting.
	iTimer = CFlhTimerObject::NewL(CActive::EPriorityStandard,*this);
	iLowestPriorityActiveObj = CFlhAsyncObject::NewL(KMinTInt32,*this);

	iAsyncIPDlgArray 		= new (ELeave) CArrayPtrSeg<CFlhAsyncIPSelectDlg>(1);
	iItemValuePairArrays	= new (ELeave) CArrayPtrSeg<CFlhItemValuePairList>(1);


	iBkLightHandler = CBackLightHandler::NewL();

#ifdef FEATURE_WEB_BROWSABILITY
	if(!iFlashUI)
	{
		//we dont support scripting in viewer mode
		iHostScriptHandler = CHostScriptHandler::NewL(this);
	}
#endif //FEATURE_WEB_BROWSABILITY

    iFlvDecoder = NULL;
#ifdef FEATURE_ATS_AUTOMATION
	if(iConfig.iMode & KPlayerInATSMode)
	{
		iATSHandler = CATSHandler::NewL();
		iPerfTestMode = ETrue; //network connection for both performance and ats automation is same. so make a common runtime flag true.
	}
#endif
  //check the engine mode  bit for performanceTest Mode
#ifdef FEATURE_PERFORMANCE_AUTOMATION
  if(aConfig.iMode & KPerformanceTestMode)
  {
	iPerfTestMode = ETrue;
  }
  #endif
#ifdef DUMP_DIRTY_RECTS
  iDirtyRectLengthsFile.Replace(iFs,_L("C:\\data\\others\\dirtyrectLengths.txt"),EFileWrite);
  iDirtyRectNum=0;
#endif

// HostEngineGlobals
  iHostEngineGlobals = CHostEngineGlobals::CreateHostEngineGlobalsL();

#ifdef SELF_IAD_UPDATE
    HandleIADCheck( aIADUpdateCompleteCallback, aConfig );
#endif

  NPPDebug( LOG_ALL, IsBrowserPluginActive(), _L("Engine::ConstructL()--"));

}
*/

TBool CPlatformFlashEngine::IsHelixFlvMode()
{
	return iConfig.iHelixFlvMode;
}
//This function returns True is mp3stream in progress
TBool CPlatformFlashEngine::IsMp3Stream()
{
    if(iMP3StreamCount)
        return ETrue;
    else
        return EFalse;
}
//This function is used to change the mp3playstate of plugin and keep count of number of streams
//Mp3Streaming
void CPlatformFlashEngine::NewMP3StreamStarted()
{
    if (!iMP3StreamCount)
    {
    	if(!iMp3PlayStateObserver)
    	{
			if(iFlashClientIf)
				iMp3PlayStateObserver = iFlashClientIf->GetMp3StateObserver();
    	}
        if (iMp3PlayStateObserver)
        {

            TRAP_IGNORE(iMp3PlayStateObserver->MP3PlayStateChangedL(EFlashMP3StreamInProgress));
            if (iMp3Timer)//if timer is construsted cancel it
            {    
                iMp3Timer->Cancel();
            }
        }
    }
    SetSwfHasAudio(ETrue);
    iMP3StreamCount ++;
}
//This function is used to change the mp3playstate of plugin and keep count of number of streams
//Mp3Streaming
void CPlatformFlashEngine::MP3StreamClosedL()
{
    iMP3StreamCount--;
    SetSwfHasAudio(EFalse);
    if (!iMP3StreamCount)
    {
        if (iMp3PlayStateObserver)
        {
            iMp3PlayStateObserver->MP3PlayStateChangedL(EFlashMP3StreamClosed);
            if (!iMp3Timer)
            {
                iMp3Timer = CFlhTimerObject::NewL(CActive::EPriorityStandard,
                        *this);
            }
            else
            {
                if(iMp3Timer->IsActive())
                {
                    iMp3Timer->Cancel();
                }
            }
            iMp3Timer->After(KMp3StreamTimer);
        }
    }
}

void CPlatformFlashEngine::CreateFilenameEnsurePath(RFs& aFs, TDes& aFileLocation, TBool /*aTemp*/)
{
	aFileLocation.SetLength(0);

	aFileLocation.Copy(KPersistentSubdirName);
	// now get the UID for the process we are running in so we can figure the data caged location
	TUid uid(User::Identity());

	//uidName consists of Uid name of application. For Ex. [101fd693]
	TPtrC uidName(uid.Name().Mid(1,8));

	aFileLocation.Append(uidName);

	aFileLocation.Append(KPathDelimiter);

	// if the tree is not present, make it
	if (!BaflUtils::FolderExists(aFs, aFileLocation))
	{
		aFs.MkDirAll(aFileLocation);
	}
}


HBufC* CreateBaseUrlFromFilenameL(const TDesC& aFilename)
{
	HBufC* tFile = aFilename.AllocLC();

	TInt len = aFilename.Length();
	TUint16* s = (TUint16*)tFile->Ptr();
	// convert to lower case because there is no case insensitive Find().
	for (TInt i=0;i<len;i++)
	{
		if ((*s >= 'A') && (*s <= 'Z'))
		{
			*s = (TUint16)(*s - 'A' + 'a');
		}
		s++;
	}

	HBufC* base = HBufC::NewL(len+KUrlProtocolFileLength);
	TPtr16 d = base->Des();
	d.Append(KLitUrlProtocolFile);
	d.Append(aFilename);

	CleanupStack::PopAndDestroy(tFile);

	return base;
}

void CPlatformFlashEngine::Destroy()
{
	/*RC ou1cimx1#635995 -> Fix for panic due to memory leak.
    fmod() funcion from "estlib.dll " leaks memory for "NAN" and "INFINITY" parameters.
    CloseSTDLIB() safely releases all the meory references of estdlib and hence avoid memory leak */
    
    CloseSTDLIB();
	delete this;
}

CPlatformFlashEngine::~CPlatformFlashEngine()
{
#ifdef FEATURE_OPENVG
    CCoeEnv::Static()->RemoveForegroundObserver(*this);
#endif    
	
#ifdef DUMP_DIRTY_RECTS
    iDirtyRectLengthsFile.Close();
#endif

#if defined(FEATURE_OPENVG) && defined(USE_VPU2)
    delete iCompositionControl;
    iCompositionControl = NULL;    
#endif

#ifdef FEATURE_INLINE_TEXT_ENTRY
	delete iTextNavigation;
	iTextNavigation = NULL;
#endif

	delete iTimer;
	delete iLowestPriorityActiveObj;
    if(iMp3Timer)
    {
        if(iMp3Timer->IsActive())
        {
            iMp3Timer->Cancel();
        }
        delete iMp3Timer;
    }
    if(iIAPTimer)
    {
        iIAPTimer->Cancel();
        delete iIAPTimer;
        iIAPTimer = NULL;
    }

    if(iBacklightExtensionTimer)
    {
        delete iBacklightExtensionTimer;
		iBacklightExtensionTimer = NULL;
    }
    
    if(iFontMapTable)
    {
    	delete iFontMapTable;
    	iFontMapTable = NULL;
    }
    
    FreeBits();
    
    if (iTrustStore)
    {
        delete iTrustStore;
        iTrustStore = NULL;
    }

	if(iBkLightHandler)
	{
		delete iBkLightHandler;
		iBkLightHandler = NULL;
	}

	if (iVideoEngine)
		{
		iVideoEngine->DeleteAllVideoObjects();
		}

    if(iSoundHandler)
    {
        iSoundHandler->StopSound();
        iSoundHandler->CleanupCachedFiles(iFs);
    }

	if (iPlayerStaticHeap)
	{
		User::Free(iPlayerStaticHeap);
	}

    for(int i=0; i<iSoftkeyArraySize; i++)
    {
        delete iSoftkeyArray[i];
    }
    delete iSoftkeyArray;

#ifdef FEATURE_PACK_3

	if(iPlatformInfo)
	    {
	    	delete iPlatformInfo;
	    	iPlatformInfo = NULL;
	    }

	if(iRegistrationStatus)
	{
		delete iRegistrationStatus;
		iRegistrationStatus = NULL;
	}

    if(iSubscriberInfo)
	{
    	delete iSubscriberInfo;
    	iSubscriberInfo = NULL;
	}

	if(iNetworkInfo)
	{
    	delete iNetworkInfo;
    	iNetworkInfo = NULL;
	}

	if(iPhoneInfo)
	{
    	delete iPhoneInfo;
    	iPhoneInfo = NULL;
	}

	if(iBatteryInfo)
    {
    	delete iBatteryInfo;
    	iBatteryInfo = NULL;
    }

    if(iSignalInfo)
    {
    	delete iSignalInfo;
    	iSignalInfo = NULL;
    }

    if(iChargingInfo)
    {
    	delete iChargingInfo;
    	iChargingInfo = NULL;
    }

#endif // FEATURE_PACK_3

	if(iPhoneMonitor)
	{
		delete iPhoneMonitor;
		iPhoneMonitor = NULL;
	}

	if(iSoundHandler)
	{
		delete iSoundHandler;
		iSoundHandler = NULL;
	}

	if(iFileEngine)
	{
		delete iFileEngine;
		iFileEngine = NULL;
	}

	if(iIPConnMgr)
		{
		delete iIPConnMgr;
		iIPConnMgr = NULL;
		}
	delete iHttpEngine;
	delete iLocalHttpEngine;
	delete iVideoEngine;

#ifdef FEATURE_XML_SOCKET
	delete iSocketEngine;
#endif //FEATURE_XML_SOCKET

	delete iImageConverter;
	delete iBaseURL;
	if(iHTMLBaseURL)
		{
		delete iHTMLBaseURL;
		iHTMLBaseURL = NULL;
		}
    if (iEngineSecurityContextUrl)
        {
        delete iEngineSecurityContextUrl;
        iEngineSecurityContextUrl = NULL;
        }
#ifdef LOG_MESSAGE
	if (iLogFile)
	{
		iLogFile->Flush();
		iLogFile->Close();

		delete iLogFile;
		iLogFile = NULL;
	}
#endif

	delete iCharacterConverter;

	CQueuedSILaunch* siLaunch;

	// flush the launch queue
	while(!(iLaunchQueue.IsEmpty()))
	{
		siLaunch=iLaunchQueue.First();
		iLaunchQueue.Remove(*siLaunch);
		delete siLaunch;
	}
	delete iLaunchQueueHandler;
#ifndef USE_SYNC_MSO
	delete iShObjEngine;
#else
	if(iSharedObjHandler)
	    delete iSharedObjHandler;
#endif	//USE_SYNC_MSO
	
	delete iFileUtils; // must be deleted after iShObjEngine

	delete iAsyncEventHandler;

	//delete iDeviceName;

	/*if(iPlatformName)
	{
		delete iPlatformName;
		iPlatformName = NULL;
	}*/


/*	if (iResourceOffset)
	{
		iEnv->DeleteResourceFile(iResourceOffset);
	}
*/
	if(iAsyncIPDlgArray)
	{
		iAsyncIPDlgArray->Reset();
		delete iAsyncIPDlgArray;
	}

	if(iItemValuePairArrays)
	{
		iItemValuePairArrays->ResetAndDestroy();
		delete iItemValuePairArrays;
	}

	DestroyStreamBuffers();//Changed as Part of HIIN-857FWY

	if(iFlashVarVal)
	{
		delete iFlashVarVal;
	}

	if(iPlatformConfig)
	{
	  	delete iPlatformConfig;
	    iPlatformConfig = NULL;
	}
#ifdef FEATURE_WEB_BROWSABILITY

	delete iHostScriptHandler;
	iHostScriptHandler = NULL;

	delete iName;
	iName= NULL;

#endif //FEATURE_WEB_BROWSABILITY

#ifdef FEATURE_ATS_AUTOMATION
	if(iATSHandler)
		{
			delete iATSHandler;
			iATSHandler = NULL;
		}
#endif

    if( iFlvDecoderArray.Count() )
    {
        iFlvDecoderArray.ResetAndDestroy();
    }

    iFlvDecoderArray.Close();
#ifdef FEATURE_AMCEXTENSIONS
    iExtensionCallback.Close();
#endif

    
    //Not used..
    /*
#ifdef SELF_IAD_UPDATE
    DestroyIADComponents();
#endif
*/

    if(iSwfPath)
    {
        delete iSwfPath;
        iSwfPath = NULL;
    }

#ifdef FEATURE_OPENVG
    FreeInputIndicatorBits();
    
    DestroyEgl();
    
    delete iRenderToggleTimer;
    iRenderToggleTimer = NULL;    
#endif

    /* delete iHostEngineGlobals; */
    //RC:ou1cimx1#513829 ,DestroyHostEngineGlobals has to be called after DestroyEgl() as this iHostEngineGlobals is used in DestroyEgl

    iHostEngineGlobals->DestroyHostEngineGlobals();

#ifdef FEATURE_WATCH_GPU_MEM
    delete iGPUMemWatch;
    iGPUMemWatch = NULL;    
#endif
    
    iRenderingWindow = NULL;

    if(iSharedMemMgr)
	{
        delete iSharedMemMgr;
		iSharedMemMgr = NULL;
	 }
    
#ifdef FORCE_REFRESH_WORKAROUND    
    if(iForceRedrawTimer)
    {
        delete iForceRedrawTimer;
        iForceRedrawTimer = NULL;
    }
#endif

#ifdef  FEATURE_COLLECT_BITMAP
    if(iLastRenderedBitmap)
    {
        delete iLastRenderedBitmap;
        iLastRenderedBitmap = NULL;
    }
#endif
}


// Get information about this device -- device UID, name and platform
/*void CPlatformFlashEngine::InitializePlatformInfoL()
{

	TInt i;

	// First, find our device UID.
	HAL::Get(HALData::EMachineUid, iMachineUid);

	LoadResourceFileL();
	TResourceReader reader;
    iEnv->CreateResourceReaderLC( reader, R_FLASH_DEVICE_DATA );

	// get the size of the array
	TInt number = reader.ReadInt16();

	for (i=0;i<number;i++)
	{
		TInt uid = reader.ReadInt32();
		HBufC* platform = reader.ReadHBufCL();
		CleanupStack::PushL(platform);
		if (uid == iMachineUid)
		{
			iPlatformName = platform;
			CleanupStack::Pop(platform);
		}
		else
		{
			CleanupStack::PopAndDestroy(platform);
		}
	}

	CleanupStack::PopAndDestroy(); // reader

	if  (!iPlatformName)
	{
		iPlatformName = iEnv->AllocReadResourceL(R_STR_DEFAULT_PLATFORM_NAME);
	}

}*/

void CPlatformFlashEngine::GetPlatformNameL(HBufC*& aPlatformName)
{
    TInt iMachineUid(0);
    
	// First, find our device UID.
	HAL::Get(HALData::EMachineUid, iMachineUid);

	int resoffset = FlashEngineRscHandler::LoadEngineResourceFileL();
	TResourceReader reader;
    iEnv->CreateResourceReaderLC( reader, R_FLASH_DEVICE_DATA );

	// get the size of the array
	TInt number = reader.ReadInt16();
	TInt i;
	for (i=0;i<number;i++)
	{
		TInt uid = reader.ReadInt32();
		HBufC* platform = reader.ReadHBufCL();
		CleanupStack::PushL(platform);
		if (uid == iMachineUid)
		{
			aPlatformName = platform;
			CleanupStack::Pop(platform);
		}
		else
		{
			CleanupStack::PopAndDestroy(platform);
		}
	}

	CleanupStack::PopAndDestroy(); // reader

	if  (!aPlatformName)
	{
		aPlatformName = iEnv->AllocReadResourceL(R_STR_DEFAULT_PLATFORM_NAME);
	}

	FlashEngineRscHandler::DeleteEngineResourceFile(iEnv, resoffset);
}

/*void CPlatformFlashEngine::LoadResourceFileL()
{
	TFileName dllName;
	TFileName rscfn;
 	Dll::FileName(dllName);
  	TBuf<2> drive = dllName.Left(2);
	rscfn.Copy(drive); // get the drive letter
	rscfn.Append(KFlash2EngineResourceFile);

	BaflUtils::NearestLanguageFile(iFs, rscfn);

	TBool fileExists( BaflUtils::FileExists(iFs, rscfn) );
	if ( fileExists )
	{
	    iResourceOffset = iEnv->AddResourceFileL(rscfn);
	}
	else
	{
		User::Leave(KErrNotFound);
	}

	if (iResourceOffset < 0)
	{
		User::Leave(iResourceOffset);
	}

}*/


TInt16 CPlatformFlashEngine::GetDeviceName(TUint8* aCharBuffer, const TInt /*aMaxLen*/)
{
    //CPhoneInfo* phoneInfo = GetPhoneInfo();
	if(iPhoneInfo)
	{
		CreateFlashString((char*)aCharBuffer,iPhoneInfo->GetDeviceName());

		return 1;
	}

	return -1;
}

TInt16 CPlatformFlashEngine::GetDeviceID(TUint8* aCharBuffer, const TInt /*aMaxLen*/)
{
    CPhoneInfo* phoneInfo = GetPhoneInfo();

	if(phoneInfo)
	{
		CreateFlashString((char*)aCharBuffer,phoneInfo->GetDeviceID());

		return 1;
	}

	return -1;
}

TUint CPlatformFlashEngine::GetBatteryLevelL()
{
	/*if(!iBatteryInfo)
	{ //ok ,object not created , delayed creation will be done now
		if(!NoETelSuppport())
		{ //let us create object now
			iBatteryInfo = CPhoneBatteryInfo::NewL();
		}
	}*/

	CPhoneBatteryInfo* batteryInfo = GetBatteryInfoL();
	
	if(batteryInfo)
	{
		return batteryInfo->GetBatteryChargeLevel();
	}

	return 0;
}

TUint CPlatformFlashEngine::GetCallerInfoL(FI_ReturnString* aName,FI_ReturnString* aNumber)
{
	CPhoneMonitor* phoneMonitor = GetPhoneMonitorL();
	
	if(phoneMonitor)
		{
		TUint retValue = phoneMonitor->GetCallerInfoL(aName,aNumber);
		return retValue;
		}
	return 4;//Default Value Indicating No Call is in Progress
}

TBool CPlatformFlashEngine::GetBatterychargeStatusL()
{
	/*if(!iChargingInfo)
	{ //ok ,object not created , delayed creation will be done now
		if(!NoETelSuppport())
		{ //let us create object now
			iChargingInfo = CPhoneChargingInfo::NewL();
		}
	}*/

    CPhoneChargingInfo* chargingInfo = GetPhoneChargingInfoL();;

	if(chargingInfo)
	{
		return chargingInfo->GetDeviceChargingInfo();
	}

	return EFalse;
}


TInt CPlatformFlashEngine::GetSignalStrengthL()
{
	/*if(!iSignalInfo)
	{ //ok ,object not created , delayed creation will be done now
		if(!NoETelSuppport())
		{ //let us create object now
			iSignalInfo = CPhoneSignalInfo::NewL();
		}
	}*/

    CPhoneSignalInfo* signalInfo = GetPhoneSignalInfoL();
	if(signalInfo)
	{
		return signalInfo->GetSignalBarValue();
	}

	return 0;
}


TInt16 CPlatformFlashEngine::GetPlatformName(TUint8* aCharBuffer, const TInt aMaxLen)
{
	TPtr8 ptrBuffer(aCharBuffer, aMaxLen);
//	if (iCharacterConverter->ConvertFromUnicode(ptrBuffer, *iPlatformName) < 0)

	CPlatformInfo* platformInfo = GetPlatformInfo();
	
	if (platformInfo)
        {
            TRAP_IGNORE(platformInfo->GetOSInfoL());//create plat info
        if (iCharacterConverter->ConvertFromUnicode(ptrBuffer,
                platformInfo->GetOSInfo()) < 0)

            {
            return 0;
            }
        }
	ptrBuffer.ZeroTerminate();
	return 1;
}

void CPlatformFlashEngine::SetForeground(TBool aForeground)
{
    if(aForeground)
     {
       iRedraw = ETrue;
     }
    iForeground = aForeground;
}

#ifdef FEATURE_SUPPORT_ALR_SNAP
TBool CPlatformFlashEngine::ConnectionPromptNeeded()
{
	//if (/*iControl == NULL ||*/ iFlashUI != NULL) //show the prompt ONLY in viewer mode
    if(eStandAlone==iExecutionMode) //show the prompt ONLY in viewer mode
	{
		return ETrue;
	}
	else
	{
		return EFalse;
	}
}
#endif

void CPlatformFlashEngine::InitializeL(const TRect& aRect, TBool aResize, TBool aLandscape)
{
    DEBUGPRINT("CPlatformFlashEngine::InitializeL: aRect(%d %d %d %d) aResize: %d", aRect.iTl.iX,
            aRect.iTl.iY, aRect.iBr.iX, aRect.iBr.iY, aResize);
#ifdef FEATURE_OPENVG
    /* In case of viewer we are always within the limits, hence checking is not required.
     * This is called from PlayerView ConstructL, hence RWindow can not be obtained in ChooseEglConfigL
     */
    if (eStandAlone != iExecutionMode)
    {
        /* Initializing EGL ahead to know the max supported EGL width & heigth */
        if (iOpenVgMode && !iEGLInitialized)
        {
            InitializeEglL();
        }        
        
        /* EGL does not support frame size more than 2048.  Even in SW rendering mode
         * Graphics layer internally uses EGL for blitting bitmap.  Currently we do not have 
         * any mechanism to propagate error from Graphics/ALF module, hence checking for max 
         * frame size & returning with KErrNoMemory. For this same reason this code is kept common
         */
        if (aRect.Width() > iEGLMaxSupportedWidth || aRect.Height() > iEGLMaxSupportedHeight)
        {
            DEBUGPRINT("CPlatformFlashEngine::InitializeL: aRect.Width: %d  aRect.Height: %d  returning KErrNoMemory",
                    aRect.Width(),aRect.Height());
            User::Leave(KErrNoMemory);
        }
    }
#endif
    
	if(iInDoPlay)
	{
		iFrameBufferResized = ETrue;
		iInitInfo.iRect = aRect;
		iInitInfo.iResize = aResize;
		iInitInfo.iLandscape = aLandscape;
		return;
	}
	
	iLandscapeScreen = aLandscape;
	iIsInitialized   = EFalse;

	if (iPlayerStaticHeap == NULL)
	{
		iPlayerStaticHeap = (TAny*)User::AllocL(iPlayerStaticHeapSize);
		User::LeaveIfNull(iPlayerStaticHeap);
	}

	iRect.xmin = 0;
	iRect.ymin = 0;
	iRect.xmax = aRect.Width();
	iRect.ymax = aRect.Height();

	iFrameBufferSize = aRect.Size();
	
	if (aResize && iWindowMode == EWindow)
	{
	    TRAPD(errd,ResizeBitmapsL(iFrameBufferSize));
		
		if(errd != KErrNone)
		{
            StopPlaying();
            User::Leave(errd);
		}

#ifdef FEATURE_OPENVG
		if(iOpenVgMode)
		{
            TSize currentWindowSize = GetWindow()->Size();
            if(iCurrentWindowSize != currentWindowSize)
            {
                TRAPD(err, RecreateSurfaceL(GetWindow()));
                if(err != KErrNone)
                {
                    SwitchToSoftwareRendering();
                }
            }
		}
#endif   
        
        iRedraw = ETrue;

		if( !iFlvDecoderArray.Count() && !iVideoRect.iRect.IsEmpty() && iVideoEngine && iVideoRect.iVideoType == EDeviceVideo )
		{
			iVideoEngine->NotifySizeChangedL();
		}
		else if( iFlvDecoderArray.Count() )
		{
			// Resizing the display rect
			SetScreenMode();
		}
	}
	else
	{
        if (iWindowMode == EWindow)
        {
	    	RecreateBitmapsL(iFrameBufferSize);
        }
#ifdef FEATURE_WINDOWLESS        
        else if(iWlessSurface)
        {
            if(iWlessGc)
            {
                delete iWlessGc;
                iWlessGc = NULL;
            }
                
            if(iWlessDevice)
            {
                if (iDefaultFont && iDefaultFontBitmapDevice == iWlessDevice)
                {
                    iWlessDevice->ReleaseFont( iDefaultFont );
                    iDefaultFont = NULL;
                }
                
                if(iFontMapTable)
                    iFontMapTable->ReleaseAllFonts(iWlessDevice);
                
                delete iWlessDevice;
                iWlessDevice = NULL;
            }
            
            iWlessDevice = CFbsBitmapDevice::NewL(iWlessSurface);
        }
#endif        	
	}

	if (iMMObject)
	{
		FI_Rect fiRect;
		fiRect.xmin = (short)iRect.xmin;
		fiRect.ymin = (short)iRect.ymin;
		fiRect.xmax = (short)iRect.xmax;
		fiRect.ymax = (short)iRect.ymax;
        	
        if(iFiObject.FI_SetFrameBuffer( NULL, (TUint16)iFrameBufferSize.iWidth, (TUint16)iFrameBufferSize.iHeight, FrameBufferPitch(), FrameBufferDisplayFormat()) == -1)
		{
            if (iFlashClientIf)
            {
                MUserNotiferIf* userNotifierIf = iFlashClientIf->GetUserNotifierIf();
                if (userNotifierIf)
                    userNotifierIf->NotifyClientError(EInvalidConfigError,
                            ETrue, ETrue);
            }
		}
        
		if(iFiObject.FI_SetDisplayRect(&fiRect) == -1)
		{
            if (iFlashClientIf)
            {
                MUserNotiferIf* userNotifierIf = iFlashClientIf->GetUserNotifierIf();
                if (userNotifierIf)
                    userNotifierIf->NotifyClientError(EInvalidConfigError,
                            ETrue, ETrue);
            }
		}
        
        iFiObject.FI_SetDirtyRect(&fiRect, 1); //dont care return value. 
	}

	iIsInitialized = ETrue;

	StartTimer();
}

/*void CPlatformFlashEngine::InitializeStandaloneL(const TRect& aRect, TBool aResize, TBool aLandscape)
{
	InitializeL(aRect, aResize, aLandscape);
	// do standalone player specific stuff here
}*/
//Not used
/*
 void  CPlatformFlashEngine::AddMp3StateObserver(MMp3StateObserver* aObserver)
    {
        iMp3PlayStateObserver = aObserver;
    }
    */
/*
void CPlatformFlashEngine::InitializePluginL(MFlashPlugin* aControl,
        const TRect& aRect, TBool aResize, TBool aLandscape)
{
	iControl = aControl;
	iBrowserPluginActive = ETrue;
	iFrameBufferResized = EFalse;

	if(!iInDoPlay)
	{
		InitializeL(aRect, aResize, aLandscape);
	}
	else
	{
		iFrameBufferResized = ETrue;
		iInitInfo.iRect = aRect;
		iInitInfo.iResize = aResize;
		iInitInfo.iLandscape = aLandscape;
	}
}*/


TBool CPlatformFlashEngine::FrameBufferBitsValid()
{
	if(iBitmap 
#ifdef FEATURE_WINDOWLESS
		|| iWlessSurface
#endif //FEATURE_WINDOWLESS
	   )
		return ETrue;
	else
		return EFalse;
}

void* CPlatformFlashEngine::LockFrameBufferBits()
{
    ASSERT(iRenderToBitmap);
    
    if (FrameBufferBitsValid())
	{
		if ( !iIsBitmapLocked )
		{
			if(iWindowMode == EWindow)
			{
				iBitmap->BeginDataAccess();
			}
			else
			{
                #ifdef FEATURE_WINDOWLESS
				iWlessSurface->BeginDataAccess();
                #endif		
			}
			iIsBitmapLocked = ETrue;
		}

		if(iWindowMode == EWindow)
		{
            return iBitmap->DataAddress();
		}
		else
		{
            #ifdef FEATURE_WINDOWLESS
			return iWlessSurface->DataAddress();
            #endif
		}
	}

	return NULL;
}

void CPlatformFlashEngine::UnlockFrameBufferBits( TAny* /*aBitmap*/ )
{
    ASSERT(iRenderToBitmap);

	if ( iIsBitmapLocked )
	{
		if(iWindowMode == EWindow) 
		{
			iBitmap->EndDataAccess();
		}
		else 
		{
            #ifdef FEATURE_WINDOWLESS
			iWlessSurface->EndDataAccess();
            #endif
		}

		iIsBitmapLocked = EFalse;
	}
}

void CPlatformFlashEngine::FreeFrameBufferBits()
{
    if(!iRenderToBitmap)
        return;

    UnlockFrameBufferBits();    
    
	if ( iWindowGc )
	{
		iWindowGc->Deactivate();
		delete iWindowGc;
		iWindowGc = NULL;
	}

	if ( iBitmapGc )
	{
		delete iBitmapGc;
		iBitmapGc = NULL;
	}

	if ( iBitmapDevice )
	{
        if (iDefaultFont && iDefaultFontBitmapDevice == iBitmapDevice)
		{
			iBitmapDevice->ReleaseFont( iDefaultFont );
			iDefaultFont = NULL;
		}
        
        if(iFontMapTable)
            iFontMapTable->ReleaseAllFonts(iBitmapDevice);

		delete iBitmapDevice;
		iBitmapDevice = NULL;
	}

	if ( iBitmap )
	{
		iBitmap->Reset();
		delete iBitmap;
		iBitmap = NULL;
	}
}


TBool CPlatformFlashEngine::CreateFrameBufferBitsL(TSize aSize)
{
    if(!iRenderToBitmap)
        return ETrue;
    
    if (FrameBufferBitsValid())
	{
		return ETrue;
	}

	FreeFrameBufferBits();

    iBitmapSize.x = aSize.iWidth;
    iBitmapSize.y = aSize.iHeight;
	
	iIsBitmapLocked = EFalse;

	if ((iBitmap = new CWsBitmap(iEnv->WsSession())) == NULL ||
		(iBitmap->Create(TSize(iBitmapSize.x, iBitmapSize.y), iDisplayFormat) != KErrNone) ||
		(iBitmapDevice = CFbsBitmapDevice::NewL(iBitmap)) == NULL)
	{
		// note: the bitmap will be deallocated automatically by the destructor
		FreeFrameBufferBits();
		return EFalse;
	}
	
	return ETrue;
}

void CPlatformFlashEngine::ClearBitmap()
{
    if(iWindowMode != EWindow)
        return;
    
	CFbsBitGc* pGc = GetBitmapContext();
	if ( !pGc )
	{
		return;
	}

	TRect rect( 0, 0, iBitmapSize.x, iBitmapSize.y );
	TRgb white( 0xFF, 0xFF, 0xFF );
	pGc->SetPenStyle( CFbsBitGc::ESolidPen );
	pGc->SetPenColor( white );
	pGc->SetBrushStyle( CFbsBitGc::ESolidBrush );
	pGc->SetBrushColor( white );
	pGc->DrawRect( rect );
}


void CPlatformFlashEngine::FreeBits()
{
    if(iWindowMode == EWindow)
    {
    	FreeFrameBufferBits();
#ifdef FEATURE_OPENVG
   	    FreeAuxTextBits();
#endif
    }
#ifdef FEATURE_WINDOWLESS
    else
    {
		if(iWlessGc)
		{
			delete iWlessGc;
			iWlessGc = NULL;
		}
		
		if(iWlessDevice)
		{
			if(iDefaultFont && iDefaultFontBitmapDevice == iWlessDevice)
			{
				iWlessDevice->ReleaseFont(iDefaultFont);
				iDefaultFont = NULL;
			}
			
	    	delete iWlessDevice;
	    	iWlessDevice = NULL;
		}
    	
    	iWlessSurface = NULL;
    }
#endif
}

#ifdef FEATURE_OPENVG
TBool CPlatformFlashEngine::CreateAuxTextBitsL(TSize aSize)
{
    if(!iOpenVgMode)
        return EFalse;
    
    ASSERT(iHwConfig.configFlags & FI_HardwareConfig_UseAuxTextBufferForHWRendering);
    
    if (AuxTextBitsValid())
    {
        return ETrue;
    }

    FreeAuxTextBits();

    iAuxTextBitmapSize.x = aSize.iWidth;
    iAuxTextBitmapSize.y = aSize.iHeight;    

    if ((iAuxTextBitmap = new CFbsBitmap()) == NULL || 
        (iAuxTextBitmap->Create(TSize(iAuxTextBitmapSize.x, iAuxTextBitmapSize.y), EColor256 /*iDisplayMode*/) != KErrNone) || 
        (iAuxTextBitmapDevice = CFbsBitmapDevice::NewL(iAuxTextBitmap)) == NULL)
    {
        // note: the bitmap will be deallocated automatically by the destructor
        FreeAuxTextBits();
        return EFalse;
    }

    NPPDebug(LOG_ERROR, EFalse, _L("CreateAuxTextBits %d"),iAuxTextBitmap->DisplayMode());    
    return ETrue;
}

void CPlatformFlashEngine::FreeAuxTextBits()
{
    if(!iOpenVgMode)
        return;

    ASSERT(iHwConfig.configFlags & FI_HardwareConfig_UseAuxTextBufferForHWRendering);
   
    UnlockAuxTextBits();
    
    if (iAuxTextBitmapGc)
    {
        delete iAuxTextBitmapGc;
        iAuxTextBitmapGc = NULL;
    }

    if (iAuxTextBitmapDevice)
    {
        if (iDefaultFont && iDefaultFontBitmapDevice == iAuxTextBitmapDevice)
        {
            iAuxTextBitmapDevice->ReleaseFont(iDefaultFont);
            iDefaultFont = NULL;
        }
        
        if(iFontMapTable)
            iFontMapTable->ReleaseAllFonts(iAuxTextBitmapDevice);

        delete iAuxTextBitmapDevice;
        iAuxTextBitmapDevice = NULL;
    }

    if (iAuxTextBitmap)
    {
        iAuxTextBitmap->Reset();
        delete iAuxTextBitmap;
        iAuxTextBitmap = NULL;
    }
}

TBool CPlatformFlashEngine::AuxTextBitsValid()
{
    return iAuxTextBitmap != NULL;
}

void* CPlatformFlashEngine::LockAuxTextBits(unsigned int* width, unsigned int* height, unsigned int* pitch, unsigned int* depth)
{
    ASSERT(iHwConfig.configFlags & FI_HardwareConfig_UseAuxTextBufferForHWRendering);
    
    if (AuxTextBitsValid())
    {
        if (!iIsAuxTextBitmapLocked)
        {
            iAuxTextBitmap->BeginDataAccess();
            iIsAuxTextBitmapLocked = ETrue;
        }

        *width = iAuxTextBitmapSize.x;
        *height = iAuxTextBitmapSize.y;
        *pitch =  iAuxTextBitmap->DataStride(); 
        *depth = TDisplayModeUtils::NumDisplayModeBitsPerPixel(iAuxTextBitmap->DisplayMode());
        return iAuxTextBitmap->DataAddress();
    }

    return NULL;
}

void CPlatformFlashEngine::UnlockAuxTextBits(TAny* /*aBitmap*/)
{
    ASSERT(iHwConfig.configFlags & FI_HardwareConfig_UseAuxTextBufferForHWRendering);
    
    if (iIsAuxTextBitmapLocked)
    {
        iAuxTextBitmap->EndDataAccess();
        iIsAuxTextBitmapLocked = EFalse;
    }
}
#endif


void CPlatformFlashEngine::UpdateFrameInterval(TUint32 aNewFrameInterval)
{
	if (iFrameInterval != aNewFrameInterval)
	{
		iFrameInterval = aNewFrameInterval;
		if(iIsRunning)
		{
			StartTimer();
		}
	}
}

void CPlatformFlashEngine::StartTimer()
{
	if (iPlayerState != EPlayerOK || !iTimer )
	{
		return;
	}

	StopTimer();

	CalculateInterval();

	//  Set the initial delay to 1, since we want the initial frame to play immediately
	if( !iTimer->IsActive() )
	{
		iTimer->After(1);
	}
}

void CPlatformFlashEngine::CalculateInterval()
{
	if (! iSvgMode)
	{
		iDelay = iFrameInterval;
		if ( iDelay <= 0 )
		{
			iDelay = 1;
		}
	}
	else
	{
	    iDelay = 10;
	}

	// ** NB : StartTimer takes intervals in milliseconds. EPOC timers run on
	// microseconds. So multiply by 1000 before passing them in.
	iDelay*=KMicrosecondsInMillisecond;
}

void CPlatformFlashEngine::StopTimer()
{
	iTimer->Cancel();
}

#ifdef __FEATURE_OSK__
void CPlatformFlashEngine::SetCompatibilityMode(TBool aOnoROff)
{
    //enable or disable the compatibility mode onscreen keypad
    //iFlashUI->SetOSKIsActive(aOnoROff);
    iFlashClientIf->GetDisplay()->SetOSKIsActive(aOnoROff);
}
#endif // __FEATURE_OSK__

void CPlatformFlashEngine::ChangeScreen(TInt aFormat)
{
    if (!iAllowFullscreen)
    {
        return;
    }
    
	if ( aFormat == EChangeScreenFullScreen || aFormat == EChangeScreenAppScreen )
	{
		iChangeScreenSizeRequest = aFormat;
	}

	TriggerAsyncEvent();
}

void ResetSoftkeysAndScreenL( MDisplay* pScreenIf )
{
    if(pScreenIf)
        {
        pScreenIf->ResetSoftkeysL();
        pScreenIf->SetAppScreenL();
        }
}

void CPlatformFlashEngine::HandleAsyncEventsL()
{
    //if(iFitVideoToScreen && !iBrowserPluginActive && (eStandAlone==iExecutionMode))
    if(iFitVideoToScreen)// && (eStandAlone==iExecutionMode)) //No need to check for !iBrowserPluginActive
                                                           //to find out viewer mode
    {     
        iFitVideoToScreen = EFalse;
        //iFlashUI->ZoomShowAll();
        iFlashClientIf->GetDisplay()->ZoomShowAll();
    }
	
	if (iGetInputTextRequest)
	{	
		if (iFlashClientIf)
		{
		MInputTxtIf* inputTxtIf = iFlashClientIf->GetInputTextIf();
		if (inputTxtIf)
			{
			inputTxtIf->GetInputTextL(*iGetInputTextRequest);
			}
		}
        /*
		if( iFlashUI )
		    {
		    iFlashUI->GetInputText(*iGetInputTextRequest);
		    }
        else
            {
            iControl->GetInputTextL(*iGetInputTextRequest);
            }
		*/
        delete iGetInputTextRequest->iInitialString;
		delete iGetInputTextRequest;
		iGetInputTextRequest = NULL;
	}

	// changing the order.. it was at the bottom initially
    // IME Control
    // We have got an SI_EnableIME call. So lets enable IME
    if (iIMEControlState == EIMEEnable)
    {
        if(iFlashClientIf)
        {
            MInputTxtIf* inputTxtIf = iFlashClientIf->GetInputTextIf();
            if(inputTxtIf)
                inputTxtIf->EnableIMEL();
        }
        
        iIMEControlState = EIMEEnabled; // we have enabled it
        
        /*
        if (iFlashUI && !iBrowserPluginActive)
            {
            iFlashUI->EnableIMEL();
            iIMEControlState = EIMEEnabled; // we have enabled it
            }
        else if (iControl && iBrowserPluginActive)
            {
            iControl->EnableIMEL();
            iIMEControlState = EIMEEnabled; // we have enabled it
            }
            */
    }

    if (iPauseFlags==ENotPaused && iSoundHandler)
    {
	    iSoundHandler->DoSoundL();
    }
    
    if(!iInDoPlay && ((iChangeScreenSizeRequest == EChangeScreenFullScreen) 
					||(iChangeScreenSizeRequest == EChangeScreenAppScreen)))
    {
		if(iFlashClientIf)
		{
			MDisplay* display = iFlashClientIf->GetDisplay();
			if(display)
			{
				if(iChangeScreenSizeRequest == EChangeScreenFullScreen)
				{
					display->SetScreenL(eFullScreen);
				}
				else
				{
					display->SetScreenL(eAppScreen);
				}
				iChangeScreenSizeRequest = EChangeScreenNull;
			}
		}
    }
    else 
    {
    	if(iChangeScreenSizeRequest != EChangeScreenNull)
    		iRequestedScreenChange=ETrue;
    }
    
    if((iChangeKeysRequest == EChangeScreenSetSoftkeys ) || (iChangeKeysRequest == EChangeScreenResetSoftkeys))
	{
    	if(iFlashClientIf)
    	{
    		MDisplay* display = iFlashClientIf->GetDisplay();
    		if(display)
    		{
    			if(iChangeKeysRequest == EChangeScreenSetSoftkeys )
    			{
    				display->SetSoftkeysL(iSoftkeyArray, iSoftkeyArraySize);
    			}
    			else
    			{
    				display->ResetSoftkeysL();
    			}
    			iChangeKeysRequest = EChangeScreenNull;
    		}
    	}
	}
    
	if (iNewFile)
	{
		if ((iPauseFlags==ENotPaused) )
		{
			iAsyncEventHandler->SetLeaveIsCritical(ETrue);
			OpenFileAndStartMovieL(*iNewFile, ETrue, ETrue);
			iAsyncEventHandler->SetLeaveIsCritical(EFalse);
			delete iNewFile;
			iNewFile = NULL;
		}
		//return;
	}

}

void CPlatformFlashEngine::PlatformTimerTick()
{
	//Backlight handling moved to ExtendBacklightForVideoPlayback

	if (iPauseFlags==ENotPaused && (iIsStopped == EFalse))
	{
		PlayStep(EFalse);
	}

}


void CPlatformFlashEngine::DrawVideoRect()
{
	DrawDirtyRegion(iVideoRect.iRect);
}

void CPlatformFlashEngine::Draw(const TRect& aDirtyRect, CWindowGc& aWGc)
{
    if(!iRenderToBitmap) {
	    aWGc.SetDrawMode(CGraphicsContext::EDrawModeWriteAlpha);  
	    aWGc.SetBrushColor(TRgb(0,0,0,0));
	    aWGc.SetBrushStyle(CGraphicsContext::ESolidBrush);
	    aWGc.DrawRect(aDirtyRect);
        return;       
    }

	if (iPlayerState == EPlayerOK && iIsInitialized )
	{
#ifdef FEATURE_VIDEO_OVERLAY_RECTS
            CWsScreenDevice* screenDevice = iEnv->ScreenDevice();

        	if( screenDevice && (screenDevice->DisplayMode() == EColor16MA || screenDevice->DisplayMode() == EColor16MAP)  )
            {
            	aWGc.SetDrawMode(CGraphicsContext::EDrawModeWriteAlpha);
            }

        	// NOTE : There is no overlay on top of Device video.

        	if( !iVideoRect.iRect.IsEmpty() && iVideoRect.iVideoType == EDeviceVideo )
        	{
        		BitBltExcludingVideoRect(aWGc, aDirtyRect);
        	}
			else if( !iVideoRect.iRect.IsEmpty() && iVideoRect.iVideoType == ENativeVideo &&
				screenDevice && screenDevice->DisplayMode() == EColor16MU &&
				iFlvDecoderArray.Count() )
        	{
				TBool playbackComplete = EFalse;
				for(TInt idx=0; idx<iFlvDecoderArray.Count(); idx++)
				{
					if(iFlvDecoderArray[idx]->IsComplete()) {
						playbackComplete = ETrue;
					}
					else {
						playbackComplete = EFalse;
						iContentOverVideo = EFalse;
						break;
					}
				}

				if(!playbackComplete) {
                    //Dont draw anything over video yet. Playback is not done yet.
	        		BitBltExcludingVideoRect(aWGc, aDirtyRect);
				}
				else {
					if(!iContentOverVideo && aDirtyRect.Intersects(iVideoRect.iRect)) {
                        //There is some content on top of video. Since playback is done, we can now draw on top of video area
						iContentOverVideo = ETrue;
					}

					if(iContentOverVideo) {
		        		aWGc.BitBlt(aDirtyRect.iTl, iBitmap, aDirtyRect);
		        		aWGc.BitBlt(iVideoRect.iRect.iTl, iBitmap, iVideoRect.iRect);
					}
					else {
		        		BitBltExcludingVideoRect(aWGc, aDirtyRect);
					}
				}
        	}
        	else
        	{
                if(iWindowMode == EWindow)
                {
                    aWGc.BitBlt(aDirtyRect.iTl, iBitmap, aDirtyRect);
                }
#ifdef FEATURE_WINDOWLESS                
                else
                {
                	GetBitmapContext();
                    if(iWlessGc && iWlessSurface)
                        this->iWlessGc->BitBlt(aDirtyRect.iTl, this->iWlessSurface, aDirtyRect);
                }
#endif //FEATURE_WINDOWLESS

            #ifdef DUMP_DIRTY_RECTS        		
            iBitmapToBeDumped = iBitmap;
            DumpDirtyRects(aDirtyRect);
            #endif
        	}

        #ifdef SHOW_REDRAW_REGIONS
        ShowRedrawRegions(aDirtyRect,aWGc);
        #endif

#else
        aWGc.SetDrawMode(CGraphicsContext::EDrawModePEN);
        BitBltExcludingVideoRect(aWGc, aDirtyRect);
#endif	// FEATURE_VIDEO_OVERLAY_RECTS
	}
	else
	{
		aWGc.Clear();
	}
}

void CPlatformFlashEngine::RefreshScreen()
{
	iRedraw = ETrue;
	HandleRedraw();
}

void CPlatformFlashEngine::DrawBitBuffer()
{
    
#ifdef  FEATURE_COLLECT_BITMAP    
    /* Ignore DrawBitBuffer calls during scrolling, Playstep calls DrawBitBuffer if framerate is lagging than expected
     * But since SWF is paused during scrolling we can ignore these calls.
     * If this call is allowed it will add additional flickers in webpage with multiple flash contents (iltalehti.fi)
     * Reset this flag once scrolling Stops/ SWF play back resumes
     */
    if(iIgnoreDrawBitBuffer)
    {
        return;
    }
#endif

#ifdef FEATURE_OPENVG    
    if(iOpenVgMode)
    {
        vgFlush();
#ifdef DUMP_DIRTY_RECTS        
        if(iSurfaceData && iSurfaceData->SizeInPixels() != iCurrentWindowSize )
        {
            delete iSurfaceData;
            iSurfaceData = NULL;
        }
        if(iSurfaceData == NULL)
        {
            iSurfaceData = new CFbsBitmap();
            iSurfaceData->Create(iCurrentWindowSize,iDisplayFormat);
        }

        MDisplay* disp = GetDisplay();
        TRect rect = disp->GetWindow()->GetDrawRect();
        eglCopyBuffers(iEGLDisplay, (EGLSurface)iEGLSurface.surface, iSurfaceData);
        iBitmapToBeDumped = iSurfaceData;
        DumpDirtyRects(TRect(iCurrentWindowSize));
#endif        
        if( eglSwapBuffers(iEGLDisplay, (EGLSurface)iEGLSurface.surface) == EGL_BAD_ALLOC)
        {
            SwitchToSoftwareRendering();
        }
    }
    else
#endif
    {
        if (iRedraw)
        {
            HandleRedraw();
        }
        else
        {
            /*//We have to either draw only sub-dirty rects, or their union. Not both.
			TInt numberOfDirtyRect = GetNumberOfSubDirtyRects();
    
            for(TInt i=0; i < numberOfDirtyRect; ++i )
            {
                DrawDirtyRegion( GetSubDirtyRect(i) );
            }*/
    
    	    DrawDirtyRegion( GetDirtyRect() );
    
            // Draw the inline text indicator
            // TODO : Check whether this can be moved to Viewer and BP controls.
            // Ideally, this is not the right place to do this stuff.
    
            #ifdef FEATURE_INLINE_TEXT_ENTRY
            if( !(iTIIndicatorDirtyRect.IsEmpty()) )
            {
                DrawDirtyRegion( iTIIndicatorDirtyRect );
            }
            #endif
        }

#ifdef ENABLE_CURSOR
        //if( iBrowserPluginActive )
        if(iExecutionMode == ePlugin)
        {
            HandleCursorDraw();
        }
#endif
    }
}

void CPlatformFlashEngine::HandleRedraw()
{
	if( !iRedraw )
	{
		return;
	}

	TRect trect(0, 0, iFrameBufferSize.iWidth, iFrameBufferSize.iHeight);

    if(iRenderToBitmap)
    {
        DrawDirtyRegion(trect);
    }
#ifdef FEATURE_OPENVG
    else if(iOpenVgMode)
    {
        FI_Rect dirtyRect;
        dirtyRect.xmin = 0;
        dirtyRect.ymin = 0;        
        dirtyRect.xmax = iFrameBufferSize.iWidth;
        dirtyRect.ymax = iFrameBufferSize.iHeight;
        
        iFiObject.FI_SetDirtyRect(&dirtyRect, 1); //dont care return value. 
    }
#endif
    
    UpdateVideoScreen();

	iRedraw = EFalse;
}

TRect CPlatformFlashEngine::GetSubDirtyRect(unsigned int index)
{
	FI_Rect dirtyRect;
	iFiObject.FI_GetSubDirtyRect(index,&dirtyRect);

	TRect trect;

	trect.iTl.iX = dirtyRect.xmin;
	trect.iTl.iY = dirtyRect.ymin;
	trect.iBr.iX = dirtyRect.xmax;
	trect.iBr.iY = dirtyRect.ymax;

	return trect;
}

unsigned short CPlatformFlashEngine::GetNumberOfSubDirtyRects()
{
	return iFiObject.FI_GetNumberOfSubDirtyRects();
}

TRect CPlatformFlashEngine::GetDirtyRect()
{
	FI_Rect dirtyRect;
	iFiObject.FI_GetDirtyRect(&dirtyRect);

	TRect trect;

	trect.iTl.iX = dirtyRect.xmin;
	trect.iTl.iY = dirtyRect.ymin;
	trect.iBr.iX = dirtyRect.xmax;
	trect.iBr.iY = dirtyRect.ymax;

	return trect;
}

void CPlatformFlashEngine::DrawDirtyRegion(const TRect& aRect)
{
    if(iFlashClientIf)
        iFlashClientIf->DrawDirtyRect(aRect);
}
/*
	if( iControl && iBrowserPluginActive )
	{
		#ifdef FEATURE_BG_TRANSPARENCY
		HandleBGTBitBlt(aRect);
		#endif

		iControl->DrawDirtyRect(aRect);
	}
	else if( iFlashUI )
	{
		iFlashUI->DrawDirtyRect(aRect);
	}
*/	
//}

void CPlatformFlashEngine::BitBltExcludingVideoRect(CWindowGc& aWGc, const TRect& aDirtyRect)
{
    ASSERT(iRenderToBitmap);
    
    TRect videoRect = iVideoRect.iRect;
    if (videoRect.IsEmpty() || !videoRect.Intersects(aDirtyRect))
    {
        // if video rect and dirty rect do NOT intersect, just blit as usual
        aWGc.BitBlt(aDirtyRect.iTl, iBitmap, aDirtyRect);
        return;
    }

	// if video rect and dirty rect intersect, divide dirty rect into sections that don't overlap
	// rectA covers the area above the video rect

	if (aDirtyRect.iTl.iY < videoRect.iTl.iY)
	{
		TRect rectA;
		rectA.iTl.iX = aDirtyRect.iTl.iX;
		rectA.iTl.iY = aDirtyRect.iTl.iY;
		rectA.iBr.iX = aDirtyRect.iBr.iX;
		rectA.iBr.iY = videoRect.iTl.iY;

		if (!rectA.IsEmpty())
		{
			aWGc.BitBlt(rectA.iTl, iBitmap, rectA);
		}
	}

	// rectB covers the area to the left of the video rect
	if (aDirtyRect.iTl.iX < videoRect.iTl.iX)
	{
		TRect rectB;
		rectB.iTl.iX = aDirtyRect.iTl.iX;
		rectB.iTl.iY = videoRect.iTl.iY;
		rectB.iBr.iX = videoRect.iTl.iX;
		rectB.iBr.iY = videoRect.iBr.iY;

		if (!rectB.IsEmpty())
		{
			aWGc.BitBlt(rectB.iTl, iBitmap, rectB);
		}
	}

	 // rectC covers the area to the right of the video rect
	if (aDirtyRect.iBr.iX > videoRect.iBr.iX)
	{
		TRect rectC;
		rectC.iTl.iX = videoRect.iBr.iX;
		rectC.iTl.iY = videoRect.iTl.iY;
		rectC.iBr.iX = aDirtyRect.iBr.iX;
		rectC.iBr.iY = videoRect.iBr.iY;

		if (!rectC.IsEmpty())
		{
			aWGc.BitBlt(rectC.iTl, iBitmap, rectC);
		}
	}

	// rectD covers the area below the video rect.
	if (aDirtyRect.iBr.iY > videoRect.iBr.iY)
	{
		TRect rectD;
		rectD.iTl.iX = aDirtyRect.iTl.iX;
		rectD.iTl.iY = videoRect.iBr.iY;
		rectD.iBr.iX = aDirtyRect.iBr.iX;
		rectD.iBr.iY = aDirtyRect.iBr.iY;

		if (!rectD.IsEmpty())
		{
			aWGc.BitBlt(rectD.iTl, iBitmap, rectD);
		}
	}
}


#ifdef ENABLE_CURSOR

MFlashCursor* CPlatformFlashEngine::Cursor()
{
    //if( !iControl )
      //  return NULL;

    //MFlashCursor* cursor = NULL;

    //cursor  = iControl->Cursor();
    
   // return iCursor;
    if(iFlashClientIf)
        return iFlashClientIf->GetCursor();
    
    return NULL;
}

void CPlatformFlashEngine::DrawCursor()
{
    CWindowGc* pGc = GetWindowContext();
	if (!pGc)
	{
		return;
	}

	MFlashCursor* cursor  = Cursor();

	if(!cursor)
	{
	    return;
	}

	TPoint startPoint = cursor->Position();
    TRect  cursorRect = cursor->GetRect();

 /*  Disabling, since sprites are used for cursor.

    DEBUGPRINT("CPlatformFlashEngine::DrawCursor");

    if (iPlayerState == EPlayerOK && iIsInitialized)
	{
        DEBUGPRINT("drawing cursor %d %d %d %d",cursorRect.iTl.iX, cursorRect.iTl.iY, cursorRect.iBr.iX, cursorRect.iBr.iY);
		pGc->BitBlt(startPoint, iBitmap, cursorRect);
	}
	else
	{
		pGc->Clear();
	}
 */
}

void CPlatformFlashEngine::ClearCursor(const TRect& aRect)
{
    // Set the dirty rect and force the render

    struct FI_Rect dirtyRect;

    dirtyRect.xmin = aRect.iTl.iX;
    dirtyRect.xmax = aRect.iBr.iX;
    dirtyRect.ymin = aRect.iTl.iY;
    dirtyRect.ymax = aRect.iBr.iY;

    TInt ret = iFiObject.FI_SetDirtyRect(&dirtyRect, 1);

    iRedraw = EFalse;

    if (IsPaused())
	{
	    FI_Rect fiRect;
		fiRect.xmin = iRect.xmin;
		fiRect.ymin = iRect.ymin;
		fiRect.xmax = iRect.xmax;
		fiRect.ymax = iRect.ymax;

		iFiObject.FI_SetDisplayRect(&fiRect);
	}

    PlayStep(ETrue);
}

void CPlatformFlashEngine::HandleCursorDraw()
{
    MFlashCursor* cursor = Cursor();
    if(cursor)
    {
        TFlashCursorState curState = cursor->State();

        if( curState == EFlashCursorDisplaying )
        {
            cursor->UpdateCursor();
        }
    }
}
#endif


//Not used
/*
void CPlatformFlashEngine::Exit()
{
	iMustExit = ETrue;
}*/

void CPlatformFlashEngine::Stop()
{
   	StopTimer();
   	//Order of call was: Earlier FI_Pause() ->FI_Stop()
   	//                   Now     FI_Stop() ->FI_Pause()
	iFiObject.FI_Stop();
  	iFiObject.FI_Pause();

	iIsRunning  = EFalse;
	iIsStopped  = ETrue;
	iPauseFlags = EReasonUser;

	if( iSoundHandler )
	{
		iSoundHandler->StopSound();
	  	iSoundHandler->CleanupCachedFiles(iFs);
	}

	// Pause the audio- video if those objects are present
	THXVDCmdArg arg;
	EngineDispatchHXCommand(EHXVDCmdPause, arg);
}

void CPlatformFlashEngine::EngineDispatchHXCommand(const THXVideoDecCommand& aCommand,THXVDCmdArg& aArgInfo)
{
    if( !iConfig.iHelixFlvMode )
    {
        return;
    }

    CFLPlatformDecoderInterface* decoderInstance;
    TInt argOriginalVolume = aArgInfo.iVolume;

    for(TInt n=0; n < iFlvDecoderArray.Count(); n++)
    {
        decoderInstance = iFlvDecoderArray[n];

        if( !decoderInstance ) continue;

        if( aCommand == EHXVDCmdSetVolume && aArgInfo.iVolume )
        {
       		TInt max = decoderInstance->MaxVolume();
       		TInt swfvol = decoderInstance->GetSwfVolume();
    		TInt vol = (swfvol * max / KMaxVolumeFromFL)* aArgInfo.iVolume / KMaxUserVolume;
   			aArgInfo.iVolume = vol;
   			DEBUGPRINT("CPlatformFlashEngine::EngineDispatchHXCommand aArgInfo.iVolume[%d]",aArgInfo.iVolume );   			
        }
        if( (aCommand == EHXVDCmdPlay || aCommand == EHXVDCmdPause) && decoderInstance->IsComplete() )
    	{
    		return;
    	}

        decoderInstance->DispatchHXCommand(aCommand, aArgInfo);
        aArgInfo.iVolume = argOriginalVolume;		
    }
}

void CPlatformFlashEngine::PauseForNetworkPrompt()
{
    //if(iFlashUI)
    if(eStandAlone==iExecutionMode)
    {
        // this is valid only in the viewer mode
        if(iIAPTimer == NULL)
        {
            TRAPD(error,iIAPTimer = CFlhTimerObject::NewL(CActive::EPriorityStandard,*this));
            if(error)
                return;
		}
        if(iNetworkPromptPausedCount == 0)
        {
            // This is the first pause.. hence we notify the viewer
            Pause(EReasonNetworkPrompt);
            //iFlashUI->NotifyEngineState(EEnginePaused);
            iFlashClientIf->NotifyEngineState(EEnginePaused);
        }

		if(iIAPTimer->IsActive())
		{
            // restart the timer
            iIAPTimer->Cancel();
		}
		
        iIAPTimer->After(KNetworkPromptTimeOut);
        iNetworkPromptPausedCount++;
    }
}

#ifdef FEATURE_AMCEXTENSIONS
void CPlatformFlashEngine::RegisterExtensionCallback(MAMCEXtensionCallback *aAMCClient)
{
    if (iExtensionCallback.Find(aAMCClient) == KErrNotFound)
        iExtensionCallback.Append(aAMCClient);
}
void CPlatformFlashEngine::DeregisterExtensionCallback(MAMCEXtensionCallback *aAMCClient)
{
    int pos = KErrNotFound;
    if ((pos = iExtensionCallback.Find(aAMCClient)) != KErrNotFound)
        iExtensionCallback.Remove(pos);
}

void CPlatformFlashEngine::NotifyExt(TPlayerState2 aPlayerState)
{
    int index;
    for(index=0; index<iExtensionCallback.Count(); ++index){
        iExtensionCallback[index]->PlayerStateChanged(aPlayerState);
    }
}

TBool CPlatformFlashEngine::AllowAMCExtension()
{
    return iFlashClientIf->AllowAMCExtension();
}

#endif // FEATURE_AMCEXTENSIONS

void CPlatformFlashEngine::Pause(TInt aReason)
{
	if (iPauseFlags==ENotPaused || iFiObject.FI_IsPlaying())
	{
		if (iMMObject)
		{
			iFiObject.FI_Pause();
		}

		// notify MMI that the player is now paused. Reason why is not propagated to MMI plugins at this point
		// so only tell on a new pause happening, and on resume happening - not when the reason changes.
		NotifyExtsOfPauseStateChange(aReason);
#ifdef FEATURE_AMCEXTENSIONS
		NotifyExt(ePlayerPause);
#endif

		// Pause the audio- video if those objects are present
		THXVDCmdArg arg;
    	EngineDispatchHXCommand(EHXVDCmdPause, arg);

		if( iSoundHandler )
		{
			iSoundHandler->PauseSound();
		}

		StopTimer();
    }

	if(!iFiObject.FI_IsPlaying())
	{
		StopTimer();
	}

	iPauseFlags|=aReason;
}


void CPlatformFlashEngine::NotifyExtsOfPauseStateChange(TInt aReason)
{
	CArrayPtr<CFlashExtension>* exts=iFiObject.Extensions();
	if(exts)
		{
		const TInt count=exts->Count();

		for(TInt i=0;i<count;i++)
			{
			(*exts)[i]->NotifyPauseState(aReason);
			}
		}
}

void CPlatformFlashEngine::NotifyExtsOfIncomingCallStateChange(TBool aStatus)
{
	CArrayPtr<CFlashExtension>* exts=iFiObject.Extensions();
	if(exts)
		{
		const TInt count=exts->Count();

		for(TInt i=0;i<count;i++)
			{
			(*exts)[i]->NotifyIncomingCall(aStatus);
			}
		}
}

void CPlatformFlashEngine::ResumeOnNetworkPrompt()
{
    //if(iFlashUI && iNetworkPromptPausedCount > 0 && iIAPTimer)
    if((eStandAlone==iExecutionMode) && iNetworkPromptPausedCount > 0 && iIAPTimer)
    {

        iNetworkPromptPausedCount--;

        if(!iIAPTimer->IsActive())  // this means that we timed out. So, resume.
            iNetworkPromptPausedCount = 0;

        if(iNetworkPromptPausedCount == 0 )
        {
            TRAPD(err, ResumeL(EReasonNetworkPrompt,EFalse));
            if(err != KErrNone )    // for some reason we could not resume
                return;             // do not notify the UI 
            
            //iFlashUI->NotifyEngineState(EEngineResumed);
            iFlashClientIf->NotifyEngineState(EEngineResumed);
            if(iIAPTimer)
            {
                iIAPTimer->Cancel();
            }
        }
    }   
}

void CPlatformFlashEngine::ResumeL(TInt aReason, TBool aIgnoreActiveView)
{

#ifdef FEATURE_COLLECT_BITMAP    
    iIgnoreDrawBitBuffer = EFalse;
#endif

	// because the user resume can unset all the flags, we may not always be paused when resume
	// is called. Check that first, and return if we are already playing.
	if(iPauseFlags==ENotPaused)
	{
		return;
	}

	//if the user instructs resume, ignore any other flags
	if(aReason==EReasonUser || aReason==EReasonFocus)
	{
		iPauseFlags=ENotPaused;
	}
	else
	{
		// unset the appropriate flag
		iPauseFlags&=(~aReason);
	}

	// player view must be active or we must be explicitly told to ignore that...
	//if(!iBrowserPluginActive)
	//{
		//if (iFlashUI && iPauseFlags==ENotPaused && (aIgnoreActiveView || iFlashUI->IsPlayerViewActive()) && !(iIsStopped))
        if ((eStandAlone==iExecutionMode) && iPauseFlags==ENotPaused && (aIgnoreActiveView ) && !(iIsStopped))
		{
			if (iMMObject)
			{
				iFiObject.FI_Resume();
				// notify MMI that the player is now paused. Reason why is not propagated to MMI plugins at this point
				// so only tell on a new pause happening, and on resume happening - not when the reason changes.
				NotifyExtsOfPauseStateChange(ENotPaused);
#ifdef FEATURE_AMCEXTENSIONS
				NotifyExt(ePlayerResume);
#endif
			}

    		if(iSoftkeyLocation&KPendingUpdateFlag)
    		{
    			iSoftkeyLocation=(short)(iSoftkeyLocation&(~KPendingUpdateFlag));
    			NotifyCorePlayerOfSoftkeyLocationChangeL();
    		}

    		if (iSoundHandler && iConfig.iHelixFlvMode )
			{
				iSoundHandler->ResumeSound();
			}

			THXVDCmdArg arg;
			EngineDispatchHXCommand(EHXVDCmdResume, arg);	

			// make sure that timer is restarted if necessary.
			if (!iTimer->IsActive())
			{
				StartTimer();
			}
		}
	//}
	else
	{
		// commented aIgnoreActiveView condition for Flash methods stop and play function
		if (iPauseFlags==ENotPaused ) /* && (aIgnoreActiveView))*/
		{
			if (iMMObject)
			{
				iFiObject.FI_Resume();
				
				//changes done for iSource [#12892]: Start
#ifdef FEATURE_AMCEXTENSIONS
                NotifyExt(ePlayerResume);
#endif
				//changes done for iSource [#12892]: End
			}

			if (iSoundHandler)
			{
				iSoundHandler->ResumeSound();
			}

			// Pause the audio- video if those objects are present
			THXVDCmdArg arg;
			EngineDispatchHXCommand(EHXVDCmdResume, arg);	

			// make sure that timer is restarted if necessary.
			if (!iTimer->IsActive())
			{
				StartTimer();
			}
		}
	}
        
    // Run once to update the buffer
    if(aReason != EReasonPhone)
      {
      PlayStep(EFalse);
      }
}


TBool CPlatformFlashEngine::CanRewind()
{
	return (iFiObject.FI_NumberOfFrames() > 1);
}

TInt CPlatformFlashEngine::GetCurrentFrameNumber()
{
	return iFiObject.FI_FrameNumber();
}

TInt CPlatformFlashEngine::GetTotalFrameNumber()
{
	return iFiObject.FI_NumberOfFrames();
}

void CPlatformFlashEngine::RewindL()
{
	// Force a refresh, because some platforms don't repaint
	// the screen after rewind.
	// rewind causes player to resume playback, so turn off the paused flag.
	if(!iIsStopped)
	{
	    iFiObject.FI_Stop();
	}

	iIsStopped = EFalse;
	iIsRunning = ETrue;
	iNotifyEndOfMovie = ETrue;
	if (iPauseFlags!=ENotPaused)
	{
		// user initiated
		ResumeL(EReasonUser, EFalse);
	}

	RefreshScreen();
}

void CPlatformFlashEngine::SetQuality(TInt aQuality)
{
	iFiObject.FI_SetQuality(static_cast<TInt16>(aQuality));
	iQuality = aQuality;
}

TInt CPlatformFlashEngine::GetQuality()
{
	return iFiObject.FI_GetQuality();
}


// this overload is called by the view and is therefore a brand new user selected SWF
// it should capture the background bitmap and reset the IAP access flags
void CPlatformFlashEngine::OpenFileAndStartMovieL(const TDesC& aFilename, TBool aResetBaseURL, const TBool& aFirstMovie, CContent* aContent )
{
	OpenFileAndStartMovieL(aFilename,aResetBaseURL,ETrue,aFirstMovie, aContent);
}

void CPlatformFlashEngine::OpenFileAndStartMovieL(const TDesC& aFilename,
                                                  TBool aResetBaseURL,
                                                  TBool aResetIAPAccess,
                                                  const TBool& aFirstMovie,
                                                  CContent* aContent )

{
	RFile file;

#ifdef FEATURE_ATS_AUTOMATION

  RFile atsfile;
  iXMLFlag = EFalse;
    
  if(iConfig.iMode & KPlayerInATSMode)
  	{  
		if(KErrNotFound != aFilename.Find(_L("ATSAutomation.swf")))
		    {
		    iXMLFlag = ETrue;	
		    }
		else if (KErrNotFound != aFilename.Find(_L("results.swf")))
		    {   
		    iXMLFlag = true;
		    atsfile.Create(iFs,_L("C:\\data\\others\\ats\\resultswf.txt"),EFileShareAny);
		    atsfile.Close();
		    }
		else 
		    {	   	    
				TFileName atsfileName;
				atsfileName = aFilename;				
				TInt cchText = aFilename.Length();
				
				for (TInt idx = 0; idx < cchText; ++idx)
					{
					if( KErrNotFound != atsfileName.Locate('/') )
						{
				    atsfileName[idx] = '\\';
						}
					}
	    
	    	// Here we presume that the test XML file is in the same directory as the SWF.
	   	 	// If we don't find it, we don't open the ATS Test library
	        
				atsfileName.Delete((aFilename.Length() -3), 3);
				_LIT(XML, "xml");
				atsfileName.Append(XML);
	
				if(BaflUtils::FileExists(CEikonEnv::Static()->FsSession(),atsfileName)) 
	            iXMLFlag = ETrue;
	      atsfile.Close();    
		    }
			}
#endif //FEATURE_ATS_AUTOMATION    
	// Is engine ready?
	if (!iIsInitialized)
		{
		User::Leave(KErrNotReady);
		}

    //Preparing File Handle from File name
    TInt err = file.Open(iFs, aFilename, EFileRead | EFileShareReadersOnly | EFileStream);
    CleanupClosePushL(file);
    if (err == KErrNone)
    {
	// Make sure not to reset baseURL if loading the openNet temp file.
	if (aResetBaseURL && (aFilename != iTempOpenNetFileName))
		{
		if (iBaseURL)
			{
			delete iBaseURL;
			iBaseURL=NULL;
			}
		iBaseURL = CreateBaseUrlFromFilenameL(aFilename);
		}

		iFLVPlayStat = EFalse;//start playing fresh file make it false;
        OpenFileHandleAndStartMovieL(file, EFalse,aResetIAPAccess, aFirstMovie, aContent);

    }
    CleanupStack::PopAndDestroy(&file);
}

unsigned short CPlatformFlashEngine::SendtoBrowserPluginL( unsigned short streamId,
														const char* url,
														unsigned int aUrllen,
														const char* aPostDataContentType,
                                                        unsigned int aPostDataContentLen,
														const unsigned char* postData,
														unsigned int aPostDataLen)
	{
	unsigned short result = 0;
	HBufC* hUrl = CreateEpocStringL(url, aUrllen);
	CleanupStack::PushL(hUrl);
	 if (postData)
		{
		TInt lPdContentTypeStrlen = (aPostDataContentType ? strlen(aPostDataContentType) : 0);
			
		HBufC* hContentType = CreateEpocStringL((const char*)aPostDataContentType,  lPdContentTypeStrlen);
						
		CleanupStack::PushL(hContentType);
        MPluginStreamIf* streamIf = iFlashClientIf->GetStreamIf();
		
		TPtrC8 ptr;
		ptr.Set((TUint8*)postData,aPostDataLen);
				
		HBufC* binaryPostdata = HBufC::NewLC(ptr.Length());
		binaryPostdata->Des().Copy(ptr);
				
		TInt ret = hContentType->Find(KTermiChar);
				
		if(ret != KErrNotFound)
			{
			//ignore \r\n and pass the rest of the string.Eg: RTMPT/S streams
			TPtrC ptrc( hContentType->Mid(0,ret));
			hContentType->Des().Copy(ptrc);
			}
        if(streamIf)
					
		//Pass the binary postdata AS IT IS to browser without any unicode conversion.			 
		result = streamIf->OpenStreamL(streamId, *hUrl, *hContentType, aPostDataContentLen, *binaryPostdata);
				
		CleanupStack::PopAndDestroy(binaryPostdata);
		CleanupStack::PopAndDestroy(hContentType);
			
		}
	else
		{
	    TPtrC nullDes;
	    MPluginStreamIf* streamIf = iFlashClientIf->GetStreamIf();
	    if(streamIf)
	        result = streamIf->OpenStreamL(streamId, *hUrl, nullDes, 0, nullDes);
		}
	CleanupStack::PopAndDestroy(hUrl);
	return result;
}

unsigned short CPlatformFlashEngine::CreateBrowserStreamL(unsigned short streamId,
														struct FI_URLStreamInfo* pStreamInfo)
{
	unsigned short result = 0;

	TPtrC8 protocolSchema;

	if( pStreamInfo->protocolSchema )
		{
		protocolSchema.Set( (TUint8*)pStreamInfo->protocolSchema );
		}

	TInt protocolSize = protocolSchema.Length();

	TPtrC8 host;

	if( pStreamInfo->hostName )
	   {
	   host.Set( (TUint8*)pStreamInfo->hostName );
	   }

	TInt hostSize = host.Length();


	TPtrC8 documentPath;
	if( pStreamInfo->documentPath )
		{
		documentPath.Set((TUint8*)pStreamInfo->documentPath);
		}

	TInt documentPathSize = documentPath.Length();

	const TInt KLengthColonChar = 1;
	const TInt KLengthZeroTerminateChar = 1;
	
	TInt sizeToBeAllocated = protocolSize + hostSize + documentPathSize + KPortNumLength + KLengthColonChar + KLengthZeroTerminateChar; // 1 for KColonChar

	HBufC8* buf = HBufC8::NewLC(sizeToBeAllocated);
	TPtr8 url = buf->Des();

	url.Copy(protocolSchema);
	url.Append(host);

	if( pStreamInfo->port && pStreamInfo->port != KHttpDefaultPort )
		{
		url.Append(KColonChar);
		url.AppendNum(pStreamInfo->port);
		}
	url.Append(documentPath);
	url.ZeroTerminate();

	result = SendtoBrowserPluginL(streamId,
							(const char*)url.Ptr(),
							url.Length(),
							pStreamInfo->additionalHeaders,
							pStreamInfo->contentLength,
							pStreamInfo->postData,
							pStreamInfo->contentLength);

	CleanupStack::PopAndDestroy(buf);

	return result;
}

_LIT( KContentLength,"Content-Length" );
_LIT( KContentType,"Content-Type" );
const TInt KMaxTIntLength = 64;
//AddContentLengthToHeaderL
void CPlatformFlashEngine::AddToHeaderInfoL(FI_URLStreamHeaderInfo& aHeaderInfo, TInt aContentLength, TDesC8& aContentType)
	{
	if(aContentLength>=0)
		{
		aHeaderInfo.headerNames	= new(ELeave) char*[2];

		aHeaderInfo.headerValues = new(ELeave) char*[2];

		aHeaderInfo.numHeaders = 2;

		aHeaderInfo.headerNames[0] = CreateFlashString(KContentLength);

		aHeaderInfo.headerValues[0] = new(ELeave) char[KMaxTIntLength];

		TPtr8 ptrContentLength ((TUint8*)aHeaderInfo.headerValues[0], KMaxTIntLength);

		ptrContentLength.AppendNum(aContentLength);
		ptrContentLength.ZeroTerminate();

		aHeaderInfo.headerNames[1] = CreateFlashString(KContentType);

		aHeaderInfo.headerValues[1] = new(ELeave) char[KMaxTIntLength];

		TPtr8 ptrContentType ((TUint8*)aHeaderInfo.headerValues[1], KMaxTIntLength);

		ptrContentType.Append(aContentType);
		ptrContentType.ZeroTerminate();
		}
	else
		{
		aHeaderInfo.headerNames	= new(ELeave) char*[1];

		aHeaderInfo.headerValues = new(ELeave) char*[1];

		aHeaderInfo.numHeaders = 1;

		aHeaderInfo.headerNames[0] = CreateFlashString(KContentType);

		aHeaderInfo.headerValues[0] = new(ELeave) char[KMaxTIntLength];

		TPtr8 ptrContentType ((TUint8*)aHeaderInfo.headerValues[0], KMaxTIntLength);

		ptrContentType.Append(aContentType);
		ptrContentType.ZeroTerminate();
		}
	}


#ifdef FEATURE_FLV_MMC
void CPlatformFlashEngine::NewURLStreamL(const char* aFinalURL, TUint aStreamId, TInt aContentLength, TDesC8& aContentType)
	{
	//FI_URLStreamHeaderInfo headerInfo;

	//AddContentLengthToHeaderL(headerInfo, aContentLength);

	CBrowserURLRequestInfo* browserURLRequestInfo = CBrowserURLRequestInfo::NewLC(this, aStreamId
																				, aFinalURL, aContentLength, aContentType);

    iNetBufArray.Append(browserURLRequestInfo);
    
    MPluginStreamIf* streamIf = iFlashClientIf->GetStreamIf();
    if(streamIf)
        streamIf->SetStreamBufferSizeL(aStreamId, browserURLRequestInfo->GetMaxSize());
	CleanupStack::Pop(browserURLRequestInfo);
	}

#else //!FEATURE_FLV_MMC
void CPlatformFlashEngine::NewURLStreamL(const char* aFinalURL, TUint aStreamId, TInt aContentLength)
{
	FI_NetworkBufferInfo* retBuf;// field dataSize need to be filled by Host application, which data stream data size
	TInt16 errorCode;
	FI_URLStreamHeaderInfo headerInfo;
	AddContentLengthToHeaderL(headerInfo, aContentLength);
	retBuf =  iFiObject.FI_URLStreamOpened(aStreamId, &headerInfo, &errorCode);

	if (errorCode <= 0)
		{
		//Some error has occured.
		// Need to check whether here to call FI_CloseURLStreamClosed() or not??
		CloseStream(aStreamId, errorCode);
		}
	else if(retBuf == NULL)
		{
		//error has not occured, but return buffer is NULL
		//in this case need to wait for SI_LoadStreamBuffer function from MM Core Player,
		//which provides the address to store headers/data
		}
	else
		{
		//no error and have got valid buffer pointer to store
		retBuf->streamId = aStreamId;
    iNetBufArray.Append(retBuf);

    iStreamIf->SetStreamBufferSizeL(aStreamId, retBuf->maxBufSize);
		}
	iFiObject.FI_URLStreamSetFinalURL( aStreamId, aFinalURL, FI_UseDefault);
}
#endif //FEATURE_FLV_MMC
#ifdef FEATURE_FLV_MMC
void CPlatformFlashEngine::SetNetworkBufferL(unsigned short aStreamId, struct FI_NetworkBufferInfo* aNetBuf)
	{
    int index = 0;
	//find the browserurlrequest object
	//corresponding to the streamID
	CBrowserURLRequestInfo* browserURLRequestInfo = NULL;
	for( ; index < iNetBufArray.Count(); index++ )
	    {
	    browserURLRequestInfo = iNetBufArray[index];
	    if( browserURLRequestInfo && browserURLRequestInfo->GetStreamID() == aStreamId )
	        {
			browserURLRequestInfo->SetNetworkBuffer(aNetBuf);
	        break;
	        }
	    }
	}

#else //!FEATURE_FLV_MMC
void CPlatformFlashEngine::SetNetworkBufferL(unsigned short aStreamId, struct FI_NetworkBufferInfo* aNetBuf)
	{

	if( aNetBuf )
	    {
	    aNetBuf->streamId = aStreamId;
	    }

	int index = 0;
	for( ; index < iNetBufArray.Count(); index++ )
	    {
	    FI_NetworkBufferInfo* netBuf = iNetBufArray[index];
	    if( netBuf && netBuf->streamId == aStreamId )
	        {
	        iNetBufArray.Remove(index);
	        iNetBufArray.InsertL(aNetBuf, index);
	        break;
	        }
	    }

	if( index == iNetBufArray.Count() )
	    {
	    iNetBufArray.Append(aNetBuf);
	    }

	if( aNetBuf )
		{
		iStreamIf->SetStreamBufferSizeL(aStreamId, aNetBuf->maxBufSize);
		}
	}
#endif //FEATURE_FLV_MMC

#ifdef FEATURE_FLV_MMC
void CPlatformFlashEngine::CancelURLStream(unsigned short aStreamId)
{
	//NPPDebug(LOG_INFO,iBrowserPluginActive,_L("CPlatformFlashEngine::CancelURLStream:%d ++"),aStreamId);

	//if(!iBrowserPluginActive) //if non plug-in mode
	if(iExecutionMode == eStandAlone)
	{
		CFileEngine* fileEngine = GetFileEngine();
		CHttpEngine* httpEngine = GetHttpEngine();
		if( fileEngine && fileEngine->GetRequestObjectOrNull(aStreamId))
		{
			fileEngine->CancelRequestObject(aStreamId);
		}
		else if (httpEngine)
		{
			// Tell HttpEventHandler to stop current stream
			httpEngine->CancelHttpRequest(GetMMObject(), aStreamId);
		}
	}
	else
	{
		CBrowserURLRequestInfo* browserURLRequestInfo = NULL;
		TInt  index=0;
//		RemoveCompletedRequest(aStreamId);
//		FireNextRequestL();
		MPluginStreamIf* streamIf = iFlashClientIf->GetStreamIf();
		    
		        
		for( ; index < iNetBufArray.Count(); index++ )
	    {
	    browserURLRequestInfo = iNetBufArray[index];
	    if( browserURLRequestInfo && browserURLRequestInfo->GetStreamID() == aStreamId )
	        {
			iNetBufArray.Remove(index);
			browserURLRequestInfo->DoCancelStream();
			if(streamIf)
			{//now tell the plug-in that stream needs to be cancelled
			 // means dont send data to engine
			streamIf->CancelStream(aStreamId);
			}
			if(browserURLRequestInfo)
			{
				delete browserURLRequestInfo;
				browserURLRequestInfo = NULL;
	        }
	        break;
	        }
	    }
	}

	//NPPDebug(LOG_DEBUG,iBrowserPluginActive,_L("CPlatformFlashEngine::CancelURLStream:--"));

}
#else
void CPlatformFlashEngine::CancelURLStream(unsigned short aStreamId)
{
	if(!iBrowserPluginActive)
	{
		CFileEngine* fileEngine = GetFileEngine();
		CHttpEngine* httpEngine = GetHttpEngine();

		if( fileEngine && fileEngine->GetRequestObjectOrNull(aStreamId))
		{
			fileEngine->CancelRequestObject(aStreamId);
		}
		else if (httpEngine)
		{
			// Tell HttpEventHandler to stop current stream
			httpEngine->CancelHttpRequest(GetMMObject(), aStreamId);
		}
	}
	else
	{

		int index = 0;
		for( ; index < iNetBufArray.Count(); index++ )
		    {
		    FI_NetworkBufferInfo* netBuf = iNetBufArray[index];
		    if( netBuf && netBuf->streamId == aStreamId )
		        {
		        iNetBufArray.Remove(index);
				//TODO:do we need to delete   netBuf;
		        break;
		        }
		    }
	}

	NPPDebug(iBrowserPluginActive,_L("CPlatformFlashEngine::CancelURLStream: --"));
}

#endif
_LIT8(KLitFile,"file://");
_LIT8(KLitLocalhostName, "localhost");
_LIT8(KLitLocalhostNumber, "127.0.0.1");
short CPlatformFlashEngine::OpenURLStreamL(unsigned short streamId
										   ,struct FI_URLStreamInfo* pStreamInfo
										   ,struct MM_Object* aMMObj)
{
	//NPPDebug(LOG_INFO,iBrowserPluginActive,_L("CPlatformFlashEngine::OpenURLStreamL:%d ++"),streamId);
	unsigned short result = SI_GenericError;


	if(IsBrowserPluginActive())
	{
		result = CreateBrowserStreamL(streamId, pStreamInfo);

	}
	else
	{
		TPtrC8 wrapper;

		if (pStreamInfo->protocolSchema)
		{
			wrapper.Set((TUint8*)pStreamInfo->protocolSchema);
		}

		if ( 0==wrapper.Compare(KLitFile))
		{
			CFileEngine* fileEngine = GetFileEngine();
			if (fileEngine)
			{
				CFileEngineRequest* feReq=CFileEngineRequest::NewL(aMMObj, pStreamInfo, streamId);
				result = fileEngine->StartFileRequest(feReq);

			}
		}
		else
		{
			TPtrC8 host;

			if (pStreamInfo->hostName)
			{
				host.Set((TUint8*)pStreamInfo->hostName);
			}

			CLocalHttpEngine* localHttpEngine = GetLocalHttpEngine();
			CHttpEngine* httpEngine = GetHttpEngine();

			if ((localHttpEngine) && (( 0==host.Compare(KLitLocalhostName)) || (0==host.Compare(KLitLocalhostNumber))))
			{
				CUrlRequestInfo* info=CLocalUrlRequestInfo::NewL(GetMMObject(), aMMObj,pStreamInfo,streamId);
				result = localHttpEngine->StartLocalRequestL(info);

			}
			else if (httpEngine)
			{
				CUrlRequestInfo* info=CUrlRequestInfo::NewL(GetMMObject(), aMMObj,pStreamInfo,streamId);
				result = httpEngine->StartHttpRequestL(info);

			}
		}
	}

	//NPPDebug(LOG_DEBUG,iBrowserPluginActive,_L("CPlatformFlashEngine::OpenURLStreamL: --"));

	return result;
}

void CPlatformFlashEngine::LoadURLStreamBufferL( unsigned short streamId
												,  struct FI_NetworkBufferInfo* pNetBuf)
{
	// see if its a file object...
	if(IsBrowserPluginActive())
	{
		//need to use the struct given by this func argument, to wrtie the stream data for MM Core Player
		return SetNetworkBufferL(streamId, pNetBuf);

	}
	else
	{
		CFileEngine* fileEngine = GetFileEngine();

		CFileEngineRequest* info =  (fileEngine )? fileEngine->GetRequestObjectOrNull(streamId) : NULL;

		if (info)
		{
			info->SetNetBuf(pNetBuf);
		}
		else
		{
			CHttpEngine* httpEngine = GetHttpEngine();

			CUrlRequestInfo* urlInfo=(CUrlRequestInfo*) (httpEngine ? httpEngine->GetRequestObject(GetMMObject(),streamId) : NULL);

			if(urlInfo)
			{
				urlInfo->SetNetworkBuffer(pNetBuf);
			}
		}
	}

}

void CPlatformFlashEngine::StreamClosed(TUint16 aStreamId, TInt16 aClosedStatusCode)                                      
{
    DEBUGPRINT("CPlatformFlashEngine::StreamClosed()++, aClosedStatusCode: %d", aClosedStatusCode);
    if( aClosedStatusCode == 0)
    {
        aClosedStatusCode = FI_ResultOK;
    }
    else
    {
        aClosedStatusCode = FI_ResultError;
    }
	//as broswer donesn't support http status ocde to be propogated to flash plugin, hence we are 
	// sending "200" for success transaction and '0' for all other cases.
    iFiObject.FI_URLStreamClosed(aStreamId, aClosedStatusCode, 0);
}

#ifdef FEATURE_FLV_MMC

TInt CPlatformFlashEngine::WriteStreamDataL(unsigned long streamId, const char* data, unsigned long dataLength)
	{
	CBrowserURLRequestInfo* browserURLRequestInfo = NULL;

	int index = 0;
	TBool status = EFalse;

	//find the browserurlrequest object
	//corresponding to the streamID

	for( ; index < iNetBufArray.Count(); index++ )
	    {
	    browserURLRequestInfo = iNetBufArray[index];
    	if( browserURLRequestInfo && browserURLRequestInfo->GetStreamID() == streamId )
        	{
            status = ETrue;
        	break;
        	}
	    }

	if( status )
		{
		TPtrC8 dataPtr ((const TUint8*)data, dataLength);
		browserURLRequestInfo->WriteStreamDataL( dataPtr, dataLength);
		
		MPluginStreamIf* streamIf = iFlashClientIf->GetStreamIf();
		if(streamIf)
		    streamIf->SetStreamBufferSizeL(streamId, browserURLRequestInfo->GetMaxSize());
		}


	// NOTE: If we perform one step of player (Playstep) as soon as data is written, then it is quite faster.

	if( iTimer )
		{
		// StartTimer();
		}

	return status;
	}

#else  //!FEATURE_FLV_MMC

TInt CPlatformFlashEngine::WriteStreamDataL(unsigned long streamId, const char* data, unsigned long dataLength)

	{

	if (iMMObject)

		{

		FI_NetworkBufferInfo* netBuf = NULL;

		int index = 0;

		for( ; index < iNetBufArray.Count(); index++ )

		    {

		    netBuf = iNetBufArray[index];

		    if( netBuf && netBuf->streamId == streamId )

		        {

		        break;

		        }

		    }


	    if( !netBuf || index == iNetBufArray.Count() || !data || !netBuf->pBuffer )

	        return EFalse;

		unsigned char * buffer = netBuf->pBuffer;

        const char* dataToWrite = data;

		TInt bytesToWrite = dataLength;

		while (bytesToWrite > 0)

			{

			if(!netBuf || !netBuf->pBuffer)

				{

				break;

				}

			netBuf->dataSize = (bytesToWrite > netBuf->maxBufSize) ? netBuf->maxBufSize : bytesToWrite;

			FlashMemCpy(netBuf->pBuffer, dataToWrite, netBuf->dataSize);


			// need to advance the dataToWrite pointer;

			if (bytesToWrite > netBuf->maxBufSize)

				{

				dataToWrite = dataToWrite + netBuf->maxBufSize;

				bytesToWrite -= netBuf->maxBufSize;

				}

			else

				{

				dataToWrite = NULL;

				bytesToWrite = 0;

				}

			netBuf = iFiObject.FI_URLStreamDataLoaded(netBuf->streamId, netBuf );


			}

		if( netBuf )

			{

			iStreamIf->SetStreamBufferSizeL(streamId, netBuf->maxBufSize);

			}
		return ETrue;
		}

	return EFalse;
	}
#endif //FEATURE_FLV_MMC
#ifdef FEATURE_FLV_MMC

void CPlatformFlashEngine::CloseStream(TUint16 aStreamId
										, TInt16 aClosedStatusCode
										, EMediaStreamType /*aMediaStreamType*/ )
	{
	if( aClosedStatusCode == HTTPStatus::EOk)
	    {
	    aClosedStatusCode = FI_ResultOK;
	    }
	else
	    {
	    aClosedStatusCode = FI_ResultError;
	    }



	for(int index = 0; index < iNetBufArray.Count(); index++ )
	    {
	    CBrowserURLRequestInfo* browserURLRequestInfo = iNetBufArray[index];
	    if( browserURLRequestInfo && browserURLRequestInfo->GetStreamID() == aStreamId )
	        {
	        //iFiObject.FI_URLStreamClosed(aStreamId, aClosedStatusCode,201);
	     //   iNetBufArray.Remove(index);
	        //to do reset to be called
	     //   delete browserURLRequestInfo;
	     	browserURLRequestInfo->WriteComplete(FI_Result(aClosedStatusCode));
	        break;
	        }
	    }

//	RemoveCompletedRequest(aStreamId);
//	FireNextRequestL();
	}



#else //!FEATURE_FLV_MMC
void CPlatformFlashEngine::CloseStream(TUint16 aStreamId
					, TInt16 aClosedStatusCode
					,EMediaStreamType aMediaStreamType)
	{
	if( aClosedStatusCode == HTTPStatus::EOk)
	    {
	    aClosedStatusCode = FI_ResultOK;
	    }
	else
	    {
	    aClosedStatusCode = FI_ResultError;
	    }

	iFiObject.FI_URLStreamClosed(aStreamId, aClosedStatusCode,200);


	for(int index = 0; index < iNetBufArray.Count(); index++ )
	    {
	    FI_NetworkBufferInfo* netBuf = iNetBufArray[index];
	    if( netBuf && netBuf->streamId == aStreamId )
	        {
	        iNetBufArray.Remove(index);
	        break;
	        }
	    }

//	 RemoveCompletedRequest(aStreamId);
//	 FireNextRequestL();
	 if(aMediaStreamType == EVideoStream)
	   { //if flv stream is closed then we need to handle backlight here
	   	//extend max 20 secs
	   	//	ExtendBacklight(20);
	   }

	}
#endif //FEATURE_FLV_MMC

#ifdef FEATURE_FLV_MMC

TBool CPlatformFlashEngine::SeekURLStreamFLV( unsigned short streamId,
						   unsigned int seekTime,
						   struct FI_NetworkBufferInfo* pNetBuf)
	{
    for(int index = 0; index < iNetBufArray.Count(); index++ )
	    {
	    CBrowserURLRequestInfo* browserURLRequestInfo = iNetBufArray[index];
	    if( browserURLRequestInfo && browserURLRequestInfo->GetStreamID() == streamId )
	        {
	     	return browserURLRequestInfo->Seek(seekTime, pNetBuf);
	        }
	    }
	return EFalse;
	}


unsigned int CPlatformFlashEngine::GetBytesLoaded(unsigned short streamId)
{

	unsigned int byteval = 0;
	for(int index = 0; index < iNetBufArray.Count(); index++ )
	    {
	    CBrowserURLRequestInfo* browserURLRequestInfo = iNetBufArray[index];
	    if( browserURLRequestInfo && browserURLRequestInfo->GetStreamID() == streamId )
	        {
	     		byteval = browserURLRequestInfo->GetBytes();
	     	}
	    }
	return byteval;
}

unsigned int CPlatformFlashEngine::GetTotalBytes(unsigned short streamId)
{

    unsigned int byteval = 0;
    for(int index = 0; index < iNetBufArray.Count(); index++ )
        {
        CBrowserURLRequestInfo* browserURLRequestInfo = iNetBufArray[index];
        if( browserURLRequestInfo && browserURLRequestInfo->GetStreamID() == streamId )
            {
                byteval = browserURLRequestInfo->GetTotalBytes();
            }
        }
    return byteval;
}

#endif //FEATURE_FLV_MMC

/*
Function compares Swfs Content's dimension with Screen size and
returns mode to be set by the viewer.
*/
TBool CPlatformFlashEngine::IsLandScapeMode()
{
	unsigned short swfHeight;
	unsigned short swfWidth;
	//check the dimension of file to be played
	iFiObject.FI_GetSWFDimensions(&swfHeight,&swfWidth);
    TSize aDeviceScreenSize = CCoeEnv::Static()->ScreenDevice()->SizeInPixels();

	if(aDeviceScreenSize.iWidth < swfWidth)
		return ETrue; // Landscape mode
	else
		return EFalse; //Portrait Mode

}


TRect CPlatformFlashEngine::GetViewRectangle()
    {
    TRect viewRect(0,0,0,0);
    
        //TODO : Check this..
        /*
        if(iBrowserPluginActive && iControl)
            return (iControl->GetRect());
        */
    MDisplay* display = iFlashClientIf->GetDisplay();
    if(display)
       viewRect = display->ClientRect();
    
    return viewRect;
    }


TInt CPlatformFlashEngine::ValidSwfContentVersion(const TUint8 *aSwfBuffer, TInt aBufferLength)
	{
	TInt result = 1;
	if(aBufferLength > 3)
		{
		TPtrC8 content(aSwfBuffer, aBufferLength);
		TBool couldbeSwf = EFalse;

		if (content.Left(KSWFFileFirstFewBytes.iTypeLength).CompareF(KSWFFileFirstFewBytes) == 0)
			{
			couldbeSwf = ETrue;
			}
		else if (content.Left(KSWCFileFirstFewBytes.iTypeLength).CompareF(KSWCFileFirstFewBytes) == 0)
			{
			couldbeSwf = ETrue;
			}

		if(couldbeSwf)
			{
			iSWFContentVersion = aSwfBuffer[3];
			if( iSWFContentVersion >  PLAYER_MAJOR_VERSION || iSWFContentVersion == 0 )
				{
				result = 0;
				//if(iFlashUI)
				if(eStandAlone==iExecutionMode)
					{
					ErrorInfo errorInfo;
					errorInfo.iInfo = (TInt)iSWFContentVersion;
					ClearBitmap();
					MUserNotiferIf* userNotifierIf = iFlashClientIf->GetUserNotifierIf();
					if(userNotifierIf)
					    userNotifierIf->NotifyFlashError(EInvalidFileVersionError,ETrue,ETrue,&errorInfo);
					}
				//else if (iControl)
				else if(ePlugin==iExecutionMode)
				    {
				    MUserNotiferIf* userNotifierIf = iFlashClientIf->GetUserNotifierIf();
				    if(userNotifierIf)
                        userNotifierIf->NotifyClientError(EInvalidFileVersionError, ETrue, ETrue);
					}
				}
			}
		}
	return result;
	}


void CPlatformFlashEngine::OpenFileHandleAndStartMovieL(RFile& aFile, TBool aResetBaseURL, TBool aResetIAPAccess,
                                                        const TBool& aFirstMovie, CContent* aContent )
{
    if(!iIsStopped)
        {
        iZoomFactor = 0;
        }
    else
    	{
    	iReplayFlag = ETrue;
    	}

    if (!iIsInitialized)
	    {
		User::Leave(KErrNotReady);
	    }

    iIsStopped = EFalse;
    TInt length = 0;
    HBufC8* swfbuf = 0;
    TPtr8 bufptr(NULL,0);

	if (!iIsInitialized)
    {
		User::Leave(KErrNotReady);
    }

   // Get file path from RFile
    TPath* filepath = new(ELeave) TPath;
    aFile.FullName(*filepath);
    CleanupStack::PushL(filepath);

    // make sure not to reset baseURL if loading the openNet temp file.
    if (aResetBaseURL && (*filepath != iTempOpenNetFileName))
    {
        if (iBaseURL)
        {
            delete iBaseURL;
            iBaseURL = NULL;
        }

		if( (eStandAlone==iExecutionMode) && (iFlashClientIf->IsUrlDescSet()) )
        {
                //iBaseURL  = iFlashUI->GetUrlDesc().AllocL();
                iBaseURL  = iFlashClientIf->GetUrlDesc().AllocL();

        }
        else
        {
        	iBaseURL = CreateBaseUrlFromFilenameL(*filepath);
        }
    }

    if(iBaseURL)
    {
        delete iSwfPath;
	    iSwfPath = NULL;
        iSwfPath = iBaseURL->AllocL();
    }

	CContent* content = NULL;
	if( !aContent )
	    {
	    content = CContent::NewLC(aFile);
	    }
    else
        {
        content = aContent;
        }

	CData* data = content->OpenContentLC( ContentAccess::EExecute );

	data->DataSizeL( length ) ;

	data->ExecuteIntent(ContentAccess::EExecute);

	//Initially read 8 bytes of header only, if SWF content version is Ok then only read
	//whole file.
	TInt swfHeaderLength = 8;
	HBufC8* swfHeaderBuf;
	swfHeaderBuf = HBufC8::NewLC(swfHeaderLength + 1);
    TPtr8 swfHeaderPtr(NULL,0);

    swfHeaderPtr.Set(swfHeaderBuf->Des());
	data->Read(swfHeaderPtr,swfHeaderLength);

	if (!ValidSwfContentVersion(swfHeaderPtr.PtrZ(),length ))
	{
	CleanupStack::PopAndDestroy(swfHeaderBuf);
	CleanupStack::PopAndDestroy(data);
	if( !aContent )
	{
	    CleanupStack::PopAndDestroy(content);
	}
	CleanupStack::PopAndDestroy(filepath);
	return;
	}

	swfHeaderLength *= -1;
	data->Seek(ESeekCurrent, swfHeaderLength);
	// Length + 1 because the buffer needs to be null terminated
	swfbuf = HBufC8::NewLC(length + 1);
    bufptr.Set(swfbuf->Des());
	data->Read(bufptr);

	char* swfURL = NULL;

    swfURL = CreateFlashStringL(iBaseURL->Des());
	char* s = swfURL;

	while (*s)
		{
		if (*s == KCharBackslash)
			{
			*s = KCharForwardSlash;
			}
		s++;
		}

    StartMovieL( swfURL, bufptr.PtrZ(), length,aResetIAPAccess,aFirstMovie);
	//if(!IsBrowserPluginActive())
		//iFlashUI->SetLandScapeModeL(IsLandScapeMode());	//Decide on the landascape/portait mode comparing screen dimensions and swf file dimensions

    //CleanupStack::PopAndDestroy(swfURLBuf);
    CleanupStack::PopAndDestroy(swfbuf);
    CleanupStack::PopAndDestroy(swfHeaderBuf);
	CleanupStack::PopAndDestroy(data);
	if( !aContent )
	{
	    CleanupStack::PopAndDestroy(content);
	}
	CleanupStack::PopAndDestroy(filepath);


}

void CPlatformFlashEngine::OpenBrowserFileAndStartMovieL(	const TDesC& aFilename,
															TBool aResetBaseURL,
															const TDesC* aBaseUrl,
															const TBool& aFirstMovie,
															CContent* aContent )
{
 	// make sure not to reset baseURL if loading the openNet temp file.
	if (aResetBaseURL && (aFilename != iTempOpenNetFileName))
		{
		if (iBaseURL)
	        {
		    delete iBaseURL;
		    iBaseURL=NULL;
		    }
		if (aBaseUrl)
		    {
		    iBaseURL = aBaseUrl->AllocL();
		    }

		else
    		{
    		iBaseURL = CreateBaseUrlFromFilenameL(aFilename);
    		}
	    }
    OpenFileAndStartMovieL(aFilename,EFalse,ETrue, aFirstMovie, aContent);
}

void CPlatformFlashEngine::SetBaseUrlL(const TDesC8* aBaseUrl)
{
    if(!aBaseUrl)
    {
        return;
    }
    
    //Part of eroom761++: 
    if(iHTMLBaseURL)
    	{
    	delete iHTMLBaseURL;
    	iHTMLBaseURL = NULL;
    	}
    iHTMLBaseURL = HBufC8::NewL(aBaseUrl->Length() + 2);
    TPtr8 urlPtr = iHTMLBaseURL->Des();
    urlPtr.Copy(*aBaseUrl);
    urlPtr.ZeroTerminate();
    //eroom761--


    //TPtr8 urlPtr = ((HBufC8*)aBaseUrl)->Des();

    //const char* url = (const char *) urlPtr.Ptr();

    //iFiObject.FI_SetBaseURL(url);

    if( iBaseURL )
    {
        delete iBaseURL;
        iBaseURL = 0;
    }
}
void CPlatformFlashEngine::SetSecurityContextUrl(const TDesC8* iSecurityContextUrl)
{
    
    if(!iSecurityContextUrl)
       {
           return;
       }
    if(iEngineSecurityContextUrl)
            {
            delete iEngineSecurityContextUrl;
            iEngineSecurityContextUrl = NULL;
            }
    iEngineSecurityContextUrl = HBufC8::NewL(iSecurityContextUrl->Length() + 2);
    TPtr8 urlPtr = iEngineSecurityContextUrl->Des();
    urlPtr.Copy(*iSecurityContextUrl);
    urlPtr.ZeroTerminate();   
}


void CPlatformFlashEngine::ProcessParamBGcolor(const TDesC& aBGColor)
{
	iRed = KDefaultBackgroundRed;
    iGreen = KDefaultBackgroundGreen;
    iBlue = KDefaultBackgroundBlue;
    iTransparency = KDefaultBackgroundTransparency;

    if(aBGColor.Length() == 0)
    	return;   
   
    const TInt KColorCodeLength = 6;
    
    if ( aBGColor.Locate(TChar('#')) == 0 && (aBGColor.Length() == (KColorCodeLength + 1)) ) //if we don't find # in the first position then ignore the color changes
       	{        	
			iBackgroundColorPresent = ETrue;       	       	
			TPtrC16 lPtr(aBGColor);
	
			const TInt KSingleColorLength = 2; //we have 2 Hex digits for every color
			const TInt KHashCharLength = 1; //lenght of '#' char
			
			for (TInt i(0); i < KColorCodeLength   ; i = i+ KSingleColorLength)
			{
				TUint lColorValue;				 
				TLex lParser(lPtr.Mid(i + KHashCharLength ,KSingleColorLength ));
				TInt error = lParser.Val(lColorValue, EHex);
				
				if(error)
					return; //return if we get any error parsing color , it is better not to give backround color info 
							//than processing wrong one.hence skipping other color value to be processed				
				else{
					switch (i)
						{
						case 0:
							iRed = lColorValue;
							break;					
						case 2:
							iGreen = lColorValue;
							break;
						case 4:
							iBlue = lColorValue;
							break;						
										
						}
					}								
				}//for loop
       	}
}
//Return the background clour if it is present else return white
TRgb CPlatformFlashEngine::GetBgcolour()
{
    if(iBackgroundColorPresent)
    {    
        return TRgb(iRed,iGreen,iBlue);
    }
    else
    {
        return TRgb(KRgbWhite);
    }
}

#ifdef  FEATURE_BG_TRANSPARENCY
void CPlatformFlashEngine::ProcessParamWMode(const TDesC& awMode)
{

	if (0 == awMode.CompareF(KWModeTransparent))
	{
		iConfig.iBackgroundAlpha = 0;
		iConfig.iPlayerBlendsBackground = ETrue;
	}
}

short CPlatformFlashEngine::RedrawBackground(struct FI_Rect* aRects, unsigned short /*aNumRects*/)
{
    if( !aRects )
        return 0;

    return 1;
}

#endif //#ifdef  FEATURE_BG_TRANSPARENCY

void CPlatformFlashEngine::ProcessParamQuality(const TDesC& aQuality)
{
	if (0 == aQuality.CompareF(KLow))
	{
		iSwfQuality = KQualityLow;
	}
	else if (0 == aQuality.CompareF(KMedium))
	{
		iSwfQuality = KQualityMedium;
	}
	else if (0 == aQuality.CompareF(KHigh))
	{
		iSwfQuality = KQualityHigh;
	}
	else
	{
		iSwfQuality = KDefaultQuality;
	}

}

void CPlatformFlashEngine::ProcessParamLoop(const TDesC& aLoop)
{
	if ((0 == aLoop.CompareF(KOn))||
		(0 == aLoop.CompareF(KTrue)) ||
		(0 == aLoop.CompareF(KYes)) )
	{
		iLoop = KLoopOn;
	}
    else if ((0 == aLoop.CompareF(KOff))||
    		(0 == aLoop.CompareF(KFalse)) ||
    		(0 == aLoop.CompareF(KNo)))
	{
		iLoop = KLoopOff;
	}

}

void CPlatformFlashEngine::ProcessParamBaseURL(const TDesC& /*aBaseURL*/)
{

}

void CPlatformFlashEngine::ProcessParamFlashVars(const TDesC& aFlashVars)
{
	iFlashVarsPresent = ETrue;

	if(iFlashVarVal)
	{
		delete iFlashVarVal;
		iFlashVarVal= NULL;
	}

   TRAP_IGNORE(iFlashVarVal = EscapeUtils::ConvertFromUnicodeToUtf8L(aFlashVars));

}




void CPlatformFlashEngine::ProcessParameters(CDesCArray* argnames, CDesCArray* argvalues)
{

    iLoop = KDefaultLoop;
    iSwfQuality = KDefaultQuality;
    iBackgroundColorPresent = EFalse;
    iFlashVarsPresent = EFalse;
    iScaleValue = -1;
    iAlignValue = -1;

    for ( int i = 0; i != argnames->Count ( ); i++ )
    {

        TPtrC argname = (*argnames)[i];
        TPtrC argvalue = (*argvalues)[i];
		if (0 == argname.CompareF(KFlashVars) )
        {
        	ProcessParamFlashVars(argvalue);
        }
        else
        if (0 == argname.CompareF(KLoop) )
        {
	        ProcessParamLoop(argvalue);
        }
        else if ( 0 == argname.CompareF(KQuality) )
        {
			ProcessParamQuality(argvalue);
        }
        else if (0 == argname.CompareF(KAllowFullscreen)) // allowfullscreen
        {
            if (0 == argvalue.CompareF(KFalse))
            {
                iAllowFullscreen = EFalse;
            }
            else
            {
                iAllowFullscreen = ETrue;
            }
        }
        else if (0 == argname.CompareF(KAllowNetworking))
        {
            if (0 == argvalue.CompareF(KAllowNetInternal))
            {
                iAllowNetworking = kAllowNetworkingInternal;
            }
            else if (0 == argvalue.CompareF(KAllowNetAll))
            {
                iAllowNetworking = kAllowNetworkingAll;
            }
            else if (0 == argvalue.CompareF(KAllowNetNone))
            {
                iAllowNetworking = kAllowNetworkingNone;
            }
            else if (0 == argvalue.CompareF(KAllowNetMax))
            {
                iAllowNetworking = kAllowNetworkingMax;
            }
        }
        else if ( (0 == argname.CompareF(KBackgroundcolor))||(0==argname.CompareF(KBgcolor)) )
        {
        	ProcessParamBGcolor(argvalue);
		}		

#ifdef  FEATURE_BG_TRANSPARENCY
    _LIT(Kblendbg, "blendbg");

		if(0 == argname.CompareF(KWMode))
		{
			ProcessParamWMode(argvalue)	;
		}
		else if(0 == argname.CompareF(Kblendbg))
		{
			iConfig.iBackgroundAlpha = GetIntFromDesc(argvalue);
		}
#endif // FEATURE_BG_TRANSPARENCY

	    else if( 0 == argname.CompareF(KFlashSwfSrc) ||0 == argname.CompareF(KFlashSwfMovie) )
        {
            iSwfSrcPath.Set(argvalue);
        }
#ifdef FEATURE_WEB_BROWSABILITY
        else if( (0 == argname.CompareF( KFlashName ))  ||
                 (0 == argname.CompareF( KFlashId )) )//or id
        {
        	if( iName )
        	{
        		delete iName;
        		iName = NULL;
        	}

        TRAP_IGNORE(iName = HBufC8::NewL( argvalue.Length() +1 ));
			TPtr8 namevar = iName->Des();
			namevar.Copy( argvalue );
			namevar.ZeroTerminate();

        }

        else if(0 == argname.Compare(KScale ))
        {
        	if (0 == argvalue.CompareF(KShowAll))
        		iScaleValue = EScaleShowAll;
        	else if (0 == argvalue.CompareF(KNoBorder))
        		iScaleValue = EScaleNoBorder;
        	else if (0 == argvalue.CompareF(KExactFit))
        		iScaleValue = EScaleExactFit;
        	else if (0 == argvalue.CompareF(KNoScale))
        		iScaleValue = ENoScale;
        }
        // Commented on 10 march.Align param is handled by the browser, which is the alignment of the swf in the html page.
        /*else if(0 == argname.Compare(KAlign ))
        {
        	if (0 == argvalue.CompareF(KLeft))
        	    iAlignValue = EAlignLeft;
			else if (0 == argvalue.CompareF(KRight))
				iAlignValue = EAlignRight;
			else if (0 == argvalue.CompareF(KTop))
				iAlignValue = EAlignTop;
			else if (0 == argvalue.CompareF(KBottom))
				iAlignValue = EAlignBottom;
        }*/
        // SAlign is the alignment of the Flash object in the swf.
        else if(0 == argname.Compare(KSAlign ))
        {
        	if ((0 == argvalue.CompareF(KTopLeft)) || (0 == argvalue.CompareF(KLeftTop)))
        	    iAlignValue = (EAlignTop | EAlignLeft);
			else if ((0 == argvalue.CompareF(KTopRight)) || (0 == argvalue.CompareF(KRightTop)))
				iAlignValue = (EAlignTop | EAlignRight);
			else if ((0 == argvalue.CompareF(KBottomLeft)) || (0 == argvalue.CompareF(KLeftBottom)))
				iAlignValue = (EAlignBottom | EAlignLeft);
			else if ((0 == argvalue.CompareF(KBottomRight)) || (0 == argvalue.CompareF(KRightBottom)))
				iAlignValue = (EAlignBottom | EAlignRight);
			else if ((0 == argvalue.CompareF(KSLeft)) || (0 == argvalue.CompareF(KLeft)))
        	    iAlignValue = EAlignLeft;
        	else if ((0 == argvalue.CompareF(KSRight)) || (0 == argvalue.CompareF(KRight)))
        	    iAlignValue = EAlignRight;
        	else if ((0 == argvalue.CompareF(KSTop)) || (0 == argvalue.CompareF(KTop)))
        	    iAlignValue = EAlignTop;
        	else if ((0 == argvalue.CompareF(KSBottom)) || (0 == argvalue.CompareF(KSBottom)))
        	    iAlignValue = EAlignBottom;
        }
       else if(0 == argname.CompareF(KCanHandleException) && 0 == argvalue.CompareF(KTrue))
       {
           iPassOnException = ETrue;
       }
#endif //FEATURE_WEB_BROWSABILITY
    }
}
TInt CPlatformFlashEngine::GetIntFromDesc(const TDesC& aDesc)
{
	const TInt len = aDesc.Length();
	TInt ret=0;
	TInt j;
	TInt digit;

	for(TInt i=0; i<len; i++)
	{
		digit=(aDesc[i]);
		digit-=KAsciiZero;
		for(j=0;j<(len-i-1);j++)
		{
			digit*=10;
		}
		ret+=digit;
	}
	return ret;
}
void CPlatformFlashEngine::RecreateBitmapL(const TRect& aRect)
{
	iIsInitialized = EFalse;

	iRect.xmin = 0; //aRect.iTl.iX;
	iRect.ymin = 0; //aRect.iTl.iY;
	iRect.xmax = aRect.Width(); // .iBr.iX;
	iRect.ymax = aRect.Height(); //iBr.iY - aRect.iTl.iY;

	iFrameBufferSize = aRect.Size();

	if(iWindowMode == EWindow)
	{
       	RecreateBitmapsL(iFrameBufferSize);
	}

	if (iMMObject)
	{
		FI_Rect fiRect;
		fiRect.xmin = iRect.xmin;
		fiRect.ymin = iRect.ymin;
		fiRect.xmax = iRect.xmax;
		fiRect.ymax = iRect.ymax;


		// must do these two commands in appropriate order based on increasing
		// or decreasing display rect size, otherwise error checks fail.
	    if(iFiObject.FI_SetFrameBuffer( NULL, (TUint16)iFrameBufferSize.iWidth, (TUint16)iFrameBufferSize.iHeight, FrameBufferPitch(), FrameBufferDisplayFormat()) == -1)
   		{
		    //invalid frame buffer
            /*
            if(iFlashUI)
		    {
		        iFlashUI->NotifyClientError(EInvalidConfigError, ETrue, ETrue);
		    }
            */
            MUserNotiferIf* userNotifierIf = iFlashClientIf->GetUserNotifierIf();
   		    if(userNotifierIf)
   		        userNotifierIf->NotifyClientError(EInvalidConfigError, ETrue, ETrue);
		}

	    if(iFiObject.FI_SetDisplayRect(&fiRect) == -1)
   		{
		  //invalid frame buffer
            /*
            if(iFlashUI)
		    {
		        iFlashUI->NotifyClientError(EInvalidConfigError, ETrue, ETrue);
		    }
            */
            MUserNotiferIf* userNotifierIf = iFlashClientIf->GetUserNotifierIf();
   		    if(userNotifierIf)
   		     userNotifierIf->NotifyClientError(EInvalidConfigError, ETrue, ETrue);
		}
	}

	iIsInitialized = ETrue;
}


#ifndef USE_SYNC_MSO
void CPlatformFlashEngine::NotifyNumberOfItemsInQueue(TInt aNumItemsInQueue)
{
/*
  * In case of Shared Object, and when Browser wants to store COOKIES, need to add if(iBrowserPluginActive)
  */
	//if(!iBrowserPluginActive)
    if(eStandAlone==iExecutionMode)
		{
		iFlashClientIf->NotifyShutdownCountdown(aNumItemsInQueue);
		}
}

#endif // USE_SYNC_MSO

void CPlatformFlashEngine::DestroyPlayer()
{
    // iHttpEngine & iLocalHttpEngine & iFileEngine call HandleRequestFailed() 
	// to notify the core player 
    // that the outstanding requests (if any) have been cancelled. 
    // Hence we need this before the core player is destroyed.
	// -> No FI Calls incase of RTMPT close
    iSwfInDestruction = ETrue;
	if(iHttpEngine)
	{
		iHttpEngine->PrepareToExit();
		iHttpEngine->CloseAllTransactions();
	}
	
    if (iLocalHttpEngine)  // used for local IP connection ("localhost" & 127.0.0.1)
    {
    	iLocalHttpEngine->PrepareToExit();
    	iLocalHttpEngine->CloseAllTransactions();
    }

	if(iFileEngine)
	{
		iFileEngine->CancelAllRequests();
	}

    /*****************************************************************************
    NOTE:December 08, 2007: This should never be called
        short* aErr = iFiObject.FI_GetInterruptVariable();
    	if(aErr !=NULL)
    	{

         	  //when flash player is in play state and browser page is getting
    		  //closed then possible that player in some state which will
    		  //cause crash, so before calling destroyplayer
    		  //set interrupt variable
    		  //eroom note:
    		  //------------

    		  //Player shutdown should be a controlled process. Basically,
    		  //FI_DestroyPlayer shouldn't be called while a thread is running inside DoPlay function of the player.
    		  //The host must wait for the DoPlay to finish,
    		  //control returns to the host, before calling FI_DestroyPlayer.
    		  //You can speedup DoPlay return, by calling FI_GetInterruptVariable,
    		  // (which returns a pointer to the interrupt variable) then set the value of the
    		  // variable to none zero. It is basically a watch dog variable.
    		  //Do you have DoPlay() running on a timer or a while loop?
    	 	  //Itis good to shutdown the timer, and breakout of the loop, That will
    		  //prevent the code from re-entering DoPlay() in the next round.
    	      //It should be safe to call FI_DestroyPlayer() after the above steps.
    		  //---------------------

    		  *aErr= 3;

    	 	  //iFiObject.FI_SetInterruptVariable(aErr);
    	}
    *****************************************************************************/


	THXVDCmdArg arg;
	EngineDispatchHXCommand(EHXVDCmdStop, arg);

	if( iMMObject )
	{
		iFiObject.FI_DestroyPlayer();
		iMMObject = NULL;
		// once we are out of FI_DestroyPlayer(), the player would have issued all the 
		// RTMTP "/close" requests and the ACK would have been received. 
	}
	//Fix for HIIN-857FWY:Remove Information of all Streams Associated with previous CorePlayer Instance	
	//as the CorePlayer has been destroyed at this point.
	DestroyStreamBuffers();
	

	if (iHttpEngine)   // used for remote IP connections
	{
        iHttpEngine->ResetEngine();
	}
	
	if(iLocalHttpEngine)
	{
        iLocalHttpEngine->ResetEngine();
	}

#ifdef FEATURE_XML_SOCKET
	if(iSocketEngine) //safe to access directly..
	{
		iSocketEngine->ResetEngine();
	}
#endif //FEATURE_XML_SOCKET

	if(iImageConverter)
	{
		iImageConverter->Reset();
	}

	// Notify the Shared Objects after the player is destroyed
	// in case FI_DestroyPlayer triggers another SharedObject request.
	
#ifndef USE_SYNC_MSO
	if(iShObjEngine)
	{
		iShObjEngine->MovieClosed();
	}
#endif //USE_SYNC_MSO

	CQueuedSILaunch* siLaunch;

	// flush the launch queue
	while(!(iLaunchQueue.IsEmpty()))
	{
		siLaunch=iLaunchQueue.First();
		iLaunchQueue.Remove(*siLaunch);
		delete siLaunch;
	}

    //unload ATS Library
#ifdef FEATURE_ATS_AUTOMATION
	if((iConfig.iMode & KPlayerInATSMode) && iXMLFlag)
	{
		if(iATSHandler)
		{
			iATSHandler->UnLoadATSLibrary();
		}
	}
#endif

          //fix for phone freeze on options->exit in sms
  //   UnlockBits(NULL);

}

void CPlatformFlashEngine::DestroyStreamBuffers()
	{
#ifdef FEATURE_FLV_MMC
		CBrowserURLRequestInfo* browserURLRequestInfo = NULL;
		for( TInt index =0 ; index < iNetBufArray.Count(); index++ )
		    {
		    browserURLRequestInfo = iNetBufArray[index];
		    if( browserURLRequestInfo )
		        {
				delete browserURLRequestInfo;
				browserURLRequestInfo = NULL;
		        }
		    }

		iNetBufArray.Reset();
		iNetBufArray.Close();
#else
		iNetBufArray.Reset();
		iNetBufArray.Close();
#endif //FEATURE_FLV_MMC	
	}

#ifdef FF_FLASHLITE_SCREENSAVER
TInt CPlatformFlashEngine::CheckFileValidityL(const TDesC& aFilename)
{
    CData* data = NULL;
    HBufC8* swfbuf = 0;
    TPtr8 bufptr(NULL,0);
    TInt length(0);
    RFile fileHandle;
    TInt err = fileHandle.Open(iFs, aFilename, EFileRead | EFileShareReadersOrWriters);


    if(err == KErrNone)
    {
        CleanupClosePushL(fileHandle);
        CContent* content = CContent::NewLC(fileHandle);
        TRAP(err, data = content->OpenContentL( ContentAccess::EExecute ));
        if ( err == KErrNone )
        {
            CleanupStack::PushL( data );
            TRAPD( sizeError, data->DataSizeL( length ) );
            if ( sizeError != KErrNone )
            {
                CleanupStack::PopAndDestroy( data );
                CleanupStack::PopAndDestroy( content ); // content
                CleanupStack::PopAndDestroy( &fileHandle );
                return sizeError;
            }
            swfbuf = HBufC8::NewLC(length + 1);
            bufptr.Set(swfbuf->Des());
            data->Read(bufptr);

            if (iPlayerStaticHeap == NULL)
            {
                iPlayerStaticHeap = (TAny*)User::AllocL(iConfig.iStaticHeapSize);
                User::LeaveIfNull(iPlayerStaticHeap);
            }
            TInt isValid;
            if(length > (iConfig.iStaticHeapSize + iPlayerDynamicHeapMaxSize))
	            {
                err = KErrNoMemory;
	            }
			if( err == KErrNone )
				{
	//This is a hack and will be removed when the prototype of FI_CheckSWFDataBufferValidity is changed by Adobe
	//to FI_CheckSWFDataBufferValidity (const unsigned char* swfBuffer, unsigned long bufferLength,void* memoryPool,unsigned long poolSize);
	            unsigned short poolSize ;
	            if(iPlayerStaticHeapSize > 0xffff)
	                {
	                poolSize = 0xffff;
	                }
	            else
	                {
	                poolSize = iPlayerStaticHeapSize;
	                }
	            isValid = iFiObject.FI_CheckSWFDataBufferValidity(bufptr.PtrZ(),length,
	                                            iPlayerStaticHeap, /*iConfig.iStaticHeapSize*/poolSize);
	            if(isValid == 1)
		            {
	                err = KErrNone;
		            }
	            else if( isValid == -1 )
		            {
	                err = KErrNoMemory;
		            }
	            else
		            {
	                err = KErrCorrupt;
		            }
				}
            CleanupStack::PopAndDestroy( swfbuf);
            CleanupStack::PopAndDestroy( data );
        }
        CleanupStack::PopAndDestroy( content );
        CleanupStack::PopAndDestroy( &fileHandle );
    }
    return err;
}
#endif //FF_FLASHLITE_SCREENSAVER    

void CPlatformFlashEngine::CreateCharacterConverterL()
{
	if ( iCharacterConverter )
	{
		return;
	}

	CCnvCharacterSetConverter* characterConverter = CCnvCharacterSetConverter::NewL();
	CleanupStack::PushL(characterConverter);

	if ( characterConverter->PrepareToConvertToOrFromL( KCharacterSetIdentifierCodePage1252, iFs )
		!= CCnvCharacterSetConverter::EAvailable )
	{
		User::Leave ( KErrNotSupported );
	}
	CleanupStack::Pop(characterConverter);
	iCharacterConverter = characterConverter;
	iCurrentCodePage = KCharacterSetIdentifierCodePage1252;
}

void CPlatformFlashEngine::ChangeCodePageL(TUint aCodePage)
{
	if (iCharacterConverter && (iCurrentCodePage != aCodePage))
	{
		iCharacterConverter->PrepareToConvertToOrFromL(aCodePage, iFs);
		iCurrentCodePage = aCodePage;
	}
}

HBufC* CPlatformFlashEngine::CreateEpocStringLC( const char* aStr, int aLength )
{
	HBufC* pBuf= CreateEpocStringL(aStr,aLength);

	CleanupStack::PushL(pBuf);

	return pBuf;
}

HBufC* CPlatformFlashEngine::CreateEpocStringL( const char* aStr, int aLength )
{
	HBufC* pBuf=CreateEpocString(aStr, aLength);

	User::LeaveIfNull(pBuf);

	return pBuf;
}

HBufC* CPlatformFlashEngine::CreateEpocString( const char* aStr, int aLength )
{
	HBufC* pResult=NULL;

	if( iCharacterConverter )
	{

		TPtrC8 ptr( (TUint8*)aStr, aLength );

		pResult = HBufC::New( aLength );

		if(pResult)
		{

			TPtr ptrResult( pResult->Des() );

			TInt state = CCnvCharacterSetConverter::KStateDefault;
			TInt err=iCharacterConverter->ConvertToUnicode( ptrResult, ptr, state );
			if(err)
			{
				delete pResult;
				pResult=NULL;
			}
		}
	}

	return pResult;
}

void  CPlatformFlashEngine::CreateFlashStringL( char* buf,const TDesC& aStr )
{
	User::LeaveIfNull( iCharacterConverter );
	TInt maxlen = aStr.Length() << 1;

	TPtr8 ptrResult( (TUint8*)buf, maxlen );

	User::LeaveIfError( iCharacterConverter->ConvertFromUnicode ( ptrResult, aStr ) );

	//pResult[buf.Length()] = 0;

	buf[aStr.Length()] = 0;

	return ;

}

void CPlatformFlashEngine::CreateFlashString(char* buf, const TDesC& aStr )
{
	TRAP_IGNORE(CreateFlashStringL(buf,aStr ) );

}

char* CPlatformFlashEngine::CreateFlashStringLC( const TDesC& aStr )
{
	User::LeaveIfNull( iCharacterConverter );

	TInt maxlen = aStr.Length() << 1;
	char* pResult = new(ELeave) char[maxlen + 1];
	CleanupStack::PushL ( pResult );

	TPtr8 ptrResult( (TUint8*)pResult, maxlen );

	User::LeaveIfError( iCharacterConverter->ConvertFromUnicode ( ptrResult, aStr ) );

	pResult[ptrResult.Length()] = 0;

	return pResult;
}


char* CPlatformFlashEngine::CreateFlashStringL( const TDesC& aStr )
{
	char* pResult = CreateFlashStringLC(aStr);

	CleanupStack::Pop(pResult);

	return pResult;
}

char* CPlatformFlashEngine::CreateFlashString( const TDesC& aStr )
{
	char* pResult = NULL;
	TRAP_IGNORE( pResult = CreateFlashStringL( aStr ) );
	return pResult;
}

void CPlatformFlashEngine::GetLanguageInfo(TInt &aSymbianCodepage, FI_CodePage &aFlashCodepage)
{
	aSymbianCodepage = KCharacterSetIdentifierCodePage1252;
	aFlashCodepage = FI_Latin1_CodePage;

#ifdef QA_OVERRIDE_PHONE_LANGUAGE
	TLanguage lang = ELangRussian;
	//TLanguage lang = ELangEstonian;
	//TLanguage lang = ELangGreek;
	//TLanguage lang = ELangTurkish;
#else
	TLanguage lang = User::Language();
#endif
	switch (lang)
	{
		case ELangAfrikaans:
		case ELangAlbanian:
		case ELangAmerican:
		case ELangApacEnglish:
		case ELangApacIndonesian:
		case ELangApacMalay:
		case ELangAustralian:
		case ELangAustrian:
		case ELangBasque:
		case ELangBelgianFlemish:
		case ELangBelgianFrench:
		case ELangBrazilianPortuguese:
		case ELangCanadianEnglish:
		case ELangCanadianFrench:
		case ELangCatalan:
		case ELangDanish:
		case ELangDutch:
		case ELangEnglish:
		case ELangFinlandSwedish:
		case ELangFinnish:
		case ELangFrench:
		case ELangGalician:
		case ELangGerman:
		case ELangIcelandic:
		case ELangIndonesian:
		case ELangInternationalEnglish:
		case ELangInternationalFrench:
		case ELangInternationalSpanish:
		case ELangIrish:
		case ELangItalian:
		case ELangLatinAmericanSpanish:
		case ELangMalay:
		case ELangNewZealand:
		case ELangNorwegian:
		case ELangPortuguese:
		case ELangSouthAfricanEnglish:
		case ELangSpanish:
		case ELangSwahili:
		case ELangSwedish:
		case ELangSwissFrench:
		case ELangSwissGerman:
		case ELangSwissItalian:
		case ELangTagalog:
		case ELangWelsh:
			aSymbianCodepage = KCharacterSetIdentifierCodePage1252;
			aFlashCodepage = FI_Latin1_CodePage;
			break;

		case ELangTurkish:
		case ELangCyprusTurkish:
			aSymbianCodepage = /*KCharacterSetIdentifierIso88599*/0x100059D9;
			aFlashCodepage = FI_Turkish_CodePage;
			break;

		case ELangEstonian:
		case ELangLatvian:
		case ELangLithuanian:
			aSymbianCodepage = /*KCharacterSetIdentifierIso88594*/0x100059DA;
			aFlashCodepage = FI_Latin4_CodePage;
			break;

		case ELangBelarussian:
		case ELangBulgarian:
		case ELangMacedonian:
		case ELangRussian:
		case ELangUkrainian:
			aSymbianCodepage = /*KCharacterSetIdentifierIso88595*/0x100059D7;
			aFlashCodepage = FI_Cyrillic_CodePage;
			break;

		case ELangCroatian:
		case ELangCzech:
		case ELangHungarian:
		case ELangPolish:
		case ELangRomanian:
		case ELangSerbian:
		case ELangSlovak:
		case ELangSlovenian:
			aSymbianCodepage = /*KCharacterSetIdentifierIso88592*/0x100059D6;
			aFlashCodepage = FI_Latin2_CodePage;
			break;

		case ELangHongKongChinese:
		case ELangHongKongEnglish:
		case ELangTaiwanChinese:
		case ELangTaiwanEnglish:
		// Some Series60 APAC variants report special IDs for
		// English. In these cases, we'll set the code page to Big5 so that
		// both English and Chinese content displays properly.
			aSymbianCodepage = KCharacterSetIdentifierBig5;
			aFlashCodepage = FI_TraditionalChinese_Big5_CodePage;
			break;

		case ELangPrcChinese:
		case ELangPrcEnglish:
			aSymbianCodepage = KCharacterSetIdentifierGbk;
			aFlashCodepage = FI_SimplifiedChinese_GBK_CodePage;
			break;

		case ELangJapanese:
		case ELangJapaneseEnglish:
			aSymbianCodepage = KCharacterSetIdentifierShiftJis;
			aFlashCodepage = FI_Japanese_ShiftJIS_CodePage;
			break;

		case ELangGreek:
		case ELangCyprusGreek:
			aSymbianCodepage = /*KCharacterSetIdentifierIso88597*/0x100059D8;
			aFlashCodepage = FI_Greek_CodePage;
			break;

		case ELangKorean:
			aSymbianCodepage = KCharacterSetIdentifierEUCKR;
			aFlashCodepage = FI_Korean_UHC_CodePage;
			break;

		case ELangUrdu:
		case ELangArabic:
			aSymbianCodepage = 0x101F8548;
			aFlashCodepage = FI_Arabic_CodePage;
			break;

		case ELangHebrew:
			aSymbianCodepage = 0x101F8547;
			aFlashCodepage = FI_Hebrew_CodePage;
			break;

		case ELangThai:
		case ELangThaiEnglish:
			aSymbianCodepage = KCharacterSetIdentifierTis620;
			aFlashCodepage = FI_Thai_CodePage;
			break;

		case ELangAmharic:
		case ELangArmenian:
		case ELangBengali:
		case ELangBurmese:
		case ELangFarsi:
		case ELangGeorgian:
		case ELangGujarati:
		case ELangHindi:
		case ELangKannada:
		case ELangKazakh:
		case ELangKhmer:
		case ELangLao:
		case ELangMalayalam:
		case ELangMarathi:
		case ELangMoldavian:
		case ELangMongolian:
		case ELangNorwegianNynorsk:
		case ELangPunjabi:
		case ELangScotsGaelic:
		case ELangSinhalese:
		case ELangSomali:
		case ELangTamil:
		case ELangTelugu:
		case ELangTibetan:
		case ELangTigrinya:
		case ELangTurkmen:
		case ELangVietnamese:
		case ELangZulu:
			aSymbianCodepage = KCharacterSetIdentifierCodePage1252;
			aFlashCodepage = FI_Latin1_CodePage;
			break;

		default:
			aSymbianCodepage = KCharacterSetIdentifierCodePage1252;
			aFlashCodepage = FI_Latin1_CodePage;
			break;
	}

}

TBool CPlatformFlashEngine::CreatePlayerL()
{
	SI_Fncs siFunctions;

	FlashMemSet(&siFunctions, 0, sizeof(siFunctions));

	siFunctions.sizeof_SI_Fncs = sizeof(SI_Fncs);

	siFunctions.SIVersion = 1;

	SI_FlashPlayerControlFncs	siFlashPlayerControl;
	FlashMemSet(&siFlashPlayerControl, 0, sizeof(siFlashPlayerControl));
	siFunctions.pSIFlashPlayerControl = &siFlashPlayerControl;

	siFlashPlayerControl.pFncSI_Malloc						= SI_Interface::SI_Malloc;
	siFlashPlayerControl.pFncSI_Free						= SI_Interface::SI_Free;
	siFlashPlayerControl.pFncSI_UpdateFrameInterval			= SI_Interface::SI_UpdateFrameInterval;
	siFlashPlayerControl.pFncSI_GetMaxAvailablePlayerMemory	= SI_Interface::SI_GetMaxAvailablePlayerMemory;
#ifdef FEATURE_BG_TRANSPARENCY
	siFlashPlayerControl.pFncSI_UpdateBackgroundRegion		= SI_Interface::SI_UpdateBackgroundRegion;
#endif //FEATURE_BG_TRANSPARENCY

#ifdef FEATURE_COMPUTE_STACK // provide stack base address compute implementation
	siFlashPlayerControl.pFncSI_ComputeStackBase = SI_Interface::SI_ComputeStackBase;
#endif
	
	// frame buffer locking/access
	SI_FrameBufferFncs			siFrameBufferFncs;
	FlashMemSet(&siFrameBufferFncs, 0, sizeof(siFrameBufferFncs));
	siFunctions.pSIFrameBufferFncs = &siFrameBufferFncs;

	siFrameBufferFncs.pFncSI_GetLockedFrameBuffer		= SI_Interface::SI_GetLockedFrameBuffer;
	siFrameBufferFncs.pFncSI_UnlockFrameBuffer			= SI_Interface::SI_UnlockFrameBuffer;

#ifdef FEATURE_OPENVG
	//if(iOpenVgMode)
	
#ifdef ACHW
        siFrameBufferFncs.pFncSI_GetHardwareInterfaces     			= SI_Interface::SI_GetHardwareInterfaces;
        siFrameBufferFncs.pFncSI_eglGetDisplay             			= SI_Interface::SI_eglGetDisplay;
        siFrameBufferFncs.pFncSI_eglInitialize             			= SI_Interface::SI_eglInitialize;
        siFrameBufferFncs.pFncSI_eglTerminate              			= SI_Interface::SI_eglTerminate;
        siFrameBufferFncs.pFncSI_eglCreateContext          			= SI_Interface::SI_eglCreateContext;
        siFrameBufferFncs.pFncSI_eglChooseConfig           			= SI_Interface::SI_eglChooseConfig;
        siFrameBufferFncs.pFncSI_eglCreatePbufferSurface   			= SI_Interface::SI_eglCreatePbufferSurface;
        siFrameBufferFncs.pFncSI_eglCreateNativePixmapSurface 		= SI_Interface::SI_eglCreateNativePixmapSurface;
        siFrameBufferFncs.pFncSI_eglCreatePbufferFromClientBuffer 	= SI_Interface::SI_eglCreatePbufferFromClientBuffer;
        siFrameBufferFncs.pFncSI_eglMakeCurrent            			= SI_Interface::SI_eglMakeCurrent;
        siFrameBufferFncs.pFncSI_eglDestroyContext         			= SI_Interface::SI_eglDestroyContext;
        siFrameBufferFncs.pFncSI_eglDestroySurface         			= SI_Interface::SI_eglDestroySurface;
        siFrameBufferFncs.pFncSI_eglGetConfigAttrib        			= SI_Interface::SI_eglGetConfigAttrib;
        siFrameBufferFncs.pFncSI_eglCopySurfaceToFrameBuffer 		= SI_Interface::SI_eglCopySurfaceToFrameBuffer;
#endif

        //OpenVG functions
        SI_OpenVGFncs          siOVGFncs;
        FlashMemSet(&siOVGFncs, 0, sizeof(siOVGFncs));
        siFunctions.pSIOpenVGFncs = &siOVGFncs;
    
        siOVGFncs.pFncSI_vgAppendPath = SI_Interface::SI_ovgAppendPath;
        siOVGFncs.pFncSI_vgAppendPathData = SI_Interface::SI_ovgAppendPathData;
        siOVGFncs.pFncSI_vgSeti = SI_Interface::SI_ovgSeti;
        siOVGFncs.pFncSI_vgClear = SI_Interface::SI_ovgClear;
        siOVGFncs.pFncSI_vgClearImage = SI_Interface::SI_ovgClearImage;
        siOVGFncs.pFncSI_vgClearPath = SI_Interface::SI_ovgClearPath;
        siOVGFncs.pFncSI_vgCreateImage = SI_Interface::SI_ovgCreateImage;
        siOVGFncs.pFncSI_vgCreateMaskLayer = SI_Interface::SI_ovgCreateMaskLayer;
        siOVGFncs.pFncSI_vgCreatePaint = SI_Interface::SI_ovgCreatePaint;
        siOVGFncs.pFncSI_vgCreatePath = SI_Interface::SI_ovgCreatePath;
        siOVGFncs.pFncSI_vgCopyMask = SI_Interface::SI_ovgCopyMask;
        siOVGFncs.pFncSI_vgDestroyImage = SI_Interface::SI_ovgDestroyImage;
        siOVGFncs.pFncSI_vgDestroyMaskLayer = SI_Interface::SI_ovgDestroyMaskLayer;
        siOVGFncs.pFncSI_vgDestroyPaint = SI_Interface::SI_ovgDestroyPaint;
        siOVGFncs.pFncSI_vgDestroyPath = SI_Interface::SI_ovgDestroyPath;
        siOVGFncs.pFncSI_vgDrawImage = SI_Interface::SI_ovgDrawImage;
        siOVGFncs.pFncSI_vgDrawPath = SI_Interface::SI_ovgDrawPath;
        siOVGFncs.pFncSI_vgFinish = SI_Interface::SI_ovgFinish;
        siOVGFncs.pFncSI_vgFlush = SI_Interface::SI_ovgFlush;
        siOVGFncs.pFncSI_vgGetError = SI_Interface::SI_ovgGetError;
        siOVGFncs.pFncSI_vgGetMatrix = SI_Interface::SI_ovgGetMatrix;
        siOVGFncs.pFncSI_vgGetParameteri = SI_Interface::SI_ovgGetParameteri;
        siOVGFncs.pFncSI_vgGeti = SI_Interface::SI_ovgGeti;
        siOVGFncs.pFncSI_vgImageSubData = SI_Interface::SI_ovgImageSubData;
        siOVGFncs.pFncSI_vgInterpolatePath = SI_Interface::SI_ovgInterpolatePath;
        siOVGFncs.pFncSI_vgLoadIdentity = SI_Interface::SI_ovgLoadIdentity;
        siOVGFncs.pFncSI_vgLoadMatrix = SI_Interface::SI_ovgLoadMatrix;
        siOVGFncs.pFncSI_vgMask = SI_Interface::SI_ovgMask;
        siOVGFncs.pFncSI_vgModifyPathCoords = SI_Interface::SI_ovgModifyPathCoords;
        siOVGFncs.pFncSI_vgMultMatrix = SI_Interface::SI_ovgMultMatrix;
        siOVGFncs.pFncSI_vgPaintPattern = SI_Interface::SI_ovgPaintPattern;
        siOVGFncs.pFncSI_vgPathBounds = SI_Interface::SI_ovgPathBounds;
        siOVGFncs.pFncSI_vgRenderToMask = SI_Interface::SI_ovgRenderToMask;
        siOVGFncs.pFncSI_vgScale = SI_Interface::SI_ovgScale;
        siOVGFncs.pFncSI_vgSetColor = SI_Interface::SI_ovgSetColor;
        siOVGFncs.pFncSI_vgSetPaint = SI_Interface::SI_ovgSetPaint;
        siOVGFncs.pFncSI_vgSetParameterfv = SI_Interface::SI_ovgSetParameterfv;
        siOVGFncs.pFncSI_vgSetParameteri = SI_Interface::SI_ovgSetParameteri;
        siOVGFncs.pFncSI_vgSetf = SI_Interface::SI_ovgSetf;
        siOVGFncs.pFncSI_vgSetfv = SI_Interface::SI_ovgSetfv;
        siOVGFncs.pFncSI_vgSetiv = SI_Interface::SI_ovgSetiv;
        siOVGFncs.pFncSI_vgTransformPath = SI_Interface::SI_ovgTransformPath;
        siOVGFncs.pFncSI_vgTranslate = SI_Interface::SI_ovgTranslate;
        siOVGFncs.pFncSI_vgChildImage = SI_Interface::SI_ovgChildImage;
	
#endif // FEATURE_OPENVG

	// device text rendering support functions
	SI_TextRenderingFncs		siTextRenderingFncs;
	FlashMemSet(&siTextRenderingFncs, 0, sizeof(siTextRenderingFncs));
	siFunctions.pSITextRenderingFncs = &siTextRenderingFncs;

	siTextRenderingFncs.pFncSI_BeginTextDraw			= SI_Interface::SI_BeginTextDraw;
	siTextRenderingFncs.pFncSI_DeviceTextOut			= SI_Interface::SI_DeviceTextOut;
	siTextRenderingFncs.pFncSI_ComplexLineBreak			= SI_Interface::SI_ComplexLineBreak;
	siTextRenderingFncs.pFncSI_EndTextDraw				= SI_Interface::SI_EndTextDraw;
	siTextRenderingFncs.pFncSI_GetBitmapInfo			= SI_Interface::SI_GetBitmapInfo;
	siTextRenderingFncs.pFncSI_GetCharacterInfo			= SI_Interface::SI_GetCharacterInfo;
	siTextRenderingFncs.pFncSI_GetFontMetrics			= SI_Interface::SI_GetFontMetrics;
	siTextRenderingFncs.pFncSI_GetTextWidth				= SI_Interface::SI_GetTextWidth;
	siTextRenderingFncs.pFncSI_CreateFont				= SI_Interface::SI_CreateFont;
	siTextRenderingFncs.pFncSI_DestroyFont				= SI_Interface::SI_DestroyFont;
	siTextRenderingFncs.pFncSI_SelectFont				= SI_Interface::SI_SelectFont;
	
	// Font Source functions
	SI_FontSourceFncs fontSourceFns;
	FlashMemSet(&fontSourceFns, 0, sizeof(fontSourceFns));
	fontSourceFns.pFncSI_NewFontSource = SI_Interface::SI_NewFontSource;
	fontSourceFns.pFncSI_FreeFontSource = SI_Interface::SI_FreeFontSource;
	siFunctions.pSIFontSourceFncs = &fontSourceFns;
	

#ifdef FEATURE_OPENVG
        siTextRenderingFncs.pFncSI_GetLockedTextBuffer = SI_Interface::SI_GetLockedTextBuffer;
        siTextRenderingFncs.pFncSI_UnlockTextBuffer    = SI_Interface::SI_UnlockTextBuffer;
#endif
	

//#ifdef FEATURE_MULTITOUCH
    SI_MultitouchFncs mtFuncs;

    mtFuncs.pFncSI_InitMultitouch = NULL;
    mtFuncs.pFncSI_GetSupportedGestures = SI_Interface::SI_GetSupportedGestures;
    mtFuncs.pFncSI_SetMultitouchInputMode = NULL;
    siFunctions.pSIMultitouchFncs = &mtFuncs; 
//#endif
    
	// character encoding support functions
	SI_CharacterEncodingFncs		siCharacterEncodingFncs;
	FlashMemSet(&siCharacterEncodingFncs, 0, sizeof(siCharacterEncodingFncs));
	siFunctions.pSICharacterEncodingFncs = &siCharacterEncodingFncs;

	siCharacterEncodingFncs.pFncSI_ConvertCStringToUTF16String = SI_Interface::SI_ConvertCStringToUTF16String;
	siCharacterEncodingFncs.pFncSI_ConvertUTF16StringToCString = SI_Interface::SI_ConvertUTF16StringToCString;

	// Inline text entry
	SI_InlineTextEntryFncs			siInlineTextEntryFncs;
	FlashMemSet(&siInlineTextEntryFncs, 0, sizeof(siInlineTextEntryFncs));
	siFunctions.pSIInlineTextEntryFncs = &siInlineTextEntryFncs;

#ifdef FEATURE_INLINE_TEXT_ENTRY
	siInlineTextEntryFncs.pFncSI_EnableIME				= SI_Interface::SI_EnableIME;
	siInlineTextEntryFncs.pFncSI_DisableIME				= SI_Interface::SI_DisableIME;
	siInlineTextEntryFncs.pFncSI_DrawFullScreenInputModeIndicator = SI_Interface::SI_DrawFullScreenInputModeIndicator;
#endif // FEATURE_INLINE_TEXT_ENTRY

	SI_ErrorNotifyFncs			siFlashLiteErrorNotifyFncs;
	FlashMemSet(&siFlashLiteErrorNotifyFncs, 0, sizeof(siFlashLiteErrorNotifyFncs));
	siFunctions.pSIFlashLiteErrorNotifyFncs = &siFlashLiteErrorNotifyFncs;

	siFlashLiteErrorNotifyFncs.pFncSI_NotifyFlashLiteError	= SI_Interface::SI_NotifyError;
	SI_SecurityFncs siSecurityFncs;
	FlashMemSet(&siSecurityFncs,0,sizeof(siSecurityFncs));
	siFunctions.pSISecurityFncs = &siSecurityFncs;
	siSecurityFncs.pFncSI_showLocalSecurityDialog = SI_Interface::SI_ShowLocalSecurityDialog;

	SI_SoundControlFncs	siSoundControlFncs;
	FlashMemSet(&siSoundControlFncs, 0, sizeof(siSoundControlFncs));

	if (iConfig.iMode & KSupportSound)
	{
		siFunctions.pSISoundControlFncs = &siSoundControlFncs;
		// event sound functions
		siSoundControlFncs.pFncSI_CacheSound				= SI_Interface::SI_CacheSound;
		siSoundControlFncs.pFncSI_PlayCachedSound			= SI_Interface::SI_PlayCachedSound;
		siSoundControlFncs.pFncSI_FreeCachedSound			= SI_Interface::SI_FreeCachedSound;
		siSoundControlFncs.pFncSI_PlaySound					= SI_Interface::SI_PlaySound;
		siSoundControlFncs.pFncSI_StopSound					= SI_Interface::SI_StopSound;
		siSoundControlFncs.pFncSI_PauseSound				= SI_Interface::SI_PauseSound;
		siSoundControlFncs.pFncSI_ResumeSound				= SI_Interface::SI_ResumeSound;

		// streaming sound functions
		siSoundControlFncs.pFncSI_CloseStreamSoundDevice	= SI_Interface::SI_CloseStreamSoundDevice;
		siSoundControlFncs.pFncSI_CreateSoundDecompressor	= SI_Interface::SI_CreateSoundDecompressor;
		siSoundControlFncs.pFncSI_DecompressSound			= SI_Interface::SI_DecompressSound;
		siSoundControlFncs.pFncSI_DestroySoundDecompressor	= SI_Interface::SI_DestroySoundDecompressor;
		siSoundControlFncs.pFncSI_OpenStreamSoundDevice		= SI_Interface::SI_OpenStreamSoundDevice;
		siSoundControlFncs.pFncSI_PlayStreamSoundBuffer		= SI_Interface::SI_PlayStreamSoundBuffer;
		siSoundControlFncs.pFncSI_SetupSoundDecompressor	= SI_Interface::SI_SetupSoundDecompressor;
	}
	else
	{
		siFunctions.pSISoundControlFncs = NULL;
	}

	SI_VideoFncs siVideoFncs;
	FlashMemSet( &siVideoFncs, 0, sizeof(siVideoFncs) );

#ifdef FEATURE_VIDEO
	SI_FLVFncs siFLVFncs;
	FlashMemSet( &siFLVFncs, 0, sizeof(siFLVFncs) );
#endif

#ifdef FEATURE_VIDEO_DLL
	SI_NativeVideoFncs siNativeVideoFncs;
	memset( &siNativeVideoFncs, 0, sizeof(siNativeVideoFncs) );
#endif //FEATURE_VIDEO_DLL
	if (iConfig.iMode & KSupportVideo)
	{
		siFunctions.pSIVideoFncs = &siVideoFncs;
		siVideoFncs.pFncSI_CreateVideo						= SI_Interface::SI_CreateVideo;
		siVideoFncs.pFncSI_PlayVideo						= SI_Interface::SI_PlayVideo;
		siVideoFncs.pFncSI_CloseVideo						= SI_Interface::SI_CloseVideo;
		siVideoFncs.pFncSI_StopVideo						= SI_Interface::SI_StopVideo;
		siVideoFncs.pFncSI_PauseVideo						= SI_Interface::SI_PauseVideo;
		siVideoFncs.pFncSI_ResumeVideo						= SI_Interface::SI_ResumeVideo;
		siVideoFncs.pFncSI_GetVideoMethods					= SI_Interface::SI_GetVideoMethods;
		siVideoFncs.pFncSI_ProcessVideoMethod				= SI_Interface::SI_ProcessVideoMethod;
		siVideoFncs.pFncSI_DestroyVideo						= SI_Interface::SI_DestroyVideo;
		siVideoFncs.pFncSI_SetVideoRect						= SI_Interface::SI_SetVideoRect;
		
		//For device video overlay
        siVideoFncs.pFncSI_GetVideoSize                     = SI_Interface::SI_GetVideoSize;
        //siVideoFncs.pFncSI_GetVideoBits                     = SI_Interface::SI_GetVideoBits;        
        
#ifdef FEATURE_VIDEO_DLL
		siFunctions.pSINativeVideoFncs = &siNativeVideoFncs;
		siNativeVideoFncs.pFncSI_CreateDecompressor			= SI_Interface::SI_NativeVideoCreateDecompressor;
		siNativeVideoFncs.pFncSI_DestroyDecompressor		= SI_Interface::SI_NativeVideoDestroyDecompressor;
#endif //FEATURE_VIDEO_DLL

#ifdef FEATURE_VIDEO
		siFunctions.pSIFLVFncs = &siFLVFncs;
		siFLVFncs.pFncSI_FLVStatus							= SI_Interface::SI_FLVStatus;
#endif //FEATURE_VIDEO
	}
	else
	{
		siFunctions.pSIVideoFncs = NULL;
	}

	// misc functions
	SI_KeyInputFncs				siKeyInputFncs;
	FlashMemSet(&siKeyInputFncs, 0, sizeof(siKeyInputFncs));
	siFunctions.pSIKeyInputFncs = &siKeyInputFncs;
	siKeyInputFncs.pFncSI_GetInputText				= SI_Interface::SI_GetInputText;

	SI_DataAccessFncs			siDataAccessFncs;
	FlashMemSet(&siDataAccessFncs, 0, sizeof(siDataAccessFncs));
	siFunctions.pSIDataAccessFncs = &siDataAccessFncs;

	if (iConfig.iMode & KSupportSharedObject)
	{
#ifndef USE_SYNC_MSO
		siDataAccessFncs.pFncSI_SetPersistentData			= SI_Interface::SI_SetPersistentData;
		siDataAccessFncs.pFncSI_GetPersistentData			= SI_Interface::SI_GetPersistentData;
		siDataAccessFncs.pFncSI_GetMaxPersistentStorage		= SI_Interface::SI_GetMaxPersistentStorage;

		siDataAccessFncs.pFncSI_GetPersistentDataSize		= SI_Interface::SI_GetPersistentDataSize;
		siDataAccessFncs.pFncSI_CancelSharedObjectRequest	= SI_Interface::SI_CancelSharedObjectRequest;
#else
		siDataAccessFncs.pFncSI_GetMaxPersistentStorage     = SI_Interface::SI_GetMaxPersistentStorage;
		
        siDataAccessFncs.pFncSI_GetPersistentDataSync       = SI_Interface::SI_GetPersistentDataSync;
        siDataAccessFncs.pFncSI_GetPersistentDataSizeSync   = SI_Interface::SI_GetPersistentDataSizeSync;
        siDataAccessFncs.pFncSI_SetPersistentDataSync       = SI_Interface::SI_SetPersistentDataSync;
#endif //USE_SYNC_MSO
        
#ifdef FEATURE_LOCAL_CONNECTION
		siDataAccessFncs.pFncSI_CreateSharedMemory          = SI_Interface::SI_CreateSharedMemory;
		siDataAccessFncs.pFncSI_DestroySharedMemory         = SI_Interface::SI_DestroySharedMemory;
		siDataAccessFncs.pFncSI_LockSharedMemory			= SI_Interface::SI_LockSharedMemory;
		siDataAccessFncs.pFncSI_UnlockSharedMemory          = SI_Interface::SI_UnLockSharedMemory;
#endif // FEATURE_LOCAL_CONNECTION

	}

	SI_URLAccessFncs			siURLAccessFncs;
	FlashMemSet(&siURLAccessFncs, 0, sizeof(siURLAccessFncs));
	siFunctions.pSIURLAccessFncs = &siURLAccessFncs;

	siURLAccessFncs.pFncSI_GetURL							= SI_Interface::SI_GetURL;

	if (iConfig.iMode & KSupportNetwork  || iConfig.iMode & KSupportLocalFile)
	{
		siURLAccessFncs.pFncSI_OpenURLStream				= SI_Interface::SI_OpenURLStream;
		siURLAccessFncs.pFncSI_LoadURLStreamBuffer			= SI_Interface::SI_LoadURLStreamBuffer;
		siURLAccessFncs.pFncSI_CancelURLStream				= SI_Interface::SI_CancelURLStream;
#ifdef FEATURE_FLV_MMC
		siURLAccessFncs.pFncSI_SeekURLStreamFLV				= SI_Interface::SI_SeekURLStreamFLV;
#ifdef FEATURE_HOST_SEEK_FLV
		siURLAccessFncs.pFncSI_FLVGetBytesLoaded			= SI_Interface::SI_FLVGetBytesLoaded;
#endif //FEATURE_HOST_SEEK_FLV - Sathya
		siURLAccessFncs.pFncSI_FLVGetTotalBytes             = SI_Interface::SI_FLVGetTotalBytes;
#endif //FEATURE_FLV_MMC
	}

	// fscommand support functions
	SI_DeviceControlFncs		siDeviceControlFncs;
	FlashMemSet(&siDeviceControlFncs, 0, sizeof(siDeviceControlFncs));
	siFunctions.pSIDeviceControlFncs = &siDeviceControlFncs;

	siDeviceControlFncs.pFncSI_DoFsCommand				= SI_Interface::SI_DoFsCommand;
	siDeviceControlFncs.pFncSI_GetBatteryLevel			= SI_Interface::SI_GetBatteryLevel;
	siDeviceControlFncs.pFncSI_GetDevice				= SI_Interface::SI_GetDevice;
	siDeviceControlFncs.pFncSI_GetDeviceCapabilities	= SI_Interface::SI_GetDeviceCapabilities;
	siDeviceControlFncs.pFncSI_GetDeviceID				= SI_Interface::SI_GetDeviceID;
	siDeviceControlFncs.pFncSI_GetLanguage				= SI_Interface::SI_GetLanguage;
	siDeviceControlFncs.pFncSI_GetMaxBatteryLevel		= SI_Interface::SI_GetMaxBatteryLevel;
	siDeviceControlFncs.pFncSI_GetMaxVolumeLevel		= SI_Interface::SI_GetMaxVolumeLevel;
	siDeviceControlFncs.pFncSI_GetPlatform				= SI_Interface::SI_GetPlatform;
	siDeviceControlFncs.pFncSI_GetPowerSource			= SI_Interface::SI_GetPowerSource;
	siDeviceControlFncs.pFncSI_GetUTCTimeStamp			= SI_Interface::SI_GetUTCTimeStamp;
	siDeviceControlFncs.pFncSI_ConvertUTCToLocalTime	= SI_Interface::SI_ConvertUTCToLocalTime;
	siDeviceControlFncs.pFncSI_ConvertLocalToUTCTime	= SI_Interface::SI_ConvertLocalToUTCTime;
	siDeviceControlFncs.pFncSI_FormatDate				= SI_Interface::SI_FormatDate;
	siDeviceControlFncs.pFncSI_FormatTimeOfDay			= SI_Interface::SI_FormatTimeOfDay;
	siDeviceControlFncs.pFncSI_GetVolumeLevel			= SI_Interface::SI_GetVolumeLevel;
	siDeviceControlFncs.pFncSI_Launch					= SI_Interface::SI_Launch;
	siDeviceControlFncs.pFncSI_QuitFlashLite			= SI_Interface::SI_QuitFlashLite;
	siDeviceControlFncs.pFncSI_SetFullScreen			= SI_Interface::SI_SetFullScreen;
#ifdef __FEATURE_OSK__
	siDeviceControlFncs.pFncSI_DisableKeypadCompatibilityMode           = SI_Interface::SI_DisableKeypadCompatibilityMode;
#endif // __FEATURE_OSK__
	siDeviceControlFncs.pFncSI_SetSoftkeys				= SI_Interface::SI_SetSoftkeys;
	siDeviceControlFncs.pFncSI_StartVibrate				= SI_Interface::SI_StartVibrate;
	siDeviceControlFncs.pFncSI_ResetSoftkeys			= SI_Interface::SI_ResetSoftkeys;
	siDeviceControlFncs.pFncSI_GetSoftkeyLocation		= SI_Interface::SI_GetSoftKeyLocation;
	siDeviceControlFncs.pFncSI_StopVibrate				= SI_Interface::SI_StopVibrate;
	siDeviceControlFncs.pFncSI_ExtendBacklightDuration	= SI_Interface::SI_ExtendBacklightDuration;
	siDeviceControlFncs.pFncSI_GetScreenInfo			= SI_Interface::SI_GetScreenInfo;
	siDeviceControlFncs.pFncSI_GetNetworkInfo			= SI_Interface::SI_GetNetworkInfo;
	siDeviceControlFncs.pFncSI_GetNetworkInfoString		= SI_Interface::SI_GetNetworkInfoString;
	siDeviceControlFncs.pFncSI_GetNumberOfSoftkeys		= SI_Interface::SI_GetNumberOfSoftkeys;
	siDeviceControlFncs.pFncSI_GetCallerInfo 			= SI_Interface::SI_GetCallerInfo;

	//Initialize socket functions
	SI_SocketFncs				siSocketFncs;
	FlashMemSet(&siSocketFncs, 0, sizeof(siSocketFncs));
	siFunctions.pSISocketFncs = &siSocketFncs;
#ifdef FEATURE_XML_SOCKET
	if (iConfig.iMode & KSupportNetwork)
	{
		siSocketFncs.pFncSI_OpenSocket					= SI_Interface::SI_OpenSocket;
		siSocketFncs.pFncSI_CloseSocket					= SI_Interface::SI_CloseSocket;
		siSocketFncs.pFncSI_SocketSend					= SI_Interface::SI_SocketSend;
	}
#endif //FEATURE_XML_SOCKET

#if defined(FEATURE_ACHW) && (ACHW_DRAWING_LIB == ACHW_DRAWING_LIB_IS_OPENGL_ES)
		SI_OpenGLESFncs siOpenGLESFncs;
		FlashMemSet(&siOpenGLESFncs, 0, sizeof(siOpenGLESFncs));
		siFunctions.pSIOpenGLESFncs = &siOpenGLESFncs;
		siOpenGLESFncs.pFncSI_glIsTexture     			= SI_Interface::SI_glIsTexture;
		siOpenGLESFncs.pFncSI_glGetError      			= SI_Interface::SI_glGetError;
		siOpenGLESFncs.pFncSI_glActiveTexture 			= SI_Interface::SI_glActiveTexture;
		siOpenGLESFncs.pFncSI_glAlphaFuncx    			= SI_Interface::SI_glAlphaFuncx;
		siOpenGLESFncs.pFncSI_glBindBuffer    			= SI_Interface::SI_glBindBuffer;
		siOpenGLESFncs.pFncSI_glBindTexture   			= SI_Interface::SI_glBindTexture;
		siOpenGLESFncs.pFncSI_glBlendFunc     			= SI_Interface::SI_glBlendFunc;
		siOpenGLESFncs.pFncSI_glBufferData    			= SI_Interface::SI_glBufferData;
		siOpenGLESFncs.pFncSI_glClear         			= SI_Interface::SI_glClear;
		siOpenGLESFncs.pFncSI_glClearColorx   			= SI_Interface::SI_glClearColorx;
		siOpenGLESFncs.pFncSI_glClearDepthx   			= SI_Interface::SI_glClearDepthx;
		siOpenGLESFncs.pFncSI_glClientActiveTexture 	= SI_Interface::SI_glClientActiveTexture;
		siOpenGLESFncs.pFncSI_glColor4x       			= SI_Interface::SI_glColor4x;
		siOpenGLESFncs.pFncSI_glColorMask     			= SI_Interface::SI_glColorMask;
		siOpenGLESFncs.pFncSI_glDeleteTextures 			= SI_Interface::SI_glDeleteTextures;
		siOpenGLESFncs.pFncSI_glDepthFunc      			= SI_Interface::SI_glDepthFunc;
		siOpenGLESFncs.pFncSI_glDepthMask      			= SI_Interface::SI_glDepthMask;
		siOpenGLESFncs.pFncSI_glDisable        			= SI_Interface::SI_glDisable;
		siOpenGLESFncs.pFncSI_glDisableClientState 		= SI_Interface::SI_glDisableClientState;
		siOpenGLESFncs.pFncSI_glDrawArrays         		= SI_Interface::SI_glDrawArrays;
		siOpenGLESFncs.pFncSI_glEnable             		= SI_Interface::SI_glEnable;
		siOpenGLESFncs.pFncSI_glEnableClientState  		= SI_Interface::SI_glEnableClientState;
		siOpenGLESFncs.pFncSI_glFinish             		= SI_Interface::SI_glFinish;
		siOpenGLESFncs.pFncSI_glGenTextures        		= SI_Interface::SI_glGenTextures;
		siOpenGLESFncs.pFncSI_glGetIntegerv        		= SI_Interface::SI_glGetIntegerv;
		siOpenGLESFncs.pFncSI_glHint               		= SI_Interface::SI_glHint;
		siOpenGLESFncs.pFncSI_glLineWidthx         		= SI_Interface::SI_glLineWidthx;
		siOpenGLESFncs.pFncSI_glLoadIdentity       		= SI_Interface::SI_glLoadIdentity;
		siOpenGLESFncs.pFncSI_glLoadMatrixx        		= SI_Interface::SI_glLoadMatrixx;
		siOpenGLESFncs.pFncSI_glMatrixMode         		= SI_Interface::SI_glMatrixMode;
		siOpenGLESFncs.pFncSI_glMultMatrixx        		= SI_Interface::SI_glMultMatrixx;
		siOpenGLESFncs.pFncSI_glOrthox             		= SI_Interface::SI_glOrthox;
		siOpenGLESFncs.pFncSI_glPixelStorei        		= SI_Interface::SI_glPixelStorei;
		siOpenGLESFncs.pFncSI_glPolygonOffsetx     		= SI_Interface::SI_glPolygonOffsetx;
		siOpenGLESFncs.pFncSI_glPopMatrix          		= SI_Interface::SI_glPopMatrix;
		siOpenGLESFncs.pFncSI_glPushMatrix         		= SI_Interface::SI_glPushMatrix;
		siOpenGLESFncs.pFncSI_glScalex             		= SI_Interface::SI_glScalex;
		siOpenGLESFncs.pFncSI_glScissor            		= SI_Interface::SI_glScissor;
		siOpenGLESFncs.pFncSI_glShadeModel         		= SI_Interface::SI_glShadeModel;
		siOpenGLESFncs.pFncSI_glTexCoordPointer    		= SI_Interface::SI_glTexCoordPointer;
		siOpenGLESFncs.pFncSI_glTexEnvx            		= SI_Interface::SI_glTexEnvx;
		siOpenGLESFncs.pFncSI_glTexEnvxv           		= SI_Interface::SI_glTexEnvxv;
		siOpenGLESFncs.pFncSI_glTexImage2D         		= SI_Interface::SI_glTexImage2D;
		siOpenGLESFncs.pFncSI_glTexParameterx      		= SI_Interface::SI_glTexParameterx;
		siOpenGLESFncs.pFncSI_glTexSubImage2D      		= SI_Interface::SI_glTexSubImage2D;
		siOpenGLESFncs.pFncSI_glTranslatex         		= SI_Interface::SI_glTranslatex;
		siOpenGLESFncs.pFncSI_glVertexPointer      		= SI_Interface::SI_glVertexPointer;
		siOpenGLESFncs.pFncSI_glViewport           		= SI_Interface::SI_glViewport;
#endif // defined(FEATURE_ACHW) && (ACHW_DRAWING_LIB == ACHW_DRAWING_LIB_IS_OPENGL_ES)


#ifdef FEATURE_EXTENSION
	SI_MiscFncs	siMiscFncs;
	FlashMemSet(&siMiscFncs, 0, sizeof(siMiscFncs));
	siMiscFncs.pFncSI_GetPluginInfo = SI_Interface::SI_GetPluginInfo;
	siMiscFncs.pFncSI_GetDisplayRectCoord = SI_Interface::SI_GetDisplayRectCoord;
#ifdef FEATURE_AMCEXTENSIONS
	siMiscFncs.pFncSI_GetExtensionPlatformInfo = SI_Interface::SI_GetExtensionPlatformInfo;
	siMiscFncs.pFncSI_GetSecurityContextPermissions = SI_Interface::SI_GetSecurityContextPermissions;
#endif
	siFunctions.pSIMiscFncs = &siMiscFncs;
#endif
	// Initialize the MMI functions to null in case there is no MMI
	siFunctions.pSIMMIFncs=NULL;

	SI_DebugFncs				siDebugFncs;
	FlashMemSet(&siDebugFncs, 0, sizeof(siDebugFncs));
	siFunctions.pSIDebugFncs = &siDebugFncs;

	siDebugFncs.pFncSI_Debug					= SI_Interface::SI_Debug;

	SI_ImageFncs			siImageFncs;
	FlashMemSet(&siImageFncs, 0, sizeof(siImageFncs));
	siFunctions.pSIImageFncs = &siImageFncs;

	siImageFncs.pFncSI_GetImageInfo				= SI_Interface::SI_GetImageInfo;
	siImageFncs.pFncSI_CancelImageRequest		= SI_Interface::SI_CancelImageRequest;

	SI_FileAccessFncs siFileAccessFncs;
	FlashMemSet(&siFileAccessFncs, 0, sizeof(siFileAccessFncs));
	siFunctions.pSIFileAccessFncs = &siFileAccessFncs;

	siFileAccessFncs.pFncSI_OpenFile			= SI_Interface::SI_OpenFile;
	siFileAccessFncs.pFncSI_CloseFile			= SI_Interface::SI_CloseFile;
	siFileAccessFncs.pFncSI_ReadFile			= SI_Interface::SI_ReadFile;
	siFileAccessFncs.pFncSI_GetFileSize			= SI_Interface::SI_GetFileSize;
	siFileAccessFncs.pFncSI_SeekFile			= SI_Interface::SI_SeekFile;


	siFunctions.SIVersion						= 1;
	siFunctions.sizeof_SI_Fncs					= sizeof(siFunctions);

#ifdef FEATURE_EXTERNAL_API

	SI_ExternalAPIFncs siExternalAPIFuncs;
	FlashMemSet(&siExternalAPIFuncs, 0, sizeof(siExternalAPIFuncs));
	siFunctions.pSIExternalAPIFncs = &siExternalAPIFuncs;

	siExternalAPIFuncs.pFncSI_EvalJs			= SI_Interface::SI_EvaluateJScript;
	siExternalAPIFuncs.pFncSI_DoFlashCall       = SI_Interface::SI_DoFlashCall;
	siExternalAPIFuncs.pFncSI_GetDomObjectId    = SI_Interface::SI_GetDOMObjectID;

#endif //FEATURE_EXTERNAL_API
	
#ifdef FEATURE_TESTAUTOMATION
	SI_TestAutomationFncs siTestAutoFuncs; //Do not move this out of here as it is used in the call "iFiObject.FI_CreatePlayer()" below
	if(iConfig.iMode & KPlayerInATSMode)
	{
		FlashMemSet(&siTestAutoFuncs, 0, sizeof(siTestAutoFuncs));
		
		siTestAutoFuncs.pFncSI_WriteFile = SI_Interface::SI_WriteFile;
		siTestAutoFuncs.pFncSI_GenerateMouseEvent = SI_Interface::SI_GenerateMouseEvent;
		siTestAutoFuncs.pFncSI_GenerateKeyEvent = SI_Interface::SI_GenerateKeyEvent;
		siTestAutoFuncs.pFncSI_GetAutomationConfigurationContent = SI_Interface::SI_GetAutomationConfigurationContent;
		
		siFunctions.pSITestAutomationFncs = &siTestAutoFuncs;
	}
#endif
	
	unsigned long fiConfigFlags = KfiConfigFlags;
	
#ifdef FEATURE_OPENVG
	if(iOpenVgMode) {
        fiConfigFlags |= FI_UseOpenVG;
	}
#endif

	if (iConfig.iMode & KSupportSVG)
	{
		fiConfigFlags |= FI_FlashLiteSVG;
	}

	if (iConfig.iMode & KSupportSharedObject)
	{
		fiConfigFlags |= FI_SharedObjects;
	}

	if( iConfig.iHelixFlvMode )
	{
		fiConfigFlags |= FI_ExternalVideoBuffering;
		fiConfigFlags |= FI_ExternalVideoRendering;
	}
	/* Eroom: 574 - FullScreen feature in Plugin Mode */
	//if (iControl != NULL) {
	/* Set this flag only for browser plugin */
	if(ePlugin == iExecutionMode)
	    {
        fiConfigFlags |= FI_PluginMode;
	    }
	TInt keyboardLayout = 0;
    RProperty::Get(KCRUidAvkon, KAknKeyBoardLayout, keyboardLayout);
    TPtiKeyboardType layout = (TPtiKeyboardType)keyboardLayout;
    if(layout!=EPtiKeyboardNone)
    {
        //IF keypad is available 4way navigation is enabled
        fiConfigFlags |=  FI_4WayNavigation;
    }
    else
    {
        //If keypad is not available we enable 4way navigation only if OSK is enabled.
        //OSK is available only in viewer
        //if(!iBrowserPluginActive)
    	if(iExecutionMode == eStandAlone)
        {
			#ifdef __FEATURE_OSK__
				fiConfigFlags |=  FI_4WayNavigation;
			#endif//__FEATURE_OSK__
        }
    }    

//Load ATS Library
#ifdef FEATURE_ATS_AUTOMATION
	SI_Fncs atsFunctions;
	if((iConfig.iMode & KPlayerInATSMode) && iXMLFlag)
	{
		iATSHandler->LoadATSLibraryL(&atsFunctions,&siFunctions);
		//ExtendBacklight(200);
	}
#endif

	iFiObject.SetEngine(this);

	iFIConfigFlags = fiConfigFlags;
	
#ifdef FEATURE_ATS_AUTOMATION
	if((iConfig.iMode & KPlayerInATSMode) && iXMLFlag)
	{
		iFiObject.FI_CreatePlayer(iPlayerStaticHeap, iPlayerStaticHeapSize, atsFunctions, fiConfigFlags);
	}
	else
	{
	    iFiObject.FI_CreatePlayer(iPlayerStaticHeap, iPlayerStaticHeapSize, siFunctions, fiConfigFlags);
	}

#else
	iFiObject.FI_CreatePlayer(iPlayerStaticHeap, iPlayerStaticHeapSize, siFunctions, fiConfigFlags);
#endif

	iMMObject = iFiObject.GetMMObject();

#ifdef FEATURE_OPENVG
	if(iOpenVgMode) {
        iFiObject.FI_ConfigureHardwareRendering(&iHwConfig);
	}
#endif
    
//setup library and exchange function pointers.
#ifdef FEATURE_ATS_AUTOMATION
	if((iConfig.iMode & KPlayerInATSMode) && iXMLFlag)
	{
		iATSHandler->SetUpATSLibrary(iMMObject,fiConfigFlags);
	}
#endif

	TBool success = EFalse;

	if (iMMObject)
	{
#ifdef FEATURE_INLINE_TEXT_ENTRY
		// CPlatformFlashEngine gets reused across multiple player instances
		if ( NULL == iTextNavigation )
		{
			iTextNavigation = new AMP_VirtualTextNavigation;
		}

		// Every time we create a player, we need to register for notification
		if ( iTextNavigation )
		{
			success = ETrue;
		}
#else
		success = ETrue;
#endif
	}

	return success;
}

_LIT8(KSvgFileFirstFewBytes, "<svg");
_LIT8(KSvgzFile1FirstFewBytes, "\037\213"); // zlib compressed -- could be SVGZ
_LIT8(KSvgzFile2FirstFewBytes, "\170\234"); // zlib compressed -- could be SVGZ

const TUint KLongestFirstFewBytesData = 4;
//SecuritySandbox


void  CPlatformFlashEngine::TrustContentL(const TPtrC &aSwfFileName)
{
    if(iTrustStore)
        iTrustStore->TrustContentL(aSwfFileName);

}
//SecuritySandbox

TBool CPlatformFlashEngine::IsContentTrustedL(const TPtrC &aSwfFileName)
{
     TBool res = EFalse;
     if(!iTrustStore)
     {
         iTrustStore= CFlashTrustStore::NewL();
     }    
     //check if aSwFileName is already trusted
     if(iTrustStore)
     {    
         TRAP_IGNORE(res =iTrustStore->IsContentTrustedL(aSwfFileName));
     }    
     return res;
}
TBool CPlatformFlashEngine::CanContentBeTrusted(const TDesC8& aSwfURL)
{
    RFs fsSession = CEikonEnv::Static()->FsSession();
    DriveInfo::TDriveArray driveArray;
    TInt err = ETrue;//This is used to find if we get any errors in getting drive info and pathinfo
    if(KErrNone == DriveInfo::GetUserVisibleDrives( fsSession, driveArray ))
    {
        err = EFalse;
        TInt i=0;  
        TInt driveCount=driveArray.Count();
        for(i=0; i < driveCount; i++)
        {
            TDriveNumber drive( driveArray[ i ] ); 
            TFileName path;
            if(KErrNone==PathInfo::GetRootPath( path, drive ))
            {
                TBuf8 <KMaxFileName> trustedPath;
                trustedPath.Copy(path);
                trustedPath.Append(PathInfo::OthersPath());
                TInt pos;
                pos = trustedPath.Find(KBackwardSlash);
                while(pos!=KErrNotFound)
                {
                    trustedPath.Replace(pos,1,KForwardSlash);
                    pos =trustedPath.Find(KBackwardSlash);
                }
                trustedPath.Append(KTrustedDir);
                if(KErrNotFound != aSwfURL.FindF(trustedPath))
                {
                    return ETrue;
                }
            }
            else
            {
                err = ETrue;
                break;
            }
        }
    }   
    if(err)//If there is a error in getting user visible drives/rootpath  we check the hardcoded paths
    {
        if(( KErrNotFound != aSwfURL.FindF( KOthersTrustedDir))|| 
            ( KErrNotFound != aSwfURL.FindF( KTrustedPhoneDirPath)))
        {
            return ETrue;   
        }
    }
	//Some application send file:/// and hence offset returned would not be 0,
	// hence checking for KErrNotFound
    if(( KErrNotFound != aSwfURL.FindF( KTrustedZDirPrivate))|| 
    ( KErrNotFound != aSwfURL.FindF( KShowroomDirPrivate)))
	{
		return ETrue;
	}

	return EFalse;
}

void CPlatformFlashEngine::StartMovieL(char* aSwfURL, const U8* aSwfData, U32 aSwfLength, TBool aResetIAPAccess, TBool aFirstMovie)
{
	CleanupStack::PushL(aSwfURL);

	// reset deviceID permission check flag.
	iAllowPhoneCall = EAllow_NotSet;

	iNotifyEndOfMovie = ETrue;

	if(aResetIAPAccess)
	{
		iAllowNetAccessId = EAllow_NotSet;
		iPromptForIAP=ETrue; // make the User select again for the next movie...
	}

	iPanMode = EFalse;

	iRedraw = ETrue;

	// make sure that soft-keys are reset back to defaults before loading a new movie.
	ResetSoftKeys();

#ifdef FEATURE_OPENVG
	if(iOpenVgMode)
	{
        //DestroyEgl();
        
        TRAPD(err,CreateEglSurfaceL());
        if(err) 
        {
            DestroyEgl(); //cleanup
            FreeBits();
            iRenderToBitmap = ETrue; //Switch to blitting via wserv
            iOpenVgMode = EFalse;
            
            TRect rect(0,0,iFrameBufferSize.iWidth,iFrameBufferSize.iHeight);
            ((MFlashEngine*)this)->InitializeL(rect,EFalse);
        }
	}
#endif 

	iPlayerState = EPlayerOK;

	if (aFirstMovie )
	{
		if(iMMObject)
	    {
		    StopTimer();
		    DestroyPlayer();
            if(iSoundHandler)
            {
    		    iSoundHandler->StopSound();
    		    iSoundHandler->CleanupCachedFiles(iFs);
            }
	    }
	    if(!CreatePlayerL())
        {
	        User::LeaveNoMemory();
        }
	}

	//if(!iBrowserPluginActive)
		{
		/*if(iFlashUI)
		    iFlashUI->ClearErrors();*/
		iFlashClientIf->ClearErrors();
		}

	ClearBitmap();

	TInt count=0;
//	char** array=AllocReadResourceArrayIntoFlashStringArrayL(count, R_FLASH_SUPPORTED_IMAGE_MIME_TYPES_ARRAY);
	char** array= MediaRecognizer::GetImageDecoderSupportedFormatsL(this,count);

	iFiObject.FI_SetupDeviceImage((unsigned short)count, (const char**) array);
	TInt i;
	for(i=0; i<count; i++)
	{
		delete[] array[i];
	}
	delete[] array;
	array=NULL;

//	array=AllocReadResourceArrayIntoFlashStringArrayL(count, R_FLASH_SUPPORTED_VIDEO_MIME_TYPES_ARRAY);
	TInt resoffset = FlashEngineRscHandler::LoadEngineResourceFileL();
	array=MediaRecognizer::GetMMFsupportedFormatsL(this,count, EFalse
					,R_FLASH_SUPPORTED_VIDEO_MIME_TYPES_ARRAY); //get video mime types from MMF

	iFiObject.FI_SetupDeviceVideo((unsigned short)count, (const char**) array);
	for(i=0; i<count; i++)
	{
		delete[] array[i];
	}
	delete[] array;
	FlashEngineRscHandler::DeleteEngineResourceFile(iEnv, resoffset);

    if(iSoundHandler)
    {
        iSoundHandler->InitializeSoundL(this);
    }

    iFiObject.FI_SetFrameBuffer( NULL, (TUint16)iFrameBufferSize.iWidth, (TUint16)iFrameBufferSize.iHeight, 
            FrameBufferPitch(), FrameBufferDisplayFormat());    
    
    FI_Rect fiRect;
    fiRect.xmin = (short) iRect.xmin;
    fiRect.ymin = (short) iRect.ymin;
    fiRect.xmax = (short) iRect.xmax;
    fiRect.ymax = (short) iRect.ymax;

	if (!iFiObject.FI_SetDisplayRect(&fiRect ))
	{
		PLAYEROUTPUT ("PlatformBitBuffer error");
	}

	else
	{
		if (iWindowMode != EWindow)
		{
#if defined (FEATURE_WINDOWLESS) && defined(FEATURE_BG_TRANSPARENCY)
			iFiObject.FI_SetBackgroundAlpha(iConfig.iBackgroundAlpha, EFalse);
#endif
		}
	/*
#ifdef FEATURE_BG_TRANSPARENCY
		if(iConfig.iBackgroundAlpha < 255)
		{
			iFiObject.FI_SetBackgroundAlpha(iConfig.iBackgroundAlpha, iConfig.iPlayerBlendsBackground);
		}
#endif //FEATURE_BG_TRANSPARENCY
*/
	
		TBool couldBeSVG = EFalse;
		TBool couldBeSWF = EFalse;

		if (aSwfLength > KLongestFirstFewBytesData)
		{
			TPtrC8 content(aSwfData, aSwfLength);

			if (content.Left(KSWFFileFirstFewBytes.iTypeLength).CompareF(KSWFFileFirstFewBytes) == 0)
			{
				couldBeSWF = ETrue;
			}
			else if (content.Left(KSWCFileFirstFewBytes.iTypeLength).CompareF(KSWCFileFirstFewBytes) == 0)
			{
				couldBeSWF = ETrue;
			}
			else if (iConfig.iMode & KSupportSVG)
			{
				if (content.FindF(KSvgFileFirstFewBytes) >= 0)
				{
					couldBeSVG = ETrue;
				}
				else if(content.Left(KSvgzFile1FirstFewBytes.iTypeLength).CompareF(KSvgzFile1FirstFewBytes) == 0)
				{
					couldBeSVG = ETrue;
				}
				else if(content.Left(KSvgzFile2FirstFewBytes.iTypeLength).CompareF(KSvgzFile2FirstFewBytes) == 0)
				{
					couldBeSVG = ETrue;
				}
			}

		}

		if (couldBeSWF)
		{
			iSvgMode = EFalse;

			FI_CodePage fiCodepage;
			TInt codepage;
			GetLanguageInfo(codepage, fiCodepage);

			ChangeCodePageL(codepage);

			//  Set the native codepage on the Flash Lite player
			iFiObject.FI_SetNativeCodePage(fiCodepage);
			iFiObject.FI_SetTextFieldBoundaryBehavior( FI_TextFieldExitsFirstAndLastLineBoundary | FI_TextFieldCursorCyclesStartAndEndBoundary );
			FI_SecuritySandbox sSandbox = FI_UseDefault; //dont change this default value, if FI_LocalTrusted set
			//then browser streaming cases get messed up

			const char* ptrUrlSchemeStripped = StripPrefix( aSwfURL, "file://" );
			if(ptrUrlSchemeStripped)
			{
                //Trusted folder set by the host , so return FI_LocalTrusted, do not change this.
                //This is required for ATS security, cross scripting, loadVars and MSO to pass
                //else is UseDefault(default sandbox) where core player will decide the sandbox.
			    TPtrC8 pSwfUrl( (TText8*)ptrUrlSchemeStripped );
			    //Check if the content is prest in default trust directory
                if (CanContentBeTrusted(pSwfUrl))
                {
                    sSandbox = FI_LocalTrusted;

                }
 //In automation mode, security sandbox prompts should be disabled
               #if defined(FEATURE_PERFORMANCE_AUTOMATION)  || defined(FEATURE_ATS_AUTOMATION) || defined(FEATURE_TESTAUTOMATION)
						if((iConfig.iMode & KPlayerInATSMode) || (iConfig.iMode & KPerformanceTestMode))
               			{
                            if(KErrNotFound == pSwfUrl.FindF(KNoAutoTrust))
                            {
                                sSandbox = FI_LocalTrusted;
                    
                            }
               			}
               #endif

                //here falsh stub applications can be in trusted sandbox.
                if(InstanceInTrustedSandBox())
                {
                    sSandbox = FI_LocalTrusted;

                }
                //SecuritySandbox
                if(/*!iBrowserPluginActive && */sSandbox != FI_LocalTrusted)
				 {
				 HBufC *pathToDisplay = CreateEpocStringLC(ptrUrlSchemeStripped, FlashStrLen(ptrUrlSchemeStripped));

				 TPtrC fileName = pathToDisplay->Des();
				 //Check if content is already trusted by user
				     if(IsContentTrustedL(fileName))
				       {
				           sSandbox = FI_LocalTrusted;
				       }

		          CleanupStack::PopAndDestroy(pathToDisplay);
				 }

			}
			//eroom761 fix:	
			if (iHTMLBaseURL != NULL)
				{
				struct FI_BrowserURLInfo pURLInfoIn;

				if (iEngineSecurityContextUrl)
				    {
				    pURLInfoIn.pURLIn = (const char*)(iEngineSecurityContextUrl->Des().Ptr());
				    }
				else
				    {
				    pURLInfoIn.pURLIn = (const char*)(iHTMLBaseURL->Des().Ptr());
				    }
				    
				if(sSandbox == FI_LocalTrusted )				    
					pURLInfoIn.bIsTrusted = ETrue;
				else
					pURLInfoIn.bIsTrusted = EFalse;
				pURLInfoIn.pageAccessType = EPageUrlNormal;
			
				iFiObject.FI_SetContainerSecurityContext(&pURLInfoIn);
				}
		
			if((iAllowScriptAccess >= 0 ) && (iAllowScriptAccess <= 2 ))
				{
					iFiObject.FI_SetScriptAccess(iAllowScriptAccess);
				}
			
			
			if (iFiObject.FI_SetSWFDataBuffer( aSwfURL, aSwfData, aSwfLength, false, FI_SwfBufferCopy, sSandbox  ))
			{
				iIsRunning = ETrue;
				StartTimer();
				iPauseFlags = ENotPaused;
			}


			if(iFlashVarsPresent)
    			{

				if(iFlashVarVal)
			   	{
			       		RBuf8 params;
			                params.ReAlloc( ( iFlashVarVal->Length() + 1 ) );
		             	        params.Copy( *iFlashVarVal );
	                   	        CleanupClosePushL( params );
			        	iFiObject.FI_SetFlashVars( (const char*)( params.PtrZ()),ETrue );
				        //Free memory
		           		CleanupStack::PopAndDestroy( &params );
  			   	}
    		         }

			#ifdef __FEATURE_PRE_COMPILED_SWF
			SetPreInstalledASClassL( );
						
            #ifdef FEATURE_BINDING_PREINSTALLED_LIB
            iFiObject.FI_SetPreInstalledASClass(KAsLibrarySwfData,KAsLibrarySwfFileSize,EFalse);
            #endif  //FEATURE_BINDING_PREINSTALLED_LIB			

			#endif //__FEATURE_PRE_COMPILED_SWF
		}
		else  if (couldBeSVG)
		{
			if (iConfig.iMode & KSupportSVG)
			{
				iSvgMode = ETrue;
				ChangeCodePageL(KCharacterSetIdentifierUtf8);
				if (iFiObject.FI_SetSVGDataBuffer( aSwfURL, aSwfData, aSwfLength ))
				{
					iIsRunning = ETrue;
					StartTimer();
					iPauseFlags = ENotPaused;
				}
			}
		}
	}

	CleanupStack::PopAndDestroy(aSwfURL);

	//if(!iBrowserPluginActive)
	if(iExecutionMode == eStandAlone)
	{
		SetQuality(iQuality);
	}
	//if (iBrowserPluginActive && iMMObject)
	if((iExecutionMode == ePlugin) && iMMObject)
    {
		iFiObject.FI_SetLooping(iLoop );
		iFiObject.FI_SetQuality(iSwfQuality);
		if(iBackgroundColorPresent)
		{
			iFiObject.FI_SetBackgroundColor( iRed, iGreen, iBlue );
		}
    }
	//if(iBrowserPluginActive && iScaleValue >=0)
	if((iExecutionMode == ePlugin) && iScaleValue >=0)
	{
#ifdef FEATURE_WEB_BROWSABILITY
		iFiObject.FI_SetScaleMode(iScaleValue);
#endif
	}

	//if(iBrowserPluginActive && iAlignValue >= 0)
	if(iExecutionMode == ePlugin)
	{
#ifdef FEATURE_WEB_BROWSABILITY
	    if (iAlignValue >= 0)
        {
            iFiObject.FI_SetAlignMode(iAlignValue);
        }
	
	    iFiObject.FI_SetAllowNetworking(iAllowNetworking);
#endif
	}
	
	
	//Moving iFiObject.FI_SetBaseURL here
	if (iHTMLBaseURL!= NULL)
		iFiObject.FI_SetBaseURL((const char*)iHTMLBaseURL->Des().Ptr());

	iSwfStarted = ETrue;
}

TUint16 CPlatformFlashEngine::FrameBufferPitch()
{
    TUint16 pitch = 0;
#ifdef FEATURE_OPENVG
    if(iOpenVgMode) {
        pitch = iFrameBufferSize.iWidth * TDisplayModeUtils::NumDisplayModeBitsPerPixel(iDisplayFormat);
    }
    else        
#endif
    {
        if(iWindowMode == EWindow)
        {
            pitch = iBitmap->DataStride();
        }
#ifdef FEATURE_WINDOWLESS
        else
        {
            pitch = iWlessSurface->DataStride();
        }	
#endif 
    }
	
    return pitch;
}

char** CPlatformFlashEngine::AllocReadResourceArrayIntoFlashStringArrayL(TInt& aCount, TInt aResourceId)
{
	CDesCArray* array = iEnv->ReadDesC16ArrayResourceL(aResourceId);
	CleanupStack::PushL(array);
	aCount=array->Count();

	char** charArray=new(ELeave) char* [aCount];
	CleanupStack::PushL(charArray);

	TInt i = 0;
	for(i=0;i<aCount;i++)
	{
		charArray[i]=CreateFlashStringLC(array->MdcaPoint(i));
	}

	CleanupStack::Pop(i+1,charArray);
	CleanupStack::PopAndDestroy(array);
	return charArray;
}


#ifdef LOG_MESSAGE
_LIT(KDateString1,"%-B%:0%J%:1%T%:2%S%.%*C4%:3%+B");
_LIT(KDateString2,"%:0%H%:1%T%:2%S.%C%:3\n");
const unsigned short KDateStrLength = 30;

void CPlatformFlashEngine::WriteLogMsgL(const char* aMsg, const TBool aShowElapsedTime)
#else
void CPlatformFlashEngine::WriteLogMsgL(const char* /*aMsg*/, const TBool /*aShowElapsedTime*/)
#endif
	{
#ifdef LOG_MESSAGE
	TInt endOfFile = 0;
	TTime currentTime;
    currentTime.HomeTime();

	TBuf<KDateStrLength> dateString;
	currentTime.FormatL(dateString, KDateString2);
	char* cDateTimeStr = CreateFlashString( dateString );

	TBuf8<256> cStr;
	cStr.Append(TPtrC8((TUint8*)cDateTimeStr));
	delete cDateTimeStr;

	cStr.Append(KLitLogSeparator);
	cStr.Append(TPtrC8((TUint8*)aMsg));

	if (iLogFile)
	{
		iLogFile->Write(cStr);
		iLogFile->Flush();
		iLogFile->Close();
		User::LeaveIfError(iLogFile->Open(iFs, KFlashLogFile, EFileWrite | EFileShareExclusive));
		iLogFile->Seek(ESeekEnd, endOfFile);
	}

	if (aShowElapsedTime)
	{
		cStr.Copy(KLitElapsedTime);
		currentTime.UniversalTime();
		TTimeIntervalMicroSeconds elaspedMicroSec = currentTime.MicroSecondsFrom(iLastTimeStamp);
		cStr.AppendNum(elaspedMicroSec.Int64());
		cStr.Append(KLitCrCr);

		if (iLogFile)
		{
			iLogFile->Write(cStr);
			iLogFile->Flush();
			iLogFile->Close();
			User::LeaveIfError(iLogFile->Open(iFs, KFlashLogFile, EFileWrite | EFileShareExclusive));
			iLogFile->Seek(ESeekEnd, endOfFile);
		}
	}
#endif	// LOG_MESSAGE
}

#ifdef LOG_MESSAGE
void CPlatformFlashEngine::WriteLogMsgWithIntL(const char* aMsg, TInt aNum)
#else
void CPlatformFlashEngine::WriteLogMsgWithIntL(const char* /*msg*/, TInt /*aNum*/)
#endif
{
#ifdef LOG_MESSAGE
	TInt endOfFile = 0;
	TTime currentTime;
    currentTime.HomeTime();
	TBuf<KDateStrLength> dateString;
	currentTime.FormatL(dateString, KDateString2);
	char* cDateTimeStr = CreateFlashString( dateString );

	TBuf8<256> cStr;
	cStr.Append(TPtrC8((TUint8*)cDateTimeStr));
	delete cDateTimeStr;

	cStr.Append(KLitLogSeparator);
	cStr.Append(TPtrC8((TUint8*)aMsg));
	cStr.Append(KLitValSep);
	cStr.AppendNum(aNum);
	cStr.Append(KLitCrCr);
	if (iLogFile)
	{
		iLogFile->Write(cStr);
		iLogFile->Flush();
		iLogFile->Close();
		User::LeaveIfError(iLogFile->Open(iFs, KFlashLogFile, EFileWrite | EFileShareExclusive));
		iLogFile->Seek(ESeekEnd, endOfFile);
	}

#endif	// LOG_MESSAGE
}

void CPlatformFlashEngine::PlayStep( TBool canInterrupt )
{
    /*
    This condition is to ensure that there is no recursive FI_DoPlay call. 

    There is a possibility of a recursive call if CActiveSchedulerWait is used any of the SI calls or AS Extension/fscommand2 implementation. 
    e.g: when a dialog box is displayed - wherein, the currently AO RunL is suspended, while another doplay is free 
    to be scheduled from a different timer. (low priority timer or platform timer).

    This condition is not mandatory as FI_DoPlay itself has a recursive FI guard. However, any FI calls tailing DoPlay, 
    inside the same RunL or another AO might fail as it might be called from within an ongoing but suspended DoPlay. 
    */  
    if (iInDoPlay)
    {
        return;
    }
    
	if (!iMMObject)
	{
		return;
	}
	TUint16  tstatus;
	TUint16 pstatus;
	if (iSvgMode)
	{
#ifdef FEATURE_OPENVG
        SetCurrentEglContext();
#endif		
		pstatus = iFiObject.FI_DoPlay(true);
		tstatus = pstatus & 0xFFCF;
	}
	else
	{
#ifdef PERFORMANCE_LOG
		// Log time information to a file
		TRAPD(err,WriteLogMsgL("Before calling DoPlay\n", FALSE));
		iLastTimeStamp.UniversalTime();
#endif	// PERFORMANCE_LOG

		if( iFrameBufferResized && !iInDoPlay )
		{
		    TRAPD(err, InitializeL(iInitInfo.iRect, iInitInfo.iResize, iInitInfo.iLandscape));
		    if (err != KErrNone)
		        {
		        NotifyClientError(EGeneralError, ETrue, ETrue);
		        }
			iFrameBufferResized = EFalse;
		}

#ifdef FEATURE_OPENVG
        SetCurrentEglContext();
#endif  
		
		iInDoPlay = ETrue;
		pstatus = iFiObject.FI_DoPlay(false);
		//This is required because core player does a or of two return values.
		//FI_DoPlayFrameRateLagging and FI_DoPlayActionsPendingFlag  have been introduced in Flashlite3.1.6
		//These can be used of improving performance.
		tstatus = pstatus & 0xFFCF;
		iInDoPlay = EFalse;

		// In case of these two error codes, DoPlay() need to be reexecuted.
		if( pstatus == FI_RenderingInterruptedByTimeout || pstatus == FI_SystemInterrupt )
		{
#ifdef FEATURE_OPENVG
            SetCurrentEglContext();
#endif  
			iInDoPlay = ETrue;
			pstatus = iFiObject.FI_DoPlay(false);
			tstatus = pstatus & 0xFFCF;
			iInDoPlay = EFalse;
		}

#ifdef PERFORMANCE_LOG
		TRAPD(err, WriteLogMsgL("After calling DoPlay\n", TRUE));
#endif	// PERFORMANCE_LOG

	}

	if (iPlayerState == EPlayerStoppedError)
	{
		// reset soft keys
		AbortPlayer();
	}

    if(iReplayFlag)
    {
        TInt temp = iZoomFactor;
		iZoomFactor = 0;
        TInt dummy;
        while(temp)
            {
            Zoom(EZoomIn,dummy);
            temp--;
            }
        //iZoomFactor = iZoomFactor/2;         
        iReplayFlag = EFalse;
    }

#ifndef USE_VPU2
    CFLPlatformDecoderInterface* decoderInstance = NULL;

	if(iConfig.iHelixFlvMode )
	{

    for(TInt n=0; n < iFlvDecoderArray.Count(); n++)
	    {
       	decoderInstance = iFlvDecoderArray[n];

   		if( !decoderInstance ) continue;

		TTimeIntervalMicroSeconds videoPosition = decoderInstance->GetVideoPosition();

			if(videoPosition.Int64() < KMaxVideoPositioToBlt)
			{
			DrawVideoRect();
			}
		}
	}
#endif

	switch(tstatus)
	{
	case FI_FrameBufferNotUpdated:
		break;

	case FI_FrameBufferUpdated:
	case FI_DoPlayFrameRateLagging:
	{
		//Backlight handling moved to ExtendBacklightForVideoPlayback
		DrawBitBuffer();

	}
		break;

	case FI_RenderingInterruptedByTimeout:
	case FI_SystemInterrupt:
		{
			//This makes the doplay synchronous if doplay to long time it starves the other  threads.
		    //pstatus = iFiObject.FI_DoPlay(false);
		}
		break;

		// handle error cases
	case FI_FrameBufferUpdatedWithError:
	{
		if( (iFLVPlayStat) && (iFLVStatus!=ENetStreamPlayStop) && (iFLVStatus!=ENetStreamPlayPause) )
	    {
	    	ExtendBacklight(1);
	    }
		DrawBitBuffer();
	}
		break;

	case FI_FrameBufferNotUpdatedWithError:
	case FI_RenderingInterruptedByTimeoutWithError:
	case FI_SystemInterruptWithError:
		break;

	default: return;
	}
	
	    
#if defined(FEATURE_PERFORMANCE_AUTOMATION) || defined(FEATURE_ATS_AUTOMATION) || defined (FEATURE_TESTAUTOMATION)
	if((iConfig.iMode & KPlayerInATSMode) || (iConfig.iMode & KPerformanceTestMode))
	    {
	    User::ResetInactivityTime();
	    }
#endif

	//notify client that play is ended if Loop is 1
	if ((KLoopOff == iLoop)
			&& iNotifyEndOfMovie
			&& (iFiObject.FI_FrameNumber() >= iFiObject.FI_NumberOfFrames()))
	{
		NotifyFlashStatus(EPlayComplete,NULL);
		iNotifyEndOfMovie = EFalse;
	}
	
    if (iRequestedScreenChange && !iInDoPlay)
        {
        if ((iChangeScreenSizeRequest == EChangeScreenFullScreen)
                && !PlayerStoppedWithError())
            {
            MDisplay* display = iFlashClientIf->GetDisplay();
            TRAPD(err, display->SetFullScreenL());
            if (err != KErrNone)
                {
                //iFlashUI->NotifyClientError(EGeneralError, ETrue, ETrue);
                MUserNotiferIf* userNotifierIf =
                        iFlashClientIf->GetUserNotifierIf();
            if (userNotifierIf)
                userNotifierIf->NotifyClientError(EGeneralError, ETrue, ETrue);
                }
            }
        else if ((iChangeScreenSizeRequest == EChangeScreenAppScreen)
                && !PlayerStoppedWithError())
            {
            MDisplay* display = iFlashClientIf->GetDisplay();
            TRAPD(err, display->SetAppScreenL());
            if (err != KErrNone)
                {
                //iFlashUI->NotifyClientError(EGeneralError, ETrue, ETrue);
                MUserNotiferIf* userNotifierIf =
                        iFlashClientIf->GetUserNotifierIf();
            if (userNotifierIf)
                userNotifierIf->NotifyClientError(EGeneralError, ETrue, ETrue);
                }
            }
        iRequestedScreenChange = EFalse;
        iChangeScreenSizeRequest = EChangeScreenNull;
        }

#ifdef FORCE_REFRESH_WORKAROUND
    if(iForceRedraw)
    {
        ForceRedraw();
    }
#endif
    
}


TUint8 ParseHexCharL(TChar ch)
{
	TUint c = ch;
	if ( '0' <= c && c <= '9' )
	{
		c = c-'0';
	}
	else if ( 'A' <= c && c <= 'F' )
	{
		c = c-'A'+KAsciiOffset;
	}
	else if ( 'a' <= c && c <= 'f' )
	{
		c =  c-'a'+KAsciiOffset;
	}
	else
	{
		User::Leave(KErrCorrupt);
	}
	return (TUint8)c;
}

HBufC8* DecodeURLDes8LC(const TDesC8& aURL)
{
	// alloc buffer to return. We know this is big enough since unescaping only makes URL smaller
	HBufC8* hBufURLDecoded = HBufC8::NewLC(aURL.Length());
	TPtr8 ptrURLDecoded = hBufURLDecoded->Des();
	for (TInt i = 0; i < aURL.Length(); i++)
	{
		TUint8 c = aURL[i];
		if ('%' == c && (i+2 < aURL.Length()))
		{
			TChar h1 = aURL[++i];  // MSB
			TChar h2 = aURL[++i];  // LSB
			TUint8 n1 = ParseHexCharL(h1);
			TUint8 n2 = ParseHexCharL(h2);
			c = static_cast<TUint8>((n1 * 16) + n2);
		}
		ptrURLDecoded.Append(c);
	}
	return hBufURLDecoded;
}

HBufC* CPlatformFlashEngine::ConvertEncodingLC(const TDesC8& aStr, TBool aIsEncoded, TBool aIsUTF8)
//
// Convert URL data from 8-bit ANSI/MBCS/UTF=8 to unicode and decode
//
{
	HBufC* hBufUrlConverted = NULL;
	if (iCharacterConverter)
	{
		TPtrC8 ptrURL(aStr);
		hBufUrlConverted = HBufC::NewLC(ptrURL.Length());
		TPtr ptrUrlConverted = hBufUrlConverted->Des();

		HBufC8* hBuf8UrlDecoded = NULL;

		if (aIsEncoded)
		{
			// need to decode prior to conversion to Unicode
			hBuf8UrlDecoded = DecodeURLDes8LC(aStr);
			ptrURL.Set(*hBuf8UrlDecoded);
		}

		if (aIsUTF8)
		{
			ChangeCodePageL(KCharacterSetIdentifierUtf8);
		}

		// convert to Unicode
		TInt state = CCnvCharacterSetConverter::KStateDefault;
		iCharacterConverter->ConvertToUnicode(ptrUrlConverted, ptrURL, state);


		// cleanup
		if (hBuf8UrlDecoded)
		{
			CleanupStack::PopAndDestroy(hBuf8UrlDecoded);
		}
	}
	else
	{
		User::Leave(KErrNotReady);
	}

	return hBufUrlConverted;
}

HBufC* CPlatformFlashEngine::ConvertToUnicodeLC(const TDesC8& aStr, TBool aIsUTF8)
//
// Convert URL data from 8-bit ANSI/MBCS/UTF=8 to unicode
//
{
	HBufC* hBufUrlConverted = NULL;
	if (iCharacterConverter)
	{
		TPtrC8 ptrURL(aStr);
		hBufUrlConverted = HBufC::NewLC(ptrURL.Length());
		TPtr ptrUrlConverted = hBufUrlConverted->Des();

		if (aIsUTF8)
		{
			ChangeCodePageL(KCharacterSetIdentifierUtf8);
		}

		// convert to Unicode
		TInt state = CCnvCharacterSetConverter::KStateDefault;
		iCharacterConverter->ConvertToUnicode(ptrUrlConverted, ptrURL, state);

	}
	else
	{
		User::Leave(KErrNotReady);
	}

	return hBufUrlConverted;
}

unsigned short CPlatformFlashEngine::HandleURLL(struct MM_Object* aMMObj, struct FI_GetURLCallInfo* aUrlInfo)
//
// Main handler in the engine responsible for parsing/converting and acting on URLs
// passes processed URL onto other handlers such as HandleTelURLL(),  HandleMailToL() etc.
//
{
	const TChar KPostDataSeparator('?');
	const TChar KColon(':');
	unsigned short retVal = 0;
	// URL is always 8-bit data, either in  UTF-8 or ANSI/MBCS
	// URL may also be encoded (http://www.blooberry.com/indexdot/html/topics/urlencoding.htm)

	// Note, that even if useCodePage is true (i.e. ANSI/MBCS) we may be sent a (part) URL in UTF-8 - see table below

	/*

	1. Non-ASCII strings are variables outside of getURL call.

						| useCodePage = false		| useCodePage = true
	==========================================================================
	getURL
	url attached data	| url-encoded UTF-8 strings | url-encoded  MBCS strings
	postData			| url-encoded UTF-8 strings | url-encoded  MBCS strings

	2. Non-ASCII strings are part of the url in the getURL call.

						| useCodePage = false		| useCodePage = true
	==========================================================================
	url					| UTF-8 strings 			| UTF-8 strings

	*/

	// so we may need to do some processing on the URL before passing to apps
	// this means decoding (removing % chars) prior to converting if necessary
	// code based on changes made to Win32 harness in changelist 180326 by jzengh

	if(!aUrlInfo)
	    return false;
	TBool urlIsUTF8 = aUrlInfo->isUTF8;
	TBool urlIsEncoded = aUrlInfo->isURLEncoded;

	TPtrC8 ptrUrl((TUint8*)aUrlInfo->url, aUrlInfo->urlLength); // raw url passed in
	HBufC* hBufURL = NULL;

	// handle URL
	if (ptrUrl.Locate(KColon) != KErrNotFound)
	{
		TInt queryStrStartPos = ptrUrl.Locate(KPostDataSeparator);
		if (queryStrStartPos == KErrNotFound)
		{
			hBufURL = CreateEpocStringLC(aUrlInfo->url, aUrlInfo->urlLength);
		}
		else
		{
			// We only want to convert/decode the query string (after the '?')
			TPtrC8 ptrPureURL = ptrUrl.Left(queryStrStartPos);
			TPtrC8 ptrQueryStr = ptrUrl.Mid(queryStrStartPos);

			HBufC* hBufQueryStr = NULL;
			HBufC* hBufPureStr = NULL;

            // if the URL has got a query string, but it's not an http or
            // https address then it must be for another messaging app, so we
            // need to decode query string before we can pass it to the mail
            // app.
			if ( (ptrUrl.Find(KProtocolPrefixHttp) == 0) ||
                 (ptrUrl.Find(KProtocolPrefixHttps) == 0) )
            {
                // If URL starts with http:// or https://
                // do 8 bit to 16 bit conversion.
                hBufQueryStr = ConvertToUnicodeLC(ptrQueryStr, urlIsUTF8);
            }
            else
			{
				hBufQueryStr = ConvertEncodingLC(ptrQueryStr, urlIsEncoded, urlIsUTF8);
				hBufPureStr = ConvertEncodingLC(ptrPureURL, urlIsEncoded, urlIsUTF8);
			}
			TInt len = ptrPureURL.Length();
			if(hBufPureStr)
				{
				len = hBufPureStr->Length();
				}

			hBufURL = HBufC::NewLC(ptrPureURL.Length() + hBufQueryStr->Length());
			TPtr ptrBufURL = hBufURL->Des();
			if (hBufPureStr)
				{
				ptrBufURL.Copy(*hBufPureStr);
				}
			else
				{
			ptrBufURL.Copy(ptrPureURL);
				}
			ptrBufURL.Append(*hBufQueryStr);
			CleanupStack::Pop(hBufURL);
			if (hBufPureStr)
				{
				CleanupStack::PopAndDestroy(hBufPureStr);
				}
			CleanupStack::PopAndDestroy(hBufQueryStr);
			CleanupStack::PushL(hBufURL);
		}

		// URL has a scheme
		TPtrC ptrUrlSchemeStripped;
		if (StripPrefix(*hBufURL, KProtocolPrefixVideoCall, ptrUrlSchemeStripped))
		{
			// video call should be supported, but the Series60 SDKs do not have any APIs yet...
			retVal = 0;
		}
		else if (StripPrefix(*hBufURL, KProtocolPrefixTelCall, ptrUrlSchemeStripped))
		{
			// tel call
			retVal =  HandleTelL(ptrUrlSchemeStripped);
		}
		else if (StripPrefix(*hBufURL, KProtocolPrefixEmail, ptrUrlSchemeStripped))
		{
			// email
			retVal = HandleMailToL(ESMTP, ptrUrlSchemeStripped, ETrue);
		}
		else if (StripPrefix(*hBufURL, KProtocolPrefixSMS, ptrUrlSchemeStripped))
		{
			// SMS
			retVal = HandleMailToL(ESMS, ptrUrlSchemeStripped, ETrue);
		}
		else if (StripPrefix(*hBufURL, KProtocolPrefixMMS, ptrUrlSchemeStripped))
		{
			// MMS
			retVal = HandleMailToL(EMMS, ptrUrlSchemeStripped, ETrue);
		}
		// Note, must check for "unix style" file:/// urls (triple slash) before other style (double slash)
		/* AKAR-7UDFZ3: In case of Plugin & Widget mode, we should be passing
		 * the file:// URL to browser directly, instead of handling it in Host engine side.
		 * Currently with this change, browser does not launch the URL in case Widget mode, 
		 * changes are required from browser side also(EJPY-7UT74J).
		 */ 
		//else if (!iBrowserPluginActive && 
		else if ((iExecutionMode == eStandAlone) &&
				(StripPrefix(*hBufURL, KProtocolPrefixFileUnixStyle, ptrUrlSchemeStripped) ||
				 StripPrefix(*hBufURL, KProtocolPrefixFile, ptrUrlSchemeStripped)))
		{
			HandleFileURLL(ptrUrlSchemeStripped, aUrlInfo);
			retVal =  1;
		}
		else if (StripPrefix(*hBufURL, KProtocolPrefixExtendedRenderingMyData, ptrUrlSchemeStripped) ||
				 StripPrefix(*hBufURL, KProtocolPrefixExtendedRenderingSystem, ptrUrlSchemeStripped))
		{
			// Do not process any Extended rendering -specific requests
			retVal = 0;
		}
		else
		{
			// if not one of the above schema, send it to the browser.

			// Unfortunately, the WWW_OpenURL message doesn't support post data.
			// We'll try to fake it with a GET.
			HBufC* hBufPostData = NULL;
			HBufC* fullUrl = NULL;
			TPtrC  ptrFullURL;
			unsigned short result = 0;
			if (aUrlInfo->postData)
			{
				// Post data may need to be decoded/converted from UTF-8
				TPtrC8 ptrPostData(aUrlInfo->postData,aUrlInfo->postDataLength);
				// hBufPostData = ConvertToUnicodeLC(ptrPostData, urlIsUTF8);
				// rborcic 2005/09/25 - converting the text to Unicode isn't always valid
				// in most cases, it makes more sense to URL encode the non-ASCII data.
				hBufPostData = URLEncodePostDataLC(ptrPostData);

				if (hBufPostData)
				{

					// create some allocation space
					const TInt maxLen=ptrUrl.Length()+hBufPostData->Length() + 1; // 1 for ?
					fullUrl=HBufC::NewLC(maxLen);

					// get the heap into a TPtr
					TPtr ptr(fullUrl->Des());

					// set the data from the URL
					HBufC* hBufPureUrl = CreateEpocStringLC((const char*)ptrUrl.Ptr(), ptrUrl.Length());
					ptr.Append(*hBufPureUrl);

					ReplaceAll(ptr, KCharBackslash, KCharForwardSlash); // To replace any backslash in the URL

					//if (iBrowserPluginActive)
					if (iExecutionMode == ePlugin)
						{
						MPluginStreamIf* streamIf = iFlashClientIf->GetStreamIf();
						if(streamIf)
                            {
                            if(aUrlInfo->target)
                                {
                                HBufC* hTargetString = CreateEpocStringLC(aUrlInfo->target, strlen(aUrlInfo->target));
                                if(hTargetString->Compare(_L("")) != 0)
                                    {
                                    result = streamIf->OpenUrlL(*hBufPureUrl, hTargetString->Des(), *hBufPostData);
                                    }
                                else
                                    {
						    result = streamIf->OpenUrlL(*hBufPureUrl, *hBufPostData);
                                    }
                                CleanupStack::PopAndDestroy(hTargetString);       
                                }
                            else
                                {
                                result = streamIf->OpenUrlL(*hBufPureUrl, *hBufPostData);
                                }
                            }
						CleanupStack::PopAndDestroy(hBufPureUrl);
						CleanupStack::PopAndDestroy(fullUrl);
						CleanupStack::PopAndDestroy(hBufPostData);
						CleanupStack::PopAndDestroy(hBufURL);

						return result;
						}
					CleanupStack::PopAndDestroy(hBufPureUrl);
					ptr.Append(KPostDataSeparator);
					ptr.Append(*hBufPostData);
					ptrFullURL.Set(*fullUrl);
				}
			}
			else
			{
				//if (iBrowserPluginActive)
				if (iExecutionMode == ePlugin)
				 	{
				 	TPtrC nullDes(NULL, 0);
                    
				 	// create some allocation space
					const TInt maxLen=ptrUrl.Length()+ 1; // 1 for ?
					
					// set the data from the URL
					HBufC* hBufPureUrl = CreateEpocStringLC((const char*)ptrUrl.Ptr(), ptrUrl.Length());

					MPluginStreamIf* streamIf = iFlashClientIf->GetStreamIf();
					if(streamIf)
					    {
                        if(aUrlInfo->target)
                            {
                            HBufC* hTargetString = CreateEpocStringLC(aUrlInfo->target, strlen(aUrlInfo->target));
                            if(hTargetString->Compare(_L("")) != 0)
                                {
                            result = streamIf->OpenUrlL(*hBufPureUrl, hTargetString->Des(), nullDes);
                                }
                            else
                                {
                                result = streamIf->OpenUrlL(*hBufPureUrl, nullDes);
                                }
                            CleanupStack::PopAndDestroy(hTargetString);    
                            }
                        else
                            {
                            result = streamIf->OpenUrlL(*hBufPureUrl, nullDes);
                            }
					    }
					    

					CleanupStack::PopAndDestroy(hBufPureUrl);
					CleanupStack::PopAndDestroy(hBufURL);
					
					return result;
					}
				ptrFullURL.Set(*hBufURL);
			}

			// Due to a redraw problem with the Web app, we have to exit flash if we are embedded.
			// To exit flash we must leave right back to the Active Scheduler due to CEikAppUi::Exit() design.
			// We cannot leave through player code, so must leave in a call stack without player functionality.
			// Therefore we will always launch the web browser async, then if we are embedded, we will be able to exit
			// cleanly.

			//copy what we need, then queue the app for launching...

			const TDesC* deses[2];
			deses[0]=&KLitBrowser;
			deses[1]=&ptrFullURL;

            //if (!iBrowserPluginActive)
			if(iExecutionMode == eStandAlone)
                {
                if (QueryAllowNetAccessL())
                    {
                    QueueSILaunchL(aMMObj,2, &(deses[0]),NULL,EFalse);
                    }
                }

			// cleanup the allocation space - if used
			if (fullUrl)
			{
				CleanupStack::PopAndDestroy(fullUrl);
			}
			if(hBufPostData)
			{
				CleanupStack::PopAndDestroy(hBufPostData);
			}

			retVal = 1;
		}
	}
	else
	{
		hBufURL = CreateEpocStringLC(aUrlInfo->url, aUrlInfo->urlLength);
		retVal = HandleRelativeUrlL(*hBufURL, aUrlInfo);
	}
	CleanupStack::PopAndDestroy(hBufURL);
	return retVal;
}


void CPlatformFlashEngine::HandleFileURLL(const TDesC& aUrl, struct FI_GetURLCallInfo* aOriginalUrlInfo)
{

	if (iNewFile)
	{	// must have received another request between processing the request and the next timer tick.
		// Ignore the old request.
		delete iNewFile;
		iNewFile = NULL;
	}


	//host needs to search for '?' and remove it and everything after it.
	//We can't handle GET style arguments here which was appended and sent by core player.
	//Refer eroom:377

	TPtrC url = aUrl;
	TInt pos = url.Find(KFlhExtraChar);
	if(pos != KErrNotFound)
	{
		url.Set(url.Left(pos));
	}

	// TODO: do we need to pre-parse the url and replace | char with colon drive delim : ???
	TPtrC ptrUrlExt = url.Right(KFlhFileExtensionSWF().Length());

	// Copy URL to local buffer where we can manipulate it
	HBufC* hBufUrl = url.AllocLC();
	TPtr ptrUrl = hBufUrl->Des();
	ReplaceAll(ptrUrl,KCharForwardSlash,KCharBackslash);


	// check to make sure this is a SWF, otherwise redirect it.
	if (ptrUrlExt.CompareF(KFlhFileExtensionSWF) != 0 && ptrUrlExt.CompareF(KFlhFileExtensionSVG) != 0)
	{
		// redirect
		RFile file;
		TInt err = file.Open(iFs, *hBufUrl, EFileRead | EFileShareExclusive | EFileStream);
        file.Close();
		if (err != KErrNone)
		{
			ForceRefresh();

			if (err != KErrNone)
			{
				//if(!iBrowserPluginActive)
				if(iExecutionMode == eStandAlone)
					{
                    //iFlashUI->NotifyDataAccessError((char*)aOriginalUrlInfo->url, ECompleteFailedFileNotFound);
                    MUserNotiferIf* userNotifierIf =
                            iFlashClientIf->GetUserNotifierIf();
                    if (userNotifierIf)
                        userNotifierIf->NotifyDataAccessError((char*) aOriginalUrlInfo->url,ECompleteFailedFileNotFound);
                    }
				User::Leave(err);
			}

		}

		else
		{
			HBufC* fileBuf=HBufC::NewLC(KSchemeFile().Length()+aUrl.Length());
			TPtr fileURL(fileBuf->Des());
			fileURL.Append(KSchemeFile);
			fileURL.Append(aUrl);
			HandleBrowserURLL(fileURL);
			CleanupStack::PopAndDestroy(fileBuf);
		}
	}
	else
	{
		TPtrC ptrFileURL(*hBufUrl);
		// remove leading slashes (now converted to backslashes)
		TInt i = 0;
		const TInt count = ptrFileURL.Length();
		while (i<count && ptrFileURL[i] == KCharBackslash)
		{
			i++;
		}
		if(i==count)
		{
			ptrFileURL.Set(KNullDesC);
		}
		else
		{
			ptrFileURL.Set(ptrFileURL.Mid(i));
		}
		TInt err;
		RFile file;

		TFileName fname;

		if (ptrFileURL.Locate(':') == KErrNotFound)
		{
			fname.Copy(PathInfo::PhoneMemoryRootPath());
			fname.Append(PathInfo::OthersPath());
		}

		fname.Append(ptrFileURL);

		iNewFile = fname.AllocL();

		err = file.Open(iFs, *iNewFile, EFileRead | EFileShareExclusive | EFileStream);

		if (err != KErrNone)
		{
			fname.SetLength(0);
			if (ptrFileURL.Locate(':') == KErrNotFound)
			{
				fname.Copy(PathInfo::MemoryCardRootPath());
				fname.Append(PathInfo::OthersPath());
			}
			fname.Append(ptrFileURL);

			delete iNewFile;
			iNewFile=NULL;

			// Save the new file name.. so that we can open it when the Async Event Handler is triggered.
			iNewFile = fname.AllocL();

			err = file.Open(iFs, *iNewFile, EFileRead | EFileShareExclusive | EFileStream);
		}

		if (err == KErrNone)
		{
			file.Close();
			TriggerAsyncEvent();
		}
		else
		{
			delete iNewFile;
			iNewFile = NULL;
			ForceRefresh();
			//if(!iBrowserPluginActive)
			if(iExecutionMode == eStandAlone)
				{
				//iFlashUI->NotifyDataAccessError((char*)aOriginalUrlInfo->url, ECompleteFailedFileNotFound);
				MUserNotiferIf* userNotifierIf = iFlashClientIf->GetUserNotifierIf();
				if (userNotifierIf)
				    userNotifierIf->NotifyDataAccessError((char*)aOriginalUrlInfo->url, ECompleteFailedFileNotFound);
				}
			}
		}
	CleanupStack::PopAndDestroy(hBufUrl);
}

HBufC* ResolveRelativeUrlL(const TDesC& aBaseURL, TDesC& aRelURL)
{
	const TUint16* s = aRelURL.Ptr();
	TInt tailSpot = 0;
	TInt up = 1;
	TInt i;
	TInt relURLlen = aRelURL.Length();

	for (i=0;i<relURLlen;)
	{
		if (*s == '.')
		{
			s++; i++;
			if (*s == '.')
			{
				s++; i++;
				if (*s == KCharBackslash || *s == KCharForwardSlash) // handles "../" case
				{
					up++;
					s++; i++;
					tailSpot = i;
				}
			}
			else if (*s == KCharBackslash || *s == KCharForwardSlash) // handles "./" case
			{
				s++; i++;
				tailSpot = i;
			}
		}
		else
		{
			s++; i++;
		}
	}


	TInt strLen = aBaseURL.Length() - 1;
	TInt lastSlash = strLen;

	for (i=strLen;i>=0;i--)
	{
		if (aBaseURL[i] == KCharBackslash || aBaseURL[i] == KCharForwardSlash)
		{
			up--;
			if (up == 0)
			{
				lastSlash = i;
				break;
			}
		}
	}

	TInt tailLen = relURLlen - tailSpot;
	TUint16* pNewURL = new(ELeave) TUint16[lastSlash+tailLen+2];
	CleanupStack::PushL(pNewURL);

	for (i=0;i<=lastSlash;i++)
	{
		pNewURL[i] = aBaseURL[i];
	}

	for (i=0;i<tailLen;i++)
	{
		pNewURL[i+lastSlash+1] = aRelURL[tailSpot+i];
	}
	pNewURL[lastSlash+tailLen+1] = '\0';
	HBufC* hNewURL = HBufC::NewL(lastSlash+tailLen+2);
	hNewURL->Des().Copy(pNewURL);
	CleanupStack::PopAndDestroy(pNewURL);

	return hNewURL;
}


unsigned short CPlatformFlashEngine::HandleRelativeUrlL(const TDesC& aUrl, struct FI_GetURLCallInfo* aOriginalUrlInfo)
{

	unsigned short retVal = 0;
	if (iBaseURL == NULL)
		{
		//if(!iBrowserPluginActive)
		if(iExecutionMode == eStandAlone)
			{
			//iFlashUI->NotifyDataAccessError((char*)aOriginalUrlInfo->url, ECompleteFailedFileNotFound);
			MUserNotiferIf* userNotifierIf = iFlashClientIf->GetUserNotifierIf();
            if (userNotifierIf)
                userNotifierIf->NotifyDataAccessError((char*)aOriginalUrlInfo->url, ECompleteFailedFileNotFound);
			}
		}
	else
	{
		TPtrC ptrUrl = aUrl;
		if (ptrUrl[0] == KCharForwardSlash)
		{
			ptrUrl.Set(ptrUrl.Mid(1));
		}

		HBufC* hUrl = ptrUrl.AllocLC();
		HBufC* newURL = ResolveRelativeUrlL(*iBaseURL, *hUrl);
		CleanupStack::PopAndDestroy(hUrl);
		CleanupStack::PushL(newURL);

		FI_GetURLCallInfo urlInfo;
		urlInfo.url = CreateFlashStringL(*newURL);
		urlInfo.urlLength = (TUint16)FlashStrLen(urlInfo.url);
		urlInfo.pEventInfo = NULL;
		urlInfo.postData = NULL;
		urlInfo.postDataLength = 0;

		retVal = SI_Interface::SI_GetURL(iMMObject, &urlInfo);

		delete[] (char*)(urlInfo.url);
		CleanupStack::PopAndDestroy(newURL);

	}
	return retVal;
}


TUint16 CPlatformFlashEngine::HandleTelL(const TDesC& aTelString)
{
	// check string for invalid characters
	TChar c = 0;
	TBuf<KMaxSymbianPhoneNumberLength> sSymbianPhoneNumber;
	TBool badChar = EFalse;
	TInt count = 0;
	for (count = 0; count < aTelString.Length(); count++)
	{
		c = aTelString[count];
		switch (c)
		{
			// these chars are allowed by Symbian
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':
			case '#':
			case '*':
			case '+':
			case 'w':
			sSymbianPhoneNumber.Append(c);
			if (count >= KMaxSymbianPhoneNumberLength)
			{
				continue;
			}
			break;

			case 'p':
			// The RCall::Dial() API ignores everything after the 'p', and some v2 FP1 phones crash when there's a 'p' in
			// the dial string, so we might as well ignore everything after the 'p'.
			count = aTelString.Length();
			continue;

			// these chars are OK, but Symbian doesn't like them.
			case '(':
			case ')':
			case ' ':
			case '-':
			case '.':
			break;


			default:
			badChar = ETrue;
		}
	}

	if (badChar || (count == 0))
	{
		//if(!iBrowserPluginActive)
			{
			//iFlashUI->NotifyClientError(EInvalidTelURLError, EFalse, EFalse);
			
			}
		return 1;
	}
	else
	{
		if (QueryAllowPhoneCallL(sSymbianPhoneNumber))
		{
            CPhoneMonitor* phoneMonitor = GetPhoneMonitorL();
			if(phoneMonitor)
			    phoneMonitor->MakeCallL(sSymbianPhoneNumber);
		}
		return 0;
	}
}

void CPlatformFlashEngine::NotifyFocusChangeL(TBool aIsActive)
{
	if (aIsActive)
	{
		Pause(EReasonBackground);
#ifdef FEATURE_OPENVG		
		if(iOpenVgMode)
        {
            if (!IsForegroundTask())        	    
                SwitchToSoftwareRendering(ETrue);   
            else
                DestroyEglSurface();
        }
#endif
		
	}
	else
	{
    if (IsForegroundTask())
    {
#ifdef FEATURE_OPENVG       
            if(iOpenVgMode)
            {
                if(iEGLSurface.surface == EGL_NO_SURFACE && iSwfStarted)
                    CreateEglSurfaceL();
            }
            else 
            {
                TBool nativeVideo = EFalse;
                if(iConfig.iHelixFlvMode && iFlvDecoderArray.Count())
                    nativeVideo = ETrue;
          
                if(!nativeVideo)
                {    
#ifdef FEATURE_WATCH_GPU_MEM
                    if(!iGPUMemLow)
#endif  
                        SwitchToHwxRendering(ETrue);
                }
            }
#endif
    
            //if (!iBrowserPluginActive)
			if(iExecutionMode == eStandAlone)
            {
                ResumeL(EReasonBackground, EFalse);
            }
            //if (iBrowserPluginActive)
			else
            {
                ResumeL(EReasonBackground, ETrue);
            }
    }
	}
}

void CPlatformFlashEngine::LaunchAppL(TFixedArray<TUid,5>* aUidsOfAppToLaunch, TInt aNumUidsToTry, TInt aArgc, HBufC** aArgv)
{
	// initialize what is needed and push on the cleanup stack
	// find the app
	RApaLsSession apaSession;
	User::LeaveIfError(apaSession.Connect());
	CleanupClosePushL(apaSession);

	TInt error=KErrNotFound;
	TApaAppInfo info;

	for(TInt jj=0;jj<aNumUidsToTry && error;jj++)
	{
		error=apaSession.GetAppInfo(info,aUidsOfAppToLaunch->At(jj));
	}

	User::LeaveIfError(error);

#if (defined(SYMBIAN_SUPPORT_UI_FRAMEWORKS_V1) || !defined(SYMBIAN_HIDE_UI_FRAMEWORKS_V1)) && !defined(SYMBIAN_REMOVE_UI_FRAMEWORKS_V1)
	// now form the command line and run the application...
	CApaCommandLine* cl=CApaCommandLine::NewLC();

	// append args to string
	if ( aArgc > 1 )
	{
		TInt lenNeeded=0;

		for (TInt i=1; i < aArgc; i++)
		{
		    const TDesC* des = aArgv[i];
			lenNeeded += des->Length() + 1;
		}

		HBufC* argBuf = HBufC::NewLC(lenNeeded);
		TPtr argPtr = argBuf->Des();

		for (TInt j=1; j < aArgc; j++)
		{
		    const TDesC* des = aArgv[j];
			argPtr.Append(*des);

			if( (j+1) < aArgc )
			{
				argPtr.Append(KLitSpace);
			}
		}

		cl->SetFullCommandLineL(argPtr);

		CleanupStack::PopAndDestroy(argBuf);
	}

	cl->SetLibraryNameL(info.iFullName);

	User::LeaveIfError(apaSession.StartApp(*cl));

	CleanupStack::PopAndDestroy(cl);
	CleanupStack::PopAndDestroy(&apaSession);

#else

	TFindFile findFile( iFs );
	TInt ret = findFile.FindByDir(info.iFullName, KNullDesC);

	CApaCommandLine* cmdLine = CApaCommandLine::NewLC ( );

	cmdLine->SetExecutableNameL( findFile.File() );

	cmdLine->SetCommandL( EApaCommandOpen );

	// append args to string
	if ( aArgc > 1 )
	{
		TInt lenNeeded=0;

		for (TInt i=1; i < aArgc; i++)
		{
		    const TDesC* des = aArgv[i];
			lenNeeded += des->Length() + 1;
		}

		HBufC* argBuf = HBufC::NewLC(lenNeeded);
		TPtr argPtr = argBuf->Des();

		for (TInt j=1; j < aArgc; j++)
		{
		    const TDesC* des = aArgv[j];
			argPtr.Append(*des);

			if( (j+1) < aArgc )
			{
				argPtr.Append(KLitSpace);
			}
		}

		cmdLine->SetDocumentNameL(argPtr);
		CleanupStack::PopAndDestroy(argBuf);
	}

	User::LeaveIfError ( apaSession.StartApp(*cmdLine) );
	CleanupStack::PopAndDestroy(cmdLine);
	CleanupStack::PopAndDestroy(&apaSession);

#endif
}


void CPlatformFlashEngine::LaunchAppL(const TDesC &aPath, const TDesC &aArgs)
{
    RApaLsSession ls;
    User::LeaveIfError(ls.Connect());
    CleanupClosePushL( ls );

	if ( aArgs == KNullDesC )
		{
		CApaCommandLine* cmdLine = CApaCommandLine::NewLC ( );
		cmdLine->SetExecutableNameL( aPath );
		cmdLine->SetCommandL( EApaCommandOpen );
		User::LeaveIfError ( ls.StartApp(*cmdLine) );
		CleanupStack::PopAndDestroy(cmdLine);
		CleanupStack::PopAndDestroy(&ls);
		return;
		}

    TBuf16<256> urlBuf;
    TPtrC ptrUrl(aArgs);
   	if(iFlashUid.iUid==KNullUidValue)
    {
    	TInt resoffset = FlashEngineRscHandler::LoadEngineResourceFileL();
		TResourceReader reader;
		iEnv->CreateResourceReaderLC(reader,R_FLASH_FLASH_UID_VALUE);
		iFlashUid.iUid=reader.ReadInt32();
		CleanupStack::PopAndDestroy(); //reader
		FlashEngineRscHandler::DeleteEngineResourceFile(iEnv, resoffset);
	}
    TBool isLocalFile = EFalse;
    TPtrC ptrUrlSchemeStripped;
    isLocalFile = StripPrefix(ptrUrl, KProtocolPrefixFileUnixStyle, ptrUrlSchemeStripped);
    if (!isLocalFile)
    {
       isLocalFile = StripPrefix(ptrUrl, KProtocolPrefixFile, ptrUrlSchemeStripped);
    }

    if (isLocalFile)
	{
        HBufC16* pathBuf = ptrUrlSchemeStripped.AllocLC(); // 2
        TPtr16 ptrPath = pathBuf->Des();
        ReplaceAll(ptrPath, KCharForwardSlash, KCharBackslash);

        RFile file;
		TInt errValue = file.Open(iFs, ptrPath, EFileRead);
		if (errValue != KErrNone)
		{
			User::Leave (KErrNotFound);
		}
		file.Close();
        TDataType dataType;
        TUid uid;
		User::LeaveIfError(ls.AppForDocument(ptrPath, uid, dataType));
		if (uid != iFlashUid)
		{
            TApaTaskList taskList (iEnv->WsSession());
            TApaTask task = taskList.FindApp(uid);
            if (task.Exists())
            {
                User::LeaveIfError(task.SwitchOpenFile(ptrPath));
                task.BringToForeground();
            }
            else
            {
                TThreadId threadId;
                User::LeaveIfError(ls.StartDocument(ptrPath, threadId));
            }
		}
        else
        {
            // Construct URL of form "file://e:/Others/subdir/document.html".
            urlBuf.Copy(aArgs);
            ReplaceAll(urlBuf, KCharBackslash, KCharForwardSlash);
        }
        CleanupStack::PopAndDestroy(pathBuf); // 1
	}
	else
	{
        urlBuf.Copy(ptrUrl);
        ReplaceAll(urlBuf, KCharBackslash, KCharBackslash);
    }

        TApaTaskList taskList(iEnv->WsSession());
	    TApaTask task = taskList.FindApp(iFlashUid);
        TThreadId id;
        ls.StartDocument(urlBuf, id);
		CleanupStack::PopAndDestroy(&ls);
}

void CPlatformFlashEngine::ForceRefresh()
{
	// ??? We need to clear the frame buffer if the player is not active or
	// simply refresh. We don't want the call to FI_UpdateRect. We need to
	// fix this.
//	iFiObject.FI_UpdateRect(rect);

	DrawBitBuffer();
}


void CPlatformFlashEngine::StopPlaying()
{
	if (iPlayerState != EPlayerStoppedError)
	{
		iPlayerState = EPlayerStoppedError;
	}
	else
	{
		return;
	}

	iIsRunning = EFalse;
	StopTimer();

    if(iSoundHandler)
    {
        iSoundHandler->StopSound();
        iSoundHandler->CleanupCachedFiles(iFs);
    }
}

void CPlatformFlashEngine::AbortPlayer()
{
	if ( iMMObject )
	{
		StopTimer();
        if(iSoundHandler)
        {
            iSoundHandler->StopSound();
            iSoundHandler->CleanupCachedFiles(iFs);
        }
		DestroyPlayer();
	}

	//if(!iBrowserPluginActive)
	if(iExecutionMode == eStandAlone)
	{
		TRAP_IGNORE(ResetSoftkeysAndScreenL(iFlashClientIf->GetDisplay())); // abort player should not be able to leave
	}
}

TBool CPlatformFlashEngine::GetCurrentFont(CFont*& aFont)
{
	if(iCurrentFontId > 0)
	{
		TBool ret = ETrue;
		aFont = iFontMapTable->GetFont(iCurrentFontId);
		if(!aFont)
			ret = EFalse;
		
		return (ret);
	}

	//TODO: Can be moved to a function
	CFbsBitmapDevice* bitmapDevice = NULL;

	if(iWindowMode == EWindow)
	{
		bitmapDevice = iBitmapDevice;
#ifdef FEATURE_OPENVG
		if(iOpenVgMode) {
		    bitmapDevice = iAuxTextBitmapDevice;
		}
#endif
	}
#ifdef FEATURE_WINDOWLESS
	else
	{
		bitmapDevice = iWlessDevice;
	}
#endif
	
    if (!iDefaultFont && bitmapDevice)
	{
		_LIT(kMyFontName,"SwissA");
		TFontSpec	myFontSpec(kMyFontName,KDefaultFontSize);
		myFontSpec.iFontStyle.SetPosture ( EPostureUpright );
		myFontSpec.iFontStyle.SetStrokeWeight ( EStrokeWeightNormal );

        bitmapDevice->GetNearestFontInPixels(iDefaultFont, myFontSpec);
        iDefaultFontBitmapDevice = bitmapDevice;
    }

    if (iDefaultFont)
    {
        aFont = iDefaultFont;
        return 1;
    }

	return 0;
}

unsigned short CPlatformFlashEngine::SetCurrentFont(void* aPFontId)
{
	iCurrentFontId = (TInt) aPFontId;
	return 1;
}

unsigned short CPlatformFlashEngine::DestroyFont(void* aPFontId)
{
	TInt fontId = (TInt)aPFontId;

	if(iCurrentFontId == fontId)
		iCurrentFontId = 0;

	CFont* font = iFontMapTable->GetFontEntryFromFontId(fontId);
#ifdef FEATURE_OPENVG
	if (iOpenVgMode && font && iAuxTextBitmapDevice) 
	{
		iAuxTextBitmapDevice->ReleaseFont(font);
	} 
	else
#endif 
	{
	    if(iWindowMode == EWindow)
        {
            if (font && iBitmapDevice) 
            {
                iBitmapDevice->ReleaseFont(font);
            }
        }
#ifdef FEATURE_WINDOWLESS
        else
        {
            if(font && iWlessDevice)
            {
                iWlessDevice->ReleaseFont(font);
            }
        }
#endif	//FEATURE_WINDOWLESS
	}

	iFontMapTable->RemoveFontEntry(fontId);
	
	return 1;
}

/*MFlashClientAppInfo* CPlatformFlashEngine::GetAppInfoIf() const
{
    return iAppInfo;
}*/

/*
MFlashUI* CPlatformFlashEngine::GetUI()
{
	return iFlashUI;
}

MFlashPlugin* CPlatformFlashEngine::GetPlugin()
{
	return iControl;
}
*/

/* private */
CFbsBitGc* CPlatformFlashEngine::GetBitmapContext()
{
    if(!iRenderToBitmap)
        return NULL;

    if (iWindowMode == EWindow)
    {
        if (iBitmapGc)
        {
            return iBitmapGc;
        }
    }
#ifdef FEATURE_WINDOWLESS    
    else
    {
        if (this->iWlessGc)
        {
            return iWlessGc;
        }
    }
#endif //FEATURE_WINDOWLESS


    if (iWindowMode == EWindow)
    {
        if (KErrNone != iBitmapDevice->CreateContext(iBitmapGc))
        {
            iBitmapGc = NULL;
        }

        return iBitmapGc;
    }
#ifdef FEATURE_WINDOWLESS    
    else
    {
        if(iWlessDevice)
        {
        	if (KErrNone != this->iWlessDevice->CreateContext(this->iWlessGc))
            {
        		iWlessGc = NULL;
            }

        	return iWlessGc;
        }
    }
#endif //FEATURE_WINDOWLESS
    
    return NULL;
}

CFbsBitGc* CPlatformFlashEngine::GetTextBitmapContext()
{
    CFbsBitGc* gc = NULL;
    
#ifdef FEATURE_OPENVG
    if(iOpenVgMode) 
    {
        gc = GetAuxTextBitmapContext();
    }
    else 
#endif
    {
        gc = GetBitmapContext();    
    }
    
 	return gc;
}



CWindowGc* CPlatformFlashEngine::GetWindowContext()
{
	if (iWindowGc)
		{
	    delete iWindowGc;
	    iWindowGc = NULL;
		}

	CWsScreenDevice* pScreenDevice = iEnv->ScreenDevice();
	if ( pScreenDevice->CreateContext(iWindowGc) != KErrNone )
	{
		iWindowGc = NULL;
	}
	else
		{
		MDisplay* display = iFlashClientIf->GetDisplay();
		RWindow* lWindow = display->GetWindow();
		iWindowGc->Activate(*lWindow);
		/*
		if(iBrowserPluginActive)
			{
			RWindow lWindow = iControl->GetWindow();
			iWindowGc->Activate(lWindow);
			}
		else
			{
			RWindow* lWindow = iFlashUI->GetWindow();
			iWindowGc->Activate(*lWindow);
			}
			*/
		}
	return iWindowGc;
}

void CPlatformFlashEngine::BeginTextDraw()
{
}

void CPlatformFlashEngine::EndTextDraw()
{
}

TBool CPlatformFlashEngine::DrawTextL(const struct FI_Text* aText, struct FI_TextInfo* aTextInfo, void* aBits, TInt aWidth, TInt aHeight)
{
    
	TBool lReturnValue = ETrue;// If Text is not rendered on screen, lReturnValue must be changed to False

    CFbsBitGc* pGc = GetTextBitmapContext();
	CFont * pFont = NULL;

	CWsBitmap* lBitmap = NULL;
    CFbsBitmapDevice* lBitmapDevice = NULL;
    TUint32 bgTextBitmapColor = 0;
    if (aBits)
        {
            {
            pGc = NULL;
            // Initialize background color of text bitmap to something other than the color of the text itself.
            if (aTextInfo->red == 0 && aTextInfo->green == 0
                    && aTextInfo->blue == 0)
                {
                bgTextBitmapColor = 0xFFFFFFFF;
                }
            else
                {
                bgTextBitmapColor = 0x00000000;
                }

            if ((lBitmap = new CWsBitmap(iEnv->WsSession())) == NULL
                    || (lBitmap->Create(TSize(aWidth, aHeight), EColor16MU)
                            != KErrNone) || (lBitmapDevice
                    = CFbsBitmapDevice::NewL(lBitmap)) == NULL)
                {
                if (lBitmap)
                        delete lBitmap;
                    lReturnValue = EFalse;
                    return lReturnValue;
                }
            if (KErrNone != lBitmapDevice->CreateContext(pGc))
                {
                pGc = NULL;
                if(lBitmap)
                    delete lBitmap;
                if(lBitmapDevice)
                    delete lBitmapDevice;
                lReturnValue = EFalse;
                return lReturnValue;
                }
          //  pGc->UseBrushPattern(lBitmap);
            //pGc->SetBrushStyle(CGraphicsContext::EPatternedBrush);
                lBitmap->BeginDataAccess(); 
                 
                TUint32* ptrStartBmp = lBitmap->DataAddress();
			    			memset(ptrStartBmp,bgTextBitmapColor,aWidth * aHeight*4);
			    			
			    			lBitmap->EndDataAccess(ETrue);
                }
                
            }
        if ( pGc && GetCurrentFont( pFont ) )
        {
        
            TPtrC ptr( aText->text.utf16String, aText->textLen );
        TRect rect(aTextInfo->xMin, aTextInfo->yMin, aTextInfo->xMax,
                         aTextInfo->yMax);

        TRgb color(aTextInfo->red, aTextInfo->green, aTextInfo->blue);
		
		TPoint	pt( aTextInfo->xPos, aTextInfo->yPos );

		pGc->SetPenColor( color );

		pGc->SetClippingRect( rect );
		pGc->UseFont( pFont );		

		/*Fix for RC case ou1cimx1#482693. We are supposed 
		to call FI_SetDirtyRect function whenever device doesn't
		support rendering of text at particular degree as it 
		consumes lot of cpu*/
		if(aTextInfo->rotation == 0)
        {
            pGc->DrawText( ptr, pt );               
        }
		else
		{
			TInt rotation = aTextInfo->rotation >> 16;
			if (rotation < 0)
			{
				rotation += 360;
			}
			else if (rotation >= 360)
			{
				rotation -= 360;
			}		

			if (rotation == 90)
			{
				//Draw Text Vertically Downward.
                pGc->DrawTextVertical(ptr, pt, EFalse);               
			}
			else if (rotation == 270)
			{
				//Draw text vertically Upward.
                pGc->DrawTextVertical(ptr, pt, ETrue);                   
			}
			else if (rotation == 0)// This is hit if rotation is passed as 0 or 360.
                {
					pGc->DrawText(ptr, pt );                    
                }
			else
			{
				//Since, Symbian can't rotate 180 degrees, we made some adjustments
				//above to simulate the position of the rotated character(s).  However, since the
				//character(s) itself isn't rotated we might be drawing the text outside the dirty
				//region calculated by the player.  So we should, therefore, call FI_SetDirtyRect on
				//the player with the new dirty rect.  Not doing so will leave the artifacts of the drawn
				//characters here in the next frame.
				FI_Rect unrotatedDirtyRect;
				unrotatedDirtyRect.xmin = aTextInfo->xMin;
				unrotatedDirtyRect.xmax = aTextInfo->xMax;
				unrotatedDirtyRect.ymin = aTextInfo->yMin;
				unrotatedDirtyRect.ymax = aTextInfo->yMax;
				if (rotation == 180)
				{
					// would handle 180 degree rotation, but Symbian doesn't support that
					// simulate rotating 180 by shifting the drawing point.
					pt.iY += pFont->AscentInPixels();
					pt.iX -= pFont->TextWidthInPixels(ptr);
		
                    unrotatedDirtyRect.xmin
                            = (short) (unrotatedDirtyRect.xmin
                                    - (short) pFont->TextWidthInPixels(ptr));
                    unrotatedDirtyRect.ymax
                            = (short) (unrotatedDirtyRect.ymax
                                    + (short) pFont->AscentInPixels());
                    pGc->DrawText(ptr, pt );                        
					iFiObject.FI_SetDirtyRect(&unrotatedDirtyRect, false);
				}
				else // for all other angles text is not rendered on screen.
				{
					lReturnValue = EFalse;
					iFiObject.FI_SetDirtyRect(&unrotatedDirtyRect, false);
				}
			}
	    }
		pGc->DiscardFont();
		pGc->CancelClippingRect();
	}
	if(lBitmap)
	    {
	    	//iEnv->WsSession().Flush();
       	// Copy only the text to the buffer given by the core player not the whole bitmap.Hence commenting the memcopy.
				TUint32* src = NULL;
      	TUint32* dst = NULL;
				TInt srcWidth = aTextInfo->xMax - aTextInfo->xMin;
        TInt srcHeight = aTextInfo->yMax - aTextInfo->yMin;
        TInt srcIncr,dstIncr;
        
        src = lBitmap->DataAddress() + (aTextInfo->yMin * aWidth)
                + aTextInfo->xMin;
        dst = (TUint32*)aBits + (aTextInfo->yMin * aWidth) + aTextInfo->xMin;
        srcIncr = dstIncr = aWidth;
        
        TUint32 d = 0xFF000000 | ((aTextInfo->red) << 16)
                | ((aTextInfo->green) << 8) | (aTextInfo->blue);
        TInt i, j;
        TUint32* dstPix,*srcPix;
        
        lBitmap->BeginDataAccess();
      			
      			for( j = 0; j < srcHeight; ++j )
              {
   							dstPix = dst;
                srcPix = src;
                dst+= dstIncr;
                src+= srcIncr;
									for ( i = 0; i < srcWidth; ++i )
                  	{
                      if(*srcPix != bgTextBitmapColor)
                          *dstPix = d;
                      ++srcPix;
                      ++dstPix;
                  	}
              }
             
			lBitmap->EndDataAccess(ETrue);
      
	    	delete lBitmap;
	    if(lBitmapDevice)
	        {
	         delete lBitmapDevice;
	         if(pGc)
	             delete pGc;
	        }
	    }

// Fix for refresh problems in text contents
// iSource bug 12069
/* Removed calling of ForceRedraw(), as this fix caused DCTS failures. 
 * ERoom: 934 & 947. iSource: 12069 also works fine without calling ForceRedraw().
 */

	return lReturnValue;
}

TBool CPlatformFlashEngine::IsForegroundTask()
{
	return iForeground;
}

void CPlatformFlashEngine::NotifyPhoneActiveL(TBool aIsActive)
{
	if(!iMMObject) //i.e. player is not created and swf playing is not started hence we will pause inside
								// DoRunL().
		{
		iPauseforActiveCall = ETrue;
		return;
		}
//    if (!iBrowserPluginActive)
	if(iExecutionMode == eStandAlone)
        {        
        if (aIsActive)
            {
            //If Engine is Not Already Paused for another Reason            
            if(!IsPaused())
            	{
            	//Multiple Calls to Enable Pause Blinker are not
            	//Possible, as only first time we get this function
            	//Call with (aActive == TRUE) the Engine may not be
            	//Paused. Next time, it has to be Paused!
            	iFlashClientIf->NotifyPhoneActiveL(ETrue); //Enable Pause Blinker
            	}
            Pause(EReasonPhone);
            }
        else
            {
            ResumeL(EReasonPhone, ETrue);
            if(!IsPaused())//Engine has Resumed!
            	{
            	//Multiple Calls to this are Possible,if this function
            	//is called with EFalse multiple times,but this does
            	//not have any side effects as we are Disabling only if
            	//Engine has resumed and (in PlayerControl) if Blinker 
            	//is currently Active.
            	iFlashClientIf->NotifyPhoneActiveL(EFalse); //Disable Pause Blinker
            	}
            }
        /*if(iFlashUI)
        	{
        	iFlashUI->NotifyPhoneActiveL(aIsActive);
        	}*/  
        //iFlashClientIf->NotifyPhoneActiveL(aIsActive);       
        	
        }
   else
	   {
	   if(aIsActive)
		   {
		   iCurrentVolume = GetVolume();
		   SetVolume(iCurrentVolume|KMuteMask);
		   Pause(EReasonPhone);
		   }
	   else
		   {
		   ResumeL(EReasonPhone, ETrue);
		   //if muted unmute
		   iCurrentVolume = GetVolume();
		   if(iCurrentVolume & KMuteMask)
			   {
		   	   SetVolume(iCurrentVolume&KUnMuteMask);
			   }
		   }

	   }
    iPauseforActiveCall = EFalse;

}

void CPlatformFlashEngine::ResetSoftKeys()
{
    TInt i;
    for(i=0; i<iSoftkeyArraySize; i++)
    {
        delete iSoftkeyArray[i];
        iSoftkeyArray[i] = 0;
    }
	iChangeKeysRequest = EChangeScreenResetSoftkeys;
	TriggerAsyncEvent();
}

#ifdef FEATURE_INLINE_TEXT_ENTRY
void CPlatformFlashEngine::RestoreSoftKeys( )
{
	iChangeKeysRequest = EChangeScreenResetSoftkeys;

	if ( iSoftkeyArray )
	{
		// We invoke the SetSoftKeys if iSoftkeyArray contains actual values
		// Otherwise, we ResetSoftKeys
		TBool containsSoftKeyValues = false;
		for ( TInt i=0; i < iSoftkeyArraySize && !containsSoftKeyValues; i++ )
		{
			containsSoftKeyValues = ( NULL != iSoftkeyArray[i] );
		}

		if ( containsSoftKeyValues )
		{
			iChangeKeysRequest = EChangeScreenSetSoftkeys;
		}
	}

	TriggerAsyncEvent();
}
#endif // FEATURE_INLINE_TEXT_ENTRY

void CPlatformFlashEngine::SetSoftKeys(HBufC** aKeyStrings, TInt aKeyCount)
{
	if (iSoftkeyArray)
	{
		TInt i;
		for (i=0; i<aKeyCount; i++)
		{
			if (i < iSoftkeyArraySize)
			{
				if(aKeyStrings[i])
				{
					delete iSoftkeyArray[i];
					iSoftkeyArray[i] = aKeyStrings[i];
				}
			}
			else
			{
				// Make sure that we delete any softkey strings
				// that we can't use.
				delete aKeyStrings[i];
			}
		}
	}

	iChangeKeysRequest = EChangeScreenSetSoftkeys;
	TriggerAsyncEvent();
}

void CPlatformFlashEngine::ConvertCStringToUTF16L(const char* aSrcCString, FI_ReturnString* aDstString)
{
	TInt strLen = FlashStrLen(aSrcCString);

	// Create the result string
	HBufC16* resultString = HBufC16::NewLC(strLen+1);
	TPtr resultDes = resultString->Des();

	// Create a buffer for the unconverted text - initialised with the input descriptor

	TPtrC8 cString;
	if (aSrcCString)
	{
		cString.Set((TUint8*)aSrcCString);
	}

	// Create a "state" variable and initialise it with CCnvCharacterSetConverter::KStateDefault
	// After initialisation the state variable must not be tampered with.
	// Simply pass into each subsequent call of ConvertToUnicode()
	TInt state = CCnvCharacterSetConverter::KStateDefault;

	// Request the character converter to perform the conversion
	const TInt returnValue = iCharacterConverter->ConvertToUnicode(resultDes, cString, state);

	// check to see that the descriptor isnt corrupt - leave if it is
	if (returnValue == CCnvCharacterSetConverter::EErrorIllFormedInput)
	{
		User::Leave(KErrCorrupt);
	}
	else if (returnValue != 0) // future-proof against "TError" expanding
	{
		User::Leave(KErrGeneral);
	}

	// Copy it back to dstString
	aDstString->SetUTF16String( aDstString, resultDes.PtrZ() );

	// Clean up stack
	CleanupStack::PopAndDestroy(resultString);
}

// This function converts UTF-16 to CString and return to caller
char* CPlatformFlashEngine::ConvertUTF16ToCStringL(const FI_UTF16Char* aSrcUnicodeString)
{

	// Create a buffer for the unconverted text - initialised with the input descriptor
	TPtrC16 unicodeText((TUint16*)aSrcUnicodeString);

	// Create a small output buffer.
    TBuf8<100> outputBuffer;

	char* currentString=NULL;
	CleanupStack::PushL(currentString);

	for(;;) // conversion loop
    {
		// Reset the buffer
		outputBuffer.Zero();

        // Start conversion. When the output buffer is full, return the
        // number of characters that were not converted
        const TInt returnValue = iCharacterConverter->ConvertFromUnicode(outputBuffer, unicodeText);

        // check to see that the descriptor isnt corrupt - leave if it is
        if (returnValue == CCnvCharacterSetConverter::EErrorIllFormedInput)
		{
            User::Leave(KErrCorrupt);
		}
        else if (returnValue < 0) // future-proof against "TError" expanding
		{
            User::Leave(KErrGeneral);
		}

        // Do something here to store the contents of the output buffer.
        // Finish conversion if there are no unconverted characters in the remainder buffer

		char* tempString = ReAllocString(currentString,(const char*)outputBuffer.Ptr(),outputBuffer.Length());
		User::LeaveIfNull(tempString);
		CleanupStack::PopAndDestroy(currentString);
		currentString = tempString;
		tempString = NULL;
		CleanupStack::PushL(currentString); // new one

        // Remove the converted source text from the remainder buffer.
        // The remainder buffer is then fed back into loop
        unicodeText.Set(unicodeText.Right(returnValue));

		// If there 's no more remaining characters to convert... done!!!
		if (returnValue == 0)
		{
			break;
		}
    }

	CleanupStack::Pop(currentString);
	return currentString;
}

// This function converts UTF-16 string to c-string then send it back to core
void CPlatformFlashEngine::ConvertUTF16ToCStringL(const FI_UTF16Char* aSrcUnicodeString, FI_ReturnString* aDstString)
{
	char* resultString=ConvertUTF16ToCStringL(aSrcUnicodeString);

	ASSERT(resultString); // debug only check - if this is null should have left already
	aDstString->SetCString( aDstString, resultString );
	delete resultString;

}

TInt32 CPlatformFlashEngine::GetAvailableDynamicMemory()
{
	TInt32 size = (TInt32)iPlayerDynamicHeapMaxSize - (TInt32)iPlayerDynamicHeapAlloced;
	return size;
}

TUint32 CPlatformFlashEngine::MemBlockSize()
{
	return KMemoryBlockSize;
}

void* CPlatformFlashEngine::AllocateDynamicMemory(TUint16 aNumBlocks)
{

#if defined (PLUG_IN_MEM_ALLOC) && !defined (__WINSCW__)
	MPluginMemHandlerIf* memHdlrIf = GetPluginMemHandlerIf();
	
	if(memHdlrIf)
	{
		if(memHdlrIf->IsMemAllocSupported())
		{
			return memHdlrIf->AllocMem(aNumBlocks);
		}
	}
#endif

	//Check for 3MB free RAM limit before every allocation

	TInt  freeRAM=0;
 	TInt r = HAL::Get(HAL::EMemoryRAMFree,freeRAM);

    if((r!=KErrNone)  || ( freeRAM < KRAMFreeCheckMark))
     {

     	 return NULL;
     }


	TInt size = aNumBlocks * KMemoryBlockSize;

	// check to see if this allocation will exceed our limit.
	// if ((iPlayerDynamicHeapAlloced + size) > iPlayerDynamicHeapMaxSize)
	if ((iPlayerDynamicHeapAlloced + size) > GetMaxHeapSize())
	{
		return NULL;
	}

	TAny* mem = User::Alloc(size);
	if (!mem)
	{
		return NULL;
	}

	DynamicMemBlock* pBlock = new DynamicMemBlock();
	if (pBlock)
	{
		pBlock->numBlocks = aNumBlocks;
		pBlock->mem = mem;
		pBlock->pNext = iDynamicMemBlocks;
		iDynamicMemBlocks = pBlock;
		// iPlayerDynamicHeapAlloced += size;
		AddDynHeapAlloced(size);
	}
	else
	{
		User::Free(mem);
		mem = NULL;
	}

	return mem;
}

void CPlatformFlashEngine::FreeDynamicMemory(TAny* aMemory)
{
#if defined (PLUG_IN_MEM_ALLOC) && !defined (__WINSCW__)
	MPluginMemHandlerIf* memHdlrIf = GetPluginMemHandlerIf();
	
	if(memHdlrIf)
	{
		if(memHdlrIf->IsMemAllocSupported())
		{
			return memHdlrIf->FreeMem(aMemory);
		}
	}
#endif

	TInt size = 0;
	DynamicMemBlock* pBlock = iDynamicMemBlocks;
	DynamicMemBlock* pPrevBlock = NULL;
	while (pBlock)
	{
		if (pBlock->mem == aMemory)
		{
			User::Free(pBlock->mem);
			if (pPrevBlock)
			{
				pPrevBlock->pNext = pBlock->pNext;
			}
			else
			{
				iDynamicMemBlocks = pBlock->pNext;
			}
			size = pBlock->numBlocks * KMaxInt;
			delete pBlock;
			break;
		}
		pPrevBlock = pBlock;
		pBlock = pBlock->pNext;
	}
	//iPlayerDynamicHeapAlloced -= size;
	DynHeapFreed(size);
}

TUint CPlatformFlashEngine::GetMaxHeapSize()
    {
	MPluginMemHandlerIf* memHdlrIf = GetPluginMemHandlerIf();
	
	if(memHdlrIf)
		return memHdlrIf->GetMaxHeapSize();
	else
		return iPlayerDynamicHeapMaxSize;
	
/* AK	
    if (iFlashClientIf->GetPluginMemHdlrIf())
        return iFlashClientIf->GetPluginMemHdlrIf()->GetMaxHeapSize();
    else
        return iPlayerDynamicHeapMaxSize;
*/
    /* if( iBrowserPluginActive && iFlashClientIf->GetPluginMemHdlrIf() )
     {
     return iFlashClientIf->GetPluginMemHdlrIf()->GetMaxHeapSize();
     }
     else if( !iBrowserPluginActive && iFlashUI )
     {
     return iPlayerDynamicHeapMaxSize;
     }
     
     return iPlayerDynamicHeapMaxSize;
     
     
     */
    }

void CPlatformFlashEngine::AddDynHeapAlloced(TUint size)
{
    /*if( iBrowserPluginActive && iFlashClientIf->GetPluginMemHdlrIf() )
        {
        iFlashClientIf->GetPluginMemHdlrIf()->AddDynHeapAlloced(size);
        }*/

    MPluginMemHandlerIf* pluginMemHdlr = iFlashClientIf->GetPluginMemHdlrIf();
    if (pluginMemHdlr)
        pluginMemHdlr->AddDynHeapAlloced(size);

    iPlayerDynamicHeapAlloced += size;
}

void CPlatformFlashEngine::DynHeapFreed(TUint size)
{
    MPluginMemHandlerIf* pluginMemHdlr = iFlashClientIf->GetPluginMemHdlrIf(); 
    //if( iBrowserPluginActive && iFlashClientIf->GetPluginMemHdlrIf() )
    if( pluginMemHdlr )
        {
        pluginMemHdlr->DynHeapFreed(size);
        }

    iPlayerDynamicHeapAlloced -= size;
}

void CPlatformFlashEngine::GetInputTextL(const TUint16* aInitialString, TUint aStrLen, TUint aMaxNumChars, TUint aTextFlags)
{
	ASSERT(iGetInputTextRequest == NULL);
	// We don't queue up GetInputText requests. Only handle the first one.
	if (iGetInputTextRequest == NULL)
	{
		iGetInputTextRequest = new(ELeave) TGetInputTextData;
		TPtrC16 ptr(aInitialString, aStrLen);
		iGetInputTextRequest->iInitialString = ptr.AllocL();
		iGetInputTextRequest->iMaxNumChars = aMaxNumChars;
		iGetInputTextRequest->iTextFlags = aTextFlags;
		TriggerAsyncEvent();
	}
}

HBufC* CPlatformFlashEngine::GetFlashVersion()
{
	HBufC* verBuf = NULL;

	const char* verString = iFiObject.FI_GetVersion();
	if (verString)
	{
		TRAP_IGNORE(verBuf = CreateEpocStringL(verString,FlashStrLen(verString)));
	}
	return verBuf;
}

TInt CPlatformFlashEngine::GetVolume()
{
	if (iSoundHandler)
	{
		return iSoundHandler->GetVolume();
	}
	else
	{
		return 0;
	}
}

void CPlatformFlashEngine::SetVolume(TInt aVolume)
{
    DEBUGPRINT("CPlatformFlashEngine::SetVolume aVolume : [%d]", aVolume);
	if( !iSoundHandler )
	{
		return;
	}

	iSoundHandler->SetVolume(aVolume);

	// in case the sound handler fiddled with the volume somehow...
	if(iVideoEngine)
	    TRAP_IGNORE(iVideoEngine->NotifyNewVolumeLevelL(iSoundHandler->GetVolume()));

	THXVDCmdArg arg;

	if (aVolume & KMuteMask)
	{
		arg.iVolume = 0;
	}
	else
    {
        arg.iVolume = iSoundHandler->GetVolume();
    }

	EngineDispatchHXCommand(EHXVDCmdSetVolume, arg);
}


const TInt32 KFixedPointPosTen = 0x000A0000;
const TInt32 KFixedPointNegTen = 0xFFF60000;

void CPlatformFlashEngine::OffsetPointToPan(TPoint& aPoint, TInt aType)
{
	if(IsPanning() && (aType == TPointerEvent::EDrag))
	{
		// In Panning mode, translate the Flash content by ten units up/down or left/right
		// on directional key events

        if(aPoint.iX > 0)
        {
        	if(aPoint.iY > 0)
        		iFiObject.FI_Translate(KFixedPointPosTen, KFixedPointPosTen);
        	else if(aPoint.iY < 0)
        		iFiObject.FI_Translate(KFixedPointPosTen, KFixedPointNegTen);
        	else
        	    iFiObject.FI_Translate(KFixedPointPosTen, 0);
        }
        else if(aPoint.iX < 0)
        {
        	if(aPoint.iY > 0)
        		iFiObject.FI_Translate(KFixedPointNegTen, KFixedPointPosTen);
        	else if(aPoint.iY < 0)
        		iFiObject.FI_Translate(KFixedPointNegTen, KFixedPointNegTen);
        	else
        	    iFiObject.FI_Translate(KFixedPointNegTen, 0);
        }
        else
        {
         	if(aPoint.iY > 0)
        		iFiObject.FI_Translate(0, KFixedPointPosTen);
        	else if(aPoint.iY < 0)
        		iFiObject.FI_Translate(0, KFixedPointNegTen);
        	else
        	    iFiObject.FI_Translate(0, 0);
        }


        PlayStep(ETrue);

	}
}


void CPlatformFlashEngine::OfferPointerEventL(TPoint& aPoint, TInt aType)
{
	TInt type = FI_EventNoEvent;
	/****No Touch support for IME control temporary. See HSAA-6RTA5A.****/
	//Determine if a Flash control exists under the specified mouse location and
	//if it is a TextField then returns 3.

	//if (iFiObject.FI_DoHitTest(aPoint.iX, aPoint.iY) != 3)
		{

		NPPDebug(LOG_NONE, ETrue,_L("CPlatformFlashEngine::OfferPointerEventL::type = %d"), aType);

		switch(aType)
			{
			case TPointerEvent::EButton1Down:
			//case TPointerEvent::EButton2Down:
			//case TPointerEvent::EButton3Down:
			type = FI_EventMouseDown;
			break;

			case TPointerEvent::EButton1Up:
			//case TPointerEvent::EButton2Up:
			//case TPointerEvent::EButton3Up:
			type = FI_EventMouseUp;
			break;

			case TPointerEvent::EMove:
			type = FI_EventMouseMove;
			break;
			case TPointerEvent::EDrag:
			type = FI_EventMouseMove;

			break;
			}
		if( iPstatus == FI_RenderingInterruptedByTimeout || iPstatus == FI_SystemInterrupt || iPstatus == FI_ActionScriptInterruptedByTimeout)
			return;
		iFiObject.FI_OfferMouseEvent ( aPoint.iX, aPoint.iY, type );
		PlayStep(ETrue);
		}
}


TBool CPlatformFlashEngine::IsControlPresent(const TPoint& aPoint)
{
	if( iPstatus == FI_RenderingInterruptedByTimeout || iPstatus == FI_SystemInterrupt || iPstatus == FI_ActionScriptInterruptedByTimeout)
		return EFalse;
    //Determine if a Flash control exists under the specified mouse location and
	//if it is 1 then it means no control.

    TInt result = iFiObject.FI_DoHitTest(aPoint.iX, aPoint.iY);
    if( result == 1 )
    {
    	iControlPresent = EFalse;
        return EFalse;
    }
    iControlPresent = ETrue;
    return ETrue;
}


void CPlatformFlashEngine::SetInputTextL(const TDesC& aNewStr)
{
	// check for 0x2029 (this is the paragraph separator unicode value
	// which seems to be used as newline separator)
	// and map it to 0x0A (LF), which is what Flash uses internally
	// to keep track of the end of a line.

	HBufC* buf = HBufC::NewLC(aNewStr.Length()+1);

	TPtr des = buf->Des();
	des.Copy(aNewStr);
	des.ZeroTerminate();

	const TInt strLen=buf->Length();

	for (TInt i = 0; i < strLen; i++)
	{
		if (des[i] == KUnicodeParagraphSeparator)
		{
			des[i] = FLASH_LINE_FEED_CHAR;
		}
	}


	FI_Text txt = { { ((char*) des.Ptr()) }, FI_UTF16EncodingForm, strLen };
	iFiObject.FI_SetInputText(&txt);
	CleanupStack::PopAndDestroy(buf);
}

void CPlatformFlashEngine::CancelInputText()
{
	iFiObject.FI_CancelInputText();
}

void CPlatformFlashEngine::QueueSILaunchL(struct MM_Object* aMMObj, TUint16 aArgc, const TDesC** aArgv, struct FI_PlayerEventInfo* /*aEventInfo*/, TInt16 aIsEmbedded)
{
	CQueuedSILaunch* siLaunch=CQueuedSILaunch::NewL(aMMObj, aArgc, aArgv, aIsEmbedded);
	iLaunchQueue.AddLast(*siLaunch);
	if(!iLaunchQueueHandler->IsActive())
	{
		iLaunchQueueHandler->Start();
	}
}

void CPlatformFlashEngine::DoRunL(const CActive* aActive)
{
    if(aActive == iBacklightExtensionTimer && !NoBackLightProcessing())
    {
		User::ResetInactivityTime();
		if(iExtendBacklight == EOn)
			iBacklightExtensionTimer->After(KBacklightExtensionTime);

		return;
    }
	
    // Resuming on Network prompt timeout
    if( aActive == iIAPTimer )
    {
        // We timed out
        ResumeOnNetworkPrompt();
        return;
    }

    //Mp3Streaming
    if (aActive == iMp3Timer)
    {
        if(iMp3PlayStateObserver)
        {   
            iMp3PlayStateObserver->MP3PlayStateChangedL(EFlashNoMP3Stream);
        }
        return;
    }

	if(aActive == iTimer || aActive == iLowestPriorityActiveObj)
	{
		iLowestPriorityActiveObj->Cancel();
		iTimer->Cancel();

		// Re-queue the timer for interval = iDelay.
		if( iPauseFlags==ENotPaused && !iIsStopped && !iTimer->IsActive() )
		{
			iTimer->After(iDelay);
		}

		// timer tick - this calls to the core player which does the time consuming stuff
		PlatformTimerTick();

		// NOTE: Above PlatformTimerTick() may take some time = x.
		// If x < iDelay, there is no problem. Other low priority active objects still gets scheduled.
		// If x > iDelay, then other high low priority active objects may starve because iTimer will always be scheduled.
		// 				  So, reissue iTimer but use a low priority AObj to reschedule ONCE ourselves.

		if( iTimer->iStatus != KRequestPending && iPauseFlags==ENotPaused )
		{
			iTimer->Cancel();
			iTimer->After(iDelay);
			iLowestPriorityActiveObj->Start();
		}
	}
	else
	{
		// must be the queued launcher
		CQueuedSILaunch* siLaunch;
		while(!(iLaunchQueue.IsEmpty()))
		{
			siLaunch=iLaunchQueue.First();
			siLaunch->LaunchL();
			iLaunchQueue.Remove(*siLaunch);
			delete siLaunch;
		}
	}
	// TSW : EPSS-7ZV8L8 This is hack to put pause on player when we open a flash content
	// while call is ongoing after first doplay so that user will have some frames in display
	// user should'nt feel like bad user experience displaying blank white screen.

	if(iPauseforActiveCall && IsPhoneCallActive())  //check for Call is active at time of pasuing.
		{
		NotifyPhoneActiveL(IsPhoneCallActive());
		}

}

TInt CPlatformFlashEngine::DoRunError(const CActive* aActive, TInt /*aError*/)
{
	if(aActive==iTimer)
	{
		ASSERT(EFalse); // should never happen - PlatformTimerTick() cannot leave - debug mode assert
	}
	//Mp3Streaming
    else if (aActive == iMp3Timer)
    {
        if(iMp3PlayStateObserver)
        {    
            TRAP_IGNORE(iMp3PlayStateObserver->MP3PlayStateChangedL(EFlashNoMP3Stream));
        }
        return KErrNone;
    }
    else
    {
        // there was a launch failure, requeue, but remove the head item...
        CQueuedSILaunch* head=iLaunchQueue.First();
        iLaunchQueue.Remove(*head);
        delete head;
        if(!(iLaunchQueue.IsEmpty()))
        {
            iLaunchQueueHandler->Start();
        }
	}
	return KErrNone; // Flash already shows an error for SI_Launch failures!
}

TInt CPlatformFlashEngine::ExtendBacklight(TUint16 aDuration)
{
	// Get the current time
	if(!NoBackLightProcessing())
	{
		//screensaver app will handle backlight, dont interfere
		if(iBkLightHandler)
		{
			iBkLightHandler->ExtendBacklight(aDuration);
		}
	}

	return 1;
}

void CPlatformFlashEngine::ExtendBacklightForVideoPlayback(TBacklightStatus aOnOrOff)
{
	// Get the current time
	if(!NoBackLightProcessing())
	{
		iExtendBacklight = aOnOrOff;
		
		//Extend the backlight when the video is playing
		if(iExtendBacklight == EOn)
		{
			if(!iBacklightExtensionTimer)
			{
				TRAPD(err, iBacklightExtensionTimer = CFlhTimerObject::NewL(CActive::EPriorityStandard,
                        *this));
				if(err != KErrNone)
				{
					iBacklightExtensionTimer = NULL;
					return;
				}
				
				//Reset the inactivity time right here as the timer will
				//expire only after 2 secs
				User::ResetInactivityTime();
			}
			
			iBacklightExtensionTimer->Cancel();
			iBacklightExtensionTimer->After(KBacklightExtensionTime);
		}
		else
		{// Stop extending the backlight when the video is either
		 // paused or stopped or when playback is complete
			if(iBacklightExtensionTimer)
			{
				iBacklightExtensionTimer->Cancel();
			}
		}
	}
	return;
}

void CPlatformFlashEngine::ExtendBackLightWhileSeekingLocalFlv()
{
	//Reset the inactivity time 
	User::ResetInactivityTime();
}

TUint32 CPlatformFlashEngine::GetConnectedIAPIdL()
{
	__UHEAP_MARK;
	TUint32 iapId = 0;

    RSocketServ socketServ;
    User::LeaveIfError(socketServ.Connect());
    CleanupClosePushL(socketServ);

    RConnection connection;
    User::LeaveIfError(connection.Open(socketServ));
    CleanupClosePushL(connection);
    TUint activeConnectionCount;
	User::LeaveIfError(connection.EnumerateConnections(activeConnectionCount));
    if(activeConnectionCount)
    {
        TPckgBuf<TConnectionInfoV2> connectionInfo;
        TInt err = KErrNone;
        for(TUint i=1; i<=activeConnectionCount && !iapId; i++)
        {
            err = connection.GetConnectionInfo(i, connectionInfo);
            if(err == KErrNone)
            {
                iapId = connectionInfo().iIapId;
            }
        }
    }
	CleanupStack::PopAndDestroy(&connection);
    CleanupStack::PopAndDestroy(&socketServ);
	__UHEAP_MARKEND;
	return iapId;
}

TBool CPlatformFlashEngine::GetNetworkInfoL(unsigned short aInfoType, TDes8& aRetString)
    {
        /*
    	if(!iNetworkInfo)
    	{ //ok ,object not created , delayed creation will be done now
    		if(!NoETelSuppport())
    		{ //let us create object now
    			iNetworkInfo = CNetworkInfo::NewL();
    		}
    	}
        */
        CNetworkInfo* networkInfo = GetNetworkInfoL();
    	if(networkInfo)
    		return networkInfo->GetNetworkInfo( aInfoType, aRetString);

    	return EFalse;
    }

TBool CPlatformFlashEngine::GetNetworkInfoL(unsigned short aInfoType, long& aRetVal)
    {
        /*
    	if(!iNetworkInfo)
    	{//ok ,object not created , delayed creation will be done now
    		if(!NoETelSuppport())
    		{ //let us create object now
    			iNetworkInfo = CNetworkInfo::NewL();
    		}
    	}
        */
        CNetworkInfo* networkInfo = GetNetworkInfoL();
    	if(networkInfo)
    		return networkInfo->GetNetworkInfo( aInfoType, aRetVal);

    	return EFalse;
    }

TBool CPlatformFlashEngine::GetSubscriberInfoL(unsigned short aInfoType, TDes8& aRetString)
    {
    	/*if(!iSubscriberInfo)
    	{//ok ,object not created , delayed creation will be done now
    		if(!NoETelSuppport())
    		{ //let us create object now
    			iSubscriberInfo = CSubscriberInfo::NewL();
    		}
    	}*/

    CSubscriberInfo* subscriberInfo = GetSubscriberInfoL();
    	if(subscriberInfo)
    		return subscriberInfo->GetSubscriberInfo(aInfoType,aRetString);

    	return EFalse;
    }

TBool CPlatformFlashEngine::GetRegistrationStatusL(unsigned short aInfoType, long& aRetValue)
    {
    	/*if(!iRegistrationStatus)
    	{//ok ,object not created , delayed creation will be done now
    		if(!NoETelSuppport())
    		{ //let us create object now
    			iRegistrationStatus = CRegistrationStatus::NewL();
    		}
    	}*/
    
        CRegistrationStatus* registrationStatus = GetRegistrationStatusL();

    	if(registrationStatus)
    		return registrationStatus->GetRegistrationStatus(aInfoType,aRetValue);

    	return EFalse;
    }


const TUint32 KFixedPointTwo = 0x00020000L; // 2.0 in 16:16 fixed point
const TUint32 KFixedPointHalf = 0x00008000L; // 0.5 in 16:16 fixed point
TBool CPlatformFlashEngine::Zoom(TReal aScaleFactor)
{
	TUint32 fixedScaleFactor = ConvertFromFloatToFixed16(aScaleFactor);

	TUint32 x = iFrameBufferSize.iWidth << 15;
	TUint32 y = iFrameBufferSize.iHeight << 15;

	return iFiObject.FI_Scale(fixedScaleFactor, x, y);
}

TUint32 CPlatformFlashEngine::ConvertFromFloatToFixed16(TReal aFloatRep)
{
	TUint32 fixedPointRep = aFloatRep;

	aFloatRep -= fixedPointRep; //get decimal part only
	fixedPointRep <<= 16;
	TUint16 decimalPart = 0;
	TReal powerOfHalf = 0.5;
	for(int i = 1 ; i <=  16; i++)   //subtract by powers of half 16 times
	{
		if((aFloatRep - powerOfHalf) >= 0)
		{
			aFloatRep = aFloatRep - powerOfHalf;
			decimalPart += ( 0x10000 >> i); //left shift n times when subtracting nth power of half
		}
		if(aFloatRep == 0)
		{
			break;
		}
		else
		{
			powerOfHalf = powerOfHalf * 0.5;
		}
	}
//	decimalPart = (~decimalPart);
	fixedPointRep += decimalPart; //add one's complement of binary rep of decimal part
	return fixedPointRep;
}


TBool CPlatformFlashEngine::Zoom(TInt aMode, TInt& aCurrentZoomLevel)
{
	TBool success = EFalse;
	switch(aMode)
	{
		case EZoomIn:
		{
			if(iZoomFactor >= KMaxZoomLevel)
			{     
				aCurrentZoomLevel = iZoomFactor;
				return EFalse; //we dont handle more than 5 times
			}

			// x and y are 16:16 fixed point numbers.
			// shift by 15 bits to get same effect as divide by 2 and shift by 16 bits.
			TUint32 x = iFrameBufferSize.iWidth << 15;
			TUint32 y = iFrameBufferSize.iHeight << 15;
			success = iFiObject.FI_Scale(KFixedPointTwo, x, y);
			if(success)
			{
                 iZoomFactor++;
                 aCurrentZoomLevel = iZoomFactor;
			}
			else
			{
				aCurrentZoomLevel = iZoomFactor;
			}
		}
		break;

		case EZoomOut:
		if (iZoomFactor > 0)
		{
			// x and y are 16:16 fixed point numbers.
			// shift by 15 bits to get same effect as divide by 2 and shift by 16 bits.
			TUint32 x = iFrameBufferSize.iWidth << 15;
			TUint32 y = iFrameBufferSize.iHeight << 15;
			success = iFiObject.FI_Scale(KFixedPointHalf, x, y);
			if(success)
			{
				iZoomFactor--;					
                aCurrentZoomLevel = iZoomFactor;
			}						
		}
		break;

		case EShowAll:
		iZoomFactor = 0;
		aCurrentZoomLevel = iZoomFactor;
		break;
	}

	// Make sure that pan mode is turned off if we zoom out.
	if (iZoomFactor == 0)
	{
		iFiObject.FI_ResetTransform();
		iPanMode = EFalse;
	}

	return success;
}

TBool CPlatformFlashEngine::IsZoomable()
{
	TUint16 status = iFiObject.FI_GetZoomAndPanEnabled();
	if ((status != 0) && !IsPaused())
	{
		return ETrue;
	}
	else
	{
		return EFalse;
	}
}

void CPlatformFlashEngine::TriggerAsyncEvent()
{
	iAsyncEventHandler->TriggerEvent();
}



TBool CPlatformFlashEngine::QueryAllowNetAccessL()
	{
	TBool rval = EFalse;
	TBool userAllows = EFalse;

		if(iAllowNetAccessId==EAllow_NotSet || iAllowNetAccessId==EAllow_Deny)
			{
			//if(!iBrowserPluginActive)
			if(iExecutionMode == eStandAlone)
				{
				//userAllows=iFlashUI->QueryAllowNetAccessL();
				 MUserNotiferIf* userNotifierIf = iFlashClientIf->GetUserNotifierIf();
				 if(userNotifierIf)
				    {
				        userAllows = userNotifierIf->QueryAllowNetAccessL();
				    }
				}
				else
				{
				MUserNotiferIf* userNotifierIf = iFlashClientIf->GetUserNotifierIf();
				if(userNotifierIf)
				userAllows=userNotifierIf->QueryAllowNetAccessL();
				}
			if(userAllows)
				{
				iAllowNetAccessId=EAllow_Allow;
				}
			else
				{
				iAllowNetAccessId=EAllow_Deny;
				}
			}
		if(iAllowNetAccessId==EAllow_Allow)
			{
			rval=ETrue;
			}

	return rval;
}



TPtrC CPlatformFlashEngine::MatchedStringFromArrayL(TInt aArrayResId, const TDesC& aMatch)
{
	const TInt count=iItemValuePairArrays->Count();

	CFlhItemValuePairList* ivpl=NULL;
	CFlhItemValuePairList* candidate=NULL;

	for(TInt i=count-1;i>=0;i--)
	{
		candidate=(*iItemValuePairArrays)[i];
		if(candidate->Id()==aArrayResId)
		{
			ivpl=candidate;
			break;
		}
	}

	if(!ivpl)
	{
		// array not loaded yet
		ivpl=CFlhItemValuePairList::NewLC(*iEnv,aArrayResId);
		iItemValuePairArrays->AppendL(ivpl);
		CleanupStack::Pop(ivpl);
	}

	return ivpl->ValueForKeyL(aMatch);
}

short CPlatformFlashEngine::GetSoftKeyLocation() const
{
	return iSoftkeyLocation;
}

void CPlatformFlashEngine::SetSoftKeyLocation()
{
	AknLayoutUtils::TAknCbaLocation cbaloc(AknLayoutUtils::CbaLocation());
	if(cbaloc==AknLayoutUtils::EAknCbaLocationLeft)
	{
		iSoftkeyLocation=1;
	}
	else if(cbaloc==AknLayoutUtils::EAknCbaLocationRight)
	{
		iSoftkeyLocation=3;
	}
	else if(cbaloc==AknLayoutUtils::EAknCbaLocationBottom)
	{
		iSoftkeyLocation=2;
	}
	else
	{
		iSoftkeyLocation=0; //top
	}
}
void CPlatformFlashEngine::HandleSoftKeyLocationChangedL()
{
#ifdef FEATURE_DEBUG_SOFTKEY_LOCATION
	iSoftkeyLocation=(short)(iSoftkeyLocation+1);
	if(iSoftkeyLocation > (short) 3)
		iSoftkeyLocation = (short) 0;
	#pragma message ("error - FEATURE_DEBUG_SOFTKEY_LOCATION is defined - must never be defined for shipping code")
#else // FEATURE_DEBUG_SOFTKEY_LOCATION
	iSoftkeyLocation=GetSoftkeyLocationFromOS();
#endif //FEATURE_DEBUG_SOFTKEY_LOCATION
	NotifyCorePlayerOfSoftkeyLocationChangeL();
	if(iPauseFlags!=ENotPaused && !iIsStopped)
	{
		PlayStep(ETrue); // force the screen to draw correctly for the new size. Softkeys will not move until playback resumes
	}
}

void CPlatformFlashEngine::NotifyCorePlayerOfSoftkeyLocationChangeL()
{
	// triggers the onResize event (or <Insert> key equivalent in AS1)
	MDisplay* display = iFlashClientIf->GetDisplay();
	if(display)
	{
	display->ResetScreenInCurrentModeL();
	}

}

TBool CPlatformFlashEngine::IsPhoneCallActive()
{
    CPhoneMonitor* phoneMonitor = NULL;
    TRAP_IGNORE(phoneMonitor = GetPhoneMonitorL());
	if (phoneMonitor && phoneMonitor->IsCallActive())
	{
		return ETrue;
	}
	return EFalse;
}

#ifdef FEATURE_OPENVG
CFbsBitGc* CPlatformFlashEngine::GetAuxTextBitmapContext()
{
    if (iAuxTextBitmapGc) {
        return iAuxTextBitmapGc;
    }

    if (KErrNone != iAuxTextBitmapDevice->CreateContext(iAuxTextBitmapGc)) {
        iAuxTextBitmapGc = NULL;
    }

    return iAuxTextBitmapGc;
}
#endif

// ----------------------------------------------------------------------
// TBool CPlatformFlashEngine::IsSoundPlaying() const
//
// The function returns whether the sound is present and playing
// ----------------------------------------------------------------------
//

TBool CPlatformFlashEngine::IsSoundPlaying() const
{
    if( iSoundHandler )
    {
        return iSoundHandler->IsPlaying();
    }

    return EFalse;
}

// This function retuns the video rect
TRect CPlatformFlashEngine::GetVideoRectL()
{
	return iVideoRect.iRect;
}

// This function informs the engine of the region in which video will be drawn.

void CPlatformFlashEngine::SetVideoRectL(const FI_Rect* aRect, const TVideoType& aVideoType)
{

	// keep track of the video rect so we can blit only the regions surrounding it.
	// if we are called with a NULL rect, it means we aren't playing video anymore

	if (aRect == NULL)
	{
	    iVideoRect.iRect.iTl.iX = 0;
	    iVideoRect.iRect.iTl.iY = 0;
		iVideoRect.iRect.SetSize(TSize(0, 0));
		iVideoRect.iVideoType = EVideoNone;
	}
	else
	{
		iVideoRect.iRect.iTl.iX = aRect->xmin;
		iVideoRect.iRect.iTl.iY = aRect->ymin;
		iVideoRect.iRect.iBr.iX = aRect->xmax;
		iVideoRect.iRect.iBr.iY = aRect->ymax;

		iVideoRect.iVideoType = aVideoType;

		//Since video rect might be different, cause redraw
		iRedraw = ETrue;
	}

	#ifdef ENABLE_CURSOR

	// This is for hiding the cursor within this video rect.
	MFlashCursor* cursor = Cursor();
	if( cursor && iVideoRect.iVideoType == EDeviceVideo )
	{
	    cursor->SetHiddenWindow(iVideoRect.iRect);
	}

	#endif // ENABLE_CURSOR

}

RWindow* CPlatformFlashEngine::GetWindow()
{
    MDisplay* display = iFlashClientIf->GetDisplay();
    if(display)
        return display->GetWindow();
    
    return NULL;
    //return (RWindow*)(&(iFlashClientIf->GetWindow()));
    /*
	if(!iBrowserPluginActive)
	{
		return iFlashUI->GetWindow();
	}
	else
	{
		return (RWindow*)(&(iControl->GetWindow()));
	}
	*/
}

void CPlatformFlashEngine::NotifyFlashError(TInt aErrorCode, TBool aIsCritical, TBool aPersistent)
{	
	MUserNotiferIf* userNotifierIf = iFlashClientIf->GetUserNotifierIf();
	if(userNotifierIf)
	//TRAP_IGNORE(err,userNotifierIf->NotifyFlashError(aErrorCode,aIsCritical,aPersistent))    ;
	 userNotifierIf->NotifyFlashError(aErrorCode,aIsCritical,aPersistent);
	
	/*
	if(!iBrowserPluginActive)
	{
		TRAP(err,iFlashUI->NotifyFlashError(aErrorCode,aIsCritical,aPersistent))	;
	}
	else
	{
		TRAP(err,iUserNotifierIf->NotifyFlashError(aErrorCode,aIsCritical,aPersistent))	;
	}
	*/
}

void CPlatformFlashEngine::NotifyClientError(TInt aErrorCode, TBool aIsCritical, TBool aPersistent)
    {    
    MUserNotiferIf* userNotifierIf = iFlashClientIf->GetUserNotifierIf();
    if(userNotifierIf)
        userNotifierIf->NotifyClientError(aErrorCode,aIsCritical,aPersistent);
    //TRAP(err,iUserNotifierIf->NotifyClientError(aErrorCode,aIsCritical,aPersistent))    ;
    /*
     if(!iBrowserPluginActive)
     {
     TRAP(err,iFlashUI->NotifyClientError(aErrorCode,aIsCritical,aPersistent))	;
     }
     else
     {
     TRAP(err,iUserNotifierIf->NotifyFlashError(aErrorCode,aIsCritical,aPersistent))	;
     }
     */
    }

void CPlatformFlashEngine::NotifyFlashStatus(TInt aFlashStatus, TAny* aParam)
{
	//TInt err ;

	MUserNotiferIf* userNotifierIf = iFlashClientIf->GetUserNotifierIf();
	if(userNotifierIf)
	//if(iUserNotifierIf)
	{
        userNotifierIf->NotifyFlashStatus(aFlashStatus,aParam);
		//TRAP(err,iUserNotifierIf->NotifyFlashStatus(aFlashStatus,aParam))	;
	}
}

void CPlatformFlashEngine::NotifyDataAccessError(const char* aUrl, TInt aErrorCode)
{
	//TInt err ;
    MUserNotiferIf* userNotifierIf = iFlashClientIf->GetUserNotifierIf();

	if(userNotifierIf)
	{
		//TRAP(err,iUserNotifierIf->NotifyDataAccessError(aUrl,aErrorCode))	;
	userNotifierIf->NotifyDataAccessError(aUrl,aErrorCode);
	}
/*	else //TODO: need to add the method to plugin interface
	{
		TRAP(err,iUserNotifierIf->NotifyDataAccessError(aUrl,aErrorCode))	;
	}	*/
}


TBool CPlatformFlashEngine::NoGetURLSupport()
{
	return (iConfig.iMode & KSupportNoGetURL)? ETrue: EFalse;
}

TBool CPlatformFlashEngine::NoVibraSupport()
{
	return (iConfig.iMode & KSupportNoVibra)? ETrue: EFalse;
}

TBool CPlatformFlashEngine::NoSoundSupport()
{
	return (iConfig.iMode & KSupportNoSound)? ETrue: EFalse;
}

TBool CPlatformFlashEngine::NoBackLightProcessing()
{
	return (iConfig.iMode & KSupportNoBackLightProcessing)? ETrue: EFalse;
}

TBool CPlatformFlashEngine::NoIncomingCallMonitor()
{
	return (iConfig.iMode & KSupportNoCallMonitor)? ETrue: EFalse;
}

#ifdef FEATURE_OPENVG
void CPlatformFlashEngine::InitializeEglL()
{
    iEGLDisplay = eglGetDisplay(EGL_DEFAULT_DISPLAY);
    if (iEGLDisplay == NULL) {
        User::Leave(KErrGeneral);
    }
    
    if (!iEGLInitialized && eglInitialize( iEGLDisplay, NULL, NULL ) == EGL_FALSE ) {
        User::Leave(KErrGeneral);
        }
    
    if(!iEGLInitialized) {
        iHostEngineGlobals->AddEGLClient((TAny*)this);
        iEGLInitialized = ETrue;
    }
    
    ChooseEglConfigL();
    
    eglBindAPI(EGL_OPENVG_API);

    // Create a rendering context
    if(iEGLContext == EGL_NO_CONTEXT)
    {
        iEGLContext = eglCreateContext(iEGLDisplay, iEGLConfig, EGL_NO_CONTEXT, NULL );
        if (iEGLContext == EGL_NO_CONTEXT)
        {
            User::Leave(KErrGeneral);
        }
    }

    /* Get the EGL max supported width & height for choosen EGL config */ 
    InitEGLMaxDimensionL();
}

void CPlatformFlashEngine::ChooseEglConfigL()
{
    if(iEGLConfig)
    {
        return;
    }
    
    EGLConfig *configList = NULL; 
    EGLint numOfConfigs = 0;
    EGLint configSize   = 0;
    
    // Get the number of possible EGLConfigs
    if ( eglGetConfigs( iEGLDisplay, configList, configSize, &numOfConfigs ) == EGL_FALSE )
    {
        DEBUGPRINT("ChooseEglConfigL: eglGetConfigs: returned EGL_FALSE");
        User::Leave(KErrGeneral);
    }
    
    configSize = numOfConfigs;
    
    // Allocate memory for the configList
    configList = (EGLConfig*) User::AllocLC( sizeof(EGLConfig)*configSize );
    
    RWindow* rWindow = GetWindow();
    TDisplayMode dispMode = rWindow->DisplayMode();
    TInt bufferSize = TDisplayModeUtils::NumDisplayModeBitsPerPixel(rWindow->DisplayMode());

    EGLint eglPixmapSurfaceType = EGL_PIXMAP_BIT;
#if !defined(EGL_SINGLE_BUFFERING) && defined(FORCE_REFRESH_WORKAROUND)
    eglPixmapSurfaceType |= EGL_SWAP_BEHAVIOR_PRESERVED_BIT;
#endif
    
    const TInt KAlphaMaskSize = 8; //8 bits are required for a 24bit color surface
    
    const EGLint KEGLPixmapConfig[] =
    {
        EGL_BUFFER_SIZE,     bufferSize, 
        EGL_SURFACE_TYPE,    eglPixmapSurfaceType,
        EGL_RENDERABLE_TYPE, EGL_OPENVG_BIT,
        EGL_ALPHA_MASK_SIZE, KAlphaMaskSize,
        EGL_NONE 
    };
    
    EGLint eglWindowSurfaceType = EGL_WINDOW_BIT;
#if !defined(EGL_SINGLE_BUFFERING) && defined(FORCE_REFRESH_WORKAROUND)
    eglWindowSurfaceType |= EGL_SWAP_BEHAVIOR_PRESERVED_BIT;
#endif

    const EGLint KEGLWindowConfig[] =
    {
        EGL_BUFFER_SIZE,     bufferSize, 
        EGL_SURFACE_TYPE,    eglWindowSurfaceType,
        EGL_RENDERABLE_TYPE, EGL_OPENVG_BIT,
        EGL_ALPHA_MASK_SIZE, KAlphaMaskSize,
        EGL_NONE 
    };     

    TBool success = EFalse;
    if(iRenderToBitmap)
    {
        success = (eglChooseConfig(iEGLDisplay, KEGLPixmapConfig, configList, configSize, &numOfConfigs) == EGL_TRUE);
    }
    else
    {
        success = (eglChooseConfig(iEGLDisplay, KEGLWindowConfig, configList, configSize, &numOfConfigs) == EGL_TRUE);        
    }
    
    if(!success || numOfConfigs == 0)
    {
        DEBUGPRINT("ChooseEglConfigL: eglChooseConfig: returned %d numOfConfigs: %d",success, numOfConfigs);
        CleanupStack::PopAndDestroy(); 
        User::Leave(KErrGeneral);
    }

    // returned by eglChooseConfig are sorted so
    // that the best matching EGLConfig is first in
    // the list.
    iEGLConfig = configList[0]; 
    CleanupStack::PopAndDestroy(); // Free configList, not used anymore.
    
}

void CPlatformFlashEngine::InitEGLMaxDimensionL()
{
    DEBUGPRINT("CPlatformFlashEngine::InitEGLMaxDimensionL:");    
            
    EGLBoolean retErrWidth, retErrHeight; 
    retErrWidth = eglGetConfigAttrib(iEGLDisplay, iEGLConfig, EGL_MAX_PBUFFER_WIDTH, &iEGLMaxSupportedWidth);
    retErrHeight = eglGetConfigAttrib(iEGLDisplay, iEGLConfig, EGL_MAX_PBUFFER_HEIGHT, &iEGLMaxSupportedHeight);

    if (retErrWidth == EGL_FALSE || retErrHeight == EGL_FALSE)
    {        
        DEBUGPRINT("GetMaxSupportedDimensionL: returned EGL_FALSE");
        
        iEGLMaxSupportedWidth = KMaxSupportedFrameDimension;
        iEGLMaxSupportedHeight = KMaxSupportedFrameDimension;
    }

    DEBUGPRINT("GetMaxSupportedDimensionL: returned maxWidth: %d maxHeight: %d",
            iEGLMaxSupportedWidth, iEGLMaxSupportedHeight);    
}

void CPlatformFlashEngine::CreateEglSurfaceL()
{
    DEBUGPRINT("CPlatformFlashEngine::CreateEglSurfaceL: iEGLInitialized: %d", iEGLInitialized);
    DestroyEgl(); //destroy if any surface is available.
        
    if (!iEGLInitialized)
    {
        InitializeEglL();
    }
    
    RWindow* rWindow = GetWindow();

    if(iRenderToBitmap)
    {
        iEGLSurface.surface = (void*) eglCreatePixmapSurface(iEGLDisplay, iEGLConfig, iBitmap, NULL);        
    }
    else
    {
        iEGLSurface.surface = (void*) eglCreateWindowSurface(iEGLDisplay, iEGLConfig, rWindow, KWinSurfaceAttribList);
    }

    if (iEGLSurface.surface == EGL_NO_SURFACE)
    {
        DEBUGPRINT("CPlatformFlashEngine::CreateEglSurfaceL(), eglCreateXXXSurface() failed! Error = %d", eglGetError());
        User::Leave(KErrGeneral);
    }

#if !defined(EGL_SINGLE_BUFFERING) && defined(FORCE_REFRESH_WORKAROUND)
    if( eglSurfaceAttrib(iEGLDisplay, (EGLSurface)iEGLSurface.surface, EGL_SWAP_BEHAVIOR, EGL_BUFFER_PRESERVED) == EGL_FALSE )
    {
        DEBUGPRINT("CPlatformFlashEngine::CreateEglSurfaceL(), eglSurfaceAttrib() failed! Error = %d", eglGetError());
        User::Leave(KErrGeneral);
    }
#endif
    
    /* Make the context current. Binds context to the current rendering thread and surface.*/
    SetCurrentEglContext();
    
#ifdef USE_VPU2 // only if VPU2 and OPENVG are enabled.
    //Alpha has to be enabled on egl, everytime egl is bound to a window.
    EnableAlphaOnEgl(rWindow);
#endif
    
    iRenderingWindow = rWindow;
    iCurrentWindowSize = rWindow->Size();

    FI_Rect fiRect;
    fiRect.xmin = (short) 0;
    fiRect.ymin = (short) 0;
    fiRect.xmax = (short) iFrameBufferSize.iWidth;
    fiRect.ymax = (short) iFrameBufferSize.iHeight;
    
    iFiObject.FI_SetDirtyRect(&fiRect, 1); //dont care return value.  
}

void CPlatformFlashEngine::DestroyEgl()
{
    DEBUGPRINT("CPlatformFlashEngine::DestroyEgl: iOpenVgMode: %d", iOpenVgMode);
    //RC: ou1cimx1#668194
    //if(!iOpenVgMode)
    //   return;
    
    DestroyEglSurface();
    
    if (iEGLContext != EGL_NO_CONTEXT)
    {
        eglDestroyContext(iEGLDisplay, iEGLContext);
        iEGLContext = EGL_NO_CONTEXT;
    }
    
    if(iEGLInitialized)
    {    
        iHostEngineGlobals->RemoveEGLClient((TAny*)this);
        iEGLInitialized = EFalse;        
    }        
        
    if (iEGLDisplay != EGL_NO_DISPLAY && iHostEngineGlobals->NumEGLClients() == 0)
    {
       		
        if(eStandAlone==iExecutionMode)
        {
            TInt err = KErrNone;
			//As browser is also HW rendered, these functions are called by browser. Todo: Dynamically check if browser is HW rendered.
			err = eglTerminate(iEGLDisplay); // Release resources associated with EGL and OpenGL ES
			
			if(err)
			DEBUGPRINT("EGL Terminated, %d", err);

		        /*RC:ou1cimx1#513829 Reason: EGL maintains a small amount of per-thread state, including the error status
		        returned by eglGetError, so to relase these memory we need to call eglReleaseThread, to set EGL to its state
		        at thread initialization*/
			eglReleaseThread();
        }
        iEGLDisplay = NULL;
       
    }    
    
/*
 * FIXME:
 * Temporarily commented out.
 * EGL needs to be initialized and terminated only once irrespective of the number of plugin instances.
 * Trying to terminate it for each instance may cause the phone to hang as the otehr instance may try to write to the surface 
    if (iEGLDisplay)
    {
        TInt err = eglTerminate(iEGLDisplay); // Release resources associated with EGL and OpenGL ES
        iEGLDisplay = NULL;
        DEBUGPRINT("EGL Terminated, %d", err);
    }
*/
}

#if defined(FEATURE_OPENVG) && defined(USE_VPU2)
void CPlatformFlashEngine::EnableAlphaOnEgl(RWindow* aWindow)
{
    ASSERT(aWindow != NULL);
    
    if(iCompositionControl)
    {
        delete iCompositionControl;
        iCompositionControl = NULL;
    }
   
    TRAPD(err,iCompositionControl = CAlfCompositionSource::NewL(*aWindow));
    if(err == KErrNone)
        iCompositionControl->EnableAlpha(ETrue);
    //else
    //  handle error
    
    delete iCompositionControl;
    iCompositionControl = NULL;
}
#endif

void CPlatformFlashEngine::RecreateSurfaceL(RWindow* aWindow)
{
    if(iEGLDisplay == EGL_NO_DISPLAY||
        // if the surface is NULL (may not be visible) then no point in creating it 
        //as it'll anyway be created when it comes into view
       iEGLSurface.surface == EGL_NO_SURFACE) 
    {    
        return;
    }

#ifndef EGL_SINGLE_BUFFERING
    TSize currentWindowSize = aWindow->Size();
    // Due to the limitation of the EGL implementation (CPAY-7VJEE8) the egl surface is automatically
    // resized *only* if the new area is less than or equal to the prev area
    
    //EAJI-84ZBAG: When User has Paused, and switch from FS to NS(New Window size is smaller)
    //EGL Surface should be automatically resized(CPAY-7VJEE8), but only Blank Screen is displayed.
    //Cannot be fixed from NGA Team now.
    //Workaround: If User has Paused, Always Recreate Whole Surface regardless of Window Size
    //			  instead of depending on Automatic Resize of EGL Surface
    if	(		  	((currentWindowSize.iWidth <= iCurrentWindowSize.iWidth && currentWindowSize.iHeight <= iCurrentWindowSize.iHeight) ||
    				(currentWindowSize.iWidth <= iCurrentWindowSize.iHeight&& currentWindowSize.iHeight <= iCurrentWindowSize.iWidth)) &&
    				(iRenderingWindow == aWindow) && (!(iPauseFlags & EReasonUser ))
		)
    	
    	{    
		iCurrentWindowSize = currentWindowSize;

        FI_Rect fiRect;
        fiRect.xmin = (short) 0;
        fiRect.ymin = (short) 0;
        fiRect.xmax = (short) iFrameBufferSize.iWidth;
        fiRect.ymax = (short) iFrameBufferSize.iHeight;
        
        iFiObject.FI_SetDirtyRect(&fiRect, 1); //dont care return value.
		
#ifdef FORCE_REFRESH_WORKAROUND        
        iForceRedraw = ETrue;
#endif
        return;
    }
#endif
    
    eglMakeCurrent( iEGLDisplay, EGL_NO_SURFACE, EGL_NO_SURFACE, EGL_NO_CONTEXT );
   
    eglDestroySurface(iEGLDisplay, (EGLSurface)iEGLSurface.surface); //dont care return value.
    
    if(iRenderToBitmap) {
        iEGLSurface.surface = (void*) eglCreatePixmapSurface(iEGLDisplay, iEGLConfig, iBitmap, NULL);        
    }
    else {
        iEGLSurface.surface = (void*) eglCreateWindowSurface(iEGLDisplay, iEGLConfig, aWindow, KWinSurfaceAttribList);
    }
    
    if (iEGLSurface.surface == EGL_NO_SURFACE)
    {
        DEBUGPRINT("CPlatformFlashEngine::RecreateSurfaceL(), eglCreateXXXSurface() failed! Error = %d", eglGetError());
        User::Leave(KErrGeneral);
    }
    
#if !defined(EGL_SINGLE_BUFFERING) && defined(FORCE_REFRESH_WORKAROUND)
    if( eglSurfaceAttrib(iEGLDisplay, (EGLSurface)iEGLSurface.surface, EGL_SWAP_BEHAVIOR, EGL_BUFFER_PRESERVED) == EGL_FALSE )
    {
        DEBUGPRINT("CPlatformFlashEngine::RecreateSurfaceL(), eglSurfaceAttrib() failed! Error = %d", eglGetError());
        User::Leave(KErrGeneral);
    }
#endif
    
    iCurrentWindowSize = GetWindow()->Size();    
    
    eglBindAPI(EGL_OPENVG_API);

    /* Make the context current. Binds context to the current rendering thread and surface.*/
    if (eglMakeCurrent(iEGLDisplay, (int) iEGLSurface.surface, (int) iEGLSurface.surface, iEGLContext) == EGL_FALSE)
    {
        DEBUGPRINT("CPlatformFlashEngine::RecreateSurfaceL(), eglMakeCurrent() failed! Error = %d", eglGetError());
        User::Leave(KErrGeneral);
    }
    
    iRenderingWindow = aWindow;
    iRedraw = ETrue;
    
#ifdef USE_VPU2 // only if VPU2 and OPENVG are enabled.
    //Alpha has to be enabled on egl, everytime egl is bound to a window.
    EnableAlphaOnEgl(aWindow);
#endif    
    
    FI_Rect fiRect;
    fiRect.xmin = (short) 0;
    fiRect.ymin = (short) 0;
    fiRect.xmax = (short) iFrameBufferSize.iWidth;
    fiRect.ymax = (short) iFrameBufferSize.iHeight;
    
    iFiObject.FI_SetDirtyRect(&fiRect, 1); //dont care return value.  
#ifdef FORCE_REFRESH_WORKAROUND        
    iForceRedraw = ETrue;
#endif
}

void CPlatformFlashEngine::DestroyEglSurface()
{    
    DEBUGPRINT("CPlatformFlashEngine::DestroyEgl: iEGLDisplay: %d", iEGLDisplay);
    if(iEGLDisplay == EGL_NO_DISPLAY)
        return;
    
    eglMakeCurrent(iEGLDisplay, EGL_NO_SURFACE, EGL_NO_SURFACE, EGL_NO_CONTEXT );

    if (iEGLSurface.surface != EGL_NO_SURFACE)
    {
        eglDestroySurface(iEGLDisplay, (EGLSurface) iEGLSurface.surface);
        iEGLSurface.surface = EGL_NO_SURFACE;
    }

}

void CPlatformFlashEngine::SetCurrentEglContext()
{
    if(!iOpenVgMode)
        return;
    
    /* Make the context current. Binds context to the current rendering thread and surface.*/
    if (eglMakeCurrent(iEGLDisplay, (int) iEGLSurface.surface, (int) iEGLSurface.surface, iEGLContext) == EGL_FALSE)
    {
        //_LIT(KMakeCurrentFailed, "eglMakeCurrent failed");
        //We need to check if we this is a critical error and show broken flash icon not user panic
        //User::Panic(KMakeCurrentFailed, 0);
    }  
}

TInt CPlatformFlashEngine::SwitchToSoftwareRendering(TBool aSync)
{
    if(iInDoPlay || !iMMObject)
    {
        return KErrGeneral;
    } 
    iRenderingSwitchType = ESwitchRenderingHWToSW;
    if(!aSync)
    {
        TCallBack cbk(ToggleRenderingMode,(TAny*)(this));
        if(iRenderToggleTimer)
        {
            delete iRenderToggleTimer;
            iRenderToggleTimer = NULL;
        }
        TRAPD(err,iRenderToggleTimer = CFlhTimerObject2::NewL(CActive::EPriorityHigh,cbk));
        if(err == KErrNone)
		{
			iSwitchingToSWRenderingInPrgress = ETrue;
            iRenderToggleTimer->After(0);
		}
    }
    else
    {
        DoToggleRenderingMode();
    }

    return KErrNone;
}

TInt CPlatformFlashEngine::SwitchToHwxRendering(TBool aSync)
{
    if(iInDoPlay || !iMMObject)
    {
        return KErrGeneral;
    }
    iRenderingSwitchType = ESwitchRenderingSWToHW;
   
    if(!aSync)
    {
        TCallBack cbk(ToggleRenderingMode,(TAny*)(this));
        if(iRenderToggleTimer)
        {
            delete iRenderToggleTimer;
            iRenderToggleTimer = NULL;
        }
        TRAPD(err,iRenderToggleTimer = CFlhTimerObject2::NewL(CActive::EPriorityHigh,cbk));
        if(err == KErrNone)
            iRenderToggleTimer->After(0);
    }
    else
    {
        DoToggleRenderingMode();
    }

    if(iFlashClientIf)
        iFlashClientIf->DrawDirtyRect(iFrameBufferSize);    
    
    return KErrNone;
}

TInt CPlatformFlashEngine::ToggleRenderingMode(TAny* aPtr)
{
    CPlatformFlashEngine* engine = (CPlatformFlashEngine*)aPtr;
    engine->iSwitchingToSWRenderingInPrgress = EFalse;

    TInt err = engine->DoToggleRenderingMode();
    
    delete engine->iRenderToggleTimer;
    engine->iRenderToggleTimer = NULL;
    
    return err;
}

TInt CPlatformFlashEngine::DoToggleRenderingMode()
{
    DEBUGPRINT("CPlatformFlashEngine::%s ++",__FUNCTION__);
    if(iOpenVgMode && iRenderingSwitchType == ESwitchRenderingHWToSW)
    {
        TInt initErr = 0, revertErr = 0;
        TInt err = iFiObject.FI_SetRenderMode(FI_RenderMode_Software);
        DEBUGPRINT("%s setrendermode %d",__FUNCTION__,err);                        
        if(err != 0)
        {//switching to SW rendering was successful
			/*RC: ou1cimx1#668194 , Do not destroy last EGL until we have a new request,
			as deleting this would make some of the resources orphan e.g. VGPath which are held by Core player and may result
			in memory leak. Deletion is done inside CreateEglSurfaceL().
			*/
            //DestroyEgl();
            FreeBits();
            
            DEBUGPRINT("CPlatformFlashEngine::%s switching to sw rend success",__FUNCTION__);
            
            iOpenVgMode = EFalse;
            iRenderToBitmap = ETrue;
            
            TRAP(initErr,InitializeL(TRect(iFrameBufferSize),EFalse,EFalse));
            
            if(initErr == KErrNone)
                DEBUGPRINT("CPlatformFlashEngine::%s initializel success",__FUNCTION__);
        }
        else
        {//switching failed. So set to HW rend again.
            if(iFiObject.FI_SetRenderMode(FI_RenderMode_Hardware) == 0)
                revertErr = KErrGeneral;
        }

        if(initErr || revertErr)
        {
            MUserNotiferIf* userNotifier = iFlashClientIf->GetUserNotifierIf();
            if(userNotifier)
            {
                userNotifier->NotifyClientError(EInsufficientGPUMemoryError, ETrue);
            }
            return KErrNone;
        }
    }
    else if(iRenderingSwitchType == ESwitchRenderingSWToHW)
    {
        TInt initErr = 0;
        TInt corePlayerSwitchErr=0, eglCreateErr=0;

        FreeBits();
        
        iOpenVgMode = ETrue;
        iRenderToBitmap = EFalse;
    
        TRAP(eglCreateErr,CreateEglSurfaceL());
        if(eglCreateErr) 
        {
            DestroyEgl(); //cleanup
        }
        
        if(!eglCreateErr)
        {
            TRAP(initErr,InitializeL(TRect(iFrameBufferSize),EFalse,EFalse));            
        }
        
        if(!initErr && !eglCreateErr)
        {
            corePlayerSwitchErr = iFiObject.FI_SetRenderMode(FI_RenderMode_Hardware);    
			/* ou1cimx1#476183 : Workaround to ensure that when we have switched to hw rendering,
             * the last bitmap blitted to the screen in sw rendering mode is cleared from the 
             * redraw store, before the new content is rendered onto the egl surface.
             * If this is not done previously blitted bitmap stays on top of the egl surface
             * and any new content rendered by egl is not visible until the screen is redrawn.
             */
            if(corePlayerSwitchErr != 0)
            {
            	DrawDirtyRegion(TRect(iFrameBufferSize));
            }
        }

        if(initErr || eglCreateErr || (corePlayerSwitchErr==0))
        {
            FreeBits();
            iOpenVgMode = EFalse;
            iRenderToBitmap = ETrue;
            
            TRAP(initErr,InitializeL(TRect(iFrameBufferSize),EFalse,EFalse));
            if(!initErr)
			{
            	corePlayerSwitchErr = iFiObject.FI_SetRenderMode(FI_RenderMode_Software);
			}
        }
        
        if(initErr || (corePlayerSwitchErr==0))        
        {
            DEBUGPRINT("initErr %d corePlayerSwitchErr %d ",initErr,corePlayerSwitchErr);
            MUserNotiferIf* userNotifier = iFlashClientIf->GetUserNotifierIf();
            if(userNotifier)
			{
                userNotifier->NotifyClientError(EInsufficientGPUMemoryError, ETrue);
            }
            return KErrNone;
        }
    }
    
    return KErrNone;
}

void CPlatformFlashEngine::HandleGainingForeground()
{
// Switching to HW rendering is handled in NotifyFocusChange
}

void CPlatformFlashEngine::HandleLosingForeground()  
{
    if(iOpenVgMode && iMMObject)
    {
        SwitchToSoftwareRendering(ETrue);
    }    
}


/*
 EGLint errCode = eglGetError();
 const char *s;

 switch (errCode)
 {
 case EGL_SUCCESS:
 s = "EGL_SUCCESS";
 break;
 case EGL_BAD_ACCESS:
 s = "EGL_BAD_ACCESS";
 break;
 case EGL_BAD_ALLOC:
 s = "EGL_BAD_ALLOC";
 break;
 case EGL_BAD_ATTRIBUTE:
 s = "EGL_BAD_ATTRIBUTE";
 break;
 case EGL_BAD_CONFIG:
 s = "EGL_BAD_CONFIG";
 break;
 case EGL_BAD_CONTEXT:
 s = "EGL_BAD_CONTEXT";
 break;
 case EGL_BAD_CURRENT_SURFACE:
 s = "EGL_BAD_CURRENT_SURFACE";
 break;
 case EGL_BAD_DISPLAY:
 s = "EGL_BAD_DISPLAY";
 break;
 case EGL_BAD_MATCH:
 s = "EGL_BAD_MATCH";
 break;
 case EGL_BAD_NATIVE_PIXMAP:
 s = "EGL_BAD_NATIVE_PIXMAP";
 break;
 case EGL_BAD_NATIVE_WINDOW:
 s = "EGL_BAD_NATIVE_WINDOW";
 break;
 case EGL_BAD_PARAMETER:
 s = "EGL_BAD_PARAMETER";
 break;
 case EGL_BAD_SURFACE:
 s = "EGL_BAD_SURFACE";
 break;
 case EGL_NOT_INITIALIZED:
 s = "EGL_NOT_INITIALIZED";
 break;
 case EGL_CONTEXT_LOST:
 s = "EGL_CONTEXT_LOST";
 break;
 default:
 s = "other";
 }*/

#endif

#ifdef FORCE_REFRESH_WORKAROUND
void CPlatformFlashEngine::ForceRedraw()
{
    if(iForceRedrawTimer)
    {
        delete iForceRedrawTimer;
        iForceRedrawTimer = NULL;
    }
	
    TCallBack cbk(ForceRedrawCallback,(TAny*)(this));
    TRAPD(err, iForceRedrawTimer = CFlhTimerObject2::NewL(CActive::EPriorityStandard,cbk));
    if(err == KErrNone)
    {
        iForceRedrawTimer->After(0);
    }
    
    iForceRedraw = EFalse;
}

TInt CPlatformFlashEngine::ForceRedrawCallback(TAny* aPtr)
{
    CPlatformFlashEngine* engine = (CPlatformFlashEngine*)aPtr;
    if(engine)
        engine->DoForceRedraw();

    return KErrNone;
}

void CPlatformFlashEngine::DoForceRedraw()
{
    iRedraw = ETrue;
    HandleRedraw();
    if(iForceRedrawTimer)
    {
        delete iForceRedrawTimer;
        iForceRedrawTimer = NULL;
    }
    iForceRedraw = EFalse;

}
#endif

TBool CPlatformFlashEngine::NoETelSuppport()
{
	return (iConfig.iMode & KSupportNoETelInfo)? ETrue: EFalse;
}

TBool CPlatformFlashEngine::HasQuertyKBSuppport()
{
	return (iConfig.iMode & KSupportQuertyKB)? ETrue: EFalse;
}

TBool CPlatformFlashEngine::InstanceInTrustedSandBox()
{
	return (iConfig.iMode & KSupportTrustedSandBox)? ETrue: EFalse;

}


#ifdef FEATURE_VIDEO_DLL
FL_ReferenceCountedObjectShare *
CPlatformFlashEngine::GetShareForCodec( U32 codecType )
{
	FL_ReferenceCountedObjectShare *		share = NULL;

	if ( codecType == kH263Codec )
		share = &m_decompressorSorenson;
	else if ( codecType == kVP6Codec || codecType == kVP6AlphaCodec )
		share = &m_decompressorOn2;
	else
	{
		PLAYERASSERT( false );
		share = NULL;
	}
	return share;
}

IVideoDecompressorInstance* CPlatformFlashEngine::GetNativeVideoDecompressor(MM_Object* aMMObj, void * aAllocator,  U32 codecType)
{
#ifdef FEATURE_WINDOWLESS	
	if((iFlashClientIf->GetWMode() != EWindow) && (codecType != AUDIO_ONLY_CODEC))
	{
		MUserNotiferIf* userNotifier = iFlashClientIf->GetUserNotifierIf();
		if(userNotifier)
		{
			userNotifier->NotifyClientError(KErrNotSupported, ETrue);
		}
		return NULL;
	}
#endif //FEATURE_WINDOWLESS

#ifdef FEATURE_OPENVG    
    if(iOpenVgMode)
    {
        iRenderingSwitchType = ESwitchRenderingHWToSW;
        TCallBack cbk(ToggleRenderingMode,(TAny*)(this));
        delete iRenderToggleTimer;
        iRenderToggleTimer = NULL;
        TRAPD(err,iRenderToggleTimer = CFlhTimerObject2::NewL(CActive::EPriorityHigh,cbk));
        if(err == KErrNone)
		{
    		iSwitchingToSWRenderingInPrgress = ETrue;
        	iRenderToggleTimer->After(0);
		}
    }
#endif	
	
    IVideoDecompressorInstance* instance = NULL;
    TRAPD(error, instance = CreateNativeVideoDecompressorL(aMMObj, aAllocator, codecType));
    if( error != KErrNone )
    {
        return NULL;
    }

    return instance;
}


IVideoDecompressorInstance* CPlatformFlashEngine::CreateNativeVideoDecompressorL(MM_Object* aMMObj, void * aAllocator, U32 codecType)
{
    // If Ph2 (helix mode) feature is present,
    // then we take the operating mode (Ph1/Ph2) based on whether the video is embedded video or not.

// Commented : AK
   /* if( iConfig.iHelixFlvMode )
	{
	    if( metaData && metaData->isEmbeddedVideo )
        {
           iConfig.iHelixFlvMode = EFalse;
        }
        else
        	iConfig.iHelixFlvMode = ETrue;

	}
	else
		iConfig.iHelixFlvMode = EFalse;

	return CreateFlvDecompressorL(aMMObj, aAllocator, codecType);
	*/
	if( iConfig.iHelixFlvMode )
	{
		return CreateFlvDecompressorL(aMMObj, aAllocator, codecType);
	}
	else
	{
	    if( !iFlvDecoder )
	    {
    		iFlvDecoder = CFLPlatformDecoderInterface::NewL(UserMode());
	    }
	    if( iFlvDecoder )
	    {
			SetVideoRectL(NULL, EVideoNone);

	        return iFlvDecoder->CreateVideoDecompressorL(aMMObj, aAllocator, codecType);
	    }
	}

	return NULL;
}


IVideoDecompressorInstance* CPlatformFlashEngine::CreateFlvDecompressorL(MM_Object* aMMObj, void * aAllocator, U32 codecType)
{
	IVideoDecompressorInstance* decoder = NULL;

    iFlvDecoder = CFLPlatformDecoderInterface::NewL(UserMode());

    if (iFlvDecoder)
    {
        iFlvDecoderArray.AppendL(iFlvDecoder);

		SetVideoRectL(NULL, EVideoNone);

        decoder= iFlvDecoder->CreateVideoDecompressorL(aMMObj, aAllocator, codecType);
        //commenting this SetMaxVideoFramesToProcess does have  performance impact for external video rendering and buffering
        //default is set to 300 by coreplayer and new exact seek functionality is dependant on max frames to process
       /* if(iConfig.iHelixFlvMode)
	        iFiObject.FI_SetMaxVideoFramesToProcess(KMaxVideoFramesToProcess);*/

        return decoder;
    }

    return NULL;
}

TUserMode CPlatformFlashEngine::UserMode()
{
	TUserMode uMode = EUnknownMode;
	//iBrowserPluginActive ? uMode = EPluginMode : uMode = EApplicationMode;
	(iExecutionMode == eStandAlone) ? uMode = EApplicationMode : uMode = EPluginMode;
	return uMode;
}

void CPlatformFlashEngine::DestroyVideoDecompressor(MM_Object * aMMObj, IVideoDecompressorInstance *aDecompressorInstance)
{
    for( TInt n=0; n < iFlvDecoderArray.Count(); n++ )
    {
        CFLPlatformDecoderInterface* decoderInstance;

        for( TInt n=0; n < iFlvDecoderArray.Count(); n++ )
        {
            decoderInstance = iFlvDecoderArray[n];

	        if( decoderInstance->DecompresssorInstance() == aDecompressorInstance )
	        {
	            iFlvDecoderArray.Remove(n);

	            decoderInstance->DestroyVideoDecompressor(aMMObj, aDecompressorInstance);

	            delete decoderInstance;
	        }
        }

        // When the list becomes empty, make the rect NULL.
        // We are making the rect = NULL because other videos may still have some rect.

        if( !iFlvDecoderArray.Count() )
        {
	    	TRAP_IGNORE(SetVideoRectL(NULL, EVideoNone));
	    }
    }

    //Switch back to HW rendering on destruction of last FLVDecoder instance.
    if(0==iFlvDecoderArray.Count() && iSwfInDestruction==EFalse)
    {
        SwitchToHwxRendering(EFalse);
    }
}

void CPlatformFlashEngine::UpdateVideoScreen()
{
	if( !iFlvDecoderArray.Count() && !iVideoRect.iRect.IsEmpty() && iVideoEngine && iVideoRect.iVideoType == EDeviceVideo )
	{
	    TRAP_IGNORE(iVideoEngine->NotifySizeChangedL());
	}

	if( !iConfig.iHelixFlvMode )
	{
		return;
	}

	if( !iFlvDecoderArray.Count() )
	{
		return;
	}

	THXVDCmdArg arg;
	EngineDispatchHXCommand(EHXVDCmdRefreshScreen, arg);
}

#endif

#ifdef FEATURE_WEB_BROWSABILITY
MHostScriptHandler* CPlatformFlashEngine::GetScriptHandler()
{
		return 	iHostScriptHandler;
}

TDesC8& CPlatformFlashEngine::GetMovieId()
{
if(iName)
{
	return (*iName);
}

TRAP_IGNORE(iName = HBufC8::NewL(KDefaultNameLength));
 return(*iName);

}
#endif

#ifdef __FEATURE_PRE_COMPILED_SWF

TBool CPlatformFlashEngine::GetClassFileBufL(const char* aFilename, int aFileLen, unsigned char*& aBuf, int& aLen)
{
	RFile file;

	HBufC* fileName = CreateEpocStringLC(aFilename,aFileLen);

	TInt ret = file.Open(iFs, *fileName, EFileRead | EFileShareExclusive | EFileStream);
	if(ret != KErrNone)
	{
		CleanupStack::PopAndDestroy(fileName);
		return EFalse;
	}
	CleanupClosePushL(file);

	User::LeaveIfError(file.Size(aLen));

	// Length + 1 because the buffer needs to be null terminated

  	aBuf = new(ELeave) unsigned char[aLen + 1];

	TPtr8 bufptr( (TUint8*)aBuf, aLen );

	User::LeaveIfError(file.Read(bufptr));

	aBuf[aLen] = '\0';

	CleanupStack::PopAndDestroy(&file);
	CleanupStack::PopAndDestroy(fileName);

	file.Close();
	return ETrue;

}

void CPlatformFlashEngine::FreeClassFileBuf(unsigned char*& aBuf)
{
	if (aBuf)
		delete aBuf;
	aBuf=NULL;
}

#ifdef __FEATURE_PRE_COMPILED_SWF_RSC
void CPlatformFlashEngine::SetPreInsASClassFromRscL ()
{
	TInt count,i;
	TInt resoffset = FlashEngineRscHandler::LoadEngineResourceFileL();
	char** array=AllocReadResourceArrayIntoFlashStringArrayL(count, R_FLASH_SUPPORTED_PREINSTALLED_AS_CLASS);

	for(i=0;i<count;i++)
	{
		unsigned char* classSwfData = NULL;
		int classLen;
		if(GetClassFileBufL(array[i],FlashStrLen(array[i]), classSwfData, classLen))
		{
			iFiObject.FI_SetPreInstalledASClass(classSwfData, classLen, false);
			FlashMemSet(classSwfData,0,classLen);
			FreeClassFileBuf(classSwfData);
		}
		delete[] array[i];
	}

	delete[] array;
	array=NULL;
	FlashEngineRscHandler::DeleteEngineResourceFile(iEnv, resoffset);
}
#endif // __FEATURE_PRE_COMPILED_SWF_RSC

void CPlatformFlashEngine::SetPreInstalledASClassL( )
{

#ifdef __FEATURE_PRE_COMPILED_SWF_RSC
	SetPreInsASClassFromRscL ();
#endif // __FEATURE_PRE_COMPILED_SWF_RSC

	if (0 == iConfig.iActScriptExtensions)
		return;

	//get iConfig.Reserved1
	//extract each
	TPtrC8 temp_ASClasses, temp_ASClass;
	const TChar KASClassSeparator = ';';
	temp_ASClasses.Set(iConfig.iActScriptExtensions->Mid(0));

	TInt pos = 0;
	while (KErrNotFound != pos)
	{
		pos = temp_ASClasses.Locate(KASClassSeparator);
		if (KErrNotFound == pos)
		{
			temp_ASClass.Set(temp_ASClasses.Mid (0));
		}
		else
		{
			temp_ASClass.Set(temp_ASClasses.Left(pos));
			temp_ASClasses.Set(temp_ASClasses.Mid(pos+1));
		}

		//Call FI_Func on temp_ASClasses
		CallFI_SetPreInstASClassL (temp_ASClass, false);
	}
}

TBool CPlatformFlashEngine::HasSwfExtension( const TDesC& aStr )
{
	TInt len = aStr.Length();
	return ( len >= 4 &&
			 (aStr[len-4] == '.' &&
			 (aStr[len-3] == 's' || aStr[len-3] == 'S') &&
			 (aStr[len-2] == 'w' || aStr[len-2] == 'W') &&
			 (aStr[len-1] == 'f' || aStr[len-1] == 'F') ) );
}

void CPlatformFlashEngine::CallFI_SetPreInstASClassL  (TDesC8 &aASClass, unsigned short aBIsNativeLibrary)
{

	TBuf <KMaxFileName> asClassPath;

	// now get the UID for the process we are running
	TUid uid(User::Identity());
	TPtrC uidName(uid.Name().Mid(1,8));


	//Convert aASClass to Unicode
	TBuf <KMaxFileName> libName;
	TInt state = CCnvCharacterSetConverter::KStateDefault;
	User::LeaveIfError(iCharacterConverter->ConvertToUnicode(libName, aASClass, state));
	if (!HasSwfExtension (libName))
	{
		return;
	}

	//Find if the ASClass is present in app private dir
	RFs fs;
	TInt err = fs.Connect();
	TBool found;

	asClassPath.Append(KLitPvt);

	asClassPath.Append(uidName);
	asClassPath.Append(KPathDelimiter);
	asClassPath.Append (libName);

	TUint attVal = 0;
	found = fs.Att(asClassPath,attVal);

	//Find if the ASClass is present in app private dir

	if (found == KErrNone)
		{
			TBuf8 <KMaxFileName> classpath;
			User::LeaveIfError(iCharacterConverter->ConvertFromUnicode(classpath, asClassPath));
			unsigned char* classSwfData = NULL;
			int classLen;
			if(GetClassFileBufL((const char*)classpath.Ptr(),asClassPath.Length (), classSwfData, classLen))
			{
				iFiObject.FI_SetPreInstalledASClass(classSwfData, classLen, aBIsNativeLibrary);
				FreeClassFileBuf(classSwfData);
			}
		}

	fs.Close();
}

#endif //__FEATURE_PRE_COMPILED_SWF

#ifdef FEATURE_MULTIPLE_DRIVE
TInt CPlatformFlashEngine::SearchASLibL(TDes& aFile)
    {
    RFs fs;
	TInt err = fs.Connect();
	HBufC* driveRootPath =HBufC::NewLC(KMaxFileName);
    TPtr ptrRootPath=driveRootPath->Des();

    TInt intDrive;
    TInt found =KErrNone ;
    TUint attVal = 0;
    DriveInfo::TDriveArray driveArray;

    User::LeaveIfError( DriveInfo::GetUserVisibleDrives( fs, driveArray ) );

    	for(TInt i=0; i < driveArray.Count(); i++)
        	{
        	TChar driveLetter = driveArray.LetterAt(i);
        	User::LeaveIfError( RFs::CharToDrive(driveLetter, intDrive) );
        	User::LeaveIfError( PathInfo::GetRootPath(ptrRootPath, intDrive) );
        	ptrRootPath.Append(aFile);

	     found = fs.Att(ptrRootPath,attVal);
			if(found)
			break;
        	}
       CleanupStack::PopAndDestroy(driveRootPath);
        	fs.Close();
        	return found;
    }
 #endif/// FEATURE_MULTIPLE_DRIVE

void CPlatformFlashEngine::FLVideoStarted(TInt32 aCodecType)
{
    TInt    dummy = 0;
    iIsVideoContent = ETrue;
    Zoom(EShowAll, dummy);
	iFLVPlayStat = ETrue; //playing flv

	// readjust dynamic heap
	iPlayerDynamicHeapMaxSize = GetFLVMaxDynHeapSize() ;



	//do setup soundhandler
	if(iSoundHandler)
		iSoundHandler->HandleFlvSetup(aCodecType);

	MFlashVideoClientIf* flvClientIf = iFlashClientIf->GetFlvClientIf();
	
	//if(iBrowserPluginActive)
	if(iExecutionMode == ePlugin)
	{
    	if(flvClientIf)
		{
		flvClientIf->FLVideoStarted();
		}
	}
	else
	{
		if(flvClientIf)
		{
            flvClientIf->FLVideoStarted();
			/* Make an async event to make another FI call for clearing
			 * previous transformations */
			iFitVideoToScreen = ETrue;
			TriggerAsyncEvent();
		}
	}
}

void CPlatformFlashEngine::VideoIsEmbedded(TBool aEmbeddedVideo)
{
	MFlashVideoClientIf* flvClientIf = iFlashClientIf->GetFlvClientIf();
	
	flvClientIf->VideoIsEmbedded(aEmbeddedVideo);
}

#ifdef __FEATURE_UI_LANDSCAPE_FULLSCREEN
void CPlatformFlashEngine::FLVideoFinished()
{
    //if(!iBrowserPluginActive && iFlashUI)
    if(eStandAlone==iExecutionMode)
    {
        iFitVideoToScreen = EFalse;
        //iFlashUI->FLVideoFinished();
        MFlashVideoClientIf* flvClientIf = iFlashClientIf->GetFlvClientIf();
        if(flvClientIf)
            flvClientIf->FLVideoFinished();
    }
}
#endif //__FEATURE_UI_LANDSCAPE_FULLSCREEN

unsigned short CPlatformFlashEngine::QueueHttpRequestL(unsigned short aStreamId, HBufC* hUrl, HBufC* hPost)
	{
	THttpRequestInfo* httpRequestInfo  = new (ELeave) THttpRequestInfo;
	httpRequestInfo->iUrl = hUrl;
	httpRequestInfo->iPost = hPost;
	httpRequestInfo->iStreamId = aStreamId;
	httpRequestInfo->iIsFired = EFalse;

	if(iRequestArray)
		{
		iRequestArray->AppendL(httpRequestInfo);
		}
	else
		{
		iRequestArray = new(ELeave) CArrayPtrSeg<THttpRequestInfo>(1);
		iRequestArray->AppendL(httpRequestInfo);
		}

	FireNextRequestL();

	return 1;
	}

TInt CPlatformFlashEngine::NumOfRequestsFired()
	{
	TInt retVal = 0;

	if(!iRequestArray)
		{
		return retVal;
		}

	for( TInt i = 0; i < iRequestArray->Count(); i++)
		{
		TBool isTrue = ( iRequestArray->At(i) )->iIsFired;
		if( isTrue != EFalse )
			{
			retVal++;
			}
		}
	return retVal;
	}

unsigned short CPlatformFlashEngine::FireNextRequestL()
	{
	unsigned short result = 0;
	if( NumOfRequestsFired() < KMaxNumberOfRequests )
		{
		if (iRequestArray)
			{
			MPluginStreamIf* streamIf = iFlashClientIf->GetStreamIf();
			
			for( TInt i = 0; i < iRequestArray->Count(); i++)
				{

				if( ( iRequestArray->At(i) )->iIsFired == EFalse )
					{
					THttpRequestInfo* httpRequestInfo = iRequestArray->At(i);
					httpRequestInfo->iIsFired = ETrue;
					
					if ( httpRequestInfo->iPost )
						{
						if(streamIf)
						    result = streamIf->OpenStreamL(httpRequestInfo->iStreamId, *(httpRequestInfo->iUrl),
						            KNullDesC,0,*(httpRequestInfo->iPost));
						}
					else
						{
						TPtrC nullDes;
						if(streamIf)
						    result = streamIf->OpenStreamL(httpRequestInfo->iStreamId, *(httpRequestInfo->iUrl),
						            KNullDesC,0,nullDes);
						}

					break;
					}
				}//for
			}
		}
	return result;
	}

void CPlatformFlashEngine::RemoveCompletedRequest(TUint16 aStreamId)
	{

		if(!iRequestArray)
			return;

		THttpRequestInfo* httpRequestInfo=NULL;

		for (TInt i=0;i<iRequestArray->Count(); i++)
		{
			httpRequestInfo = iRequestArray->At(i);

			if( httpRequestInfo && ( httpRequestInfo )->iStreamId == aStreamId )
			{
				delete httpRequestInfo;//let us delete it first

				iRequestArray->Delete(i);

				break;
			}

		}


		if (iRequestArray && iRequestArray->Count() == 0)
			{
				delete iRequestArray;
				iRequestArray = NULL;
			}
	}

void CPlatformFlashEngine::RemoveAllRequest()
{
	if(!iRequestArray)
		return;

	THttpRequestInfo* httpRequestInfo=NULL;

	while(iRequestArray->Count())
	{
		httpRequestInfo = iRequestArray->At(0);

		delete httpRequestInfo;

		iRequestArray->Delete(0);

	}

	delete iRequestArray;
	iRequestArray = NULL;
}

void CPlatformFlashEngine::SetFLVStatus(const char* code)
{
	if( !code )
	{
		return;
	}

	TInt len;

	const char* KStatusBufferEmpty 	= "NetStream.Buffer.Empty";
    const char* KStatusBufferFull	= "NetStream.Buffer.Full";
	const char* KStatusBufferFlush	= "NetStream.Buffer.Flush";
    const char* KStatusStart		= "NetStream.Play.Start";
   	const char* KStatusStop			= "NetStream.Play.Stop";
    const char* KStatusSeekNotify	= "NetStream.Seek.Notify";
    const char* KStatusPause		= "NetStream.Play.Pause";
    const char* KStatusResume		= "NetStream.Play.Resume";

	for(len=0;code[len]!='\0';len++)//Findng out the length of status string
		;
	if(!strncmp(code,KStatusBufferEmpty,len))
	{
		iFLVStatus = ENetStreamBufferEmpty;
	}

	if(!strncmp(code,KStatusBufferFull,len))
	{
		iFLVStatus = ENetStreamBufferFull;
	}

	if(!strncmp(code,KStatusBufferFlush,len))
	{
		iFLVStatus = ENetStreamBufferFlush;
	}

	if(!strncmp(code,KStatusStart,len))
	{
		iFLVStatus = ENetStreamPlayStart;
	}

	if(!strncmp(code,KStatusStop,len))
	{
		iFLVStatus = ENetStreamPlayStop;
	}

	if(!strncmp(code,KStatusPause,len))
	{
		iFLVStatus = ENetStreamPlayPause;
	}

	if(!strncmp(code,KStatusResume,len))
	{
		iFLVStatus = ENetStreamPlayResume;
	}

	if(!strncmp(code,KStatusSeekNotify,len))
	{
		iFLVStatus = ENetStreamNull;
	}
}


void CPlatformFlashEngine::SetScreenMode()
{
	if(  !iConfig.iHelixFlvMode || !iFlvDecoderArray.Count() )
	{
		return;
	}

	THXVDCmdArg arg;
	
	//TODO : Revisit this part..check if this is ok for browser plugin
	MDisplay* display = iFlashClientIf->GetDisplay(); 
    if (display->IsFullScreenMode())
        {
        arg.iScreenMode = EFullScreenMode;
        }
    else
        {
        arg.iScreenMode = ENormalScreenMode;
        }
	    

	/*if( iFlashUI )
	{
		if( iFlashUI->IsFullScreenMode() )
		{
			arg.iScreenMode = EFullScreenMode;
		}
		else
		{
			arg.iScreenMode = ENormalScreenMode;
		}
	}
	else if( iFlashClientIf->GetDisplay() )
	{
		if( iFlashClientIf->GetDisplay()->IsFullScreenMode() )
		{
			arg.iScreenMode = EFullScreenMode;
		}
		else
		{
			arg.iScreenMode = ENormalScreenMode;
		}
	}*/

	EngineDispatchHXCommand(EHXVDCmdSetScreenMode, arg);
}

void CPlatformFlashEngine::SetEglContainerWindow(RWindow* aWindow)
{
#ifdef FEATURE_OPENVG
    if(iOpenVgMode && iRenderingWindow != aWindow)
    {//current rendering window iRenderingWindow will be updated
     //when the egl surface is recreated.
        TRAPD(err, RecreateSurfaceL(aWindow));
        if(err != KErrNone)
        {
            SwitchToSoftwareRendering();
        }
    }
#endif
}

void CPlatformFlashEngine::SetVideoWindow(RWindow* aWindow)
{
    // Propagate window change to renderers.
	if(  iConfig.iHelixFlvMode && iFlvDecoderArray.Count() )
	{
        THXVDCmdArg arg;
        arg.iWindow = aWindow;
    
        EngineDispatchHXCommand(EHXVDCmdSetWindow, arg);
	}
	
	if(iVideoEngine && iVideoEngine->HasActivePlayback())
    {
        iVideoEngine->SetVideoWindow(aWindow);
    }
}

void CPlatformFlashEngine::SetVideoDisplayRectL(const TRect& aVideoRect, const TRect& aClipRect)
{
	//if(  !iControl || !iConfig.iHelixFlvMode )
    if((iExecutionMode != ePlugin) || !iConfig.iHelixFlvMode )
	{
		return;
	}

	THXVDCmdArg arg;
	arg.iDisplayRect = aVideoRect;
	arg.iClipRect	 = aClipRect;

	EngineDispatchHXCommand(EHXVDCmdSetDisplayRect, arg);

    // if using CVideoObject, we have to send the new rect to that object.
	if( iVideoEngine )
	    iVideoEngine->NotifyScrollL();

}

void CPlatformFlashEngine::PauseVideo()
{
	//if(  !iControl || !iConfig.iHelixFlvMode )
    if((iExecutionMode!=ePlugin) || !iConfig.iHelixFlvMode )
	{
		return;
	}

	THXVDCmdArg arg;
	EngineDispatchHXCommand(EHXVDCmdPause, arg);
}

void CPlatformFlashEngine::ResumeVideo()
{
    DEBUGPRINT("CPlatformFlashEngine::ResumeVideo()++");
    //if(  !iControl || !iConfig.iHelixFlvMode )
    if((iExecutionMode!=ePlugin) || !iConfig.iHelixFlvMode )
    {
        return;
    }

    THXVDCmdArg arg;
    EngineDispatchHXCommand(EHXVDCmdResume, arg);
    DEBUGPRINT("CPlatformFlashEngine::ResumeVideo()--");
}

void CPlatformFlashEngine::PlayVideo()
{
	//if(  !iControl || !iConfig.iHelixFlvMode )
    if((iExecutionMode!=ePlugin) || !iConfig.iHelixFlvMode )
	{
		return;
	}

	THXVDCmdArg arg;
	EngineDispatchHXCommand(EHXVDCmdPlay, arg);
}


void CPlatformFlashEngine::SeekFlv()
{
	if( !iFlvDecoder || !iConfig.iHelixFlvMode )
	{
		return;
	}

	THXVDCmdArg arg;
	EngineDispatchHXCommand(EHXVDCmdSeek, arg);
}


TInt32 CPlatformFlashEngine::GetFLVMaxDynHeapSize()
	{
	return iPlatformConfig->GetVideoDynHeapSize();
	}

FI_Interface& CPlatformFlashEngine::GetFIObject()
{
    return iFiObject;
}

TBool CPlatformFlashEngine::IsStereoSupported()
{
	if(iConfig.iMode & KSupportStereo)
	{
		return ETrue;
	}

	return EFalse;
}

void CPlatformFlashEngine::HandleWidgetError(TBool videoError)
{
    // Check if the embed parameter is set, which implies that it is a custom
    // widget and we traverse back to the previous page. If not then it is a
    // generic case and we need to handle it separately.
    if (iHostEngineGlobals->GetNoOfPlugins() != 1 || !(iFlashClientIf->IsWidgetMode()))
        return;
    const char *js_command;
    if (iPassOnException && videoError) 
    {
        // The following string is the Java Script command to navigate to the
        // previous page.
        js_command =  "try \
                             { \
                             document.getElementById(\"swfObject\").SetReturnValue(__flash__toXML(onPlayerError(\"PlayerError\")) ); \
                             } catch (e) \
                             { \
                             document.getElementById(\"swfObject\").SetReturnValue(\"<undefined/>\"); \
                             }";
    }
    else
    {
        js_command = "javascript:window.close();";
        TBufC<128> KResFile(_L("flash2engine.rsc") );
        TInt resOffset = LoadPluginResourceL(KResFile);
        HBufC* textResource = StringLoader::LoadL( R_FLASH_ERR_EIKON_GENERAL );
        CleanupStack::PushL( textResource );
        CAknErrorNote* note = new ( ELeave ) CAknErrorNote( ETrue );
        note->ExecuteLD( *textResource );   
        CleanupStack::PopAndDestroy( textResource );     
        CEikonEnv::Static()->DeleteResourceFile(resOffset);
    }
    
    //RC Error:ou1cimx1#519118 Crash seen SI_EvaluateJavascript call
     if(iHostScriptHandler && iHostScriptHandler->GetPluginScriptHandler())
        iHostScriptHandler->GetPluginScriptHandler()->EvaluateJavaScript(js_command);
}
void CPlatformFlashEngine::HandleHelixError(const TInt& aError)
{
    HandleWidgetError(true);
	if( aError != KErrNone && iConfig.iHelixFlvMode )
	{
        MFlashVideoClientIf* flvClientIf = iFlashClientIf->GetFlvClientIf();
        if(flvClientIf)
            flvClientIf->HandleVideoError(aError);
	/*
		// Handle error
		if( GetPlugin() )
		{
			GetPlugin()->HandleVideoError(aError);
		}
		else if( GetUI() )
		{
			GetUI()->HandleVideoError(aError);            
		}
	*/
	}
}

#ifdef __FEATURE_FLV_RECOG_PLAY

	RFile* CPlatformFlashEngine::GetRFileHandleForPlay()
	{
		/*if(iFlashUI)
		{
			return iFlashUI->GetRFileHandleForPlay();
		}*/

        return this->iFlashClientIf->GetRFileHandleForPlay();
	
		//return NULL;
	}

#endif
#ifdef FEATURE_EXTENSION

PluginInfo* CPlatformFlashEngine::GetPluginInfoL(struct MM_Object* /*aMMObj*/,
        struct ExtensionInterface* pEI)
    {
    
    PluginInfo* pInfo= NULL;
    //if(!iBrowserPluginActive)// || //Not browser plugin -> Viewer app/Stub app 
       //(iBrowserPluginActive && (iInteractionMode == EWidgetMode))) //Plugin in widget mode
    	if(iExecutionMode == eStandAlone)
        {
        
        PluginInfo* temp= NULL;
        PluginInfo* temp1 = NULL;
    
        RImplInfoPtrArray pASExtensionImplArray;
    
        REComSession::ListImplementationsL(KASExtInterfaceUid, pASExtensionImplArray);
        TInt noOfImplfound = pASExtensionImplArray.Count();
        for (TInt lIndex(0); lIndex < noOfImplfound; ++lIndex)
            {
            HBufC8* pluginName =EscapeUtils::ConvertFromUnicodeToUtf8L(pASExtensionImplArray[lIndex]->DisplayName());
            CleanupStack::PushL(pluginName);
    
            CASExtensionDelegate* pImpl= NULL;
            TRAPD(err,pImpl = CASExtensionDelegate::NewL(*pluginName));
            CleanupStack::PopAndDestroy(pluginName);
    
            if((err == KErrNone) && pImpl )
                {
                TRAPD(err1, temp = pImpl->GetPluginInfoL(this, pEI));
                if( (err1 == KErrNone) && temp)
                    {
                    if(lIndex == 0 )
                        {
                        pInfo = temp;
                        temp1 = temp;
                        }
                    else
                        {
                        temp1->reserved1 = temp;
                        temp1 = temp;                  
                        }
                    pImpl->InitPlugin( CASExtensionDelegate::EOpCodeSMCheckNeeded , (TAny*)iConfig.iSMCheckNeeded );
                    }
                }
            }
    
        for (TInt lIndex(0); lIndex < noOfImplfound; ++lIndex)
            {
            CImplementationInformation* lTempImplInfo = pASExtensionImplArray[0];
            pASExtensionImplArray.Remove(0);
            delete lTempImplInfo;
            }
    
        pASExtensionImplArray.ResetAndDestroy();
        temp = NULL;
        temp1 = NULL;    
        }
    
    return pInfo;
    }

void CPlatformFlashEngine::ProcessHostCmdL(const TDesC& aCommandName, RASExtensionArgArray& aArgArray, TInt& aReturnValue)
    { 
    
    if(!aCommandName.Compare(KASCmdResumePlayer))
        {
        if(iPauseFlags == EReasonBackground && (aArgArray.Count() == 1))            
            {
            TBool lBringToForeground = TBool(aArgArray[0]->pVariableValue); 
            
            MDeviceExtnIf* deviceIf = iFlashClientIf->GetDeviceIf();
            if(deviceIf)
                deviceIf->ResumeOnEventL(lBringToForeground);
            
            //todo put the check for widget mode and call the resume on plugin control
            /*
            if((iInteractionMode == EWidgetMode )&& iControl)
            
                {
                this->iFlashClientIf->GetDeviceIf()->ResumeOnEventL(lBringToForeground);                
                aReturnValue = 0;
                }
            else if(iFlashUI)
                {
                this->iFlashClientIf->GetDeviceIf()->ResumeOnEventL(lBringToForeground);
                aReturnValue = 0;
                }
            */
            }            
        }
     else if(!aCommandName.Compare(KDisableAutoRoataion))
        {
        if((aArgArray.Count() == 1) && ((aArgArray[0]->variableType == kExtnVarTypeBoolean)))
            {
            TBool lAuotRotationMode = TBool(aArgArray[0]->pVariableValue);
            
            MDisplay* display = iFlashClientIf->GetDisplay();
                if(display)	
	          	{
	          	display->SetAutoRotationModeL(lAuotRotationMode);
				aReturnValue = 0;		
	          	}            	
            }
        }
    else if (!aCommandName.Compare(KExpediteConnection))
        {
        #ifdef FEATURE_XML_SOCKET
        if (iSocketEngine) //safe to access directly..
            {
            iSocketEngine->ExpediteConnectionL();
            aReturnValue = 0;
            }
        #endif
        }
     else
        {
        aReturnValue = KASErrNotSupported; //not Supported
        }           
    
    }
#endif

#ifdef FEATURE_WATCH_GPU_MEM
void CPlatformFlashEngine::GPUMemoryLow(TBool aLow)
{
    iGPUMemLow = aLow;
    
    if(iOpenVgMode && iGPUMemLow && !iIsInitialized)
    {
        iOpenVgMode = EFalse;
        iRenderToBitmap = ETrue;
    }
    
#if 0    
    if(!iOpenVgMode || !iGPUMemLow)
        return;
        
    if(!iEGLInitialized)
        return;

    iRenderingSwitchType = ESwitchRenderingHWToSW;
    DoToggleRenderingMode();
#endif
}
#endif

#ifdef SELF_IAD_UPDATE
void CPlatformFlashEngine::HandleIADCheck( MIadUpdateCallback* aIADUpdateCompleteCallback, FlashEngineConfig& aConfig )
{
    // we do not check for updates if the mode is
    // * Screen saver
    // * tutorial

    if( !aConfig.iCheckIADUpdate )
        return;
    NPPDebug( LOG_ALL, IsBrowserPluginActive(), _L("void CPlatformFlashEngine::HandleIADCheck( MIadUpdateCallback* aIADUpdateCompleteCallback ) ++ ") );

    // NOTE: we'll trap all the errors and not pass it back to the engine
    // as the IAD check is not critical

    // iIADUpdateChecker is in HostEngineGlobals and hence it'll be deleted when the last instance
    // of the HostEngine is deleted.

    CIADUpdateChecker* iIADUpdateChecker = iHostEngineGlobals->IADUpdateChecker(
                                                                            KFlashLitePackageID,
                                                                            KNullDesC,
                                                                            KNullDesC,
                                                                            KNullDesC8,
                                                                            EFalse,
                                                                            aIADUpdateCompleteCallback
                                                                            );

    if( !iIADUpdateChecker )
    {
        // the IAD object could not be created for some reason.
        // continue with the host engine creation as IAD update check isn't _that_ critical
        NPPDebug( LOG_ALL, IsBrowserPluginActive(), _L("!iIADUpdateChecker") );
        return;
    }

    NPPDebug( LOG_ALL,IsBrowserPluginActive(), _L("iIADUpdateChecker") );

    // check which state the update process is in...
    CIADUpdateChecker::TIadUpdateStatus updateStatus = iIADUpdateChecker->UpdateStatus();
    NPPDebug( LOG_ALL,IsBrowserPluginActive(), _L("updateStatus  : %d"), updateStatus );


    /*
     * Continue only if we haven't checked for updates of if the update check has failed.
     * Return otherwise
     */
    if( !(  updateStatus == CIADUpdateChecker::KUpdateNotStarted
        ||  updateStatus == CIADUpdateChecker::KUpdateFailed
         )
      )
    {
        return;
    }

    // the update checker and the observer class were successfully created.
    // no we go ahead and initiate the update process.

    if( iIADUpdateChecker->IsUpdateSupported() )
    {
        NPPDebug( LOG_ALL,IsBrowserPluginActive(), _L("IAD Update supported") );
        DEBUGPRINT("IAD Update Supported");

        TRAPD( updateError, iIADUpdateChecker->CheckUpdateL() );
        if( updateError != KErrNone )
        {
            // there was some error while checking for updates.
            // lets not bother the user.

            NPPDebug( LOG_ALL,IsBrowserPluginActive(), _L("updateError != KErrNone") );
            delete iIADUpdateChecker;
            iIADUpdateChecker = NULL;
        }
    }

    NPPDebug( LOG_ALL,IsBrowserPluginActive(), _L("void CPlatformFlashEngine::HandleIADCheck( MIadUpdateCallback* aIADUpdateCompleteCallback ) --") );

}

void CPlatformFlashEngine::DestroyIADComponents()
{
    // iIADUpdateChecker is in HostEngineGlobals and hence it'll be deleted when the last instance
    // of the HostEngine is deleted.
/*
    if( iIADUpdateChecker )
    {
        delete iIADUpdateChecker;
        iIADUpdateChecker = NULL;
    }
*/
}

#endif

void CPlatformFlashEngine::NotifyFullScreen(TBool aFullScreen)
{
	iFiObject.FI_NotifyFullScreenStatus(aFullScreen);
}

void CPlatformFlashEngine::SetFullScreenViaFSCommand(TBool aFullScreen)
{
    iFullScreenViaFSCommand = aFullScreen;
}

TBool CPlatformFlashEngine::IsOpenVgRenderingMode()
{
    return iOpenVgMode;
}

TBool CPlatformFlashEngine::IsRenderingToBitmap()    
{
    return iRenderToBitmap;
}

void CPlatformFlashEngine::SetSwfHasVideo(TBool aVideo)
{
    if(aVideo)
    {
        iSwfHasVideo++;
    }
    else
    {
        iSwfHasVideo--;
        if(iSwfHasVideo<0)	// Most likely will not happen. But just incase...
            iSwfHasVideo = 0;
    }
}

void CPlatformFlashEngine::SetSwfHasAudio(TBool aAudio)
{
    if(aAudio)
    {
        iSwfHasAudio++;
    }
    else
    {
        iSwfHasAudio--;
        if(iSwfHasAudio<0)  // Most likely will not happen. But just incase...
            iSwfHasAudio = 0;
    }
}

TUint16 CPlatformFlashEngine::FrameBufferDisplayFormat()
{
    return iFrameBufferDisplayFormat;
}

#ifdef DUMP_DIRTY_RECTS
void CPlatformFlashEngine::DumpDirtyRects(TRect aDirtyRect)
#else
void CPlatformFlashEngine::DumpDirtyRects(TRect /*aDirtyRect*/)
#endif
{
#ifdef DUMP_DIRTY_RECTS
    if(iBitmapToBeDumped == NULL)
    {
        return;
    }
    
    iDirtyRectNum++;

    TBuf<64> lFileName;
    lFileName.AppendFormat(_L("C:\\data\\others\\dirtyrectdump%d"),iDirtyRectNum);
    lFileName.AppendFormat(_L(".raw"));
    iDirtyRectDumpFile.Replace(iFs,lFileName,EFileWrite);

    TSize lSize = iBitmapToBeDumped->SizeInPixels();

    TUint8* lTempAddr = (TUint8*)iBitmapToBeDumped->DataAddress() +
    ((lSize.iWidth * 4) * aDirtyRect.iTl.iY) + aDirtyRect.iTl.iX * 4;

    TInt lLengthWritten = 0;
    for(TInt lYLine=aDirtyRect.iTl.iY; lYLine <= aDirtyRect.iBr.iY; lYLine++ )
    {
        TPtr8 lPtr(lTempAddr, aDirtyRect.Width() * 4, aDirtyRect.Width() * 4);
        iDirtyRectDumpFile.Write(lPtr);
        lLengthWritten += aDirtyRect.Width() * 4;
        lTempAddr += (lSize.iWidth * 4);
    }

    TBuf8<128> lBuf;
    lBuf.AppendFormat(_L8("Dirty rect=(%d,%d,%d,%d), size=%d\r\n"),aDirtyRect.iTl.iX,aDirtyRect.iTl.iY,aDirtyRect.Width(),aDirtyRect.Height(),lLengthWritten);
    iDirtyRectLengthsFile.Write(lBuf);

    iDirtyRectDumpFile.Close();
#endif
}

void CPlatformFlashEngine::ShowRedrawRegions(TRect /*aDirtyRect*/, CWindowGc& /*aWGc*/)
{
#ifdef SHOW_REDRAW_REGIONS //useful only in ph2
    DEBUGPRINT("Drawing dirty rect regions %d %d %d %d", aDirtyRect.iTl.iX, aDirtyRect.iTl.iY,
            aDirtyRect.iBr.iX, aDirtyRect.iBr.iY);
    aWGc.SetDrawMode(CGraphicsContext::EDrawModePEN);
    aWGc.SetPenColor(KRgbRed);    
    aWGc.SetBrushStyle(CGraphicsContext::ENullBrush);
    aWGc.DrawRect(aDirtyRect);
#endif
}

void CPlatformFlashEngine::ResizeBitmapsL(TSize aSize)
{
    ResizeFrameBufferBitmapL(aSize);
#ifdef FEATURE_OPENVG    
    if(iOpenVgMode)
        ResizeAuxTextBitmapL(aSize);
#endif    
}

void CPlatformFlashEngine::ResizeFrameBufferBitmapL(TSize aSize)
{
    if(!iRenderToBitmap)
        return;

    iBitmapSize.x = aSize.iWidth;
    iBitmapSize.y = aSize.iHeight;
    
    TInt errd = KErrNone;
    errd = iBitmap->Resize(TSize(iBitmapSize.x, iBitmapSize.y));
    if (errd == KErrNone) {
        errd = iBitmapDevice->Resize(TSize(iBitmapSize.x, iBitmapSize.y));
    }

    if(errd != KErrNone) {
        FreeFrameBufferBits();
    }
    
    User::LeaveIfError(errd);
    
    TUint32* da = iBitmap->DataAddress();
    TInt len = iBitmap->SizeInPixels().iWidth * iBitmap->SizeInPixels().iHeight;
    for(TInt i=0;i<len;i++) {
        *(da+i) = KRgbBlack.Value();
    }
    
    CFbsBitGc* bGc = GetBitmapContext();
    if(bGc) {
        bGc->Resized();
    }
}

#ifdef FEATURE_OPENVG
void CPlatformFlashEngine::ResizeAuxTextBitmapL(TSize aSize)
{
    TInt errd = KErrNone;

    iAuxTextBitmapSize.x = aSize.iWidth;
    iAuxTextBitmapSize.y = aSize.iHeight;      
    
    errd = iAuxTextBitmap->Resize(TSize(iAuxTextBitmapSize.x, iAuxTextBitmapSize.y));
    if (errd == KErrNone) {
        errd = iAuxTextBitmapDevice->Resize(TSize(iAuxTextBitmapSize.x, iAuxTextBitmapSize.y));
    }

    if(errd != KErrNone) {
        FreeAuxTextBits();
    }

    User::LeaveIfError(errd);
    
    CFbsBitGc* gc = GetAuxTextBitmapContext();
    if (gc) {
        gc->Resized();
    }
}
#endif


void CPlatformFlashEngine::RecreateBitmapsL(TSize aSize)
{
    RecreateFrameBufferBitmapL(aSize);
#ifdef FEATURE_OPENVG    
    RecreateAuxTextBitmapL(aSize);
#endif    
}


void CPlatformFlashEngine::RecreateFrameBufferBitmapL(TSize aSize)
{
    if(!iRenderToBitmap)
        return;

    FreeFrameBufferBits();
    if (!CreateFrameBufferBitsL(aSize)) {
        User::Leave(KErrNoMemory);
    }
}

#ifdef FEATURE_OPENVG
void CPlatformFlashEngine::RecreateAuxTextBitmapL(TSize aSize)
{
    if(!iOpenVgMode)
        return;
    
    FreeAuxTextBits();
    if (!CreateAuxTextBitsL(aSize)) {
        User::Leave(KErrNoMemory);
    }
}
#endif

#ifndef USE_SYNC_MSO
CFlhShObjEngine* CPlatformFlashEngine::GetShObjEngine()
{
    if(iShObjEngine)
        return iShObjEngine;

    if(!(iConfig.iMode & KSupportSharedObject))
        return NULL;
    
    if(iSwfPath == NULL)
        return NULL;

    TFileName persistentDirectory;
    if(iFlashClientIf)
    	iFlashClientIf->GetPersistentDirectory(*iSwfPath,persistentDirectory);
/*    
    if(iFlashUI)
        iFlashUI->GetPersistentDirectory(*iSwfPath,persistentDirectory);
    else if(iControl)
        iControl->GetPersistentDirectory(*iSwfPath,persistentDirectory);
*/
    TRAP_IGNORE(iShObjEngine = CFlhShObjEngine::NewL(iFs, *iFileUtils, persistentDirectory, *this));
    return iShObjEngine;
}
#else
CSharedObjectHandler* CPlatformFlashEngine::GetShObjHandler()
    {
    if (iSharedObjHandler)
        return iSharedObjHandler;

    if (!(iConfig.iMode & KSupportSharedObject))
        return NULL;

    if (iSwfPath == NULL)
        return NULL;

    TFileName persistentDirectory;
    if (iFlashClientIf)
        iFlashClientIf->GetPersistentDirectory(*iSwfPath, persistentDirectory);

    TRAP_IGNORE(iSharedObjHandler = CSharedObjectHandler::NewL(*this, persistentDirectory));
    // iSharedObjHandler is NULL by default. If it could not be created, return the default value, which is NULL
    return iSharedObjHandler;
    }
#endif //USE_SYNC_MSO

HBufC* CPlatformFlashEngine::GetSwfGuidLC()
{
    AMP_ReturnString returnString(FI_NativeEncodingForm);
    FI_ReturnString* fiSwfGUID = returnString.Wrapper();
    
    User::LeaveIfError(iFiObject.FI_GetThisSWFGUID(fiSwfGUID));
    
    TPtr8 guidDes((TUint8*)returnString.GetTemporaryCString(),returnString.GetLength(),returnString.GetLength());
    
    HBufC* swfGUID16 = HBufC::NewLC(guidDes.Length());
    
    //Since guid is english alpha-numeric, it is safe to use Copy to convert from 8-bit string to 16-bit string.
    swfGUID16->Des().Copy(guidDes);
    
    return swfGUID16;
}


CHttpEngine* CPlatformFlashEngine::GetHttpEngine()
{
	if (iConfig.iMode & KSupportNetwork)
	{
		if (!iHttpEngine)
		{
			TRAP_IGNORE(iHttpEngine = CHttpEngine::NewL(this));
		}
	}
	return iHttpEngine;
}

CIPConnMgr* CPlatformFlashEngine::GetIPConnectionMgr()
	{
	if(!iIPConnMgr)
		{
		TRAP_IGNORE(iIPConnMgr = CIPConnMgr::NewL(this));
		}
	return iIPConnMgr;
	}
CLocalHttpEngine*   CPlatformFlashEngine::GetLocalHttpEngine()
{
	if (iConfig.iMode & KSupportNetwork)
	{
		if (!iLocalHttpEngine)
		{
			TRAP_IGNORE(iLocalHttpEngine = CLocalHttpEngine::NewL());
		}
	}
	return iLocalHttpEngine;
}

#ifdef FEATURE_XML_SOCKET
CFlashSocketEngine* CPlatformFlashEngine::GetSocketEngine()
{
	if (!iSocketEngine)
	{
		TRAP_IGNORE(iSocketEngine = CFlashSocketEngine::NewL(*this));
	}

	return iSocketEngine;
}
#endif

CFileEngine* CPlatformFlashEngine::GetFileEngine()
{
	if (iConfig.iMode & KSupportLocalFile)
	{
		if (!iFileEngine)
		{
			TRAP_IGNORE(iFileEngine = CFileEngine::NewL());
		}
	}
	return iFileEngine;
}

CVideoEngine* CPlatformFlashEngine::GetVideoEngine()
{
	if (iConfig.iMode & KSupportVideo)
	{
		if (!iVideoEngine)
		{
			TRAP_IGNORE(iVideoEngine = CVideoEngine::NewL(*this, iFs));
		}
	}
	return iVideoEngine;
}

CImageConverter* CPlatformFlashEngine::GetImageConverter()
{
    if(!iImageConverter)
    {
        TRAP_IGNORE(iImageConverter = CImageConverter::NewL(*this));
    }
    
    return iImageConverter;
}

CPlatformInfo* CPlatformFlashEngine::GetPlatformInfo()
{
	if (!iPlatformInfo)
	{
		TRAP_IGNORE(iPlatformInfo = CPlatformInfo::NewL(this));
	}

	return iPlatformInfo;
}

CPhoneInfo* CPlatformFlashEngine::GetPhoneInfo()
{
	if (!NoETelSuppport())
	{
		if (!iPhoneInfo)
		{
			TRAP_IGNORE(iPhoneInfo = CPhoneInfo::NewL());
		}
		return iPhoneInfo;
	}
	return NULL;
}

CNetworkInfo* CPlatformFlashEngine::GetNetworkInfoL()
    {
    if(!NoETelSuppport())
        {
            if(eStandAlone==iExecutionMode)
            {
            if (!iNetworkInfo)
                {
                iNetworkInfo = CNetworkInfo::NewL();
                }
            }
            return iNetworkInfo;
        }
    return NULL;
    }

CSubscriberInfo* CPlatformFlashEngine::GetSubscriberInfoL()
    {
    if (!NoETelSuppport())
        {
        if (eStandAlone == iExecutionMode)
            {
            if (!iSubscriberInfo)
                {
                iSubscriberInfo = CSubscriberInfo::NewL();
                }
            }
        return iSubscriberInfo;
        }
    return NULL;
    }

CRegistrationStatus* CPlatformFlashEngine::GetRegistrationStatusL()
    {
    if (!NoETelSuppport())
        {
        if (eStandAlone == iExecutionMode)
            {
            if (!iRegistrationStatus)
                {
                iRegistrationStatus = CRegistrationStatus::NewL();
                }
            }
        return iRegistrationStatus;
        }
    return NULL;
    }

CPhoneBatteryInfo* CPlatformFlashEngine::GetBatteryInfoL()
    {
    if (!NoETelSuppport())
        {
        //Should Work For All Modes including Widget and BrowserPlugin modes.
        //if (eStandAlone == iExecutionMode)
            {
            if (!iBatteryInfo)
                {
                iBatteryInfo = CPhoneBatteryInfo::NewL();
                }
            }
        return iBatteryInfo;
        }
    return NULL;
    }

CPhoneSignalInfo* CPlatformFlashEngine::GetPhoneSignalInfoL()
    {
    if (!NoETelSuppport())
        {
        //if (eStandAlone == iExecutionMode)
            {
            if (!iSignalInfo)
                {
                iSignalInfo = CPhoneSignalInfo::NewL();
                }
            }
        return iSignalInfo;
        }
    return NULL;
    }

CPhoneChargingInfo* CPlatformFlashEngine::GetPhoneChargingInfoL()
    {
    if (!NoETelSuppport())
        {
        if (eStandAlone == iExecutionMode)
            {
            if (!iChargingInfo)
                {
                iChargingInfo = CPhoneChargingInfo::NewL();
                }
            }
        return iChargingInfo;
        }
    return NULL;
    }

CPhoneMonitor* CPlatformFlashEngine::GetPhoneMonitorL()
    {
    if (!NoIncomingCallMonitor())
        {
        if(!iPhoneMonitor)
            {
            iPhoneMonitor = new (ELeave) CPhoneMonitor();
            iPhoneMonitor->ConstructL(this);
            }
        return iPhoneMonitor;
        }
    return NULL;
    }

TInt CPlatformFlashEngine::GetOTFont(unsigned char** aFont, TBool aBold)
{
    // Get the font data from the policy server
    CFlashRTPolicyClient* policyClient = NULL;
    TRAPD( error, 
           policyClient = CFlashRTPolicyClient::NewL(); );
    
    if(error == KErrNone )
        {
        unsigned char* font = NULL;
        error = policyClient->ReadFont( &(font), aBold );
        (*aFont) = font;
        delete policyClient;
        }    
    return error;
}

TBool CPlatformFlashEngine::IsTouchSupported()
{
    return AknLayoutUtils::PenEnabled();
}

/*
 * 1. Check if the File requested is a .jpeg file
 * 2. If a .jpg file, check the resolution and see if the resolution is more than say VGA(640X480)
 * 3. If resolution is more return ETrue else return EFalse; 
 */
TBool CPlatformFlashEngine::ImageDownScalingRequiredL(const TDesC& aFileName)
{
	TBool imageDSReq = EFalse;
	TBool isJpegFile = EFalse;
	CContent* content = CContent::NewLC(aFileName);
	if(content)
		{
	    	HBufC* tmpMIME = HBufC::NewLC( KMaxDataTypeLength );

	    	TPtr mimePtr( tmpMIME->Des() );            

	    	content->GetStringAttribute(EMimeType, mimePtr );

	    	isJpegFile =  (0 != mimePtr.CompareF(KJPEGMimeType))? EFalse : ETrue ;

	      	CleanupStack::PopAndDestroy(tmpMIME);
	    }
	CleanupStack::PopAndDestroy(content);
	if(!isJpegFile)
	{
		return imageDSReq;
	}
		
	/* Now that the file is having .jpg extension check its Resulution */
	CImageDecoder* decoder = CImageDecoder::FileNewL(iFs,aFileName, CImageDecoder::EOptionAlwaysThread); 
	TFrameInfo frameInfo = decoder->FrameInfo(0);
	TSize aDeviceScreenSize = CCoeEnv::Static()->ScreenDevice()->SizeInPixels();
	if(frameInfo.iOverallSizeInPixels.iWidth > aDeviceScreenSize.iWidth || frameInfo.iOverallSizeInPixels.iHeight >aDeviceScreenSize.iHeight)
		{
		imageDSReq = ETrue;
		}
	delete decoder; 
	return imageDSReq;
}

CSharedMemoryManager* CPlatformFlashEngine::GetSharedMemoryManagerL()
{
    if(!iSharedMemMgr)
        iSharedMemMgr = CSharedMemoryManager::CreateInstanceL();

    return iSharedMemMgr;
}
#ifdef FEATURE_AMCEXTENSIONS
int CPlatformFlashEngine::LoadPluginResourceL(const TDesC& aFileName)
    {
    TInt resOffset = -1;
    TBuf16<128> aResourcePath(_L("\\resource\\apps"));
    TInt fileNameLength = aFileName.Length();
    TFileName resourceFileName;
    CEikonEnv* env = CEikonEnv::Static();
    RFs fileServerSession = env->FsSession();
    if (fileNameLength > 4)
        {
        TBuf16<128> fName = aFileName.Mid(0, fileNameLength - 4);
        TBuf16<512> variantFile;
        _LIT16( KFormat, ":%S\\%S.r%S%d");
        TInt languageID = User::Language();
        TBuf16<8> leadingZero;
        leadingZero.Copy(_L(""));
        if (languageID < 10)
            leadingZero.Copy(_L("0"));
        for (TInt i = EDriveY; i >= EDriveA; i--)
            {
            TChar driveLetter;
            fileServerSession.DriveToChar(i, driveLetter);
            variantFile.Append(driveLetter);
            variantFile.AppendFormat(KFormat,  &aResourcePath, &fName,
                    &leadingZero, languageID);
            resourceFileName.Copy(variantFile);
            TBool fileExists = BaflUtils::FileExists(
                    env->FsSession(), resourceFileName);
            if (fileExists)
                {
                resOffset = env->AddResourceFileL(resourceFileName);
                return resOffset;
                }
            }
        TChar driveLetterZ;
        fileServerSession.DriveToChar(EDriveZ, driveLetterZ);
        variantFile.Append(driveLetterZ);
        variantFile.AppendFormat(KFormat,  &aResourcePath, &fName,
                           &leadingZero, languageID);
        resourceFileName.Copy(variantFile);
        TBool fileExists = BaflUtils::FileExists(
                env->FsSession(), resourceFileName);
        if (fileExists)
            {
            resOffset = env->AddResourceFileL(resourceFileName);
            return resOffset;
            }
        _LIT16( KNearestLangFormat, ":%S\\%S");
        for (TInt i = EDriveY; i >= EDriveA; i--)
            {
            TChar driveLetter;
            fileServerSession.DriveToChar(i, driveLetter);
            variantFile.Append(driveLetter);
            variantFile.AppendFormat(KNearestLangFormat, 
                    &aResourcePath, &aFileName); // use the filename that was passed in
            resourceFileName.Copy(variantFile);
            BaflUtils::NearestLanguageFile(env->FsSession(),
                    resourceFileName);
            TBool fileExists = BaflUtils::FileExists(
                    env->FsSession(), resourceFileName);
            if (fileExists)
                {
                resOffset = env->AddResourceFileL(
                        resourceFileName);
                return resOffset;
                }
            }
        variantFile.Append(driveLetterZ);
        variantFile.AppendFormat(KNearestLangFormat,  &aResourcePath,
                &aFileName);
        resourceFileName.Copy(variantFile);
        BaflUtils::NearestLanguageFile(env->FsSession(),
                resourceFileName);
        fileExists = BaflUtils::FileExists(env->FsSession(),
                resourceFileName);
        if (fileExists)
            {
            resOffset = env->AddResourceFileL(resourceFileName);
            return resOffset;
            }
        }
    return resOffset; // -1
    }
TBool CPlatformFlashEngine::QueryAllowDenyL(const TDesC& aQueryText)
    {
    TBool rval = EFalse;
    TBufC<128> KResFile(_L("FlashlitePlugin.rsc") );
    TInt resOffset = CPlatformFlashEngine::LoadPluginResourceL(KResFile);
    CAknQueryDialog* dlg = CAknQueryDialog::NewL();
   TInt result = (dlg->ExecuteLD(R_SAFLASH_DIALOG_ALLOW_DENY, aQueryText));
   if (result)
        {
        rval = ETrue;
        }
    CEikonEnv::Static()->DeleteResourceFile(resOffset);
    return rval;
    }
    #endif

#ifdef  FEATURE_COLLECT_BITMAP    

TInt CPlatformFlashEngine::ToggleBrowserRendering(EBrPluginRenderingMode aMode)
{
    if(aMode == EBrowserRenderingMode)
    {
        iIgnoreDrawBitBuffer = ETrue;
        if(iOpenVgMode)
        {
            PlayStep(ETrue);
            TRAPD(err, CopyLastRenderedFrameToBitmapL());
            if(err)
            {
                iIgnoreDrawBitBuffer = EFalse;
                return err;
            }
        }
    }
    else
    {   
        iIgnoreDrawBitBuffer = EFalse;
        if(iLastRenderedBitmap)
        {
            delete iLastRenderedBitmap;
            iLastRenderedBitmap = NULL;
        }
    }

    return KErrNone;
}
CFbsBitmap* CPlatformFlashEngine::GetLastRenderedBitmap()
{   
    if(iOpenVgMode)
        return iLastRenderedBitmap;
    else
        return iBitmap;
}

void CPlatformFlashEngine::CopyLastRenderedFrameToBitmapL()
{
    if(iLastRenderedBitmap && iLastRenderedBitmap->SizeInPixels() != iCurrentWindowSize)
    {
        delete iLastRenderedBitmap;
        iLastRenderedBitmap = NULL;
    }
    
    if(iLastRenderedBitmap == NULL)
    {
        iLastRenderedBitmap = new(ELeave) CFbsBitmap();
        TInt err = iLastRenderedBitmap->Create(iCurrentWindowSize,iDisplayFormat);
        if(err != KErrNone)
        {
            delete iLastRenderedBitmap;
            iLastRenderedBitmap = NULL;
            User::Leave(err);
        }
    }
    
    if(iLastRenderedBitmap)
        eglCopyBuffers(iEGLDisplay, (EGLSurface)iEGLSurface.surface, iLastRenderedBitmap);
}
#endif    

//end of file
